﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CodeWalker.GameFiles
{

    public static class MetaNames
    {
        public static bool TryGetString(uint h, out string str)
        {
            if (Enum.IsDefined(typeof(MetaName), h))
            {
                str = ((MetaName)h).ToString();
                if (str.StartsWith("@")) str = str.Substring(1); //mainly to handle the @null entry
                return true;
            }
            str = null;
            return false;
        }
    }

    
    public class MetaNamesUtil
    {


        public static string GetNameEnumCode()
        {
            //code to generate the enum code with the hash from the list of names
            StringBuilder sb = new StringBuilder();
            string[] names = ShaderParamNames.Split(new[] { "\r\n" }, StringSplitOptions.RemoveEmptyEntries);
            foreach (string name in names)
            {
                uint hash = JenkHash.GenHash(name/*.ToLower()*/, JenkHashInputEncoding.UTF8);
                sb.AppendFormat("{0} = {1},", name, hash);
                sb.AppendLine();
            }
            string result = sb.ToString();
            return result;
        }

        public static string ShaderParamNames = @"";//[redundant list removed]

    }





    public enum MetaName : uint
    {
        aabb = 293662904,
        AABB = 1666779607,
        AbilityType = 229841885,
        Action = 1705836299,
        activeChangesetConditions = 618424668,
        AdditiveDamageClipSet = 1159808383,
        AET_Directed_In_Place = 1450000159,
        AET_Flinch = 2886590336,
        AET_In_Place = 3552718780,
        AET_Interesting = 478982036,
        AET_Threatened = 1152560683,
        AET_Threatening = 56876971,
        aExplosionTagData = 2196546139,
        AFF_POOR = 1885794222,
        Affluence = 2895355855,
        Age = 2099622785,
        aircraftDownwashPtFxDist = 1452685083,
        aircraftDownwashPtFxEnabled = 1469712840,
        aircraftDownwashPtFxNameDefault = 461290670,
        aircraftDownwashPtFxNameDirt = 2734634606,
        aircraftDownwashPtFxNameFoliage = 2573299811,
        aircraftDownwashPtFxNameSand = 1320803722,
        aircraftDownwashPtFxNameWater = 1934771968,
        aircraftDownwashPtFxRange = 192247734,
        aircraftDownwashPtFxSpeedEvoMax = 632867260,
        aircraftDownwashPtFxSpeedEvoMin = 4072762094,
        aircraftSectionDamageSmokePtFxEnabled = 136971974,
        aircraftSectionDamageSmokePtFxName = 345776584,
        aircraftSectionDamageSmokePtFxRange = 2299979830,
        aircraftSectionDamageSmokePtFxSpeedEvoMax = 1864737051,
        aircraftSectionDamageSmokePtFxSpeedEvoMin = 3715270087,
        ALL = 3690519890,
        Allow = 1329228842,
        allowBonnetSlide = 1294495304,
        AllowCloseSpawning = 4019244692,
        ALTERNATE_VARIATIONS_FILE = 611054590,
        AmbientClipsForFlee = 1496688419,
        AmbulanceShouldRespondTo = 2153846297,
        Amount = 42366424,
        Amplitude = 946881915,
        anchor = 1880738441,
        ANCHOR_EARS = 119829315,
        ANCHOR_EYES = 1125276126,
        ANCHOR_HEAD = 2389455644,
        ANCHOR_LEFT_WRIST = 935290624,
        ANCHOR_RIGHT_WRIST = 1131235937,
        AnimalAudioObject = 1131698046,
        AnimatedModel = 1544926406,
        Animations = 212063203,
        AnimDict = 1027851728,
        AnimName = 1300132907,
        AP_LOW = 2695760829,
        AP_MEDIUM = 629290484,
        APF_ISBLENDAUTOREMOVE = 4147018654,
        APF_ISLOOPED = 829168795,
        Apply = 804826100,
        archetypeName = 2686689324,
        archetypes = 25836315,
        areas = 4258609502,
        assetName = 2591541189,
        assetType = 110101682,
        AT_TXD = 3870813049,
        AUDIO_DYNAMIXDATA = 2538787365,
        AUDIO_GAMEDATA = 2568179508,
        AUDIO_SOUNDDATA = 4061522791,
        AUDIO_SPEECHDATA = 2934881832,
        AUDIO_SYNTHDATA = 1488170759,
        AUDIO_WAVEPACK = 1781244916,
        audioApply = 636362136,
        audioId = 3218488635,
        AUDIOMESH_INDEXREMAPPING_FILE = 26529435,
        AutoOpenCloseRateTaper = 838139088,
        AutoOpenCosineAngleBetweenThreshold = 2537405501,
        AutoOpenRadiusModifier = 380434751,
        AutoOpenRate = 4024424870,
        AutoOpensForAllVehicles = 1314594320,
        AutoOpensForLawEnforcement = 711087453,
        AutoOpensForMPPlayerPedsOnly = 2116737868,
        AutoOpensForMPVehicleWithPedsOnly = 4004737101,
        AutoOpensForSPPlayerPedsOnly = 17022999,
        AutoOpensForSPVehicleWithPedsOnly = 883718936,
        AutoOpenVolumeOffset = 2598815900,
        availableInMpSp = 286077157,
        backfirePtFxEnabled = 3590298048,
        backfirePtFxName = 326241207,
        backfirePtFxRange = 2051678496,
        bAppliesContinuousDamage = 1994294878,
        bbMax = 3884623384,
        bbMin = 3656352310,
        bCanSetPedOnFire = 1975010672,
        bDamageObjects = 3087256498,
        bDamageVehicles = 410915188,
        BF_ALLOW_CONFRONT_FOR_TERRITORY_REACTIONS = 135224044,
        BF_BOOST_BRAVERY_IN_GROUP = 1233676580,
        BF_COWARDLY_FOR_SHOCKING_EVENTS = 2349079456,
        Bias = 2130430791,
        BICYCLE = 3348377513,
        bIgnoreExplodingEntity = 558484383,
        BIKE = 1039130067,
        blend = 3933447691,
        Blend = 3998560112,
        BlendOutDelta = 2689634897,
        BlendShapeFileName = 538335227,
        block = 3828602749,
        BLOODFX_FILE = 2150607422,
        bmax = 3220565995,
        bmin = 2028577215,
        bNoOcclusion = 1554370232,
        BOAT = 3921641754,
        boatBowPtFxEnabled = 3846459290,
        boatBowPtFxForwardName = 1639130517,
        boatBowPtFxKeelEvoMax = 237804409,
        boatBowPtFxKeelEvoMin = 3676512912,
        boatBowPtFxRange = 985220618,
        boatBowPtFxReverseName = 547727530,
        boatBowPtFxReverseOffset = 3858334001,
        boatBowPtFxScale = 1915459369,
        boatBowPtFxSpeedEvoMax = 1653246433,
        boatBowPtFxSpeedEvoMin = 2239940421,
        boatEntryPtFxEnabled = 2986953331,
        boatEntryPtFxName = 3178605558,
        boatEntryPtFxRange = 3592388731,
        boatEntryPtFxScale = 2701410410,
        boatEntryPtFxSpeedEvoMax = 2846825758,
        boatEntryPtFxSpeedEvoMin = 690983709,
        boatLowLodWakePtFxEnabled = 1609784914,
        boatLowLodWakePtFxName = 4184644587,
        boatLowLodWakePtFxRangeMax = 2835234692,
        boatLowLodWakePtFxRangeMin = 661173079,
        boatLowLodWakePtFxScale = 3728892023,
        boatLowLodWakePtFxSpeedEvoMax = 3584741482,
        boatLowLodWakePtFxSpeedEvoMin = 1014081258,
        boatPropellerPtFxBackwardSpeedEvoMax = 2824456943,
        boatPropellerPtFxBackwardSpeedEvoMin = 3685235291,
        boatPropellerPtFxDepthEvoMax = 1772973337,
        boatPropellerPtFxDepthEvoMin = 3807963294,
        boatPropellerPtFxEnabled = 620740022,
        boatPropellerPtFxForwardSpeedEvoMax = 4046105228,
        boatPropellerPtFxForwardSpeedEvoMin = 3958699285,
        boatPropellerPtFxName = 2372580323,
        boatPropellerPtFxRange = 333451303,
        boatPropellerPtFxScale = 2960340578,
        boatWashPtFxEnabled = 1083605797,
        boatWashPtFxName = 1782303759,
        boatWashPtFxRange = 3400904137,
        boatWashPtFxScale = 3769797352,
        boatWashPtFxSpeedEvoMax = 1641333397,
        boatWashPtFxSpeedEvoMin = 3421082045,
        bobble_base = 1417117096,
        bobble_head = 1789547068,
        bone = 282216227,
        boneMask = 593061963,
        boneTag = 702019504,
        BONETAG_HEAD = 3914473216,
        BONETAG_INVALID = 3548260605,
        BONETAG_L_CALF = 4031667174,
        BONETAG_L_CLAVICLE = 3253512823,
        BONETAG_L_FINGER0 = 3483436254,
        BONETAG_L_FINGER01 = 3342631108,
        BONETAG_L_FINGER02 = 2503351480,
        BONETAG_L_FINGER1 = 986241836,
        BONETAG_L_FINGER11 = 2527500201,
        BONETAG_L_FINGER12 = 4250526990,
        BONETAG_L_FINGER2 = 1293713363,
        BONETAG_L_FINGER21 = 3526758439,
        BONETAG_L_FINGER22 = 222561854,
        BONETAG_L_FINGER3 = 858967036,
        BONETAG_L_FINGER31 = 3236167907,
        BONETAG_L_FINGER32 = 2527702127,
        BONETAG_L_FINGER4 = 1149791911,
        BONETAG_L_FINGER41 = 3182656438,
        BONETAG_L_FINGER42 = 4127878243,
        BONETAG_L_FOOT = 1655517369,
        BONETAG_L_TOE = 3734897948,
        BONETAG_L_TOE1 = 2497263744,
        BONETAG_L_FOREARM = 2583642279,
        BONETAG_L_HAND = 3058573909,
        BONETAG_L_PH_HAND = 2994337423,
        BONETAG_L_THIGH = 2825836160,
        BONETAG_L_UPPERARM = 3728862758,
        BONETAG_NECK = 1526074386,
        BONETAG_NECK2 = 3577705298,
        BONETAG_PELVIS = 572940669,
        BONETAG_PELVIS1 = 2070754819,
        BONETAG_R_CALF = 1591530804,
        BONETAG_R_CLAVICLE = 623050371,
        BONETAG_R_FINGER0 = 2544970273,
        BONETAG_R_FINGER01 = 1005591915,
        BONETAG_R_FINGER02 = 774537696,
        BONETAG_R_FINGER1 = 4262590177,
        BONETAG_R_FINGER11 = 557114589,
        BONETAG_R_FINGER12 = 308168496,
        BONETAG_R_FINGER2 = 2082763528,
        BONETAG_R_FINGER21 = 2175091220,
        BONETAG_R_FINGER22 = 1557592184,
        BONETAG_R_FINGER3 = 1358503090,
        BONETAG_R_FINGER31 = 1281645843,
        BONETAG_R_FINGER32 = 2136457977,
        BONETAG_R_FINGER4 = 1589098543,
        BONETAG_R_FINGER41 = 1518893755,
        BONETAG_R_FINGER42 = 2295060289,
        BONETAG_R_FOOT = 3872946345,
        BONETAG_R_TOE = 1201239981,
        BONETAG_R_TOE1 = 3004057651,
        BONETAG_R_FOREARM = 3269208355,
        BONETAG_R_HAND = 1128649107,
        BONETAG_R_PH_HAND = 1835505437,
        BONETAG_R_THIGH = 1692969046,
        BONETAG_R_UPPERARM = 868290042,
        BONETAG_ROOT = 102109035,
        BONETAG_SPINE_ROOT = 4085918559,
        BONETAG_SPINE0 = 2529646404,
        BONETAG_SPINE1 = 2239149219,
        BONETAG_SPINE2 = 740327916,
        BONETAG_SPINE3 = 2718199230,
        BONETAG_TAIL0 = 981146734,
        BONETAG_TAIL1 = 1278001105,
        BONETAG_TAIL2 = 2362982695,
        BONETAG_TAIL3 = 2659378300,
        BONETAG_TAIL4 = 1899006424,
        BONETAG_TAIL5 = 2199399847,
        bOnlyAffectsLivePeds = 2543255645,
        bOnlyBulkyItemVariations = 3412263941,
        bonnet = 1704829083,
        boot = 3042873625,
        bottom = 4007699126,
        bPostProcessCollisionsWithNoForce = 1091620747,
        bPreventWaterExplosionVFX = 3664732218,
        BreakableByVehicle = 3427926298,
        BreakingImpulse = 1467901147,
        bsCentre = 3591926527,
        bsRadius = 2196293086,
        bSuppressCrime = 1060477616,
        bumper_f = 3886330357,
        bumper_r = 2370370867,
        bUseDistanceDamageCalc = 1929564509,
        CAiCoverClipVariationHelper__Tunables = 1889755865,
        camAnimatedCameraMetadata = 2493365232,
        camAnimatedShakeMetadata = 830598329,
        camAnimSceneDirectorMetadata = 3688863121,
        CAmbientLookAt__Tunables = 3791958970,
        CAmbientPedModelVariations = 949980109,
        camCatchUpHelperMetadata = 1074754094,
        camCinematicAnimatedCameraMetadata = 597434980,
        camCinematicBustedContextMetadata = 2582741472,
        camCinematicBustedShotMetadata = 46335367,
        camCinematicCameraManCameraMetadata = 1752694078,
        camCinematicCameraManShotMetadata = 3795997700,
        camCinematicCameraOperatorShakeSettings = 267450829,
        camCinematicCameraOperatorShakeTurbulenceSettings = 2761299644,
        camCinematicCameraOperatorShakeUncertaintySettings = 1672408332,
        camCinematicCraningCameraManShotMetadata = 644794406,
        camCinematicDirectorMetadata = 2947939407,
        camCinematicFallFromHeliContextMetadata = 3141653833,
        camCinematicFallFromHeliShotMetadata = 4001219648,
        camCinematicFirstPersonIdleCameraMetadata = 3500761789,
        camCinematicGroupCameraMetadata = 2180005320,
        camCinematicHeliChaseCameraMetadata = 385169240,
        camCinematicHeliTrackingShotMetadata = 50998987,
        camCinematicIdleCameraMetadata = 3818374703,
        camCinematicIdleShots = 3503595515,
        camCinematicInTrainAtStationContextMetadata = 3022638185,
        camCinematicInTrainContextMetadata = 3314933929,
        camCinematicInVehicleContextMetadata = 1660686749,
        camCinematicInVehicleCrashShotMetadata = 35962033,
        camCinematicInVehicleFirstPersonContextMetadata = 976409621,
        camCinematicInVehicleMultiplayerPassengerContextMetadata = 2822987935,
        camCinematicInVehicleOverriddenFirstPersonContextMetadata = 1737743598,
        camCinematicInVehicleWantedContextMetadata = 3656622133,
        camCinematicMissileKillShotMetadata = 947812684,
        camCinematicMountedCameraMetadata = 2185301869,
        camCinematicMountedCameraMetadataFirstPersonPitchOffset = 2402191709,
        camCinematicMountedCameraMetadataFirstPersonRoll = 4132129159,
        camCinematicMountedCameraMetadataLeadingLookSettings = 954561561,
        camCinematicMountedCameraMetadataLookAroundSettings = 1554281348,
        camCinematicMountedCameraMetadataMovementOnAccelerationSettings = 3508760093,
        camCinematicMountedCameraMetadataOrientationSpring = 356764392,
        camCinematicMountedCameraMetadataRelativePitchScalingToThrottle = 745700012,
        camCinematicMountedPartCameraMetadata = 3009480533,
        camCinematicOnFootAssistedAimingContextMetadata = 3749335843,
        camCinematicOnFootAssistedAimingKillShotMetadata = 2251342366,
        camCinematicOnFootFirstPersonIdleShotMetadata = 371427845,
        camCinematicOnFootIdleContextMetadata = 251156589,
        camCinematicOnFootIdleShotMetadata = 1361168617,
        camCinematicOnFootMeleeContextMetadata = 254446303,
        camCinematicOnFootMeleeShotMetadata = 341599647,
        camCinematicOnFootSpectatingContextMetadata = 4029911638,
        camCinematicParachuteCameraManShotMetadata = 4063985916,
        camCinematicParachuteContextMetadata = 13761107,
        camCinematicParachuteHeliShotMetadata = 3350745713,
        camCinematicPedCloseUpCameraMetadata = 3732353935,
        camCinematicPoliceExitVehicleShotMetadata = 3244599436,
        camCinematicPoliceHeliMountedShotMetadata = 216191320,
        camCinematicPoliceInCoverShotMetadata = 971556424,
        camCinematicPoliceRoadBlockShotMetadata = 1663387456,
        camCinematicPositionCameraMetadata = 3193773259,
        camCinematicScriptContextMetadata = 866723283,
        camCinematicScriptedMissionCreatorFailContextMetadata = 1368189925,
        camCinematicScriptedRaceCheckPointContextMetadata = 4197977312,
        camCinematicScriptRaceCheckPointShotMetadata = 1301482539,
        camCinematicShots = 3403418927,
        camCinematicSpectatorNewsChannelContextMetadata = 1655520052,
        camCinematicStuntCameraMetadata = 3215612005,
        camCinematicStuntJumpContextMetadata = 3436792018,
        camCinematicStuntJumpShotMetadata = 3180375976,
        camCinematicTrainPassengerShotMetadata = 1891076392,
        camCinematicTrainRoofMountedShotMetadata = 1375436400,
        camCinematicTrainStationShotMetadata = 4261417377,
        camCinematicTrainTrackingCameraMetadata = 2537902390,
        camCinematicTrainTrackShotMetadata = 2718877126,
        camCinematicTwoShotCameraMetadata = 2296445362,
        camCinematicVehicleBonnetShotMetadata = 3690068033,
        camCinematicVehicleConvertibleRoofShotMetadata = 4253546052,
        camCinematicVehicleGroupShotMetadata = 3216211679,
        camCinematicVehicleLowOrbitCameraMetadata = 1680076183,
        camCinematicVehicleLowOrbitShotMetadata = 357811358,
        camCinematicVehicleOrbitCameraInitalSettings = 3064456407,
        camCinematicVehicleOrbitCameraMetadata = 4218813220,
        camCinematicVehicleOrbitShotMetadata = 723416050,
        camCinematicVehiclePartShotMetadata = 2287426079,
        camCinematicVehicleTrackingCameraMetadata = 2837215026,
        camCinematicWaterCrashCameraMetadata = 1054960932,
        camCinematicWaterCrashShotMetadata = 2640788941,
        camCollisionMetadata = 201950034,
        camCollisionMetadataBuoyancySettings = 3616131743,
        camCollisionMetadataClippingAvoidance = 3777878985,
        camCollisionMetadataOcclusionSweep = 1331207488,
        camCollisionMetadataOrbitDistanceDamping = 2044384768,
        camCollisionMetadataPathFinding = 937440555,
        camCollisionMetadataPullBackTowardsCollision = 1759437459,
        camCollisionMetadataPushBeyondEntitiesIfClipping = 1986022537,
        camCollisionMetadataRotationTowardsLos = 1805808954,
        camControlHelperMetadata = 2587719592,
        camControlHelperMetadataLookAround = 565470605,
        camControlHelperMetaDataPrecisionAimSettings = 3449554353,
        camControlHelperMetadataViewModes = 3633454422,
        camControlHelperMetadataViewModeSettings = 517960737,
        camControlHelperMetadataZoom = 1487224137,
        camCustomTimedSplineCameraMetadata = 4009398869,
        camCutsceneDirectorMetadata = 3410125985,
        camDebugDirectorMetadata = 3499963834,
        camDepthOfFieldSettingsMetadata = 3604381381,
        camEnvelopeMetadata = 2722791558,
        Camera = 2997360705,
        cameraPos = 2339743138,
        camFirstPersonAimCameraMetadataHeadingCorrection = 1094369805,
        camFirstPersonHeadTrackingAimCameraMetadata = 3079183712,
        camFirstPersonPedAimCameraMetadata = 821570743,
        camFirstPersonShooterCameraMetadata = 3837693093,
        camFirstPersonShooterCameraMetadataCoverSettings = 2863258061,
        camFirstPersonShooterCameraMetadataOrientationSpring = 4197661848,
        camFirstPersonShooterCameraMetadataOrientationSpringLite = 1421319957,
        camFirstPersonShooterCameraMetadataRelativeAttachOrientationSettings = 1064503511,
        camFirstPersonShooterCameraMetadataSprintBreakOutSettings = 3371709132,
        camFirstPersonShooterCameraMetadataStickyAim = 2799165301,
        camFollowCameraMetadataFollowOrientationConing = 2364914607,
        camFollowCameraMetadataHighAltitudeZoomSettings = 418469874,
        camFollowCameraMetadataPullAroundSettings = 3437120378,
        camFollowCameraMetadataRollSettings = 1774242875,
        camFollowParachuteCameraMetadata = 736042439,
        camFollowParachuteCameraMetadataCustomSettings = 1574447900,
        camFollowPedCameraMetadata = 3759477553,
        camFollowPedCameraMetadataAssistedMovementAlignment = 559130398,
        camFollowPedCameraMetadataCustomViewModeSettings = 2553880007,
        camFollowPedCameraMetadataDivingShakeSettings = 2182445161,
        camFollowPedCameraMetadataHighFallShakeSettings = 2518615630,
        camFollowPedCameraMetadataLadderAlignment = 947799964,
        camFollowPedCameraMetadataOrbitPitchLimitsForOverheadCollision = 1431341429,
        camFollowPedCameraMetadataPushBeyondNearbyVehiclesInRagdollSettings = 2530185515,
        camFollowPedCameraMetadataRappellingAlignment = 1129712783,
        camFollowPedCameraMetadataRunningShakeSettings = 2053748298,
        camFollowPedCameraMetadataSwimmingShakeSettings = 4069495749,
        camFollowVehicleCameraMetadata = 420909885,
        camFollowVehicleCameraMetadataDuckUnderOverheadCollisionSettings = 4113023525,
        camFollowVehicleCameraMetadataDuckUnderOverheadCollisionSettingsCapsuleSettings = 3720026770,
        camFollowVehicleCameraMetadataHandBrakeSwingSettings = 2830469256,
        camFollowVehicleCameraMetadataHighSpeedShakeSettings = 2477380333,
        camFollowVehicleCameraMetadataHighSpeedZoomSettings = 2338842389,
        camFollowVehicleCameraMetadataVerticalFlightModeSettings = 62698329,
        camFollowVehicleCameraMetadataWaterEntryShakeSettings = 3274567537,
        camFreeCameraMetadata = 569456131,
        camGameplayDirectorMetadata = 1800753065,
        camGameplayDirectorMetadataExplosionShakeSettings = 2835005341,
        camGameplayDirectorMetadataVehicleCustomSettings = 3404668154,
        camHintHelperMetadata = 939949516,
        camHintHelperMetadataPivotPositionAdditive = 242159927,
        camInconsistentBehaviourZoomHelperAirborneSettings = 3999425876,
        camInconsistentBehaviourZoomHelperDetectFastCameraTurnSettings = 193557158,
        camInconsistentBehaviourZoomHelperDetectSuddenMovementSettings = 2547763044,
        camInconsistentBehaviourZoomHelperLosSettings = 2655036129,
        camInconsistentBehaviourZoomHelperMetadata = 589272335,
        camLongSwoopSwitchHelperMetadata = 3366863628,
        camLookAheadHelperMetadata = 1630118580,
        camLookAtDampingHelperMetadata = 2621748074,
        camMarketingAToBCameraMetadata = 2461291580,
        camMarketingDirectorMetadata = 1412464790,
        camMarketingDirectorMetadataMode = 1136544428,
        camMarketingFreeCameraMetadata = 1284661433,
        camMarketingFreeCameraMetadataInputResponse = 624552429,
        camMarketingMountedCameraMetadata = 925580290,
        camMarketingOrbitCameraMetadata = 545216445,
        camMarketingStickyCameraMetadata = 915237293,
        camMetadataStore = 1634862667,
        camMotionBlurSettingsMetadata = 2215393933,
        camNearClipScannerMetadata = 2769283405,
        camOscillatorMetadata = 1877334503,
        camPreferredShotSelectionType = 2475841577,
        camReplayBaseCameraMetadataCollisionSettings = 1965600814,
        camReplayBaseCameraMetadataInputResponse = 3315215408,
        camReplayDirectorMetadata = 3250236667,
        camReplayFreeCameraMetadata = 3833530058,
        camReplayPresetCameraMetadata = 3519845310,
        camReplayRecordedCameraMetadata = 68919197,
        camRoundedSplineCameraMetadata = 4144888485,
        camScriptDirectorMetadata = 808165906,
        camScriptedCameraMetadata = 2249792487,
        camScriptedFlyCameraMetadata = 201638894,
        camScriptedFlyCameraMetadataInputResponse = 2912311349,
        camSeatSpecificCameras = 3206558883,
        camShake = 2812731727,
        camShakeMetadata = 2610893148,
        camShakeMetadataFrameComponent = 1092637061,
        camShakeName = 3155961353,
        camShakeRollOffScaling = 1058165836,
        camShortRotationSwitchHelperMetadata = 4216220206,
        camShortTranslationSwitchHelperMetadata = 1635202674,
        camShortZoomInOutSwitchHelperMetadata = 1845372544,
        camShortZoomToHeadSwitchHelperMetadata = 3608544718,
        camSmoothedSplineCameraMetadata = 2992118265,
        camSpeedRelativeShakeSettingsMetadata = 3163469773,
        camSpringMountMetadata = 545475055,
        camSwitchCameraMetadata = 3778407244,
        camSwitchDirectorMetadata = 1186645804,
        camSyncedSceneDirectorMetadata = 3842242989,
        camThirdPersonCameraMetadataBasePivotPosition = 2562557362,
        camThirdPersonCameraMetadataBasePivotPositionRollSettings = 3378401281,
        camThirdPersonCameraMetadataBuoyancySettings = 4280883922,
        camThirdPersonCameraMetadataCollisionFallBackPosition = 2931931466,
        camThirdPersonCameraMetadataCustomBoundingBoxSettings = 542523046,
        camThirdPersonCameraMetadataLookOverSettings = 1204861982,
        camThirdPersonCameraMetadataPivotOverBoungingBoxSettings = 70704803,
        camThirdPersonCameraMetadataPivotPosition = 3548788069,
        camThirdPersonCameraMetadataQuadrupedalHeightSpring = 2372917588,
        camThirdPersonCameraMetadataStealthZoomSettings = 1308532518,
        camThirdPersonCameraMetadataVehicleOnTopOfVehicleCollisionSettings = 1457190622,
        camThirdPersonPedAimCameraMetadata = 1732613077,
        camThirdPersonPedAimCameraMetadataLockOnOrbitDistanceSettings = 2689046040,
        camThirdPersonPedAimCameraMetadataLockOnTargetDampingSettings = 810467818,
        camThirdPersonPedAimInCoverCameraMetadata = 3583421172,
        camThirdPersonPedAimInCoverCameraMetadataAimingSettings = 2711282760,
        camThirdPersonPedAimInCoverCameraMetadataLowCoverSettings = 4274825405,
        camThirdPersonPedAssistedAimCameraCinematicMomentSettings = 2799730898,
        camThirdPersonPedAssistedAimCameraInCoverSettings = 2194812563,
        camThirdPersonPedAssistedAimCameraLockOnAlignmentSettings = 2731233901,
        camThirdPersonPedAssistedAimCameraMetadata = 4075428929,
        camThirdPersonPedAssistedAimCameraPivotScalingSettings = 774378567,
        camThirdPersonPedAssistedAimCameraPlayerFramingSettings = 1026402136,
        camThirdPersonPedAssistedAimCameraRecoilShakeScalingSettings = 3357216290,
        camThirdPersonPedAssistedAimCameraRunningShakeSettings = 1609808531,
        camThirdPersonPedAssistedAimCameraShakeActivityScalingSettings = 3550987017,
        camThirdPersonPedAssistedAimCameraShootingFocusSettings = 4025041103,
        camThirdPersonPedMeleeAimCameraMetadata = 3247898661,
        camThirdPersonVehicleAimCameraMetadata = 1836891244,
        camTimedSplineCameraMetadata = 2703512219,
        camVehicleCustomSettingsMetadata = 2297662625,
        camVehicleCustomSettingsMetadataAdditionalBoundScalingVehicleSettings = 2484857206,
        camVehicleCustomSettingsMetadataDoorAlignmentSettings = 690471002,
        camVehicleCustomSettingsMetadataExitSeatPhaseForCameraExitSettings = 2756864235,
        camVehicleCustomSettingsMetadataInvalidCinematcShotsRefsForVehicleSettings = 4239733162,
        camVehicleCustomSettingsMetadataMultiplayerPassengerCameraHashSettings = 695621723,
        camVehicleCustomSettingsMetadataSeatSpecficCameras = 1805758296,
        CAnimSpeedUps__Tunables = 1899092416,
        CanRideBikeWithNoHelmet = 2247732941,
        CanSpawnInCar = 2174732092,
        CantUse = 4039535360,
        CapsuleHalfHeight = 2163883074,
        CapsuleHalfWidth = 629093761,
        CapsuleLen = 3235184882,
        CapsuleRadius = 1996975203,
        CapsuleZOffset = 1054694912,
        CAR = 185025060,
        CARCOLS_FILE = 869804114,
        carModel = 3176005905,
        CBaseArchetypeDef = 2195127427,
        CBikeLeanAngleHelper__Tunables = 1450700199,
        CCarGen = 1860713439,
        CClipScalingHelper__Tunables = 3772901649,
        CCombatTaskManager__Tunables = 1555503841,
        CCreatureMetaData = 2042092773,
        CCurve = 608533002,
        CCurveSet = 2222014563,
        CDataFileMgr__ContentsOfDataFileXml = 1736702710,
        CDispatchAdvancedSpawnHelper__Tunables = 91788279,
        CDispatchHelperSearchInAutomobile__Tunables = 587339511,
        CDispatchHelperSearchInBoat__Tunables = 2880812777,
        CDispatchHelperSearchInHeli__Tunables = 1963636404,
        CDispatchHelperSearchOnFoot__Tunables = 2463141505,
        CDispatchHelperVolumes__Tunables = 3789346099,
        CDispatchSpawnHelper__Tunables = 487533277,
        CDistantLODLight = 2033467892,
        CDoorTuningFile = 2411310721,
        CDynamicCoverHelper__Tunables = 3153023901,
        centerAndRadius = 4089746177,
        CEntityDef = 3461354627,
        CEventAgitated__Tunables = 2874507431,
        CEventCrimeCryForHelp__Tunables = 2970598878,
        CEventEncroachingPed__Tunables = 30996625,
        CEventExplosionHeard__Tunables = 2586882546,
        CEventFootStepHeard__Tunables = 2570549492,
        CEventGunAimedAt__Tunables = 1810003585,
        CEventGunShot__Tunables = 2246785633,
        CEventMeleeAction__Tunables = 2580170005,
        CEventPedJackingMyVehicle__Tunables = 3230173079,
        CEventPotentialBeWalkedInto__Tunables = 447216401,
        CEventPotentialBlast__Tunables = 3804045499,
        CEventPotentialGetRunOver__Tunables = 4074745581,
        CEventRequestHelp__Tunables = 1097617571,
        CEventRespondedToThreat__Tunables = 1657862556,
        CEventShocking__Tunables = 2688422386,
        CEventSuspiciousActivity__Tunables = 2370193555,
        CExplosionInfoManager = 254220034,
        CExtensionDefAudioCollisionSettings = 366926375,
        CExtensionDefAudioEmitter = 637823035,
        CExtensionDefBuoyancy = 749982947,
        CExtensionDefDoor = 1965932561,
        CExtensionDefExplosionEffect = 104349545,
        CExtensionDefExpression = 3870521079,
        CExtensionDefLadder = 2182960161,
        CExtensionDefLightEffect = 663891011,
        CExtensionDefLightShaft = 2718997053,
        CExtensionDefParticleEffect = 975627745,
        CExtensionDefProcObject = 2565191912,
        CExtensionDefSpawnPoint = 3300062776,
        CExtensionDefSpawnPointOverride = 2716862120,
        CExtensionDefWindDisturbance = 569228403,
        CFiringPatternInfo = 4139644871,
        CFiringPatternInfoManager = 3698419088,
        CGrabHelper__Tunables = 1898505781,
        Chances = 3434267272,
        changeSetName = 3618800523,
        chassis = 3558367838,
        CHDTxdAssetBinding = 1501994083,
        childName = 204594422,
        children = 240949893,
        CLegIkSolver__Tunables = 841524051,
        CLevelData = 75111904,
        CLightAttrDef = 4115341947,
        Clip = 547633373,
        CLIP_SETS_FILE = 4136207125,
        clipDictionaryMetadatas = 3037672124,
        clipDictionaryName = 635311839,
        ClipDictionaryName = 2571958159,
        clipItems = 3294768058,
        clips = 1731275751,
        ClipSet = 230522063,
        ClipSetId = 1769383946,
        clipSets = 2366522350,
        ClipSets = 2460310938,
        CLODLight = 2276214072,
        CLookAtHistory__Tunables = 4214737672,
        CMapData = 3545841574,
        CMapTypes = 3649811809,
        CMiniMap__Tunables = 4077958042,
        CMloArchetypeDef = 273704021,
        CMloEntitySet = 3601308153,
        CMloInstanceDef = 164374718,
        CMloPortalDef = 2572186314,
        CMloRoomDef = 186126833,
        CMloTimeCycleModifier = 807246248,
        CMultiTxdRelationship = 1261337422,
        CNmMessage = 540147835,
        CNmParameterBool = 3201838637,
        CNmParameterFloat = 2458347956,
        CNmParameterInt = 1429899100,
        CNmParameterRandomFloat = 3855903374,
        CNmParameterRandomInt = 213806608,
        CNmParameterResetMessage = 3594683582,
        CNmParameterString = 2290405727,
        CNmParameterVector = 1886176625,
        CNmTuningSet = 1903166467,
        col = 2082703339,
        collisionBone = 3234051813,
        CollisionData = 3547055785,
        CollisionRadius = 2961500813,
        color = 3914595625,
        Color = 1308845671,
        colors = 140995175,
        colour = 1541149667,
        CombatInfo = 894792629,
        Component = 3344490581,
        components = 3094514372,
        compositeEntityTypes = 1709823211,
        CompRestrictions = 1292693219,
        CONDITIONAL_ANIMS_FILE = 7003891,
        CONTENT_UNLOCKING_META_FILE = 138872183,
        contentChangeSets = 614695604,
        contents = 780522884,
        CONTENTS_ANIMATION = 1729429563,
        CONTENTS_CUTSCENE = 1341504475,
        CONTENTS_DLC_MAP_DATA = 2008833657,
        CONTENTS_LODS = 129500478,
        CONTENTS_MAP = 3584173080,
        CONTENTS_PEDS = 2150818969,
        CONTENTS_PROPS = 85688491,
        CONTENTS_VEHICLES = 3204813008,
        Context = 2518983606,
        corners = 1329770163,
        CPackFileMetaData = 2477165103,
        CPedCompExpressionData = 3105947251,
        CPedModelInfo__InitDataList = 3715594014,
        CPedModelInfo__PersonalityDataList = 2428131759,
        CPedPropExpressionData = 2871393870,
        CPedTargetEvaluator__Tunables = 1616944729,
        CPedTargetting__Tunables = 3572343040,
        CPlayerCoverClipVariationHelper__Tunables = 3847977171,
        CPlayerInfo__sPlayerStatInfo = 1168828738,
        CPlayerInfo__sSprintControlData = 2225340824,
        CPlayerInfo__Tunables = 3763924699,
        CPlayerPedTargeting__Tunables = 1955283657,
        CPoliceBoatDispatch__Tunables = 308678703,
        CPrioritizedClipSetRequestManager__Tunables = 76934329,
        CProceduralInfo = 4283490117,
        CPtFxAssetDependencyInfo = 3936596588,
        CPtFxAssetInfoMgr = 3599498566,
        CRandomEventManager__Tunables = 3308217727,
        CreatureMetadataName = 982286538,
        CRelationshipManager__Tunables = 1682166943,
        Crimes = 944438733,
        CScenarioClipHelper__Tunables = 1707736265,
        CScenarioPointGroup = 3383680063,
        CScenarioPointManifest = 1425675487,
        CScenarioPointRegionDef = 1251976652,
        CShaderVariableComponent = 3881120539,
        CSituationalClipSetStreamer__Tunables = 1395325338,
        CTacticalAnalysis__Tunables = 1413047452,
        CTacticalAnalysisCoverPoints__Tunables = 3043164413,
        CTacticalAnalysisCoverPointSearch__Tunables = 2640991648,
        CTacticalAnalysisNavMeshPoints__Tunables = 1220308217,
        CTargettingDifficultyInfo = 1135093158,
        CTaskAdvance__Tunables = 166066110,
        CTaskAgitated__Tunables = 451717787,
        CTaskAimAndThrowProjectile__Tunables = 920055786,
        CTaskAimFromGround__Tunables = 1016413941,
        CTaskAimGunBlindFire__Tunables = 3400346520,
        CTaskAimGunFromCoverIntro__Tunables = 675160047,
        CTaskAimGunFromCoverOutro__Tunables = 753314165,
        CTaskAimGunOnFoot__Tunables = 71881945,
        CTaskAimGunVehicleDriveBy__Tunables = 3042947166,
        CTaskAmbientClips__Tunables = 1589125251,
        CTaskAnimatedHitByExplosion__Tunables = 1117516593,
        CTaskArrestPed__Tunables = 1399891452,
        CTaskBoatChase__Tunables = 3798971738,
        CTaskBoatCombat__Tunables = 2409668190,
        CTaskBoatStrafe__Tunables = 3036495892,
        CTaskCallPolice__Tunables = 2834037164,
        CTaskCarReactToVehicleCollision__Tunables = 2728841566,
        CTaskChat__Tunables = 52767132,
        CTaskCloseVehicleDoorFromInside__Tunables = 3615161210,
        CTaskCombat__Tunables = 1035504443,
        CTaskCombatAdditionalTask__Tunables = 4286320209,
        CTaskCombatFlank__Tunables = 3480084478,
        CTaskComplexEvasiveStep__Tunables = 1335476290,
        CTaskConfront__Tunables = 150142004,
        CTaskConversationHelper__Tunables = 754470627,
        CTaskCoupleScenario__Tunables = 44269074,
        CTaskCover__Tunables = 3452806650,
        CTaskCowerScenario__Tunables = 27789385,
        CTaskDamageElectric__Tunables = 856265530,
        CTaskDraggingToSafety__Tunables = 4043706236,
        CTaskDyingDead__Tunables = 2675734391,
        CTaskEnterCover__Tunables = 1433330874,
        CTaskEnterVehicle__Tunables = 1027962175,
        CTaskEnterVehicleAlign__Tunables = 1636991334,
        CTaskEnterVehicleSeat__Tunables = 135393357,
        CTaskExhaustedFlee__Tunables = 633079219,
        CTaskExitCover__Tunables = 3296810549,
        CTaskExitVehicle__Tunables = 4141614587,
        CTaskExitVehicleSeat__Tunables = 4292350695,
        CTaskFall__Tunables = 3858033844,
        CTaskFishLocomotion__Tunables = 528773834,
        CTaskFlyingWander__Tunables = 2593718369,
        CTaskFlyToPoint__Tunables = 2856283273,
        CTaskGetUp__Tunables = 1454643673,
        CTaskGoToScenario__Tunables = 342235337,
        CTaskGrowlAndFlee__Tunables = 3882342074,
        CTaskGun__Tunables = 1283860553,
        CTaskHeliChase__Tunables = 4167522072,
        CTaskHeliCombat__Tunables = 1828825613,
        CTaskHelicopterStrafe__Tunables = 3763664820,
        CTaskHeliOrderResponse__Tunables = 162290274,
        CTaskHeliPassengerRappel__Tunables = 3828979530,
        CTaskHumanLocomotion__Tunables = 2920137037,
        CTaskInCover__Tunables = 1340552235,
        CTaskIntimidate__Tunables = 1888161203,
        CTaskInVehicleBasic__Tunables = 3591430584,
        CTaskInvestigate__Tunables = 2122351816,
        CTaskJump__Tunables = 1477206380,
        CTaskMeleeActionResult__Tunables = 1673636385,
        CTaskMotionAiming__Tunables = 1860470777,
        CTaskMotionBasicLocomotionLowLod__Tunables = 835509391,
        CTaskMotionInAutomobile__Tunables = 175867186,
        CTaskMotionInCover__Tunables = 1914830328,
        CTaskMotionInTurret__Tunables = 2020941567,
        CTaskMotionInVehicle__Tunables = 2450186166,
        CTaskMotionOnBicycle__Tunables = 1415781118,
        CTaskMotionOnBicycleController__Tunables = 1645332033,
        CTaskMotionSwimming__Tunables = 1000070523,
        CTaskMotionTennis__Tunables = 3629609639,
        CTaskMoveCombatMounted__Tunables = 1568594793,
        CTaskMoveCrossRoadAtTrafficLights__Tunables = 2381559732,
        CTaskMoveFollowNavMesh__Tunables = 418889424,
        CTaskMoveToTacticalPoint__Tunables = 2603381663,
        CTaskMoveWithinAttackWindow__Tunables = 938139729,
        CTaskNMBalance__Tunables = 4156771533,
        CTaskNMBehaviour__Tunables = 1424285270,
        CTaskNMBrace__Tunables = 959283411,
        CTaskNMBuoyancy__Tunables = 2908480529,
        CTaskNMControl__Tunables = 208512313,
        CTaskNMDraggingToSafety__Tunables = 4274630537,
        CTaskNMDrunk__Tunables = 1927528235,
        CTaskNMElectrocute__Tunables = 1986788875,
        CTaskNMExplosion__Tunables = 3668321041,
        CTaskNMFlinch__Tunables = 1394958084,
        CTaskNMHighFall__Tunables = 4010904374,
        CTaskNMInjuredOnGround__Tunables = 3943948180,
        CTaskNMJumpRollFromRoadVehicle__Tunables = 465597172,
        CTaskNMOnFire__Tunables = 749058568,
        CTaskNMPrototype__Tunables = 2697213281,
        CTaskNMPrototype__Tunables__TimedTuning = 1783260611,
        CTaskNMRiverRapids__Tunables = 2208098656,
        CTaskNMShot__Tunables = 365558263,
        CTaskNMSimple__Tunables = 1759871612,
        CTaskNMThroughWindscreen__Tunables = 701095463,
        CTaskOpenVehicleDoorFromOutside__Tunables = 4000867050,
        CTaskParachute__Tunables = 330647109,
        CTaskParachuteObject__Tunables = 533009545,
        CTaskPlaneChase__Tunables = 3362905475,
        CTaskPlayerDrive__Tunables = 2233320042,
        CTaskPlayerOnFoot__Tunables = 2843912235,
        CTaskPoliceOrderResponse__Tunables = 1572997428,
        CTaskPursueCriminal__Tunables = 1017737308,
        CTaskQuadLocomotion__Tunables = 3451166416,
        CTaskRageRagdoll__Tunables = 4111703670,
        CTaskRappel__Tunables = 583393603,
        CTaskReactAimWeapon__Tunables = 3431679747,
        CTaskReactAndFlee__Tunables = 1455936464,
        CTaskReactInDirection__Tunables = 1160501277,
        CTaskReactToBeingAskedToLeaveVehicle__Tunables = 2747883046,
        CTaskReactToBuddyShot__Tunables = 3060185515,
        CTaskReactToExplosion__Tunables = 1714101654,
        CTaskReactToImminentExplosion__Tunables = 2053606685,
        CTaskReactToPursuit__Tunables = 3823017031,
        CTaskRideTrain__Tunables = 85139718,
        CTaskScenarioFlee__Tunables = 4223438874,
        CTaskSearch__Tunables = 2186129008,
        CTaskSearchBase__Tunables = 1006486559,
        CTaskSearchForUnknownThreat__Tunables = 3552809742,
        CTaskSearchInAutomobile__Tunables = 3157865989,
        CTaskSearchInBoat__Tunables = 3740707804,
        CTaskSearchInHeli__Tunables = 2902745725,
        CTaskSearchOnFoot__Tunables = 1589612569,
        CTaskSharkAttack__Tunables = 2411903884,
        CTaskSharkCircle__Tunables = 3798074522,
        CTaskShockingEvent__Tunables = 2668698466,
        CTaskShockingEventBackAway__Tunables = 1421095933,
        CTaskShockingEventGoto__Tunables = 3634782675,
        CTaskShockingEventHurryAway__Tunables = 3936521982,
        CTaskShockingEventReact__Tunables = 1524084241,
        CTaskShockingEventReactToAircraft__Tunables = 1470816321,
        CTaskShockingEventStopAndStare__Tunables = 1473719990,
        CTaskShockingEventWatch__Tunables = 4159743939,
        CTaskShockingPoliceInvestigate__Tunables = 2727614619,
        CTaskShootOutTire__Tunables = 3623406952,
        CTaskShove__Tunables = 2315221829,
        CTaskShoved__Tunables = 2184485071,
        CTaskSmartFlee__Tunables = 2929340853,
        CTaskStandGuard__Tunables = 928089637,
        CTaskStealVehicle__Tunables = 3788906738,
        CTaskSwapWeapon__Tunables = 756021342,
        CTaskSwatOrderResponse__Tunables = 1687602234,
        CTaskSwimmingWander__Tunables = 581692275,
        CTaskTakeOffPedVariation__Tunables = 2581463145,
        CTaskTargetUnreachable__Tunables = 1996880107,
        CTaskTargetUnreachableInExterior__Tunables = 1858966752,
        CTaskTargetUnreachableInInterior__Tunables = 2878804031,
        CTaskTrainBase__Tunables = 2321692150,
        CTaskTryToGrabVehicleDoor__Tunables = 2780911905,
        CTaskUnalerted__Tunables = 3631212269,
        CTaskUseScenario__Tunables = 4286728767,
        CTaskUseVehicleScenario__Tunables = 1105517236,
        CTaskVariedAimPose__Tunables = 572125765,
        CTaskVault__Tunables = 4107041159,
        CTaskVehicleApproach__Tunables = 3998182611,
        CTaskVehicleBlock__Tunables = 946218496,
        CTaskVehicleBlockBackAndForth__Tunables = 3195863117,
        CTaskVehicleBlockBrakeInFront__Tunables = 1783020311,
        CTaskVehicleBlockCruiseInFront__Tunables = 2600077603,
        CTaskVehicleChase__Tunables = 1182936554,
        CTaskVehicleCombat__Tunables = 1479019922,
        CTaskVehicleCrash__Tunables = 3962616343,
        CTaskVehicleCruiseBoat__Tunables = 3100673805,
        CTaskVehicleDeadDriver__Tunables = 2144691340,
        CTaskVehicleFlee__Tunables = 195975428,
        CTaskVehicleFleeBoat__Tunables = 1082281615,
        CTaskVehicleFSM__Tunables = 2154756726,
        CTaskVehicleGoToBoat__Tunables = 1874670628,
        CTaskVehicleGoToHelicopter__Tunables = 505312818,
        CTaskVehicleGoToPlane__Tunables = 2216414081,
        CTaskVehicleGoToPointWithAvoidanceAutomobile__Tunables = 305265911,
        CTaskVehicleLandPlane__Tunables = 2468823445,
        CTaskVehicleMissionBase__Tunables = 3839812632,
        CTaskVehicleParkNew__Tunables = 1266857276,
        CTaskVehiclePersuit__Tunables = 424095714,
        CTaskVehiclePlaneChase__Tunables = 2639568629,
        CTaskVehiclePullAlongside__Tunables = 3971388892,
        CTaskVehiclePursue__Tunables = 1465682442,
        CTaskVehicleRam__Tunables = 4205884753,
        CTaskVehicleShotTire__Tunables = 4029377803,
        CTaskVehicleSpinOut__Tunables = 1106913269,
        CTaskWalkAway__Tunables = 206304570,
        CTaskWander__Tunables = 3543621225,
        CTaskWanderInArea__Tunables = 711403403,
        CTaskWanderingScenario__Tunables = 4183061553,
        CTaskWitness__Tunables = 1436906951,
        CTimeArchetypeDef = 1991296364,
        CTimeCycleModifier = 1733268304,
        CustomTriggerBox = 2579426011,
        CVehicleClipRequestHelper__Tunables = 2857018690,
        CVehicleModelInfoVarGlobal = 3184659407,
        CVehicleModelInfoVariation = 746362187,
        CVehicleScenarioManager__AttractorTuning__Tunables = 1138425769,
        CVfxVehicleInfo = 2566559812,
        CVfxVehicleInfoMgr = 13081091,
        CWanted__Tunables = 2938521871,
        CWantedHelicopterDispatch__Tunables = 3681116455,
        CWildlifeManager__Tunables = 3899878125,
        damageAtCentre = 626304432,
        damageAtEdge = 1456455832,
        dataFiles = 4164602339,
        DECALS_FILE = 721270417,
        decayFactor = 2187394038,
        DecisionMakerName = 71722552,
        Default = 1012917042,
        DefaultBrawlingStyle = 665939989,
        defaultEntitySets = 1407157833,
        DefaultGestureClipSet = 289586118,
        DefaultRemoveRangeMultiplier = 2267082285,
        DefaultSpawningPreference = 3497281775,
        DefaultTaskDataSetName = 2977281996,
        DefaultUnarmedWeapon = 2801601573,
        DefaultVisemeClipSet = 3269491505,
        DelayDoorClosingForPlayer = 2356415658,
        Density = 1026783212,
        DensityRange = 4153067752,
        directedLifeTime = 2075377911,
        directedWidth = 932713096,
        direction = 887068712,
        Direction = 2690021765,
        disableBonnetCamera = 1563940027,
        disabled = 2572083169,
        Disabled = 295298378,
        disabledFiles = 3110537950,
        Dispatch = 3591134869,
        Distance = 1974652584,
        DistanceRange = 1987085678,
        DISTANT_LIGHTS_FILE = 983558349,
        DISTANT_LIGHTS_HD_FILE = 2925996279,
        distBetweenCoronas = 1962520137,
        distBetweenCoronas_far = 232750087,
        DLC_ITYP_REQUEST = 4114167230,
        DLC_SCRIPT_METAFILE = 259967989,
        DLC_WEAPON_PICKUPS = 3168769355,
        dlcName = 2337697442,
        DontCloseWhenTouched = 1465449817,
        door_dside_f = 1744947660,
        door_dside_r = 3782851822,
        door_pside_f = 2553297679,
        door_pside_r = 1096977781,
        DOOR_TUNING_FILE = 57918953,
        drawableDictionary = 4229936891,
        DrawableId = 1166348048,
        DrawableIndex = 1740452767,
        DSP_NORMAL = 1082005734,
        duration = 3674968789,
        Duration = 2193831214,
        Edges = 1456031062,
        effectsData = 3285521232,
        emmissiveBoost = 1697573984,
        EMPTY = 2749884260,
        Enable = 421699355,
        enabled = 1527945487,
        Enabled = 1989893331,
        EnabledByDefault = 3921215899,
        end = 2965669335,
        End = 443072552,
        endHour = 380604338,
        EndModel = 3041118144,
        endPhase = 1600588195,
        endRadius = 306326438,
        enforceLsnSorting = 3949387622,
        engineblock = 2036489924,
        engineDamagePtFxEnabled = 2314702693,
        engineDamagePtFxHasPanel = 811799967,
        engineDamagePtFxHasRotorEvo = 935734665,
        engineDamagePtFxNoPanelName = 2142304406,
        engineDamagePtFxPanelOpenName = 2589870806,
        engineDamagePtFxPanelShutName = 2754603386,
        engineDamagePtFxRange = 1633907331,
        engineDamagePtFxSpeedEvoMax = 4116298751,
        engineDamagePtFxSpeedEvoMin = 1190778122,
        engineStartupPtFxEnabled = 2837195620,
        engineStartupPtFxName = 2081216567,
        engineStartupPtFxRange = 3534688011,
        entities = 3433796359,
        ENTITYFX_FILE = 209619560,
        EventType = 2248400140,
        exclusions = 1912839368,
        executionConditions = 312713139,
        exhaust = 2148626005,
        exhaust_2 = 3047243728,
        exhaust_3 = 4276408918,
        exhaust_4 = 286750395,
        exhaustPtFxCutOffSpeed = 1411922576,
        exhaustPtFxEnabled = 3040982233,
        exhaustPtFxName = 2262693655,
        exhaustPtFxRange = 3636073,
        exhaustPtFxScale = 4006380515,
        exhaustPtFxSpeedEvoMax = 1132138093,
        exhaustPtFxSpeedEvoMin = 2787040150,
        exhaustPtFxTempEvoMax = 2189200497,
        exhaustPtFxTempEvoMin = 2162145396,
        exhaustPtFxThrottleEvoOnGearChange = 1254006862,
        explodeAttachEntityWhenFinished = 2712903420,
        Explosion = 3638218222,
        EXPLOSION_INFO_FILE = 1307223293,
        EXPLOSIONFX_FILE = 2522650906,
        ExpressionDictionaryName = 1760551351,
        expressionName = 1573835099,
        ExpressionName = 3005293958,
        ExpressionSetName = 2352891724,
        extendedRange = 3534580187,
        extensions = 4051599144,
        ExternallyDrivenDOFs = 4106672091,
        extra_1 = 3819846466,
        extra_2 = 3050790801,
        extra_3 = 2297431491,
        extra_4 = 2590320813,
        extra_5 = 2830583129,
        EXTRA_FOLDER_MOUNT_DATA = 374419551,
        EXTRA_TITLE_UPDATE_DATA = 2227896657,
        FacialClipsetGroupName = 1843847949,
        fallbackId = 3378470045,
        Falling = 4171606781,
        falloff = 3429369576,
        falloffExponent = 733168314,
        falloffMax = 2603992812,
        Female = 107208361,
        FFrontOffset = 2475984948,
        Fight = 2236152585,
        filename = 1087019066,
        filesToDisable = 3328021166,
        filesToEnable = 2417471446,
        filesToInvalidate = 3805669424,
        fileType = 345145806,
        FIREFX_FILE = 1731707109,
        FirstPersonDriveByIKOffset = 1272308759,
        flags = 1741842546,
        Flags = 1264718594,
        flash = 2239439183,
        Flee = 1684954205,
        forceFactor = 3761213775,
        Forward = 4076313930,
        Fov = 3926516228,
        fragDamage = 2676323813,
        fRagdollForceModifier = 1451234527,
        frontIndicatorCorona = 3430197797,
        fSelfForceModifier = 3267483248,
        FullBodyDamageClipSet = 4228310587,
        FUpOffset = 4137555685,
        fwClipItem = 4225016529,
        fwClipItemWithProps = 615994212,
        fwClipSet = 3765269019,
        fwClipSetManager = 4032904779,
        fxName = 1920790105,
        fxOffsetPos = 3676475576,
        fxOffsetRot = 1710928362,
        fxType = 529104057,
        GetupSetHash = 1726861708,
        GroundColor = 860002656,
        group = 3391120809,
        Group = 1713610519,
        Groups = 2500839488,
        GTXD_PARENTING_DATA = 2798946644,
        guid = 2591780461,
        HANDLING_FILE = 46800217,
        hash = 1048674328,
        HDDist = 4257505727,
        HDTxd = 1692217392,
        HDTxdBindingArray = 4153080611,
        Heading = 3903571810,
        HeadingLimits = 2310315578,
        headLight = 1105987835,
        headlight_l = 2403350912,
        headlight_r = 3886869072,
        headLightCorona = 1649539989,
        Height = 4052201683,
        HIGH_HEELS = 2100709655,
        highPri = 1331010150,
        HoldDuration = 2367844690,
        hub_lf = 3891344909,
        hub_rf = 2300894090,
        iCosZ = 3735431522,
        id = 459292749,
        Id = 3809113010,
        identifier = 4004242505,
        Idle = 923499413,
        IdleTransitionBlendOutTime = 61709549,
        IdleTransitions = 1687702635,
        ids = 4038920459,
        IgnoreMaxInRange = 3250311224,
        IgnoreOpenDoorTaskEdgeLerp = 975984281,
        IgnorePavementChecks = 1501464625,
        imapDependencies = 735712319,
        imapDependencies_2 = 3712769228,
        imapName = 833569695,
        IN_VEHICLE = 1015874207,
        includedDataFiles = 2354614069,
        includedXmlFiles = 3280956850,
        Index = 1035793140,
        indicator = 801150652,
        indicator_lf = 3403024362,
        indicator_rf = 2051585809,
        indices = 3921649453,
        Infos = 802810900,
        InitDatas = 1512338287,
        initSpeed = 3640438618,
        InjuredStrafeClipSet = 1464530836,
        innerConeAngle = 1245835442,
        installPartition = 3475002187,
        intensity = 4023228733,
        Intensity = 140854398,
        intensity_far = 3542645631,
        IntensityVar = 2813237244,
        interior = 560567274,
        INTERIOR_PROXY_ORDER_FILE = 821873185,
        InteriorNames = 2406565252,
        Interiors = 947288719,
        IPL_FILE = 2251386970,
        iRadius = 1998996693,
        IsHeadBlendPed = 591520311,
        iSinZ = 1351095745,
        IsStreamedGfx = 3353096503,
        Item = 104834034,
        itypDependencies_2 = 3529579673,
        iType = 3252237582,
        JUNCTION_TEMPLATES_FILE = 1075369871,
        JUNCTION_TEMPLATES_PSO_FILE = 1684997832,
        kBoth = 1849703770,
        Key = 1620616462,
        KilledPerceptionRangeModifer = 2618596152,
        kitName = 1513897539,
        kits = 1843360923,
        Kits = 1497090499,
        kitType = 3008983707,
        leakPtFxEnabled = 1064432315,
        leakPtFxOilName = 729665807,
        leakPtFxPetrolName = 3533268990,
        leakPtFxRange = 2910098562,
        leakPtFxSpeedEvoMax = 1705315422,
        leakPtFxSpeedEvoMin = 2575887885,
        length = 2508072249,
        LifeTime = 4209357938,
        Lights = 2854514190,
        lightSettings = 2377329928,
        limitAngle = 2100360280,
        linkedModels = 3815104759,
        linkMods = 769154353,
        LIQUIDFX_FILE = 1699106320,
        liveries = 2791605300,
        livery = 2153615120,
        liveryNames = 1704397081,
        loadCompletely = 713423689,
        LoadOut = 4277349827,
        LOADOUTS_FILE = 808720620,
        locations = 3724288529,
        locked = 2448219441,
        lodDist = 3212107687,
        lodLevel = 1821316885,
        LODTYPES_DEPTH_HD = 3259521980,
        LODTYPES_DEPTH_LOD = 2384644182,
        LODTYPES_DEPTH_SLOD1 = 2554074988,
        LODTYPES_DEPTH_SLOD2 = 315427988,
        LODTYPES_DEPTH_SLOD3 = 2164549889,
        LODTYPES_DEPTH_SLOD4 = 1868383667,
        LODTYPES_DEPTH_ORPHANHD = 2106806081,
        mapChangeSetData = 815157305,
        MapDataGroups = 3039604259,
        MAPZONES_FILE = 2154214988,
        maskID = 2432235300,
        MassMultiplier = 1613940114,
        MATERIALFX_FILE = 905909785,
        max = 1616931012,
        Max = 344563784,
        MaxDistance = 2770481267,
        MaxPassengersInCar = 1694835331,
        MaxScale = 4214801493,
        MaxScaleZ = 1351348251,
        MaxSpeed = 3972966657,
        MaxTime = 786767296,
        MaxTintPalette = 3492298933,
        MaxXRotation = 658255980,
        MaxYRotation = 2609605325,
        MaxZOffset = 1569839200,
        MaxZRotation = 3093288384,
        memoryGroup = 1079355696,
        MicroMovementsFreqH = 215094271,
        MicroMovementsFreqV = 1945002622,
        MicroMovementsScaleH = 2532792329,
        MicroMovementsScaleV = 2313960935,
        min = 4264617715,
        Min = 3358645132,
        MinActivationImpulse = 1033747207,
        MinDistance = 1316787168,
        minorExplosion = 3090421228,
        MinScale = 2118753352,
        MinScaleZ = 572504281,
        MinTime = 614798748,
        MinTintPalette = 2179154468,
        MinXRotation = 3795236509,
        MinYRotation = 2447817968,
        MinZOffset = 1998724326,
        MinZRotation = 2511320236,
        mirrorTexture = 1892759569,
        misc_a = 2172915033,
        misc_b = 2948983260,
        misc_c = 3705750550,
        misc_d = 2334728355,
        misc_e = 3629890315,
        misc_f = 4003129225,
        misc_g = 867496380,
        misc_h = 702996000,
        misc_i = 2672412968,
        misc_j = 2246219354,
        misc_k = 986218535,
        misc_l = 1360178363,
        misc_m = 4199644986,
        misc_n = 3363543951,
        misc_o = 2517907133,
        misc_p = 3821556264,
        misc_q = 101324459,
        misc_r = 332902982,
        misc_s = 3515428266,
        misc_t = 526666079,
        misc_u = 1020363837,
        misc_v = 1257971856,
        misc_w = 1686098841,
        misc_x = 2041970181,
        misc_y = 1413133063,
        misc_z = 2850643555,
        misfirePtFxEnabled = 2760245605,
        misfirePtFxName = 4265177602,
        misfirePtFxRange = 3937313011,
        MKT_SPECIAL = 2316627489,
        MKT_SPORT = 3608585597,
        MKT_STANDARD = 315733923,
        MKT_SUV = 2385734984,
        MLOInstflags = 3761966250,
        mod_col_1 = 1338030889,
        mod_col_2 = 2758960267,
        mod_col_3 = 1785032818,
        mod_col_4 = 1092558310,
        mod_col_5 = 119450078,
        ModelId = 2410101093,
        modelName = 194221603,
        ModelName = 4216861609,
        ModelSet = 1518141539,
        ModelToTuneMapping = 1001913906,
        modifier = 1699237703,
        modShopLabel = 4132169566,
        MotionTaskDataSetName = 1092878940,
        Move = 528166787,
        MOVE_NETWORK_DEFS = 4182086555,
        MoveBlendRatio = 778269991,
        MovementClipSet = 3248325447,
        MovementClipSetId = 549835433,
        MovementModes = 2739474645,
        MovementModeUnholsterData = 523961350,
        MovementToStrafeClipSet = 4177809469,
        moveNetworkFlags = 4273852377,
        MP_STATS_DISPLAY_LIST_FILE = 759160086,
        MP_STATS_UI_LIST_FILE = 2486889377,
        mtlBangPtFxVehicleEvo = 1188575673,
        mtlBangPtFxVehicleScale = 2772539357,
        mtlScrapePtFxVehicleEvo = 1379406366,
        mtlScrapePtFxVehicleScale = 3990432188,
        multiples = 1309656778,
        multiTxdRelationships = 3649984070,
        MustUse = 331851963,
        name = 3873537812,
        Name = 2901156542,
        NamedTuningArray = 2148169260,
        NavCapabilitiesName = 3282019215,
        NAVMESH_INDEXREMAPPING_FILE = 1431019085,
        NAVNODE_INDEXREMAPPING_FILE = 2576484635,
        networkPedModifier = 2824520073,
        networkPlayerModifier = 3578474195,
        Nodes = 804169170,
        none = 493038497,
        None = 1640121937,
        normal = 1330140418,
        Normal = 3599348095,
        NormalMapName = 2845714814,
        NUM_ANCHORS = 665640573,
        numCoronas = 2225470999,
        numExitPortals = 528711607,
        OBJ_COVER_TUNING_FILE = 628815953,
        offset = 2705095151,
        offsetPosition = 3633645315,
        offsetRotation = 1389511464,
        ON_FOOT = 2976953365,
        opacity = 3644411688,
        outerConeAngle = 4179134239,
        overlay = 943450718,
        OVERLAY_INFO_FILE = 3489350694,
        overturnedSmokePtFxAngleThresh = 2735995463,
        overturnedSmokePtFxEnabled = 1633606873,
        overturnedSmokePtFxEngineHealthThresh = 132281413,
        overturnedSmokePtFxName = 1978623397,
        overturnedSmokePtFxRange = 1730945222,
        overturnedSmokePtFxSpeedThresh = 2304473042,
        owner = 2349203824,
        OwnerName = 1481791743,
        Pad = 1592782806,
        parent = 2845591121,
        parentIndex = 3633459645,
        parentName = 2521104825,
        PARTITION_0 = 1376468858,
        PARTITION_1 = 2621625320,
        PARTITION_2 = 2912515733,
        patchFiles = 3524138408,
        PATH_ZONES_FILE = 884764256,
        PED_DAMAGE_APPEND_FILE = 3868325674,
        PED_FIRST_PERSON_ALTERNATE_DATA = 143306029,
        PED_FIRST_PERSON_ASSET_DATA = 348738744,
        PED_METADATA_FILE = 3698391097,
        PED_OVERLAY_FILE = 1407571174,
        PED_PERSONALITY_FILE = 469479865,
        PedCapsuleName = 3605846536,
        pedCompExpressionIndex = 656720598,
        pedCompExpressions = 4168161021,
        pedcompID = 3512253528,
        pedCompID = 3337196122,
        PedComponentClothName = 2679581144,
        PedComponentSetName = 3295015867,
        pedCompVarIndex = 2890646891,
        PedIKSettingsName = 851100275,
        PedLayoutName = 704782517,
        PedPersonalities = 2345512339,
        pedPropExpressionIndex = 3269764788,
        pedPropExpressions = 1538058350,
        pedPropID = 1389713939,
        pedPropVarIndex = 461768873,
        Peds = 4047618778,
        PedScale = 3537940146,
        PEDSTREAM_FILE = 1358252642,
        pedType = 2747160189,
        Pedtype = 3052355362,
        PedVoiceGroup = 1999554162,
        percentage = 2947557653,
        PerceptionInfo = 3174726878,
        PERMANENT_ITYP_FILE = 2437884080,
        persistent = 4183121383,
        Personality = 620072928,
        petrolTankFirePtFxName = 2162940361,
        petrolTankFirePtFxRadius = 2461827139,
        petrolTankFirePtFxRange = 165484253,
        petrolTankFirePtFxSpeedEvoMax = 2172227529,
        petrolTankFirePtFxSpeedEvoMin = 1276446821,
        Pistol = 805949221,
        Pitch = 4037952930,
        PitchChangeRate = 1754758744,
        PitchLimits = 1158567006,
        PitchOffset = 3015997841,
        PLANE = 2676158011,
        planeAfterburnerPtFxEnabled = 3213641538,
        planeAfterburnerPtFxName = 446218229,
        planeAfterburnerPtFxRange = 408793866,
        planeAfterburnerPtFxScale = 2145730461,
        planeDamageFirePtFxEnabled = 3414165598,
        planeDamageFirePtFxName = 1338161444,
        planeDamageFirePtFxRange = 2839206294,
        planeDamageFirePtFxSpeedEvoMax = 571971263,
        planeDamageFirePtFxSpeedEvoMin = 1883098650,
        planeGroundDisturbPtFxDist = 4253009632,
        planeGroundDisturbPtFxEnabled = 3844975759,
        planeGroundDisturbPtFxNameDefault = 648304806,
        planeGroundDisturbPtFxNameDirt = 1349328259,
        planeGroundDisturbPtFxNameFoliage = 3426743478,
        planeGroundDisturbPtFxNameSand = 3528449028,
        planeGroundDisturbPtFxNameWater = 253287460,
        planeGroundDisturbPtFxRange = 2117069571,
        planeGroundDisturbPtFxSpeedEvoMax = 1904205977,
        planeGroundDisturbPtFxSpeedEvoMin = 3750053303,
        planeWingTipPtFxEnabled = 630564551,
        planeWingTipPtFxName = 1116747820,
        planeWingTipPtFxRange = 2911605361,
        planeWingTipPtFxSpeedEvoMax = 1891037280,
        planeWingTipPtFxSpeedEvoMin = 432519559,
        plantInfos = 1195126367,
        PlantTag = 1119170566,
        plateProbabilities = 759151167,
        Player = 2751443189,
        POPGRP_FILE = 2708681290,
        POPSCHED_FILE = 3496245090,
        PoseMatcherName = 407450340,
        PoseMatcherProneName = 1468409568,
        position = 18243940,
        Position = 210930065,
        PositionOffset = 3553152178,
        posn = 967189988,
        PovCameraOffset = 3390378580,
        PreciseUseTime = 196435285,
        priority = 342945216,
        Priority = 2673351645,
        Probabilities = 4251991726,
        probability = 3698534260,
        PROC_META_FILE = 3342716104,
        PROCOBJ_ALIGN_OBJ = 2620161998,
        PROCOBJ_CAST_SHADOW = 1528296021,
        PROCOBJ_FILE = 1526130529,
        PROCOBJ_IS_FLOATING = 3217678483,
        PROCOBJ_NETWORK_GAME = 390676221,
        PROCOBJ_USE_SEED = 2229775436,
        procObjInfos = 4262901725,
        PROCPLANT_CAMERADONOTCULL = 1147935867,
        PROCPLANT_FURGRASS = 3729666926,
        PROCPLANT_GROUNDSCALE1VERT = 389823981,
        PROCPLANT_LOD0 = 1994951555,
        PROCPLANT_LOD1 = 4009819058,
        PROCPLANT_LOD2 = 72099408,
        PROCPLANT_NOGROUNDSKEW_LOD0 = 398505754,
        PROCPLANT_NOGROUNDSKEW_LOD1 = 3381598904,
        PROCPLANT_NOGROUNDSKEW_LOD2 = 885125404,
        PROCPLANT_NOSHADOW = 696619156,
        PROCPLANT_UNDERWATER = 882615863,
        procTagTable = 2377507684,
        PropRestrictions = 465162194,
        props = 2287400538,
        PropsName = 1179225812,
        ptfxAssetDependencyInfos = 493695515,
        PTFXASSETINFO_FILE = 1772520447,
        ptFxHasTint = 3576542357,
        ptFxIsTriggered = 3434402314,
        ptFxName = 1203215085,
        ptFxProbability = 3448174308,
        ptFxScale = 1567144545,
        ptFxSize = 1080281337,
        ptFxSpeedEvoMax = 320256667,
        ptFxSpeedEvoMin = 3884276349,
        ptFxTag = 2524903540,
        ptFxTintB = 2225110962,
        ptFxTintG = 23853287,
        ptFxTintR = 1304072655,
        pull = 350772507,
        pullCoronaIn = 538460876,
        PV_COMP_INVALID = 476847607,
        PV_COMP_ACCS = 3760011790,
        PV_COMP_BERD = 696691459,
        PV_COMP_DECL = 3631275576,
        PV_COMP_FEET = 2300506577,
        PV_COMP_HAIR = 2918472950,
        PV_COMP_HAND = 2793296290,
        PV_COMP_HEAD = 1159394596,
        PV_COMP_JBIB = 2376289126,
        PV_COMP_LOWR = 3254995156,
        PV_COMP_MAX = 920969818,
        PV_COMP_TASK = 1051671594,
        PV_COMP_TEEF = 1520752005,
        PV_COMP_UPPR = 3707586858,
        RADIO_GENRE_CLASSIC_ROCK = 567874491,
        RADIO_GENRE_JAZZ = 3210576665,
        RADIO_GENRE_MEXICAN = 4058039902,
        RADIO_GENRE_MODERN_ROCK = 4200371511,
        RADIO_GENRE_MOTOWN = 1526192047,
        RADIO_GENRE_OFF = 3820886398,
        RADIO_GENRE_PUNK = 2352668725,
        RADIO_GENRE_REGGAE = 2059985335,
        RADIO_GENRE_RIGHT_WING_TALK = 1758684295,
        RADIO_GENRE_SURF = 2495475670,
        Radio1 = 3430266395,
        Radio2 = 3132297878,
        radius = 1337695475,
        Radius = 3144350114,
        RadiusScale = 3245550474,
        rage__fwInstancedMapData = 4048164286,
        rage__phVerletClothCustomBounds = 847348117,
        rage__spdGrid2D = 2599150383,
        range = 332484516,
        Rate = 2986741774,
        rear = 2243100542,
        rearIndicatorCorona = 103408473,
        RegionDefs = 3713107563,
        RelationshipGroup = 4150596315,
        requiredImap = 2090738474,
        requiresLoadingScreen = 3135083525,
        ResetNoCollisionOnCleanUp = 3362749677,
        residentAnims = 2052114030,
        residentResources = 82002169,
        residentTxd = 1079754329,
        Restriction = 26114980,
        reversingLight = 242592930,
        reversingLightCorona = 3960865135,
        RFrontOffset = 1353482245,
        RGBI = 194542898,
        Rifle = 3187352598,
        rimRadius = 1671388815,
        Roll = 2579823494,
        rooms = 3441481640,
        rotate = 3903098393,
        rotation = 2010988560,
        Rotation = 2371198895,
        RotationLimitAngle = 648763416,
        RPF_FILE = 81740897,
        RPF_FILE_PRE_INSTALL = 31119764,
        RumbleDuration = 79170607,
        RUpOffset = 3943427752,
        SAT_NONE = 836773056,
        SCALEFORM_DLC_FILE = 258049916,
        ScaleRange = 2691059430,
        ScaleRangeXYZ = 4267248400,
        ScaleRangeZ = 2934008023,
        ScaleVariationXY = 754964759,
        ScaleVariationZ = 2602640464,
        ScaleXY = 3128382556,
        ScaleZ = 712150328,
        SCENARIO_INFO_FILE = 2244432863,
        SCENARIO_POINTS_PSO_FILE = 1653171061,
        SCENARIO_POP_STREAMING_NORMAL = 79175210,
        ScenarioPoints = 3966518334,
        ScenarioPopStreamingSlot = 3440415111,
        ScenarioType = 191322199,
        SCRIPTFX_FILE = 3176550718,
        SeatIndex = 2604655109,
        Seats = 368310011,
        sets = 4021164785,
        Sets = 778639775,
        settings = 2768156407,
        Settings = 1654011315,
        Sexiness = 867165133,
        SF_HOT_PERSON = 3612284555,
        SF_JEER_AT_HOT_PED = 213733388,
        shaderVariableComponents = 3687287113,
        shaderVariableHashString = 490746723,
        shadowBlur = 3672716153,
        shockingEventAudioRangeOverride = 345540543,
        shockingEventVisualRangeOverride = 2220221975,
        SHOP_PED_APPAREL_META_FILE = 4189023929,
        shortRange = 178074428,
        ShouldLatchShut = 1101824832,
        SidestepClipSet = 1255368790,
        sirenSettings = 2230033165,
        Situations = 2546696905,
        size = 3226656423,
        size_far = 388176731,
        sLevelData = 4248020339,
        SLOD_HUMAN = 2092589681,
        slot = 933689839,
        slotNames = 2198312216,
        SLOWNESS_ZONES_FILE = 819490736,
        Sniper = 3200555378,
        SP_Low = 1535176458,
        SP_Medium = 1318432000,
        SP_MULTIPLAYER_RESIDENT = 330835765,
        SP_SINGLEPLAYER_RESIDENT = 2843514243,
        SP_STATS_DISPLAY_LIST_FILE = 957687860,
        SP_STATS_UI_LIST_FILE = 3848387179,
        SP_STREAMING = 1647646833,
        spacing = 370899326,
        Spacing = 1644991037,
        spawnType = 4261247615,
        specialAttribute = 1813324772,
        speed = 4187447851,
        sphere = 953812642,
        Spheres = 3873229047,
        splashInPtFxEnabled = 2568271272,
        splashInPtFxName = 1671048614,
        splashInPtFxRange = 424335064,
        splashInPtFxSizeEvoMax = 2546557251,
        splashInPtFxSpeedDownwardEvoMax = 2719708920,
        splashInPtFxSpeedDownwardEvoMin = 1110754284,
        splashInPtFxSpeedDownwardThresh = 2861864958,
        splashInPtFxSpeedLateralEvoMax = 717627197,
        splashInPtFxSpeedLateralEvoMin = 1180941296,
        splashOutPtFxEnabled = 265145855,
        splashOutPtFxName = 2228265562,
        splashOutPtFxRange = 2084717992,
        splashOutPtFxSizeEvoMax = 2926629502,
        splashOutPtFxSpeedLateralEvoMax = 4269956697,
        splashOutPtFxSpeedLateralEvoMin = 976640088,
        splashOutPtFxSpeedUpwardEvoMax = 2874671957,
        splashOutPtFxSpeedUpwardEvoMin = 340254431,
        splashTrailPtFxEnabled = 1540336092,
        splashTrailPtFxName = 3437892535,
        splashTrailPtFxRange = 496141127,
        splashTrailPtFxSizeEvoMax = 2112168390,
        splashTrailPtFxSpeedEvoMax = 1320429615,
        splashTrailPtFxSpeedEvoMin = 465674370,
        splashWadePtFxEnabled = 3946923366,
        splashWadePtFxName = 573019250,
        splashWadePtFxRange = 2801117501,
        splashWadePtFxSizeEvoMax = 230363215,
        splashWadePtFxSpeedRiverEvoMax = 3237227592,
        splashWadePtFxSpeedRiverEvoMin = 1052618905,
        splashWadePtFxSpeedVehicleEvoMax = 1036775998,
        splashWadePtFxSpeedVehicleEvoMin = 1176468081,
        sStatsMetadataTuning = 3459433883,
        StaggerFall = 2002487478,
        Standard = 2352402326,
        start = 2229020447,
        Start = 3073138309,
        startHour = 625204231,
        StartModel = 226559569,
        startPhase = 3221846423,
        StationaryReactions = 2620629637,
        statMods = 216311195,
        STATS_METADATA_PSO_FILE = 1289107292,
        StdDoorOpenBothDir = 1469697918,
        StdDoorOpenNegDir = 2656051665,
        StdDoorRotDir = 1083750337,
        steeringwheel = 1325046900,
        Stiffness = 294387850,
        StillToSitPedalGearApproachRate = 2386385168,
        StrafeClipSet = 1514292895,
        STREAMING_REQUEST_LISTS_FILE = 2865461394,
        streamingPolicy = 827725946,
        streamingPriority = 3660169125,
        STREET_VEHICLE_ASSOCIATION_FILE = 3243535945,
        strength = 4280043047,
        Stubble = 2766015245,
        SuperlodType = 868617040,
        Tag = 2215212623,
        tailLight = 1210163367,
        tailLightCorona = 4104001094,
        tailLightMiddleCorona = 3579298804,
        tangent = 2389642153,
        Target = 3866136337,
        targetAsset = 662555360,
        TargetingThreatModifier = 41162556,
        TargetOffset = 2175492938,
        TargetRadius = 1146856098,
        TaskDataName = 653610287,
        TATTOO_SHOP_DLC_FILE = 1223910633,
        TB_WARM = 1158270414,
        TechSavvy = 248494816,
        Teeter = 3508388318,
        template = 3202639186,
        texId = 1785432003,
        TEXTFILE_METAFILE = 1142425891,
        textureDictionary = 1976702369,
        TextureId = 3617584144,
        textureName = 440050042,
        ThermalBehaviour = 3253990041,
        time = 258444835,
        TIME_FILE = 1428695449,
        TIMECYCLE_FILE = 755616351,
        TIMECYCLEMOD_FILE = 2793750187,
        timeCycleModifiers = 2946251737,
        timeTillPedLeaves = 213640539,
        top = 1281216666,
        TorqueAngularVelocityLimit = 3539021765,
        tracks = 794089857,
        TRAILER = 4229025179,
        TRAINCONFIGS_FILE = 751887759,
        TRAINTRACK_FILE = 680882864,
        TriggerBoxMinMax = 2642293346,
        TS_LOW = 4290350623,
        Tunables = 508571515,
        Tuning = 2317966594,
        TuningName = 2921576840,
        Turn = 3647068299,
        turnOffBones = 3764022105,
        turnOffExtra = 2892421376,
        txdRelationships = 110813075,
        txdToLoad = 465628444,
        txdToUnload = 2372422677,
        type = 828747869,
        types = 138573281,
        UnholsterClipData = 1235872865,
        UnholsterClips = 3511043731,
        UnholsterClipSetId = 3278048392,
        unregisterResources = 910312539,
        Update = 575805931,
        UpperBodyFeatheredLeanEnabled = 2028170470,
        UpperBodyShadowExpressionEnabled = 1264317859,
        UseAutoOpenTriggerBox = 4151971060,
        UseLeftHandIk = 1829639529,
        UseWeaponAnimsForGrip = 1775814871,
        Value = 4108660753,
        variationData = 3467549031,
        Variations = 1085728185,
        VEHGEN_MARKUP_FILE = 2433209284,
        VEHICLE_LAYOUTS_FILE = 2004032454,
        VEHICLE_METADATA_FILE = 4125139733,
        VEHICLE_POPULATION_FILE = 4010054647,
        VEHICLE_RESPONSE_DEFAULT = 3986150789,
        VEHICLE_RESPONSE_ARMY_BASE = 317362887,
        VEHICLE_RESPONSE_COUNTRYSIDE = 2467847847,
        VEHICLE_SHOP_DLC_FILE = 3203173146,
        VEHICLE_VARIATION_FILE = 4226342447,
        VEHICLEEXTRAS_FILE = 2814482675,
        VehicleScale = 201238485,
        Velocity = 3642784282,
        version = 1757576755,
        VersionNumber = 1292187579,
        verts = 120498671,
        VFX_SETTINGS_FILE = 1765838387,
        VFXFOGVOLUMEINFO_FILE = 895306,
        VfxInfoName = 3527474215,
        VFXINTERIORINFO_FILE = 354822867,
        VFXPEDINFO_FILE = 962370952,
        VFXREGIONINFO_FILE = 3633596549,
        vfxregioninfo_default = 526963733,
        vfxregioninfo_desert = 1202232026,
        vfxregioninfo_beach = 4239901007,
        vfxregioninfo_slum = 4267832995,
        vfxregioninfo_woodland = 1397181648,
        vfxregioninfo_mountain = 3282595980,
        vfxregioninfo_countryside = 2691334223,
        vfxTagHashName = 1944993828,
        VFXVEHICLEINFO_FILE = 1918258814,
        vfxVehicleInfos = 1829968483,
        VFXWEAPONINFO_FILE = 1215743990,
        visibleMods = 33867712,
        //vlink87812 = 380604338,
        VMCP_DEFAULT = 1688385326,
        VMT_ARMOUR = 2031251422,
        VMT_BONNET = 1157831199,
        VMT_BRAKES = 2354237771,
        VMT_BUMPER_F = 3594621894,
        VMT_BUMPER_R = 2063293755,
        VMT_CHASSIS = 2275972991,
        VMT_CHASSIS2 = 2944517492,
        VMT_CHASSIS3 = 2694326177,
        VMT_CHASSIS4 = 2463042575,
        VMT_CHASSIS5 = 2742201586,
        VMT_DOOR_L = 3833672138,
        VMT_ENGINE = 154537048,
        VMT_ENGINEBAY1 = 3358404671,
        VMT_ENGINEBAY2 = 4274232691,
        VMT_ENGINEBAY3 = 3976067552,
        VMT_EXHAUST = 610039613,
        VMT_GEARBOX = 2500094337,
        VMT_GRILL = 2021558782,
        VMT_HORN = 100765382,
        VMT_HYDRO = 1330081664,
        VMT_ICE = 2442467387,
        VMT_INTERIOR1 = 4022516897,
        VMT_INTERIOR2 = 1135961221,
        VMT_INTERIOR3 = 829865992,
        VMT_INTERIOR4 = 675392926,
        VMT_INTERIOR5 = 368838931,
        VMT_KNOB = 676118374,
        VMT_LIVERY_MOD = 2724696322,
        VMT_PLAQUE = 671395830,
        VMT_PLTHOLDER = 1090914661,
        VMT_PLTVANITY = 1166632877,
        VMT_ROOF = 908701629,
        VMT_SEATS = 4033680966,
        VMT_SKIRT = 380480791,
        VMT_SPOILER = 1049675683,
        VMT_STEERING = 31361425,
        VMT_SUSPENSION = 3334458998,
        VMT_TRUNK = 514422827,
        VMT_WHEELS = 4228473823,
        VMT_WHEELS_REAR_OR_HYDRAULICS = 1919950653,
        VMT_WING_L = 3535906757,
        VMT_WING_R = 2323846985,
        vPos = 587040309,
        WantedLevel1 = 2416800515,
        WantedLevel2 = 1650825140,
        WantedLevel3 = 1939323416,
        WantedLevel4 = 1171840667,
        WantedLevel5 = 1195762037,
        WATER_FILE = 2413655090,
        Weak = 4041095418,
        WEAPON_ANIMATIONS_FILE = 3924289757,
        WEAPON_METADATA_FILE = 2179567645,
        WEAPON_SHOP_INFO_METADATA_FILE = 3762885521,
        WeaponAccuracy = 2027467678,
        WeaponAnimations = 4015456176,
        WeaponClipFilterId = 671807081,
        WeaponClipSetId = 2215753076,
        WEAPONCOMPONENTSINFO_FILE = 2246020636,
        WEAPONFX_FILE = 1805309100,
        WeaponImpulseMultiplier = 86352657,
        WEAPONINFO_FILE = 314037850,
        WEAPONINFO_FILE_PATCH = 4078051975,
        Weapons = 3632627376,
        WEATHER_FILE = 1275718771,
        WeatherTypes = 2541515394,
        weight = 2618193740,
        wheelBurnoutPtFxFricMult = 3985640029,
        wheelBurnoutPtFxTempMult = 4090549898,
        wheelBurstPtFxName = 2298765511,
        wheelBurstPtFxRange = 627010713,
        wheelDisplacementPtFxDispMult = 1903391014,
        wheelFirePtFxName = 1493987177,
        wheelFirePtFxRange = 2979062979,
        wheelFirePtFxSpeedEvoMax = 2074742492,
        wheelFirePtFxSpeedEvoMin = 88414520,
        wheelFrictionPtFxFricMult = 3344943153,
        WHEELFX_FILE = 797011099,
        wheelGenericDecalSet = 42119146,
        wheelGenericPtFxSet = 317708598,
        wheelGenericRangeMult = 3112058125,
        wheelLowLodPtFxScale = 3101484583,
        wheelName = 1946665057,
        wheelPuncturePtFxName = 3306375051,
        wheelPuncturePtFxRange = 1038999289,
        Wheels = 3527735923,
        wheelSkidmarkPressureMult = 3868991234,
        wheelSkidmarkRearOnly = 3924188767,
        wheelSkidmarkSlipMult = 1637659302,
        wheelVariation = 3934106566,
        Width = 2076102628,
        WindBendScale = 2639208686,
        WindBendVariation = 3427496475,
        window_lf = 4283577347,
        window_rf = 498851022,
        windowsWithExposedEdges = 2852673211,
        windscreen_r = 1088105007,
        wing_lf = 491509005,
        wing_rf = 3902761333,
        WORLD_HEIGHTMAP_FILE = 2667598674,
        WORLD_WATERHEIGHT_FILE = 2962141595,
        wreckedFire2OffsetPos = 3365413657,
        wreckedFire2PtFxDurationMax = 3958205758,
        wreckedFire2PtFxDurationMin = 934999495,
        wreckedFire2PtFxEnabled = 942100204,
        wreckedFire2PtFxName = 2665978636,
        wreckedFire2PtFxRadius = 1241381211,
        wreckedFire2UseOverheatBone = 1005799487,
        wreckedFire3OffsetPos = 1884074151,
        wreckedFire3PtFxDurationMax = 3291844506,
        wreckedFire3PtFxDurationMin = 2778506827,
        wreckedFire3PtFxEnabled = 1459332728,
        wreckedFire3PtFxName = 4213089658,
        wreckedFire3PtFxRadius = 19666915,
        wreckedFire3UseOverheatBone = 3745878980,
        wreckedFirePtFxDurationMax = 912287935,
        wreckedFirePtFxDurationMin = 1608647578,
        wreckedFirePtFxEnabled = 1538181140,
        wreckedFirePtFxName = 4220065034,
        wreckedFirePtFxRadius = 1064003341,
        x = 2466489829,
        X = 1252398387,
        xRotation = 712901235,
        y = 2157248776,
        Y = 953119110,
        yRotation = 3411163434,
        z = 3059772574,
        Z = 1848695880,
        zBias = 4001151357,
        ZONEBIND_FILE = 3024721823,
        zRotation = 1366235387,



































        //Shader params - casing issues now fixed here - see ShaderParamNames enum for cased versions!


        _dimensionlod2 = 2213330743,
        _fakedgrassnormal = 3847734030,
        _veccollparams = 1235110448,
        _vecvehcoll0b = 3443329873,
        _vecvehcoll0m = 2054776271,
        _vecvehcoll0r = 3676612388,
        _vecvehcoll1b = 3338172776,
        _vecvehcoll1m = 3731892311,
        _vecvehcoll1r = 1839679119,
        _vecvehcoll2b = 1542889970,
        _vecvehcoll2m = 298913216,
        _vecvehcoll2r = 3503557575,
        _vecvehcoll3b = 2492173731,
        _vecvehcoll3m = 2003587933,
        _vecvehcoll3r = 3129694622,
        _vecvehcollb = 4034110113,
        _vecvehcollm = 4084115603,
        _vecvehcollr = 2902956998,
        acceleration_delta = 4042077187,
        accumulationbuffersampler0 = 8230410,
        accumulationbuffersampler1 = 272905623,
        activeshadowcascades = 2747556057,
        adapdofproj = 711499858,
        adaplumsampler = 2600073949,
        adaptedlummax = 735476279,
        adaptedlummin = 120989687,
        adaptionparams = 994945211,
        adaptive = 2577319765,
        adaptivedofdepthdownsampleparams = 530741887,
        adaptivedofexposuresampler = 2063861440,
        adaptivedoffocusdistancedampingparams1 = 4192702981,
        adaptivedoffocusdistancedampingparams2 = 3918393682,
        adaptivedofoutputbuffer = 2655767810,
        adaptivedofparams0 = 1088399132,
        adaptivedofparams1 = 806028659,
        adaptivedofparams2 = 1767143429,
        adaptivedofparams3 = 2870836122,
        adaptivedofparamsbuffer = 209455569,
        adaptivedofsampler = 2098736783,
        adaptivedofsamplerdepth = 718794333,
        adapttime = 1514540018,
        airresist = 1208302886,
        alphaadjust = 1287606900,
        alphamaskmapsampler = 1705051233,
        alpharange = 1331056747,
        alphascale = 931055822,
        alphatest = 950204405,
        alphatestvalue = 3310830370,
        altremap = 285573515,
        ambientdecalmask = 3686186843,
        ambientlightingparams = 1614910597,
        ambientocclusioncontrast = 633061550,
        ambientoccsampler = 1212577329,
        animatednormalmapmask0sampler = 2630205212,
        animatednormalmapmask1sampler = 1838164585,
        animatednormalmapmask2sampler = 2257753125,
        animatednormalmapmod1 = 96407192,
        animatednormalmapmod2 = 326478341,
        anisonoisespecsampler = 2134197289,
        anisotropicalphabias = 363074471,
        anisotropicspecularcolour = 1673722929,
        anisotropicspecularexponent = 499953092,
        anisotropicspecularintensity = 401654871,
        aplanesampler = 1600333029,
        applydamagesampler = 1117905904,
        approxtangent = 3606611481,
        armourstrength = 3061795481,
        attenuationsampler = 483360323,
        averageluminanceout = 1654447808,
        avgluminancetexture = 1087818619,
        azimuthcolor = 360934156,
        azimuthcoloreast = 1882877478,
        azimutheastcolor = 1044876032,
        azimuthheight = 2649852765,
        azimuthstrength = 2824307566,
        azimuthtransitioncolor = 2670115477,
        azimuthtransitionposition = 2764855899,
        azimuthwestcolor = 1874413695,
        backbuffersampler = 3700325701,
        backbuffertexture = 3200056981,
        basesampler = 2669264211,
        basetexturesampler = 1399472831,
        bdebugdisplaydamagemap = 727005071,
        bdebugdisplaydamagescale = 1720897181,
        billboard = 552363713,
        blitsampler = 4098753311,
        bloodsampler = 1970149772,
        bloodsamplervs = 3796090472,
        bloodzoneadjust = 1011740581,
        bloomlum = 1959356754,
        bloomparams = 1213613006,
        bloomsampler = 1613750243,
        bloomsamplerg = 2187220839,
        bloomtexelsize = 3590118590,
        blueoff = 1614062594,
        blurintensity = 804387779,
        blursampler = 822703767,
        blurvignettingparams = 871768731,
        bokehalphacutoff = 1703140281,
        bokehbrightnessparams = 1737665654,
        bokehenablevar = 643379889,
        bokehglobalalpha = 1022881476,
        bokehnumaddedtobuckets = 2514924683,
        bokehparams1 = 3945388007,
        bokehparams2 = 4184896628,
        bokehpointbuffer = 2084769495,
        bokehsortedindexbuffer = 1533187666,
        bokehsortedlistbuffer = 201662228,
        bokehsortlevel = 2314931517,
        bokehsortlevelmask = 1605336858,
        bokehsorttransposematheight = 3470273647,
        bokehsorttransposematwidth = 821002802,
        bokehspritepointbuffer = 170997925,
        bottomskycolour = 161676916,
        boundradius = 2230834649,
        branchbendpivot = 892666959,
        branchbendstiffnessadjust = 3894262326,
        brightness = 26603225,
        brightnesssetting = 303513935,
        brighttonemapparams0 = 118691255,
        brighttonemapparams1 = 1904208559,
        brokenbumpsampler = 2033191777,
        brokencolor = 2817208061,
        brokendiffusecolor = 878330249,
        brokendiffusesampler = 3349868497,
        brokenglasstilescale = 1356197901,
        brokenspecularcolor = 1359397883,
        brokenspecularsampler = 3872409448,
        bumpiness = 4134611841,
        bumpsampler = 1186448975,
        bumpsampler_layer0 = 1073714531,
        bumpsampler_layer1 = 1422769919,
        bumpsampler_layer2 = 2745359528,
        bumpsampler_layer3 = 2975430677,
        bumpsampler_layer4 = 2417505683,
        bumpsampler_layer5 = 3720106230,
        bumpsampler_layer6 = 4091379000,
        bumpsampler2 = 1893875305,
        bumpsamplerfur = 2030333799,
        bumpselfshadowamount = 2907460320,
        burnoutlimit = 2048742054,
        cbplanesampler = 1648690748,
        chromabparam = 2243268978,
        clearcol = 2021704599,
        clippingplane = 1632555383,
        clipplanes = 4225498643,
        clothdarken = 4285790447,
        clothdarkencolor = 2192646550,
        clothparentmatrix = 2335024113,
        clothsweatmapsampler = 1059055951,
        clothsweatspec = 2469844039,
        cloudbasecolour = 2670795993,
        cloudbaseminusmidcolour = 207551193,
        cloudbias = 1077109597,
        cloudbillboardparams = 1372983410,
        cloudcolor = 3245908258,
        cloudconstants1 = 1542931277,
        cloudconstants2 = 1848698816,
        cloudconstants3 = 3972097247,
        clouddetailconstants = 2178269534,
        cloudfadeout = 1796923256,
        cloudinscatteringrange = 1590938598,
        cloudlayeranimscale1 = 2699058131,
        cloudlayeranimscale2 = 2904978527,
        cloudlayeranimscale3 = 1697604722,
        cloudmidcolour = 3120184161,
        cloudshadowcolour = 2429466598,
        cloudshadowminusbasecolourtimesshadowstrength = 3681751999,
        cloudshadowoffset = 1192276656,
        cloudshadowstrength = 3469302040,
        cloudthicknessedgesmoothdetailscalestrength = 2448643918,
        cloudthreshold = 2011404587,
        clumpbump = 620873514,
        cocoutputtexture = 561614071,
        colorcorrect = 1418724964,
        colorcorrecthighlum = 1002641818,
        colorfringeparams1 = 1315010326,
        colorfringeparams2 = 94922157,
        colorhighlum = 3178323397,
        colorlowlum = 4274011020,
        colorlum = 819694290,
        colorsampler = 3918882525,
        colorscaler = 2433112487,
        colorshift = 3269836664,
        colorshiftlowlum = 2775271800,
        colorshiftscalar = 2106064165,
        colortexture = 934209648,
        comboheightsamplerfur = 455740840,
        comboheightsamplerfur01 = 1709265783,
        comboheightsamplerfur2 = 374924583,
        comboheightsamplerfur23 = 2930074258,
        comboheightsamplerfur3 = 2760212866,
        comboheightsamplerfur4 = 4056161278,
        comboheightsamplerfur45 = 2509158229,
        comboheightsamplerfur67 = 1396547512,
        comboheighttexmask = 285679314,
        contrast = 699508084,
        convertsampler = 4959160,
        coronasdepthmapsampler = 3603235271,
        crackdecalbumpalphathreshold = 3343925161,
        crackdecalbumpamount = 2155296103,
        crackdecalbumptilescale = 730767419,
        crackedgebumpamount = 3420190257,
        crackedgebumptilescale = 492538267,
        crackleintensity = 1771354266,
        cracklesampler = 1774790613,
        crackmatrix = 2644409350,
        crackoffset = 2214698276,
        cracksampler = 3328498618,
        crplanesampler = 3915834095,
        cubeface = 2567801214,
        curlumsampler = 3431586341,
        currentdoftechnique = 3543504858,
        currentlum = 968818364,
        currentresolution = 4182813263,
        curvecoeffs = 2763646717,
        damagedwheeloffsets = 1348413520,
        damagemultiplier = 378227101,
        damagesampler = 3579349756,
        damagespectexturesampler = 3820652825,
        damagetextureoffset = 4318529,
        damagetexturesampler = 4132715990,
        damagevertbuffer = 2811144871,
        darktonemapparams0 = 1554855265,
        darktonemapparams1 = 780523795,
        deathintensity = 2219791851,
        deathsampler = 4146990968,
        debugcloudsparams = 580885775,
        debuglightcolour = 227690714,
        decalsampler = 2811948736,
        decaltint = 3092072610,
        decorationframeinfo = 3729783099,
        decorationtattooadjust = 1578586549,
        decorationtintpalettesel = 2448945809,
        decorationtintpalettetexsampler = 4286164294,
        deferredlightdownsampledepthsampler = 110250107,
        deferredlightparams = 1690620309,
        deferredlightscreensize = 3811483225,
        deferredlightvolumeparams = 2130744975,
        deferredperspectiveshearparams0 = 3433855881,
        deferredperspectiveshearparams1 = 61303170,
        deferredperspectiveshearparams2 = 4125937165,
        deferredprojectionparams = 424764587,
        deferredvolumecolour = 2115695095,
        deferredvolumedepthbuffersamp = 3381865158,
        deferredvolumedirection = 3203966112,
        deferredvolumeposition = 1009422528,
        deferredvolumeshaftcompositemtx = 3101393666,
        deferredvolumeshaftgradient = 404580226,
        deferredvolumeshaftgradientcolourinv = 1067440921,
        deferredvolumeshaftplanes = 3122758957,
        deferredvolumetangentxandshaftradius = 1118228408,
        deferredvolumetangentyandshaftlength = 4283942594,
        densitysampler = 3828368598,
        depthblurhalfressampler = 2333753907,
        depthblurhalfrestexture = 2638246296,
        depthblursampler = 979379647,
        depthblurtexture = 4038110621,
        depthbuffer = 3447665758,
        depthbuffer2 = 1908423578,
        depthbuffer2_sampler = 720934291,
        depthbuffersamp = 2492728818,
        depthbuffersampler = 3497598060,
        depthmappointsampler = 4215380418,
        depthmapsampler = 847477652,
        depthmaptexsampler = 2784473838,
        depthsampler = 383876435,
        depthsourcesampler = 2578937463,
        depthtexture = 4088842947,
        depthtexturems = 4134029566,
        desatcontrastgamma = 1070958827,
        desaturate = 2639337807,
        desaturatetint = 2511699259,
        detailbumpiness = 1675037470,
        detailbumpsampler = 143227613,
        detaildensity2sampler = 2587222892,
        detaildensitysampler = 2270155403,
        detailmapoffset = 3032413960,
        detailmapsampler = 1041827691,
        detailmapuscale = 489333004,
        detailmapvscale = 2830921123,
        detailnormal2sampler = 2004179855,
        detailnormalsampler = 2903840997,
        detailoffset = 2002782257,
        detailsampler = 3393362404,
        detailsettings = 3038654095,
        detailuvscale = 3418497265,
        diffuse2specmod = 1788442252,
        diffusecol = 1517692383,
        diffuseextrasampler = 58635929,
        diffusehfsampler = 2946270081,
        diffusemod = 1685953011,
        diffusenobordertexsampler = 1732587965,
        diffusesampler = 4059966321,
        diffusesampler2 = 181641832,
        DiffuseSampler3 = 1429813046, //thanks CP
        diffusesamplerfur = 1282320680,
        diffusesamplerphase2 = 3227619449,
        diffusesamplerpoint = 4015001285,
        diffusesplattertexsampler = 1412546033,
        diffusetexsampler = 3004704155,
        diffusetexsampler01 = 255045494,
        diffusetexsampler02 = 2707084226,
        diffusetexsampler03 = 2981196911,
        diffusetexsampler04 = 3291650421,
        diffusetextileuv = 2816002123,
        diffusewoundtexsampler = 3758481220,
        diffusionradius = 4024070401,
        dimmerset = 1523312743,
        dimmersetpacked = 4182305072,
        directionalmotionbluriterparams = 2777949533,
        directionalmotionblurlength = 544111294,
        directionalmotionblurparams = 3408424243,
        dirtcolor = 1146381126,
        dirtdecalmask = 1050016400,
        dirtlevel = 47191856,
        dirtlevelmod = 3961814809,
        dirtsampler = 2124031998,
        DirtBumpSampler = 3157820509,//thanks CP
        diskbrakeglow = 1035405954,
        displparams = 1163050293,
        distancemapsampler = 1616890976,
        distepsilonscalemin = 1163639717,
        distmapcenterval = 1612602645,
        distortionparams = 2957679312,
        distortionsampler = 342449994,
        dithersampler = 612917610,
        dofblur = 731686132,
        dofblurweight = 706444485,
        dofdist = 3329041621,
        dofinten = 3552457075,
        dofnoblurblendringsize = 413916545,
        dofnoblurradius = 108398598,
        dofoutputtexture = 3487236658,
        dofproj = 2305108861,
        dofprojcompute = 2729164810,
        dofrendertargetsize = 3995371223,
        dofsampler = 2614429576,
        dofshear = 1387749709,
        dofskyweightmodifier = 1603770318,
        doftargetsize = 3565962906,
        downsampleddepthsampler = 2057740952,
        downsampledepthsampler = 498175796,
        dpmapfarclip = 3395601267,
        dpmapnearclip = 479573217,
        drawbucket = 514782960,
        dreflectionparams = 153627866,
        droopparams = 2926981594,
        druggedeffectcolorshift = 4028255612,
        druggedeffectparams = 858398664,
        dshadowmatrix = 3423656318,
        dshadowoffsetscale = 930807775,
        dshadowparam0123 = 3916656767,
        dshadowparam4567 = 584100066,
        dshadowparam891113 = 1698928349,
        dsttexturesize = 45365902,
        eaaparams2 = 1422359808,
        earlyout = 3422479905,
        earlyout_sampler = 2971523439,
        earlyoutparams = 141437565,
        eastcolor = 1417575779,
        edgemarkparams = 717226593,
        edgethreshold = 2670218238,
        edgethresholdmin = 316543927,
        effectsconstants = 1179101422,
        elapsedtime = 4152310215,
        emissivemultiplier = 1592520008,
        emissivereflectmultiplier = 1347035993,
        emitterparamlifeandspeed = 1295421465,
        emitterparampos = 2286595424,
        emitterparamposrange = 3505097448,
        emitterparamprobablityphase2 = 1652433309,
        emittertransform = 2216438402,
        emittervelocityboxpos = 1027158774,
        emittervelocityboxrange = 3202652030,
        envbloodbinormal = 304838968,
        envblooddata = 2241230170,
        envbloodpos = 3704052925,
        envbloodsampler = 3616483953,
        envbloodtangent = 1134317228,
        envefffatthickness = 436649803,
        enveffscale = 2431974683,
        envefftextileuv = 3670603239,
        enveffthickness = 2702504809,
        environmentsampler = 3317411368,
        exposure = 2538078618,
        exposureclampandhistory = 2911392042,
        exposurecurve = 1836476954,
        exposureparams0 = 2329380491,
        exposureparams1 = 1031924697,
        exposureparams2 = 1253836365,
        exposureparams3 = 301405380,
        exposures = 2947662557,
        exposureswitches = 1784826898,
        facetexturesampler = 624309278,
        facetmask = 4034105764,
        fade_thickness = 205855514,
        fadealphadist = 4164097433,
        fadealphadistumtimer = 3637887135,
        fadealphalod1dist = 3563207876,
        fadealphalod2dist = 1294165969,
        fadealphalod2distfar0 = 4248689351,
        fage = 2063122051,
        falloffandkernelparam = 1703468999,
        fillcolor = 3014106266,
        filmic0 = 2611530409,
        fintensity = 847954571,
        flowsampler = 1214194352,
        foamsampler = 3266349336,
        fogcolor = 3922291195,
        fogparams = 1243028310,
        fograytexsampler = 1487203018,
        fogsampler = 2568933054,
        fogvolumecolor = 2907231751,
        fogvolumedepthsampler = 1087981784,
        fogvolumeinvtransform = 786602411,
        fogvolumeparams = 10424280,
        fogvolumeposition = 2937842810,
        fogvolumetransform = 1406518664,
        foliagebranchbendpivot = 353881103,
        foliagebranchbendstiffnessadjust = 3429332683,
        fontnormalsampler = 3140496408,
        fontnormalscale = 91417371,
        fontsampler = 2048139100,
        fonttexture = 3394800319,
        fourplanedof = 2764191939,
        fpvmotionblursize = 1677050762,
        fpvmotionblurvelocity = 4116905408,
        fpvmotionblurweights = 4038439571,
        framemap = 1835157646,
        framemaptexsampler = 507369750,
        frequency1 = 2441536523,
        frequency2 = 2219624855,
        fresnelrolloff = 3796399242,
        fullsampler = 3157511856,
        furalphaclip03 = 290288684,
        furalphaclip47 = 4280570754,
        furalphadistance = 4141869331,
        furaoblend = 4026629301,
        furattencoef = 2491165204,
        furbendparams = 3489000159,
        furditheralphafadeparams = 3407922321,
        furglobalparams = 443249107,
        furlayerparams = 1122745807,
        furlayerparams2 = 3825466177,
        furlayerparams3 = 1668577832,
        furlayerstep = 1208356461,
        furlength = 1430134069,
        furmasksampler = 3794875320,
        furmaxlayers = 253873259,
        furminlayers = 3007864804,
        furnoiseuvscale = 1008743034,
        furnumlayers = 110936794,
        furselfshadowmin = 3093266608,
        furshadow03 = 1104745269,
        furshadow47 = 711397225,
        furstiffness = 2137279259,
        furuvscales = 897751165,
        g_alphafade = 1960511459,
        g_bloodcolor = 985986992,
        g_bloodsplatparams = 1621619881,
        g_cpqsmix_qsfadein = 2799702011,
        g_currentvalue = 1312005277,
        g_edgehighlightcolour = 1596321467,
        g_f4rtsize = 4169783008,
        g_fbilateralcoefficient = 2015612345,
        g_fbilateraledgethreshold = 2771898508,
        g_fcollisionsqscale = 731874660,
        g_fenablespringforces = 2189248122,
        g_fgrassspringrigidity = 3152689414,
        g_fgrassspringscale = 2339438728,
        g_fripplerainstrength = 2044767128,
        g_fssaobilateralcoef = 145680953,
        g_fssaokernelscale = 3370811738,
        g_fvolumetriclightrayintensitymult = 3709677333,
        g_gbuffertexture3param = 3145202593,
        g_ghostlevel = 1563742563,
        g_hdao_params1 = 1535730194,
        g_hdao_params2 = 3676889419,
        g_hdaoapplyparams = 2705555169,
        g_hdaocomputeparams = 2528000437,
        g_hdaoextraparams = 3628503020,
        g_hdaovalleyparams = 1466262319,
        g_highlightscale = 1705698884,
        g_impostersize = 786569893,
        g_lightningstrikenoiseparams = 390679343,
        g_lightningstrikeparams = 3780586083,
        g_linearclampsampler = 2261256735,
        g_msaapointtexture1_dim = 3319333866,
        g_msaapointtexture2_dim = 3715862146,
        g_occlusiontextureparams = 4007914843,
        g_pointsampler = 3230386348,
        g_projparams = 360593454,
        g_projshear = 1833194361,
        g_puddle_scalexy_range = 529156535,
        g_puddleparams = 3536830402,
        g_resulttexture = 3349637075,
        g_ssaostrength = 1519496158,
        g_targetsize = 1149055682,
        g_textcolour = 3414941892,
        g_textshadowcolour = 3326514923,
        g_textshadowscale = 828975922,
        g_vcollisionparams = 390873962,
        g_vcollisionspheres = 2187899533,
        g_vplayerposition = 148353768,
        g_vrelativeluminancethresholdparams = 1353171807,
        g_vrippleattributes = 1686992389,
        g_vrippletexelsize = 2041279531,
        g_vtexelsize = 1568580394,
        g_wavexoffset = 2340128792,
        g_wavexzoom = 1940934038,
        g_waveyzoom = 936340354,
        g_widthscalar = 1482315230,
        gactiveunit = 247068080,
        galaxyoffset = 2261454336,
        galaxysampler = 304699295,
        galphacutoffminmax = 3012586280,
        galphatest = 2215224122,
        galphatocoveragescale = 955152299,
        gambientamount = 862548646,
        gambientcolor = 2502793579,
        gambientmult = 2621865253,
        gambientshadow = 1730637860,
        gamma = 1617619096,
        gammacorrection = 2923835982,
        ganimatednormalmapparams = 1356180523,
        ganimblendweights = 3438696362,
        ganimcombine = 4162938569,
        ganimsculpt = 732819097,
        gaussianweights = 3546535582,
        gbackgrounddistortionalphabooster = 1266153517,
        gbackgrounddistortionamount = 2358946644,
        gbackgrounddistortionvisibilitypercentage = 1950755416,
        gbiastocamera = 969255365,
        gblitmatrix = 1903406607,
        gblooddata = 2470245206,
        gblooduvboundspage = 318462180,
        gbluramount = 2372939986,
        gbonedamage0 = 493675041,
        gbonedamageenabled = 3445557846,
        gbouncecolor = 3285219193,
        gboxcentrepos = 1213320064,
        gboxforward = 2141719324,
        gboxright = 3950477470,
        gboxsize = 4157270760,
        gbufferstenciltexturesampler = 34323572,
        gbuffertexture0 = 1370576551,
        gbuffertexture2 = 989669695,
        gbuffertexturedepth = 3214151316,
        gbuffertexturesampler0 = 3101514270,
        gbuffertexturesampler1 = 1931628197,
        gbuffertexturesampler2 = 1601349446,
        gbuffertexturesampler3 = 394499945,
        gbuffertexturesamplerdepth = 3001958741,
        gbuffertexturesamplerssaodepth = 566345585,
        gcableparams = 3557855020,
        gcamanglelimits = 1391293880,
        gcamerabias = 481136556,
        gcameradistanceatmaxdisplacement = 894396470,
        gcamerapos = 130109679,
        gcameraposition = 3861036523,
        gcamerashrink = 196757553,
        gclipplanes = 993087185,
        gcloudcolor = 3349623462,
        gcloudviewproj = 1388118204,
        gcollisionlifemodifier = 28882798,
        gcollisionpositionmodifier = 1413333801,
        gcollisionvelocitymodifier = 2917041400,
        gcolortint = 1945696018,
        gcolortintphase2 = 3971978241,
        gcolour = 819380429,
        gcoloursplash = 2769897443,
        gcontrollight = 1458962865,
        gcrossfadedistance = 2123742775,
        gcsmparticleshadowsamp = 18467538,
        gcsmparticleshadowtexture = 1879733647,
        gcsmshadervars_deferred = 4041368736,
        gdaynightscale = 2033466401,
        gdecalchannelselection = 129604674,
        gdecalnormalsampler = 353477773,
        gdecalsampler = 2317915042,
        gdeferredinverseviewprojmatrix = 3129339935,
        gdeferredlightcolourandintensity = 3618208763,
        gdeferredlightconeangle = 1457978794,
        gdeferredlightconeanglei = 3706722404,
        gdeferredlightconeoffset = 2681954581,
        gdeferredlightconescale = 3587849890,
        gdeferredlightdirection = 3096160936,
        gdeferredlightinvsqrradius = 1076369960,
        gdeferredlightposition = 3515628483,
        gdeferredlightradius = 771816156,
        gdeferredlightradiusprojshearparams = 507484242,
        gdeferredlightsampler = 1527752693,
        gdeferredlightsampler0p = 3029377315,
        gdeferredlightsampler1 = 575604989,
        gdeferredlightsampler2 = 1424289320,
        gdeferredlightshadowmap0 = 2826529087,
        gdeferredlightshadowmap1 = 2589969676,
        gdeferredlightshadowmap2 = 2224923016,
        gdeferredlightshadowmap3 = 1962213943,
        gdeferredlightshaftparams = 2784101259,
        gdeferredlighttangent = 3997363695,
        gdeferredlighttype = 874695930,
        gdeferredlightvolumeparams = 371509596,
        gdeferredprojparams = 1174638206,
        gdeferredvolumeradiusscale = 3037897088,
        gdensityshiftscale = 3043875162,
        gdepthviewprojmtx = 512139429,
        gdiffuse = 1220611861,
        gdirectional = 2203405262,
        gdirectionallightshadowamount = 3920559848,
        gdirectionalmotionblurlength = 2219759593,
        gdirectionalmult = 4000928118,
        gdirectionalvelocityadd = 1608450430,
        gdirectionalzoffsetminrange = 955747368,
        gdirnormalbias = 1480114695,
        gdispersalsettings = 570820137,
        gdistancescale = 3645463202,
        geastminuswestcolor = 2332609458,
        gedgesoftness = 867642987,
        generalparams0 = 3458676571,
        generalparams1 = 3166540936,
        gextralightmult = 3645170126,
        gextralights = 2849007823,
        gextraparams0 = 1363351178,
        gextraparams1 = 3423931440,
        gextraparams2 = 4223069043,
        gextraparams3 = 3907306959,
        gextraparams4 = 2518327352,
        gfadeinout = 1682568218,
        gfadenearfar = 1244256289,
        gfadezbaselohi = 542136670,
        gfirsttimeupdate = 92947686,
        gfogcompositeambientcolor = 2918893733,
        gfogcompositedirectionalcolor = 646659969,
        gfogcompositeparams = 3080532465,
        gfogcompositetexoffset = 1705135815,
        gfrustumparameters = 1069442784,
        ggrassskipinstance = 3294601711,
        ggravitywindtimestepcut = 2189578124,
        ggustamplifier = 1813609204,
        ggustspacing = 2572448010,
        ghdrexposure = 1986583430,
        gheathaze = 1822868744,
        gheathazeripplelength = 1850681702,
        gheathazeripplerate = 3558453078,
        gheathazescale = 3312170287,
        gheathazesize = 1319873596,
        gheathazewidth = 3133152963,
        gheatphase = 2721110750,
        ghitplane = 3729639013,
        ghorizscale = 2467525454,
        ghybridaddratio = 3504408232,
        ginstancevars = 3432648184,
        ginstcullparams = 3871720938,
        gintensity = 3311833552,
        ginterpolationfactor = 1392131636,
        gisshadowpass = 1999109769,
        glifefade = 1079477869,
        glifeminmaxclamptoground = 3942952480,
        glifetimescale = 3294686231,
        glightintensityclamp = 4186188647,
        glightintensitymult = 1884220195,
        glightsettings = 1029904424,
        globalanimuv0 = 3617324062,
        globalanimuv1 = 3126116752,
        globalfograyfadeparam = 1248095708,
        globalfograyparam = 1620085657,
        globalfreeaimdir = 3943027507,
        glocallightsmultiplier = 4293612306,
        glodfadecontrolrange = 4185950307,
        glodfadepower = 2662986932,
        glodfaderange = 3264171975,
        glodfadestartdist = 1949054155,
        glodfadetilescale = 1082098581,
        glodinstanttransition = 596864795,
        glodthresholds = 979130770,
        glowresdepthsampler = 2824212180,
        glowresdepthtexture = 3015483598,
        gmaxdisplacement = 1164495840,
        gmaxlife = 3970444018,
        gmirrorbounds = 1887204037,
        gmirrorcrackamount = 1562064116,
        gmirrorcracksampler = 2984091644,
        gmirrordebugparams = 496893366,
        gmirrordistortionamount = 987148199,
        gmotionblur = 294407736,
        gnearfarqmult = 2513511302,
        gnormalarc = 808788377,
        gnormalheight = 3146080364,
        gnormalmapmult = 3282331164,
        gnormaloffset = 2355039984,
        gnormalscale = 2365712398,
        gnumclipplanes = 828848872,
        goffsetparticlepos = 842278893,
        goffsetscale0 = 70492586,
        goffsetscale1 = 428526680,
        goldfactor = 358396505,
        goldfresnelrolloff = 295546023,
        goldreflectcolorbase = 2396384524,
        goldreflectcoloroverlay = 2603016628,
        goldreflectivepower = 2990597200,
        goldspecmapintmask = 1333698176,
        goldspecularfactor = 435211370,
        golftrailtexturesamp = 241657115,
        goodeferredlightscreensize = 3073062802,
        gorienttoterrain = 3165461554,
        gparticlecolorpercentage = 1853363478,
        gparticletexturesize = 2550169896,
        gperspectiveshearparams0 = 2149148446,
        gperspectiveshearparams1 = 509977564,
        gperspectiveshearparams2 = 263128687,
        gpiercinglightpower_strength_normalstrength_thickness = 2302032860,
        gpositionoffset = 2734209203,
        gpositionscale = 4212665338,
        gpower = 1384422613,
        gprevviewproj = 1120562824,
        gprojparams = 2311871851,
        gradientfiltercolbottom = 3762433606,
        gradientfiltercolmiddle = 1794637696,
        gradientfiltercoltop = 4015194706,
        gradius = 526220184,
        graindebug = 1247076385,
        gravitydroop = 3181978688,
        greenoff = 3283681954,
        greflscales = 1520419346,
        grefparticlepos = 2705128804,
        grefraction = 2643069888,
        grescaleuv1 = 724216589,
        grescaleuv2 = 2046871736,
        grescaleuv3 = 2259804698,
        gresetparticles = 2831259018,
        grg_blendenddistance = 3347456804,
        grg_blendstartdistance = 4179423620,
        grotationcenter = 2718167535,
        grotspeedminrange = 3733294048,
        groundcolor = 3169191053,
        gscalediffusefillambient = 397913198,
        gscalefade = 3144708943,
        gscalerange = 4248652172,
        gscatterg_gsquared_phasemult_scale = 987241318,
        gshadowamount = 3297538021,
        gsizeminmax = 1571728947,
        gsizeminrange = 3419056622,
        gskycolor = 3328933361,
        gsoftness = 2874180382,
        gsoftnesscurve = 2667435005,
        gsoftnessshadowmult = 2718764463,
        gsoftnessshadowoffset = 2710273761,
        gsoftparticlerange = 3901093204,
        gspecularexponent = 3204977572,
        gspecularintensity = 247886295,
        gsplashframes = 944333453,
        gsplashsizeminmax = 4062424283,
        gsuncolor = 3007207522,
        gsundirection = 2009439163,
        gsuperalpha = 1225534059,
        gsurfacesettings = 3834090438,
        gtaskydomeclip = 964033580,
        gtaskydomefade = 826009472,
        gtawatercolor = 4280744704,
        gtexcoordscaleoffset0 = 3099617970,
        gtexcoordscaleoffset1 = 2745647232,
        gtexcoordscaleoffset2 = 2499388197,
        gtexcoordscaleoffset3 = 2456002041,
        gtextureanglerads = 241993590,
        gtextureanimation = 20918084,
        gtextureanimratescaleoverlifestart2end2 = 3412279679,
        gtexturerowscols = 1276450911,
        gtexturerowscolsstartend = 1241308942,
        gtotallifetimescale = 2824822244,
        gusecomputeshaderoutputbuffer = 1009029736,
        gusedirectional = 1281964389,
        guseshadows = 345674786,
        guvoffset = 3300015766,
        guvoffset1 = 2565276602,
        guvoffset2 = 2325899053,
        guvoffset3 = 3510465638,
        gvelocitymax = 3037552071,
        gvelocitymin = 507774218,
        gvertscale = 1074904593,
        gviewproj = 4124209033,
        gvolumelightssampler = 1687175937,
        gvolumelightstexture = 2884407863,
        gwaterheight = 446050918,
        gwestcolor = 3223173913,
        gwindbasevel = 3813992546,
        gwindbendingglobals = 709598663,
        gwindbendscalevar = 2552738797,
        gwindgustvel = 2099280216,
        gwindmultparams = 982613925,
        gwindparams = 3536772057,
        gwindvariancevel = 2216170969,
        gworldbinormal = 2267341197,
        gworldinstanceinversetranspose = 1914807,
        gworldinstancematrix = 981286173,
        gworldtangent = 1317093162,
        gwrapbias = 1858190163,
        gwraplighting = 75905342,
        gwraplighting_msaaref = 833328952,
        gwrapscale = 3087563039,
        gzdampen = 2165766204,
        hardalphablend = 3913511942,
        hdrcolortexture = 2362960420,
        hdrexposure = 3039323892,
        hdrexposureclamp = 1487577326,
        hdrintensity = 4136287658,
        hdrintensitymultiplier = 1498595219,
        hdrpointsampler = 3702694755,
        hdrsampler = 1709735268,
        hdrsunexposure = 81989056,
        hdrtextureaa = 2769796592,
        heathazeoffsetparams = 234272229,
        heathazeparams = 3041693270,
        heathazesampler = 2900829390,
        heathazetex1params = 157461750,
        heathazetex2params = 3686416465,
        heightbias = 330974467,
        heightbias0 = 537974167,
        heightbias1 = 820082484,
        heightbias2 = 3378489398,
        heightbias3 = 3161525849,
        heightfogparams = 4202365273,
        heightmapsampler = 1008099585,
        heightmapsamplerlayer0 = 781078585,
        heightmapsamplerlayer1 = 2570495372,
        heightmapsamplerlayer2 = 2346748640,
        heightmapsamplerlayer3 = 2242969217,
        heightmaptransformmtx = 1556799447,
        heightopacity = 2935469584,
        heightsampler = 4049987115,
        heightscale = 947222050,
        heightscale0 = 2807156689,
        heightscale1 = 1898472319,
        heightscale2 = 2178811114,
        heightscale3 = 1536800866,
        heighttexture = 4152773162,
        hemi_bias = 3477916617,
        hemi_near = 4068871657,
        hemi_params = 3188015657,
        hemi_range = 2843854391,
        hemi_res = 3411758646,
        hemicubesampler = 145567721,
        hidofmiscparams = 851407070,
        hidofparams = 3302089350,
        highdetailnoisebumpsampler = 1044331566,
        highdetailnoisesampler = 3822359214,
        highdetailsampler = 860147427,
        highlum = 737146002,
        history = 2023011857,
        hmdwarpparam = 4161661017,
        horizonlevel = 403229780,
        hybridadd = 4234023609,
        hybridaddratio = 1902453223,
        imagefxparams = 3775812724,
        importancebuffersampler = 1983941369,
        imposterdir = 15105794,
        impostersampler = 4013138833,
        imposterworldx = 3187870439,
        imposterworldy = 3495145352,
        imposterworldz = 4037865530,
        initpositiontexsampler = 867916958,
        initvelocitytexsampler = 3796043845,
        inputtex = 2352384719,
        instancebuffer = 571392628,
        interlaceindex = 92545662,
        interlacemapsampler = 4281682490,
        interlacetotalnum = 1200425084,
        intermediatetarget = 2216618306,
        intermediatetarget_sampler = 1179275796,
        intermediatetargetaa = 2580729000,
        jittersampler = 887426944,
        kernelparam = 348424870,
        kernelradius = 1819724113,
        killflashcol = 1705946031,
        killflashuvoff = 1449898229,
        lasersampler = 3973852449,
        laservisibilityminmax = 2050561467,
        lastbuffersize = 878694393,
        lensartefactsparams0 = 1487316152,
        lensartefactsparams1 = 870406958,
        lensartefactsparams2 = 1165295189,
        lensartefactsparams3 = 263361233,
        lensartefactsparams4 = 2409501354,
        lensartefactsparams5 = 1794558296,
        lenscenter = 163655085,
        lensdistortionparams = 705844615,
        letterindex1 = 1794007338,
        letterindex2 = 865825409,
        lettersize = 1497980819,
        licenseplatefontextents = 3015810411,
        licenseplatefonttint = 1846736030,
        lightcolor = 1945364554,
        lightdir = 1608210580,
        lightocclusionsampler = 3039301469,
        lightrayparams = 912013868,
        lightrayparams2 = 3575716412,
        lightstreaksblurdir = 2085391682,
        lightstreakscolorshift0 = 4082051348,
        linearsampler = 2135833848,
        linearsampler1 = 4052371224,
        linearsampler2 = 2627575128,
        linearwrapsampler = 681732347,
        linearwrapsampler2 = 1379901712,
        linearwraptexture3 = 4011882001,
        lookupsampler = 2295086480,
        lowlum = 2175272747,
        lowresdepthmappointsampler = 1894550764,
        lowresdepthpointmap = 4131434726,
        lumfilterparams = 2120745528,
        luminanceconstants = 2215984599,
        luminancedownsampleoosrcdstsize = 1869154352,
        lunarcycle = 3166975708,
        manualdepthtest = 2024632841,
        maskalphareverse = 3046988116,
        masktexturesampler = 2110569141,
        matdiffusecolor = 408880252,
        matdiffusecolor2 = 1577977996,
        matdiffusecolortint = 99676333,
        materialdiffuse = 424198508,
        materialidsampler = 892830080,
        materialwetnessmultiplier = 3170143313,
        matgrasstransform = 72771513,
        matmaterialcolorscale = 2492093682,
        matwheeltransform = 2829072482,
        matwheelworld = 3178367768,
        matwheelworldviewproj = 2078334811,
        mbperspectiveshearparams0 = 1033188477,
        mbperspectiveshearparams1 = 2555242989,
        mbperspectiveshearparams2 = 2292140688,
        mbprevviewprojmatrixw = 556540040,
        mbprevviewprojmatrixx = 2198692937,
        mbprevviewprojmatrixy = 2433876050,
        mipmaplod = 482766300,
        mirrorintensity = 2215660639,
        mirrornormalintensity = 1531688027,
        mirrorparams = 2538518895,
        mirrorreflectionskyintensity = 3525553109,
        mirrorspecmaskintensity = 2901241109,
        mlaaarealutsampler = 2609019681,
        mlaalinearsampler = 655764451,
        mlaapointsampler = 1645524956,
        mooncolor = 2213576281,
        mooncolorconstant = 2616626323,
        moondirection = 3484629706,
        moonglow = 2037987613,
        moonglowsampler = 2151873246,
        moonintensity = 2342189917,
        moonlight = 2593156215,
        moonposition = 124803246,
        moonsampler = 1534106922,
        moontexconvert = 1796762296,
        moontexposition = 1128557715,
        moonvisiblity = 3257982346,
        moonxvector = 1764174018,
        moonyvector = 3157759019,
        motionblurmatrix = 2950235179,
        motionblursampler = 3974544708,
        mp_bullettimeparams = 51894946,
        msaapointsampler1 = 3816347419,
        msaapointtexture1 = 750933622,
        msaapointtexture2 = 989590249,
        nearfarclip = 1899734512,
        noise1sampler = 3941892287,
        noise2sampler = 215717268,
        noisedensityoffset = 3780934309,
        noisefilterarea = 1418684055,
        noisefrequency = 1364176943,
        noisehighlum = 3113827561,
        noiselowlum = 3302331435,
        noiselum = 1493025892,
        noisemapsampler = 2678081716,
        noiseparams = 2296796634,
        noisephase = 1916643725,
        noisesampler = 2461808165,
        noisescale = 4186750186,
        noisesoftness = 984327287,
        noisetexsampler = 651303591,
        noisetexture = 1661149109,
        noisetexturesampler = 4127640691,
        noisethreshold = 188180875,
        noisewarp = 1708817206,
        normalbuffer = 3727614344,
        normalbuffersamp = 3334794412,
        normalmapblendratio = 432051653,
        normalmapmod = 1363116819,
        normalmapsampler = 860923645,
        normalmapsampler1 = 225912280,
        normalmapsampler2 = 4224746123,
        normalmaptexsampler = 2007347265,
        normalsampler = 2327911600,
        normalspecmaptexsampler = 2275171214,
        normaltexture = 3453458978,
        normaltexturesampler = 53266845,
        normbuffersampler = 2450983583,
        normfresnelrolloff = 469438475,
        normreflectivepower = 99909810,
        normspecmapintmask = 4286481776,
        normspecularfactor = 106090312,
        normtable = 478874367,
        numactiveshadowcascades = 2608506194,
        numletters = 1303240218,
        occlusionsampler = 50748941,
        occlusiontexture = 2967810622,
        oceanlocalparams0 = 2333080707,
        offsethighlum = 3768233024,
        offsetlowlum = 1745892694,
        offsetlum = 3139368420,
        ordernumber = 1617153586,
        palettecolor0 = 2390234167,
        palettecolor1 = 345546874,
        palettecolor2 = 650331343,
        palettecolor3 = 1102019239,
        paletteindex = 2499973182,
        palettesampler = 2950395616,
        paletteselector = 2636279676,
        paletteselector2 = 588791948,
        parabsampler = 2604688681,
        parallaxscalebias = 2178632789,
        parallaxselfshadowamount = 242286661,
        param0 = 3022832690,
        param1 = 1630936646,
        param2 = 2407332563,
        param3 = 2110904189,
        param4 = 739161080,
        param5 = 411995384,
        param6 = 1178691677,
        param7 = 947113154,
        params_ = 890816472,
        particlecollisionsampler = 3713958763,
        particlepostexsampler = 2603657112,
        particleposxytexsampler = 2279694207,
        particleposzwtexsampler = 1408622679,
        particleshadowsparams = 2589755661,
        particleveltexsampler = 1792971393,
        particlevelxytexsampler = 3377719961,
        particlevelzwtexsampler = 572101329,
        pedbrightness = 2965570322,
        perlinnoisesampler = 2192344499,
        perlinsampler = 3428612092,
        persistance = 319450804,
        perspectiveshearparam = 686675449,
        phase = 2726250539,
        plantcolor = 1360494706,
        platebgbumpsampler = 1709116366,
        platebgsampler = 1342317448,
        player_mask = 2584097651,
        playerbrightness = 1987993393,
        playerlfootpos = 1466936,
        playerrfootpos = 982297002,
        pointsampler = 1728781698,
        pointsampler1 = 857651826,
        pointsampler2 = 2186729701,
        pointtexture1 = 3319640342,
        pointtexture2 = 463756450,
        pointtexture3 = 715389601,
        pointtexture4 = 4030629335,
        pointtexture5 = 4280230808,
        poisson12 = 3700554683,
        polyrejectthreshold = 3669125377,
        positiontexsampler = 124136329,
        postfxadaptivedofcustomplanesparams = 2921923875,
        postfxadaptivedofenvblurparams = 383528417,
        postfxsampler2 = 3640527007,
        postfxsampler3 = 1268084184,
        postprocess_flipdepth_nearplanefade_params = 1212194473,
        projectionparams = 4041985547,
        prtoccsampler = 3756087939,
        ptfxalphamapsampler = 2528190781,
        ptfxdepthmapsampler = 3549846349,
        puddlebumpsampler = 644999851,
        puddlemasksampler = 1899494261,
        puddleplayerbumpsampler = 375060758,
        quadalpha = 319478650,
        quadposition = 4152407657,
        quadscale = 876246817,
        quadtexcoords = 2382487901,
        qualitysubpix = 1192820550,
        radialblurcenter = 265875256,
        radialblursampler = 6871558,
        radialblursamplescale = 1978511676,
        radialblurscale = 847338530,
        radialblurtexturestep = 3637740945,
        radialfadearea = 3417034203,
        radialfadetime = 820208297,
        radialwaveparam = 4020440334,
        //radius = 1337695475,
        rainnormalcontrols = 2413728713,
        rainnormalsampler = 205121072,
        rawinstancebuffer = 2533822745,
        rcpframe = 3616804746,
        redoff = 550595403,
        reductiondepthtexture = 156102219,
        reductionoutputtexture = 3090928251,
        refblurmapsampler = 553137719,
        reflectancesampler = 2024624668,
        reflectivepower = 1002989215,
        reflectivepowered = 680514554,
        reflecttexturesampler = 2975449189,
        refmipblurparams = 309170118,
        refmipblursampler = 3559513422,
        refractionmaptexsampler = 3189040505,
        refractsampler = 2398824821,
        rendercubemapsampler = 3123859691,
        rendermappointsampler = 1552806584,
        rendermappointsamplermsaa = 840576025,
        renderpointmapint = 3218359854,
        renderpointmapintparam = 945456412,
        rendertargetsize = 2592035668,
        rendertexarray = 183558417,
        rendertexarraysampler = 1776075411,
        rendertexfmask = 334637039,
        rendertexmsaa = 2388364099,
        rendertexmsaaint = 1120019968,
        rendertexmsaaparam = 445950974,
        reserve_vs_const_c253 = 888979958,
        reserve_vs_const_c254 = 572824646,
        reserve_vs_const_c255 = 3578071436,
        resolveddepthsampler = 870591330,
        resolveddepthtexture = 1168394501,
        result = 1204638111,
        rimamount = 3950947166,
        rimpower = 1017175370,
        ripplebumpiness = 3108440880,
        rippledata = 1154845288,
        ripplescale = 3553443429,
        ripplescaleoffset = 1931187426,
        ripplespeed = 1172914979,
        ropecolor = 3402942199,
        samp = 4292969706,
        sampfiltered = 200703167,
        sampleangle = 1030071922,
        samplescale = 65527032,
        Scale_ = 116180525,
        scale_ = 3279249823,
        Scale = 1018839014,
        scale = 1342385372,
        scalein = 1489667163,
        scalerlum = 1241172112,
        scanlinefilterparams = 3994711222,
        screenblurfade = 337464727,
        screencenter = 2855930302,
        screenres = 2982944708,
        screenrez = 1216400687,
        screensizehalfscale = 3116016449,
        seamtexturesampler = 1888072213,
        seethroughcolorfar = 3831201608,
        seethroughcolornear = 3012901639,
        seethroughcolorvisiblebase = 2159046948,
        seethroughcolorvisiblewarm = 3370209405,
        seethroughparams = 4084639067,
        segmentsize = 2511004421,
        selfshadowing = 1840833647,
        sfxwindsampler3d = 2060224441,
        shader_cableambient = 2538368771,
        shader_cablediffuse = 1793087594,
        shader_cablediffuse2 = 115414613,
        shader_cableemissive = 132015748,
        shader_fadeexponent = 2415019593,
        shader_radiusscale = 2225356731,
        shader_windamount = 33262047,
        shadervariables = 2308502112,
        shadowfacingoffset = 2069856698,
        shadowfalloff = 1293272419,
        shadowmap_res = 4230725802,
        shadowmapsamp = 4212336983,
        shadowparams2 = 2293499745,
        skincolourtweak = 2856526403,
        skinparams = 441924618,
        skycolor = 1706854363,
        skymapsampler = 2000097477,
        skyplanecolor = 3575965978,
        skyplaneparams = 2005428036,
        smallcloudcolorhdr = 1741381730,
        smallcloudcolorxhdrintensity = 2180964324,
        smallcloudconstants = 376734756,
        smartblitcubemapsampler = 4204135808,
        smartblitcubemaptexture = 712004116,
        smartblitsampler = 909202272,
        smartblittexture = 4234899854,
        smokeparams = 2945162076,
        smokesampler = 2479196183,
        snowsampler = 3153629680,
        snowsampler0 = 43291740,
        snowsampler1 = 296170113,
        soakframeinfo = 2322806119,
        //Softness = 187712958, //softness is already in the list, used by types other than shaders!
        source = 572563616,
        specdesaturateexponent = 3019471088,
        specdesaturateintensity = 716647240,
        specexp = 191070201,
        specfalloffadjust = 227128491,
        specfresnelexp = 1058370591,
        specfresnelmax = 4192555480,
        specfresnelmin = 1243102889,
        specintensity = 3710484485,
        specintensityadjust = 4171608282,
        specmapexpmask = 1709596004,
        specmapintmask = 4279333149,
        specmapreflectmask = 3348420270,
        specsampler = 1619499462,
        specsampler_layer01 = 2048257998,
        specsampler_layer23 = 3596135066,
        spectextileuv = 1430901041,
        specular2color = 685871723,
        specular2color_dirlerp = 2732605880,
        specular2colorintensity = 3929351910,
        specular2colorintensityed = 1998056897,
        specular2colorintensityre = 4172410899,
        specular2factor = 629012244,
        specular2factored = 3425067163,
        specularcolorfactor = 1212833469,
        specularcolorfactor1 = 475502710,
        specularcolorfactor2 = 1361248780,
        specularcolorfactor3 = 1060953664,
        specularcolorfactored = 1250428158,
        specularfactor = 376311761,
        specularfactor1 = 1627805193,
        specularfactor2 = 2405249722,
        specularfactor3 = 3075146389,
        specularfactored = 2497120655,
        specularfalloff = 3957040118,
        specularfalloffmult = 2272544384,
        specularfalloffmultspecmap = 2748867194,
        specularfresnel = 666481402,
        specularintensity = 2841625909,
        specularintensitymult = 4095226703,
        specularintensitymultspecmap = 1058366663,
        specularnoisemapuvscalefactor = 3472765508,
        specularpower = 2313518026,
        speedconstants = 4031543803,
        spherereflectionskyintensity = 798112437,
        splatterframeinfo = 1795230185,
        srctexturesize = 2371438916,
        sslrcenter = 2233700119,
        sslrparams = 2393555267,
        sslrsampler = 362115574,
        starfieldbrightness = 257351982,
        starfieldintensity = 1720801864,
        starfieldsampler = 4148544921,
        starfielduvrepeat = 2211182669,
        starthreshold = 2069166037,
        stencilcopy = 2849038798,
        stencilcopysampler = 2084502919,
        stencilcopytexture = 526908546,
        stenciltech = 471113370,
        stipplesampler = 3178703610,
        stubblecontrol = 3996109161,
        subcolor = 3318550136,
        subscatwidth = 993622972,
        subscatwrap = 511449331,
        subsurfacecolor = 1759569064,
        subsurfaceintensity = 1096960668,
        subsurfacerolloff = 3870878664,
        subviewportparams = 2820867500,
        sunaxias = 2561150543,
        suncentre = 240054980,
        suncolor = 891485471,
        suncolorhdr = 1049428866,
        suncolour = 1204497173,
        sunconstants = 1546824331,
        sundirection = 2607379178,
        sundisccolor = 3557539369,
        sundisccolorhdr = 1079908950,
        sunelevation = 569130658,
        sunhdrintensity = 3152536124,
        sunposition = 2950046911,
        sunraysparams = 291571442,
        sunsetcolor = 2702399089,
        sunsize = 1478210724,
        surfacetexturesampler = 3864743319,
        sweatmapsampler = 2330958813,
        switchon = 3150944317,
        targetsize = 1880392259,
        targetsizeparam = 1053269285,
        teargasparams = 1288904305,
        terraingridcentrepos = 3625956620,
        terraingridforward = 1519085164,
        terraingridhighheightcol = 580500403,
        terraingridlowheightcol = 2936084960,
        terraingridmidheightcol = 2606299729,
        terraingridparams = 1298168495,
        terraingridparams2 = 3179684830,
        terraingridright = 1294931141,
        tessellationmultiplier = 1934793340,
        texelsize = 3160646551,
        texm = 169731954,
        textureclamp = 812052183,
        texturegrasssampler = 4087226378,
        texturenowrapsampler = 2957556365,
        texturesamp = 485865047,
        texturesampler = 726757629,
        texturesampler_layer0 = 3576369631,
        texturesampler_layer1 = 606121937,
        texturesampler_layer2 = 831736502,
        texturesampler_layer3 = 2025281789,
        texturesampler_layer4 = 235963313,
        texturesampler_layer5 = 1429049834,
        texturesampler_layer6 = 1784855636,
        texturesampler2 = 90460676,
        texturesamplerdiffpal = 2878898974,
        texturesize = 3986548189,
        tiledlightingsampler = 3579496475,
        timeofday = 1778950238,
        tintblendamount = 481228442,
        tintblendlayer0 = 549865893,
        tintblendlayer1 = 3618355041,
        tintblendlayer2 = 3305181708,
        tintblendlayer3 = 4225662918,
        tintbumpiness = 3412667425,
        tintbumpsampler = 3461703736,
        tintintensity = 3676759262,
        tintpalettesampler = 4131954791,
        tintpaletteselector = 4258764495,
        tintsampler = 1530343050,
        tonemapcolorfilterparams0 = 324960120,
        tonemapcolorfilterparams1 = 48979602,
        tonemapparams = 2402343587,
        topcloudbiasdetailthresholdheight = 2470194715,
        topcloudcolor = 2654156795,
        topclouddetail = 3891329052,
        topcloudheight = 1826174990,
        topcloudlight = 1738437051,
        topcloudthreshold = 1907493970,
        toplum = 2532426199,
        totalelapsedtime = 3838297418,
        trackanimuv = 3759799674,
        transcolor = 2460231751,
        transparentdstmapsampler = 2450925918,
        transparentsrcmap = 2768420156,
        transparentsrcmapsampler = 3675757750,
        transpos = 3580147959,
        transtex0 = 719147892,
        transtex1 = 1023997899,
        transtex2 = 88705101,
        treelod2normal = 1105633214,
        treelod2params = 1951298816,
        txabc_texture = 737921561,
        txcoc_texture = 849209715,
        txx_texture = 2443058410,
        txyn_texture = 314367857,
        tyredeformparams = 1573146290,
        tyredeformparams2 = 4085683888,
        tyredeformswitchon = 1318515464,
        uicolor = 2438354415,
        uicolorxformoffset = 805638785,
        uicolorxformscale = 1696850869,
        uiposmtx = 2371642382,
        uipremultiplyalpha = 653605664,
        uitex0mtx = 1320157902,
        uitex1mtx = 2219459259,
        uitexture0 = 3890278027,
        uitexture1 = 3587000932,
        umglobaloverrideparams = 3341722211,
        umglobalparams = 570415642,
        umovementparams = 3156484982,
        umtriwave1params = 1002429420,
        umtriwave2params = 1181853954,
        umtriwave3params = 2191838184,
        underlightstrength = 618284065,
        unsharpamount = 982234565,
        updateoffset = 1690179723,
        updateparams0 = 1210532871,
        updateparams1 = 1947442147,
        usetessellation = 1176544093,
        usetreenormals = 3771895108,
        uvscalar = 2343745306,
        uvscales = 2395163223,
        vbonevelocitiesx = 58804251,
        vbonevelocitiesy = 2266287952,
        vcustomdata = 2809044919,
        vecbatchaabbdelta = 2709975619,
        vecbatchaabbmin = 1568822605,
        veccamerapos = 3890753729,
        vecplayerpos = 2050268192,
        vehglasscracktextureparams = 3043112491,
        vehglasscracktexturesampler = 3541769459,
        velocity1 = 1362920836,
        velocity2 = 1853341690,
        velocitybuffersampler = 415075366,
        velocitymapsampler = 3944176109,
        velocitytexsampler = 2305380067,
        vhairparams = 4131157628,
        viewproj = 1758764692,
        viewtoworldprojectionparam = 3809745575,
        vignettingcolor = 587686680,
        vignettingparams = 2870132669,
        visibleinstancebuffer0 = 3815124047,
        visibleinstancebuffer1 = 774685147,
        visibleinstancebuffer2 = 443193943,
        visibleinstancebuffer3 = 2592414350,
        vnoiseparams = 1120961721,
        vol_offsets = 2154022121,
        volumesampler = 789275230,
        vskinsweat = 3181015961,
        vsweatparams = 3596190507,
        waterbumpparams = 126236009,
        watercolor = 4201563883,
        watercolorsampler = 1938107181,
        watercolour = 217812784,
        waterfogfadecolor = 93338982,
        waterfogptfxparams = 1185901400,
        waterheight = 276101176,
        waterintensity = 3098236963,
        waterreflectionscale = 386931249,
        waterreflectionskyintensity = 4202734524,
        waterrendersimparam = 3115418423,
        waterripplesampler = 3870579404,
        watersimparam = 1441798312,
        watersimparams1 = 764072840,
        watersimparams2 = 2978995088,
        watersurfacesampler = 4239336251,
        watertexresvalue = 1128648105,
        wavemovement = 683816830,
        waveoffset = 2296487471,
        westcolor = 2977103135,
        wetanisotropicspecular = 1297501138,
        wetanisotropicspecularcolour = 4244410187,
        wetdarken = 3170546064,
        wetnessmultiplier = 853385205,
        windglobalparams = 208642390,
        windstr = 3237952635,
        woundframeinfo = 2347313451,
        wrapamount = 477869607,
        wrapligthtingterm = 850731621,
        wrinklemasksampler_0 = 2261465245,
        wrinklemasksampler_1 = 3567506505,
        wrinklemasksampler_2 = 2959477710,
        wrinklemasksampler_3 = 3181913682,
        wrinklemasksampler_4 = 199377605,
        wrinklemasksampler_5 = 498853496,
        wrinklemaskstrengths0 = 3696993600,
        wrinklemaskstrengths1 = 3993356436,
        wrinklemaskstrengths2 = 9399719,
        wrinklemaskstrengths3 = 1226342076,
        wrinklesampler_a = 2285332697,
        wrinklesampler_b = 163310560,
        yplanesampler = 2291309475,
        yuvtorgb = 361269406,
        zenithcolor = 1379881353,
        zenithconstants = 2801684,
        zenithtransitioncolor = 3025743240,
        zoomblurmasksize = 1914884772,
        zoomfocusdistance = 2687037299,
        zshift = 2743864906,
        zshiftscale = 273550094,














        CCompositeEntityType = 1185771007,
        scaleXY = 2627937847,
        scaleZ = 284916802,
        numChildren = 2793909385,
        childLodDist = 3398912973,
        portals = 2314725778,
        entitySets = 1169996080,
        timeFlags = 2248791340,
        rage__spdAABB = 4084721864,
        rage__fwGrassInstanceListDef = 2085051229,
        rage__fwGrassInstanceListDef__InstanceData = 3985044770,
        rage__fwPropInstanceListDef = 3120863088,
        NormalX = 3138065392,
        NormalY = 273792636,

        CImapDependency = 3501026914,
        CImapDependencies = 3240050401,
        CItypDependencies = 1515605584,
        CMapDataGroup = 3260758307, //PSO/YMF
        Bounds = 3298223272,
        HoursOnOff = 4190815249,
        itypName = 2890158180,
        packFileName = 4216494073,
        itypDepArray = 2410949350,





        //dexyfex manual guessing
        CScenarioPointRegion = 1492970064,
        CScenarioPointContainer = 2380938603,
        CScenarioPoint = 4103049490,
        CScenarioChain = 871314709,
        CScenarioChainingNode = 3340683255,
        CScenarioChainingEdge = 4255409560,
        Points = 702683191,
        Chains = 3254907796,
        rage__spdSphere = 1062159465,
        EdgeIds = 934700563,
        TypeNames = 3057471271,
        GroupNames = 2506712617,
        PedModelSetNames = 3020866217,
        VehicleModelSetNames = 3827910541,
        ModelSetId = 3361647288,
        LookUps = 1097626284,
        RequiredIMapNames = 1767860162,

        vPositionAndDirection = 4685037,
        CScenarioEntityOverride = 4213733800,
        EntityOverrides = 697469539,
        EntityPosition = 642078041,
        CScenarioPointCluster = 750308016,
        Clusters = 3587988394,
        ClusterSphere = 352461053,
        iInterior = 1975994103,
        iRequiredIMapId = 1229525587,
        iTimeTillPedLeaves = 2296188475,
        uAvailableInMpSp = 717991212,

        CPopGroupList = 738910261,

        CStreamingRequestFrame = 999226379,

        CVehicleWheel = 2964364979,

        CVfxPedInfoMgr = 2677836644,
        CVfxPedInfo = 3269469953,
        vfxPedInfos = 1918175602,

        CPedModelInfo__InitData = 3949383814,

        CVfxFogVolumeInfoMgr = 1633161012,
        CVfxFogVolumeInfo = 759946685,
        vfxFogVolumeInfos = 2287400076,

        CVfxWeaponInfoMgr = 623762845,
        CVfxWeaponInfo = 1271168564,

        CVfxInteriorInfoMgr = 4126959192,
        CVfxInteriorInfo = 998078140,
        vfxInteriorInfos = 3759474957,

        CVfxRegionInfoMgr = 3596444566,
        CVfxRegionInfo = 286275649,
        vfxRegionInfos = 4124078855,



        CWanted__Tunables__WantedLevel = 4209402831,
        AFF_AVERAGE = 2722191879,
        AFF_RICH = 1119317219,
        TS_HIGH = 956599249,
        StdDoorOpenPosDir = 2885011506,
        CDataFileMgr__DataFile = 4025199407,
        CDataFileMgr__ContentChangeSet = 2958929574,
        DataFileType = 3864419067,
        DataFileContents = 655728054,
        CONTENTS_DEFAULT = 507224223,
        InstallPartition = 2685892631,
        PARTITION_NONE = 3712881064,
        ExecutionConditions = 1196731409,
        ExecutionCondition = 2539760734,
        CTxdRelationship = 3649202799,
        child = 54445749,
        LODLights = 1326371921,
        BoxOccluder = 975711773,
        OccludeModel = 2741784237,
        sirenLight = 4091688452,
        sirenCorona = 472016577,

        fwClipDictionaryMetadata = 331140115,
        fwMemoryGroupMetadata = 2046450505,
        memoryGroupMetadatas = 3211922640,
        SP_High = 44700989,
        AP_HIGH = 313384972,
        TB_DEAD = 3088554349,
        TB_COLD = 3827341951,
        TB_HOT = 2709699671,

        vehicleLight = 1339481019,
        vehicleLightSettings = 2581049192,
        vehicleCorona = 1860240263,
        CVehicleKit = 679130282,
        CVehicleModVisible = 4238291236,
        CVehicleModLink = 2730707380,
        CVehicleModStat = 243590259,
        CVehicleModelColor = 4213335822,
        CVehicleWindowColor = 2561269966,
        CVehicleMetallicSetting = 2073371064,
        CVehicleXenonLightColor = 2807227399,
        PlateProbabilities = 2135495316,
        CVehicleModColors = 2858318490,
        CVehicleModColor = 1443412025,
        metallic = 2204727143,
        classic = 2458459502,
        matte = 1951049216,
        metals = 2740125593,
        chrome = 1114790148,
        pearlescent = 3095366650,
        spec = 1912906641,
        sirens = 2047330294,
        CCreditItem = 113388969,
        JOB_MED = 568575574,
        JOB_SMALL = 4127034762,

        eVehicleModType = 2363989491,
        eVehicleModCameraPos = 3413962745,

        eVfxGroup = 679492,

        silence = 3503773450, //used in game.dat151.rel
        null_sound = 3817852694, //used in game.dat151.rel
        constant_one = 3454258691, //used in dat .rels

        run = 285848937, //used in game.dat151.rel
        cop_dispatch_interaction_settings = 778268174, //used in game.dat151.rel




        FloatXYZ = 3805007828,

        aPropMetaData = 3902803273,
        ePedVarComp = 884254308,
        ePropRenderFlags = 4212977111,
        CPedPropTexData = 254518642,
        eScenarioPopStreamingSlot = 3029795674,
        eFadeCurveType = 3057039286,
        eSuperlodType = 4015041481,
        ePedRadioGenre = 2942646938,
        eSexinessFlags = 374769227,
        eExternallyDrivenDOFs = 637184392,
        eAnchorPoints = 2834549053,
        SpecialAbilityType = 2011786168,
        DefaultSpawnPreference = 888587604,
        numAlternatives = 2806194106,
        bHasDrawblVariations = 4086467184,

        CScenarioChainingEdge__eAction = 3609807418,
        CScenarioChainingEdge__eNavMode = 3971773454,
        CScenarioChainingEdge__eNavSpeed = 941086046,
        CStreamingRequestCommonSet = 1358189812,

        animal = 974042365, //in peds.ymt
        standard_ped = 2703423328, //in peds.ymt
        standard_male = 1860494962, //in peds.ymt PedCapsuleName - from pedbounds.xml
        standard_female = 3778684510, //in peds.ymt PedCapsuleName
        standard_player_male = 190297546, //in peds.ymt PedCapsuleName
        standard_player_female = 3813733509, //in peds.ymt PedCapsuleName
        large_male = 2182606047, //in peds.ymt PedCapsuleName
        facial_clipset_group_gen_male = 2968316036, //in peds.ymt FacialClipsetGroupName
        facial_clipset_group_gen_female = 984918963, //in peds.ymt FacialClipsetGroupName
        facial_clipset_group_p_m_zero = 3839850645, //in peds.ymt FacialClipsetGroupName
        facial_clipset_group_p_m_one = 3697506179, //in peds.ymt FacialClipsetGroupName
        facial_clipset_group_p_m_two = 3958944905, //in peds.ymt FacialClipsetGroupName
        anim_group_gesture_m_generic = 4080627616, //in peds.ymt DefaultGestureClipSet
        anim_group_gesture_f_generic = 1375166916, //in peds.ymt DefaultGestureClipSet
        anim_group_visemes_m_lo = 3326036851, //in peds.ymt DefaultVisemeClipSet
        anim_group_visemes_f_lo = 2783456433, //in peds.ymt DefaultVisemeClipSet
        nmbs_slow_getups = 69709351, //peds.ymt GetupSetHash
        clip_set_id_invalid = 2106583169, //in peds.ymt
        move_strafe_injured = 1434752434, //in peds.ymt InjuredStrafeClipSet
        move_ped_to_strafe = 3943634031, //in peds.ymt MovementToStrafeClipSet
        move_ped_strafing = 2464962150, //in peds.ymt StrafeClipSet
        civmale = 45677184, //in peds.ymt Pedtype
        civfemale = 1191392768, //in peds.ymt Pedtype
        vfxpedinfo_human_generic = 1167185222, //in peds.ymt VfxInfoName
        expr_set_ambient_male = 2495275024, //in peds.ymt ExpressionSetName
        expr_set_ambient_female = 3793172393, //in peds.ymt ExpressionSetName
        default_perception = 3537703288, //in peds.ymt PerceptionInfo
        streamed_male = 4014297412, //in peds.ymt Personality
        streamed_female = 991949850, //in peds.ymt Personality
        fitnessmale = 921466782, //in peds.ymt Personality
        fitnessfemale = 419688606, //in peds.ymt Personality
        youngrichman = 3818603935, //in peds.ymt Personality
        youngrichwoman = 367809573, //in peds.ymt Personality
        youngaverageweakman = 3971800366, //in peds.ymt Personality
        youngaverageweakwoman = 806694113, //in peds.ymt Personality
        bs_ai = 2150391885,  //in peds.ymt DefaultBrawlingStyle
        bs_franklin = 1037948029, //in peds.ymt DefaultBrawlingStyle
        bs_michael = 2057220685, //in peds.ymt DefaultBrawlingStyle
        bs_trevor = 1249954968, //in peds.ymt DefaultBrawlingStyle
        weapon_unarmed = 2725352035,  //in peds.ymt DefaultUnarmedWeapon
        silent_pvg = 423993118,  //in peds.ymt PedVoiceGroup
        silent_cutscene_pvg = 1896822940,  //in peds.ymt PedVoiceGroup

        @null = 987444055, // how best to handle this? C# doesn't like it


        exportcamera = 962998194, //cutscene related stuff











        //ped ymt's hashes from Siprus
        numAvailProps = 2598445407,
        numAvailTex = 3371516811,
        ownsCloth = 2828247905,
        aComponentData3 = 3796409423,
        aDrawblData3 = 1756136273,
        bHasTexVariations = 1235281004,
        availComp = 2996560424,
        CPVDrawblData = 1535046754,
        CPVComponentData = 3538495220,
        CPVTextureData = 1036962405,
        propTexId = 672172037,
        propDrawableId = 2095974912,
        compDrawableId = 173599222,
        propAnchorId = 3598106198,
        compTexId = 2991454271,
        PRF_CUTOUT = 3395845123,
        PRF_DECAL = 3735238938,
        PRF_ALPHA = 3757767268,
        ANCHOR_PH_L_HAND = 604819740,
        ANCHOR_PH_R_HAND = 2358626934,

        //occlusion ymt's from Siprus
        DestRoomIdx = 1028873946,
        PortalInfoIdx = 1084559223,
        DestInteriorHash = 57503776,
        InteriorProxyHash = 3748344047,
        PathNodeList = 1142266249,
        PathNodeKey = 2721898107,
        PathNodeChildList = 3530626268,
        PortalEntityList = 3203972140,
        PortalInfoList = 3085292924,

        //vfxinteriorinfo ymt's from Siprus
        CVfxInteriorSetup = 128879576,
        CVfxRoomSetup = 769638437,
        dustPtFxEnabled = 1270885502,
        dustPtFxEvo = 3916956310,
        dustPtFxName = 4061889016,
        interiorInfoName = 3197750225,
        smokePtFxEnabled = 174438245,
        smokePtFxLevelOverride = 1794720348,
        smokePtFxName = 2216385556,
        vfxInteriorSetups = 3147314065,
        vfxRoomSetups = 70742260,

        //entries for vfxinteriorinfo values from Siprus
        vfxinteriorinfo_club_bar = 3012126598,
        vfxinteriorinfo_default = 2186191160,
        vfxinteriorinfo_disabled = 4043117346,
        vfxinteriorinfo_factory = 3704850198,
        vfxinteriorinfo_factory2 = 789288375,
        vfxinteriorinfo_foundry = 3102010781,
        vfxinteriorinfo_methlab = 1747000990,
        vfxinteriorinfo_michael_mansion = 2503389540,
        vfxinteriorinfo_recycle = 3828623237,
        env_bar_haze = 2464653728,
        env_dust_motes_int_hvy = 2388998730,
        env_dust_motes_int_recycle = 1189228428,
        env_gunsmoke = 1283110988,
        env_gunsmoke_paper_factory = 2917372338,
        env_stripclub_haze = 3512462560,
        v_34_deliveryrm = 1873829195,
        v_34_processrm = 2131172512,
        v_64_back = 291590403,
        v_64_back_lower = 2635531210,
        v_64_base2 = 2901364601,
        v_64_cloak = 2699110422,
        v_64_dance = 1921450756,
        v_64_entry = 209242346,
        v_64_entry_trans = 3070346248,
        v_64_rear = 4193595779,
        v_64_rear_trans = 1532913744,
        v_64_side = 2526696518,
        v_64_side_upper = 593969979,
        v_64_upper = 182753347,
        v_recycle_chopper = 2694641996,
        v_recycle_cor1 = 2624371671,
        v_recycle_door = 4022865356,
        v_recycle_main = 1108714138,
        v_recycle_office1 = 4228826032,
        v_recycle_shield = 2720085499,
        v_recycle_stair2 = 3998905162,
        v_recycle_window = 2808950336,

        //more ped.ymt's hashes from Siprus
        shoe_dress_shoes = 3199946566,
        shoe_golf_shoes = 2839919184,
        shoe_heavy_boots = 1032158653,
        shoe_scuba_flippers = 378813016,
        shoe_flip_flops = 2060154316,
        shoe_cowboy_boots = 2839908380,
        shoe_normal_heels = 3937154717,
        shoe_rubber = 3737214528,
        shoe_trainers = 3325651536,
        shoe_heels = 2000019839,
        shoe_barefoot = 1461428428,
        shoe_high_heels = 3928708288,
        shoe_rubber_boots = 3194973734,
        cloth_backpack = 1069599825,
        cloth_ballistic = 4078855526,
        cloth_cop_belt = 4133108633,
        cloth_gas_mask = 4065623745,
        cloth_heavy_bag = 4153104635,
        cloth_lower_ballistic_armour = 4106198121,
        cloth_lower_bare = 1628659471,
        cloth_lower_cop = 1540859016,
        cloth_lower_cotton = 1141160746,
        cloth_lower_extreme = 4088613522,
        cloth_lower_fireman = 1406591853,
        cloth_lower_leather = 3327176319,
        cloth_lower_pants_denim = 4176749571,
        cloth_lower_pants_leather = 529572143,
        cloth_lower_pants_suit = 3685853881,
        cloth_lower_pants_tight = 879250969,
        cloth_lower_shorts = 3301429444,
        cloth_lower_skirt_long = 421389060,
        cloth_lower_skirt_short = 710005800,
        cloth_lower_swat = 291450192,
        cloth_lower_waterproof = 1695056885,
        cloth_rappel_parachute = 3513212182,
        cloth_scuba = 861851786,
        cloth_tool_belt = 2531067209,
        cloth_upper_alien = 2291900169,
        cloth_upper_ballistic_armour = 145524546,
        cloth_upper_bare = 1870774092,
        cloth_upper_bikini_top = 3629254153,
        cloth_upper_coat_scientist = 1946563223,
        cloth_upper_cop = 2483445690,
        cloth_upper_cop_vest = 1515519271,
        cloth_upper_cotton = 830866350,
        cloth_upper_fireman = 669860574,
        cloth_upper_jacket_cotton = 4008082313,
        cloth_upper_jacket_leather = 1106508751,
        cloth_upper_jacket_puffy = 2884411436,
        cloth_upper_jacket_suit = 979848852,
        cloth_upper_leather = 401172640,
        cloth_upper_shirt_cotton_heavy = 3934084272,
        cloth_upper_shirt_cotton_lite = 176526946,
        cloth_upper_shirt_leather = 67091042,
        cloth_upper_shirt_tee = 1237088534,
        cloth_upper_spacesuit = 1018641360,
        cloth_upper_swat = 2783390651,
        cloth_upper_sweater = 3189514483,
        cloth_upper_waterproof = 3748562816,
        upper_cotton = 3438959116,

        //CExtensionDefLightShaft enum value hashes from Siprus
        LIGHTSHAFT_VOLUMETYPE_CYLINDER = 462992848,
        LIGHTSHAFT_DENSITYTYPE_LINEAR = 152140774,
        LIGHTSHAFT_DENSITYTYPE_CONSTANT = 676250331,
        LIGHTSHAFT_DENSITYTYPE_QUADRATIC = 1098824079,
        LIGHTSHAFT_DENSITYTYPE_QUADRATIC_GRADIENT = 1492299290,
        LIGHTSHAFT_DENSITYTYPE_SOFT_SHADOW_HD = 1816804348,
        LIGHTSHAFT_DENSITYTYPE_SOFT_SHADOW = 2057886646,
        LIGHTSHAFT_DENSITYTYPE_LINEAR_GRADIENT = 2088805984,
        LIGHTSHAFT_DENSITYTYPE_SOFT = 2399586564,



        ////various entries from Siprus - thanks!
        // eVfxGroup
        VFXGROUP_TARMAC_BRITTLE = 349722727,
        VFXGROUP_LINOLEUM = 656066551,
        VFXGROUP_TVSCREEN = 688944506,
        VFXGROUP_SAND_LOOSE = 1041698964,
        VFXGROUP_CARDBOARD = 1710619059,
        VFXGROUP_UNDEFINED = 1777437223,
        VFXGROUP_CAR_PLASTIC = 2101842785,
        VFXGROUP_SAND_UNDERWATER = 2143791359,
        VFXGROUP_GENERIC = 2432469028,
        VFXGROUP_SAND_DEEP = 2673689260,
        VFXGROUP_CONCRETE_DUSTY = 3536499660,
        VFXGROUP_LIQUID_MUD = 3745008516,
        VFXGROUP_FOAM = 3912379355,

        // POPGROUPS
        POPGROUP_RARE = 35209924,

        // DataFileType enum
        AMB_PROCEDURAL_BLOOD_FILE = 2738801230,
        COMBAT_BEHAVIOUR_OVERRIDE_FILE = 364263123,
        CONTROLLER_LABELS_FILE_DURANGO = 4129824885,
        CONTROLLER_LABELS_FILE_ORBIS = 91648887,
        CONTROLLER_LABELS_FILE_ORBIS_JPN = 2018868761,
        DELAYED_IDE_FILE = 4115202587,
        DLC_POP_GROUPS = 2421375782,
        FACIAL_CLIPSET_GROUPS_FILE = 1714317514,
        FLIGHTZONES_FILE = 3179455283,
        LEADERBOARD_ICONS_FILE = 1431237327,
        PED_DAMAGE_OVERRIDE_FILE = 3155601669,
        RMPTFX_FILE = 2041822787,
        SCALEFORM_PREALLOC_FILE = 2609475948,
        SCALEFORM_VALID_METHODS_FILE = 3169431862,
        SCENARIO_POINTS_OVERRIDE_FILE = 33804852,
        SCRIPT_BRAIN_FILE = 2678176687,
        SCROLLBARS_FILE = 3993726615,

        // animation clip priority enum
        eAnimPriority = 1498349301,
        AP_FACE_HIGH = 611607097,
        AP_FACE_LOW = 2096169364,
        AP_FACE_MEDIUM = 3509068476,

        // eAnimPlayerFlag
        APF_BLOCK_IK = 1238878851,
        APF_ISPLAYING = 508324092,
        APF_SCRIPT = 2827814553,
        APF_UNUSED_3 = 2727614813,
        APF_UNUSED_4 = 3032530358,
        APF_UNUSED_6 = 3646785267,
        APF_UNUSED_7 = 3914016462,
        APF_UNUSED_8 = 1023626813,
        APF_UNUSED_9 = 1321103795,

        // ped ymts
        bHasLowLODs = 911147899,
        bIsSuperLOD = 315291935,

        //rel categories
        ambience_birds = 2111673525,
        ambience_collectables = 1822293160,
        ambience_general = 605434024,
        ambience_industrial = 3601034378,
        ambience_insects = 1516192474,
        ambience_music = 4061751802,
        ambience_speech = 4118533336,
        ambience_weather = 2993238467,
        collisions_cloth = 4114296646,
        collisions_glass = 3665884229,
        collisions_louder = 3707599549,
        collisions_scripted = 3607066630,
        collisions_vehicles_glass = 40916134,
        cutscenes = 2130818598,
        doors_loud = 4083376175,
        fire = 3540648811,
        fire_louder = 3795113672,
        frontend_game_loud = 1563623315,
        frontend_menu = 3209785070,
        frontend_menu_loud = 2867594907,
        frontend_radio = 130804751,
        game_world = 657061725,
        interactive_music = 1572110022,
        music = 3376826828,
        music_loading = 1691427420,
        peds_clothing = 2705431951,
        peds_collisions = 2898035946,
        peds_collisions_loud = 3672708454,
        peds_wind = 3149982308,
        radio = 1847911863,
        score = 2134238453,
        scripted = 1670758327,
        scripted_alarms = 2563970085,
        scripted_louder = 682050869,
        scripted_tv = 201797022,
        speech = 163313604,
        speech_ambient = 410026006,
        speech_breathing = 2670011790,
        speech_pain = 2021015895,
        speech_scripted = 3078245965,
        underwater_loud = 4027278097,
        underwater_muted = 2969328544,
        underwater_swimming = 2137972630,
        vehicles_bicycles = 3685564039,
        vehicles_bicycles_mechanical = 134197036,
        vehicles_boats_engines = 1823905713,
        vehicles_boats_water = 343703808,
        vehicles_brakes = 1315521004,
        vehicles_car_by = 2709313722,
        vehicles_chassis_rattle = 270455670,
        vehicles_doors = 2640217883,
        vehicles_engines_cooling = 1473309549,
        vehicles_engines_damage = 431436680,
        vehicles_engines_ignition = 325435029,
        vehicles_engines_intake = 266876274,
        vehicles_engines_loud = 607318229,
        vehicles_engines_reflections = 2730342635,
        vehicles_engines_startup = 2812351357,
        vehicles_extras_loud = 1806509607,
        vehicles_helis = 3565904205,
        vehicles_helis_distant = 1203937907,
        vehicles_horns = 3310407619,
        vehicles_horns_loud = 1875957285,
        vehicles_planes = 360518393,
        vehicles_planes_close = 450576074,
        vehicles_planes_distant = 2745068879,
        vehicles_planes_extras = 2970811186,
        vehicles_planes_jet = 2496384807,
        vehicles_planes_prop = 2880809343,
        vehicles_sirens = 3312980540,
        vehicles_suspension = 2521949505,
        vehicles_train = 2900951834,
        vehicles_train_brakes = 400861892,
        vehicles_train_carriage = 3957967078,
        vehicles_train_clack = 1353825976,
        vehicles_wheels = 3141782289,
        vehicles_wheels_loud = 3187816841,
        vehicles_wheels_skids = 1011082280,
        water_loud = 3800267791,
        water_ocean = 3756642183,
        water_swimming = 3392133420,
        weapons_explosions = 217319362,
        weapons_explosions_loud = 3464961727,
        weapons_guns = 1238862244,
        weather_rain = 973848687,
        weather_rain_heavy = 646232623,
        weather_rain_props = 633103322,
        weather_thunder = 1377523001,
        weather_wind = 3506430202,
        weather_wind_foliage = 480273725,


        // particles ShaderVars names from Siprus
        diffusetex2 = 234123336,
        softnesscurve = 415919122,
        directionalmult = 1250560552,
        normalmapmult = 2008564461,
        superalpha = 2445226024,
        normalspecmap = 3009619921,
        normalarc = 3063280732,
        shadowamount = 3218705437,
        refractionmap = 3749494808,
        camerabias = 4030385036,
        ambientmult = 4164128389,
        softnessshadowoffset = 2810291083,
        softnessshadowmult = 341373563,
        extralightmult = 3338535754,
        camerashrink = 2170767496,


        //AWC markers names from Siprus
        tank_jump = 322089989,
        tank_weapon_main_cannon_hit = 2054994489,
        tank_jump_land = 2326210279,
        tank_turret_move = 3770661529,
        tempo = 2051628467,
        beat = 3902465932,
        dj = 148611320,
        //01 = 2740850834,//this one added in RpfManager.BuildBaseJenkIndex
        rockout = 4078653290,
        uihit = 3632555010,//is this right?
        r_p = 295134840,//is this right?
        g_s = 349722558,//is this right?
        m_p = 2304294116,//is this right?








        //GranularSound dat54.rel FileName hashes from NotGigo
        engine_accel = 3748922026,
        exhaust_accel = 598446449,
        engine_decel = 2556723864,
        exhaust_decel = 780159042,
        engine_idle = 1025030561,
        exhaust_idle = 396221610,












        //from dav90's PSO_RBF_XMLExport_V5.7
        AutoJunctionAdjustments = 1352439928,
        vLocation = 929088795,
        fCycleOffset = 1883372816,
        fCycleDuration = 3328650398,

        registerAs = 1419376801,

        CreditItems = 1705522053,
        LineType = 660169259,
        cTextId1 = 4188319879,
        cTextId2 = 2913343627,
        JOB_BIG = 1035407208,

        flee_left = 204999120,
        flee_right = 1266046331,
        flee_forward = 1547194093,
        flee_back = 1622623046,




        //dav90 suggestions
        AccelGrid = 3053155275,
        NavMode = 859022269,
        NavSpeed = 1419316113,
        NodeIndexTo = 2851806039,
        NodeIndexFrom = 3236798246,
        CScenarioPointLookUps = 3019621867,
        ANCHOR_MOUTH = 2032023579,
        ANCHOR_LEFT_HAND = 100074042,
        ANCHOR_RIGHT_HAND = 3693638868,
        ANCHOR_HIP = 2778755006,
        ANCHOR_LEFT_FOOT = 1100801960,
        ANCHOR_RIGHT_FOOT = 1776231225,
        mloFlags = 3590839912,
        floorId = 2187650609,
        timecycleName = 2724323497,
        secondaryTimecycleName = 3255324828,
        portalCount = 1105339827,
        exteriorVisibiltyDepth = 552849982, //not correct = spelling error?
        attachedObjects = 2382704940,
        roomFrom = 4101034749,
        roomTo = 2607060513,
        mirrorPriority = 1185490713,
        audioOcclusion = 1093790004,
        dataSize = 2442753371,
        iCenterX = 48026296,
        iCenterY = 896907229,
        iCenterZ = 1597508449,
        iLength = 2854610661,
        iWidth = 168013536,
        iHeight = 3485277993,
        explosionName = 3301388915,
        explosionTag = 2653034051,
        explosionType = 3379115010,
        cornerA = 3302595027,
        cornerB = 2393877884,
        cornerC = 2692731164,
        cornerD = 4250372814,
        directionAmount = 1441249296,
        densityType = 235100599,
        volumeType = 4021175589,
        softness = 187712958,
        disturbanceType = 3802708370,
        radiusInner = 406390660,
        radiusOuter = 1814053978,
        minScale = 3662913353,
        maxScale = 803384552,
        objectHash = 1951307499,
        LoadSavePoints = 3016741991,
        MyPoints = 1170781136,
        iProbability = 2974610960,
        iScenarioGroup = 2180252673,
        EntityType = 1374199246,
        CStreamingRequestRecord = 135915278,
        Frames = 419044527,
        CommonSets = 4248405899,
        NewStyle = 2333392588,
        AddList = 327274266,
        RemoveList = 3372321331,
        CamPos = 357008256,
        CamDir = 210316193,
        Requests = 2743119154,
        compInfos = 592652859,
        propInfo = 2240851416,
        propMask = 2932859459,
        aTexData = 1251090986,
        clothData = 2464583091,
        distribution = 914976023,
        inclusions = 2172318933,
        aAnchors = 162345210,
        expressionMods = 942761829,
        texData = 4088935562,
        renderFlags = 4239582912,
        propFlags = 1066841901,
        anchorId = 2731224028,
        propId = 3817142252,
        inclusionId = 1938349561,
        exclusionId = 3819522186,
        weaponSlot = 1912311826,
        disableProjectileDriveby = 531190847,
        disableDriveby = 3038752585,
        NoSpawn = 2321493392,   //scenario point flags enum values
        TerritorialScenario = 763077056,
        InWater = 3157896680,
        OpenDoor = 2382141124,
        ExtendedRange = 324643703,
        ShortRange = 3717016373,
        HighPriority = 3426447659,
        IgnoreLoitering = 626032513,
        //ZoomTransformInformations = 3304563391, //this one doesn't make sense
        kOnlySp = 4171042740, //scenario spawn point availability enum
        kOnlyMp = 549935372,
        Direct = 1129153779, //scenario chain edge nav mode enum
        NavMesh = 4272634460,
        Roads = 177164187,
        METAL_LIGHT_LADDER = 846330484,
        CComponentInfo = 1866571721,
        CAnchorProps = 2170383875,
        CBlockDesc = 3072355914,
        CClassNameOfItemType = 440716365, //array type for (PSO) MAP fields
        zones = 2319609287,
        spName = 4254542050,
        CInteriorBoundsFiles = 741495440,
        PortalIdx = 1061685079,
        RoomIdx = 3136588885,
        LinkType = 1812903871,
        MaxOcclusion = 3034993422,
        IsDoor = 474556907,
        IsGlass = 1060358829,

        CellDimX = 2690909759,
        CellDimY = 3691675019,
        MaxCellX = 3824598937,
        MaxCellY = 3374647798,
        MinCellX = 860552138,
        MinCellY = 496029782,
        aSelectionSets = 2131007641,
        creatureMetadataName = 2766477159,
        expressionDictionaryName = 1095612811,
        fadeDistanceEnd = 475013030,
        fadeDistanceStart = 40301253,
        fadeInTimeEnd = 120454521,
        fadeInTimeStart = 1616789093,
        fadeOutTimeEnd = 75548206,
        fadeOutTimeStart = 1297365553,
        initialiseOnCollision = 1562817888,
        maxScaleZ = 147400493,
        maxZOffset = 3889902555,
        minScaleZ = 3913056845,
        minZOffset = 2591582364,
        numTris = 2337695078,
        numVertsInBytes = 853977995,
        scaleBySunIntensity = 59101696,

        CVehicleModPearlescentColors = 1380492417,
        baseCols = 2645876692,
        specCols = 666439252,




        ACTION_TABLE_BRANCHES = 873568416,
        ACTION_TABLE_DAMAGES = 595808921,
        ACTION_TABLE_DEFINITIONS = 1586102416,
        ACTION_TABLE_FACIAL_ANIM_SETS = 2229907729,
        ACTION_TABLE_HOMINGS = 322779061,
        ACTION_TABLE_IMPULSES = 3648540414,
        ACTION_TABLE_INTERRELATIONS = 1160967041,
        ACTION_TABLE_RESULTS = 1389081087,
        ACTION_TABLE_RUMBLES = 2747161193,
        ACTION_TABLE_STEALTH_KILLS = 607800534,
        ACTION_TABLE_STRIKE_BONES = 2040342322,
        ACTION_TABLE_VFX = 387140454,
        AF_AimDirect = 860304717,
        AF_AtEdge = 3386029841,
        AF_CAN_DIVE = 1665251515,
        AF_Center = 3392782621,
        AF_EnterLeft = 3822780995,
        AF_FaceLeft = 754232761,
        AF_Low = 4105818928,
        AF_Scope = 2989860387,
        AF_ToLow = 569621039,
        AF_ToPeek = 1740709742,
        AIEnterCoverClips = 102329791,
        AIEnterTransitionClips = 2915894063,
        AIOneHandedAimingClipSetId = 1351184833,
        AIOnlyReactionRangeScaleFactor = 1284602455,
        AIStandEnterCoverClips = 3619734025,
        AITimeBetweenLookAtsFailureMax = 825960985,
        AITimeBetweenLookAtsFailureMin = 1036503478,
        AITimeWaitingToCrossRoadMax = 242751779,
        AITimeWaitingToCrossRoadMin = 299126851,
        AITwoHandedAimingClipSetId = 1837001601,
        AI_IdleTurnRate = 985371239,
        AI_MBRAcceleration = 2741511192,
        AI_MBRDeceleration = 3394605993,
        AMBIENT_PED_MODEL_SET_FILE = 2585891657,
        AMBIENT_PROP_MODEL_SET_FILE = 1221077490,
        AMBIENT_VEHICLE_MODEL_SET_FILE = 2488014020,
        APF_ADDITIVE = 332392317,
        APF_BLOCK_HEAD_IK = 1871501357,
        APF_FACIAL = 1706286383,
        APF_ISFINISHAUTOREMOVE = 3723366928,
        APF_UPPERBODYONLY = 3541611037,
        APF_USE_SECONDARY_SLOT = 2933717348,
        AUDIO_CURVEDATA = 2270570848,
        AUDIO_LEGALS = 980984444,
        AUDIO_NAME = 1792396879,
        AUTOGYRO = 2983251618,
        AbandonDistance = 3316020555,
        AbortAimedAtMinDistance = 2471124155,
        AccelRate = 1799363495,
        Acceleration = 455772583,
        AccelerationBased = 1199000829,
        AccelerationForce = 4142316102,
        AccelerationLimit = 2807887859,
        AccelerationScaleBike = 1717140709,
        AccelerationSmoothing = 946605886,
        AccelerationSmoothingBike = 1058383858,
        AccelerationToStartLeaning = 3976993041,
        ActionBlendInDuration = 1593645740,
        ActionClipRate = 2230131245,
        ActionCombatAlignRate = 1946397601,
        ActionModeTime = 258368020,
        ActionSets = 4009202106,
        ActionsHandcuffedNetworkId = 2803702095,
        AddPedGenBlockedArea = 3664766217,
        AddToBaseStuckOnVehicleSets = 4027713155,
        AdditionalDistanceForApproach = 3311720447,
        AdditionalDistanceForStrafe = 3249320190,
        AdditionalModifier = 3164975884,
        AdditionalSpeedCap = 3139639651,
        AdditionalWindscreenRagdollForceFwd = 1948944372,
        AdditionalWindscreenRagdollForceUp = 3235771585,
        Adjustment = 1514279376,
        Adjustments = 4147768898,
        AdvanceDistanceSquared = 898987704,
        AdvanceUseTimeRandomMaxProportion = 652219771,
        AggressiveMove = 625597120,
        Agility = 3039521267,
        AgitatedPersonality = 3499834918,
        AgitationTriggers = 1849624842,
        Ai = 237851371,
        AiAimIntroCloseEnoughTolerance = 295831481,
        AiClearedVehicleDelay = 2616874064,
        AiClearedVehicleSmartFallDelay = 2452951318,
        AiEntryHalfAngleTolerance = 2527222356,
        AiEntryMaxRate = 976189127,
        AiEntryMinRate = 2645460108,
        AiMoverFixupMaxExtraHeadingChange = 3215816764,
        AimAssistBlendInTime = 505547665,
        AimAssistBlendOutTime = 3649321767,
        AimAssistCapsuleMaxLength = 134284951,
        AimAssistCapsuleRadius = 2827935386,
        AimAssistDistanceCurve = 390534438,
        AimBehaviourEnvelopeRef = 2238897248,
        AimDirectlyMaxAngle = 3060249921,
        AimDistance = 3825720952,
        AimFov = 3154554341,
        AimIntroClips = 1512682432,
        AimIntroMaxAngleChangeRate = 1952772149,
        AimIntroMaxPhaseChangeRate = 2752952312,
        AimIntroMaxTimedOutPhaseChangeRate = 3521301980,
        AimIntroMinPhaseChangeRate = 1545452032,
        AimIntroRateForAi = 3231686180,
        AimIntroTaskBlendOutDuration = 473976041,
        AimOutroDelayTime = 2973722662,
        AimOutroMinTaskTimeWhenRunPressed = 2511610049,
        AimOutroRateForAi = 1089147792,
        AimOutroTime = 1822973195,
        AimOutroTimeIfAimingOnStick = 1768561713,
        AimPoses = 877489286,
        AimSensitivityScalingLimits = 1539206266,
        AimTurnCosAngleTolerance = 2821466544,
        Aiming = 3260617242,
        AimingOnStickCooldownMs = 1466310013,
        AimingOnStickExitCooldown = 2412774208,
        AimingSettings = 85936843,
        AirResistanceOption = 220567909,
        AlignSuccessMaxDist = 2661149439,
        AlignmentConeAngle = 3992317122,
        AlignmentConeAngleWithTrailer = 3365340087,
        AlignmentConeOffsetTowardsVehicleFrontAngle = 1160959405,
        AllowArmouredKnockdown = 3717266986,
        AllowArmouredLegShot = 1779515548,
        AllowDriveToGetup = 2492839498,
        AllowDriverLockOnToAmbientPeds = 3783727678,
        AllowDriverLockOnToAmbientPedsInSP = 3215957770,
        AllowEntryToMPWarpInSeats = 4265363743,
        AllowIgnoreAsLowPriority = 3215420778,
        AllowMovingArmedMeleeAttack = 2144745273,
        AllowNonPlayerHighFallAbort = 4255515242,
        AllowOffScreenHighFallAbort = 992799658,
        AllowPitchAndRoll = 3861069366,
        AllowPlayerStunned = 3993091983,
        AllowPursuePlayer = 1975950903,
        AllowRoadCrossHurryOnLightChange = 3260171409,
        AllowScanningEvenIfPreviouslyReacted = 3118021097,
        AllowSlowCruisingWithMusic = 2380425018,
        AllowSoftLockFineAim = 297555324,
        AllowWarningActivations = 4197576600,
        AllowWhenBalanced = 2018281497,
        AlternateControlStickInputThreshold = 3417116793,
        AlternativeAnimBlockedHeight = 3876119945,
        AlwaysUse = 715231316,
        AmbientAnimLengthBuffer = 1095839119,
        AmbientAudio = 3268464789,
        AmbientEventLifetime = 1941376054,
        AmbientEventType = 1507389089,
        AmountPinnedDownByBullet = 866380197,
        AmountPinnedDownByDamage = 3456533073,
        AmountPinnedDownByWitnessKill = 1098445330,
        AmplitudeLimits = 2371650129,
        AmplitudeNoise = 312484959,
        AmplitudeScale = 2919368248,
        AngleDelta = 737052146,
        AngleDifferenceForMax = 2207962562,
        AngleDifferenceForMin = 3784903261,
        AngleForMax = 760576493,
        AngleForMin = 485092302,
        AngleForRunway = 2103581552,
        AngleOfCoverWeighting = 2472038331,
        AngleScalingFactor = 1160632805,
        AngleToCameraWeighting = 1431242126,
        AngleToCoverWeighting = 647728646,
        AngleToDynamicCoverWeighting = 3402563167,
        AngledArea = 2592513975,
        AngledAreas = 3530189928,
        AngledClimbScaleVelocityExtensionMax = 2762624828,
        AngledClimbTheshold = 3158074083,
        AngularVelocityLimits = 1247412006,
        AnimMode = 1881596949,
        AnimPostFXManager = 4209092714,
        AnimalBodyScale = 3667685650,
        AnimalPelvisScale = 4074006169,
        AnimatedPostFX = 3205113395,
        AnkleAndWrist = 3435621206,
        ApplyPedScale = 1737474230,
        ApplyRotationScaling = 142881218,
        ApplyTranslationScaling = 2981016968,
        ApplyVehicleScale = 3650822252,
        ApproachTarget = 432947414,
        ApproachingPlayerCosineThreshold = 372581586,
        ApproachingPlayerDistanceThreshold = 1461747338,
        ApproachingPlayerModifier = 2714692767,
        ApproachingTargetVehicleHoldFireDistance = 1135781765,
        AquaticSpawnDepth = 798871205,
        AquaticSpawnMaxHeightAbovePlayer = 1856882404,
        Arc = 1995960590,
        ArcRadius = 1686516854,
        ArcStatus = 743861760,
        ArmShot = 3674358794,
        ArmourEfficiency = 3330066831,
        Armoured = 264772538,
        ArmouredBonus = 81171216,
        ArmouredRapidHitCount = 3537415104,
        Army = 2552595859,
        ArrestDistance = 684815089,
        ArrestDot = 1800609114,
        ArrestHardLockDistance = 1845591318,
        ArrestInVehicleDistance = 1433360068,
        ArrestProbeDistance = 4096940896,
        AspectRatio = 69123357,
        AssetName = 2112595704,
        AssistanceAngle = 763241052,
        AssistedAimCamera = 4068186391,
        AssistedAimInterpolateInDuration = 4032674616,
        AssistedAimOutroTime = 4243324346,
        AtEdgeAnimStateInfos = 1367701780,
        AttachBoneTag = 575433612,
        AttachOffset = 3651374867,
        AttachOffsetX = 1914687253,
        AttachOffsetY = 1407750823,
        AttachOffsetZ = 1694184652,
        AttachOrientationX = 2711684267,
        AttachOrientationY = 2941689878,
        AttachOrientationZ = 1795856235,
        AttachParentHeightRatioToAttain = 2070771362,
        AttachParentHeightRatioToAttainInTightSpace = 2923457671,
        AttachParentHeightScalingForCameraRelativeVerticalOffset = 2685248219,
        AttachParentHeightScalingForCameraRelativeVerticalOffset_AfterAiming = 3654232577,
        AttachParentHeightScalingForExtraCameraRelativeVerticalOffset = 3987821886,
        AttachParentInAirEnvelopeRef = 1789219851,
        AttachParentMatrixForRelativeOrbitSpringConstant = 2521592812,
        AttachParentMatrixForRelativeOrbitSpringDampingRatio = 4067016949,
        AttachParentRelativeHeading = 10648206,
        AttachParentRelativePitch = 3436942647,
        AttachParentRollDampingPitchHardLimits = 1356521412,
        AttachParentRollDampingPitchSoftLimits = 4039533147,
        AttachParentRollSpringConstant = 293341517,
        AttachParentRollSpringDampingRatio = 3607038158,
        AttachParentUpwardSpeedScalingInAirEnvelopeRef = 2960196386,
        AttachParentUpwardSpeedScalingOnGroundEnvelopeRef = 2224847663,
        AttachParentWidthScalingForCameraRelativeSideOffset = 142271562,
        AttachPart = 2289273332,
        AttachPedPelvisOffsetSpringConstant = 1148495425,
        AttachPedPelvisOffsetSpringDampingRatio = 536202543,
        AttachRelativeOffset = 3718710002,
        AttackDelay = 1512162309,
        AttackDuration = 75961662,
        AttackStrengthMax = 3806042807,
        AttackStrengthMin = 2502152653,
        AudioReactionRange = 17870529,
        AutomaticHeadShot = 478190306,
        AutomaticInitialSnapMult = 1689181219,
        AutomaticNeckShot = 451773670,
        AutomobileSpeedModifier = 2432019232,
        AvoidNearbyPedDotThreshold = 2430060993,
        AvoidNearbyPedHorizontal = 2710536525,
        AvoidNearbyPedVertical = 868109097,
        AvoidOffsetXY = 2249292417,
        AvoidOffsetZ = 2919714320,
        AvoidanceMarginForOtherLawEnforcementVehicles = 48543250,
        AvoidanceProbeInterval = 3847609025,
        AvoidanceProbeLength = 715859273,
        AvoidanceProbePullback = 3266740728,
        AvoidanceSteerAngleDegrees = 3581037895,
        Avoids = 394023184,
        AwardParachuteJumpDistanceA = 3004548533,
        AwardParachuteJumpDistanceB = 3235406138,
        AwardParachuteJumpTime = 1740411412,
        AwardVehicleJumpDistanceA = 3662021366,
        AwardVehicleJumpDistanceB = 2301583602,
        AwardVehicleJumpTime = 1801522365,
        AxesFacingTolerance = 1858039250,
        BACKGROUND_SCRIPT_FILE = 1197964820,
        BCRExclusionZone = 3968865312,
        BC_Randomize = 4235841451,
        BC_Retain = 2165534923,
        BF_AGGRESSIVE_AFTER_RUNNING_PED_OVER = 4159638386,
        BF_ARGUMENTATIVE = 168692563,
        BF_CAN_ACCELERATE_IN_CAR = 1160283338,
        BF_CAN_FLEE_WHEN_HIT_BY_CAR = 687848862,
        BF_CAN_GET_OUT_WHEN_HIT_BY_CAR = 2997524846,
        BF_CONFRONTATIONAL = 1200956848,
        BF_DONT_FORCE_FLEE_COMBAT = 1196718962,
        BF_DONT_RUN_ON_MELEE_ATTACK = 914958829,
        BF_DONT_SAY_PANIC_ON_FLEE = 640530450,
        BF_GET_PISSED_WHEN_HIT_BY_CAR = 4164385006,
        BF_INTERVENE_ON_MELEE_ACTION = 294976751,
        BF_INTIMIDATE_PLAYER = 2849017488,
        BF_LIMIT_COMBATANTS = 4202267286,
        BF_PLAY_CAR_HORN = 3634362686,
        BF_PURSUE_WHEN_HIT_BY_CAR = 985531983,
        BF_REACT_ON_COMBAT = 3501709025,
        BF_WATCH_ON_CAR_STOLEN = 1317922943,
        BIG_REACTION = 3804705025,
        BUILDING_META_DISPLACEMENT_FILE = 1815909929,
        BackHeadingInterpRate = 1673427683,
        BackOffTimer = 3890964100,
        BackShot = 3495314353,
        BadRoute = 1572599387,
        BadRouteValue = 3663294436,
        Base = 212355988,
        BaseAttachVelocityToIgnoreEnvelopeRef = 60641442,
        BaseClipId = 1993756531,
        BaseFov = 1865815245,
        BaseFovToEmulateWithFocalLengthMultiplier = 3921296525,
        BaseHeading = 2985933428,
        BaseMotionBlurStrength = 652273141,
        BaseNearClip = 2755051531,
        BaseOrbitPitchOffset = 1778852906,
        BaseOrbitPitchOffsetInTightSpace = 158553507,
        BasePivotHeightScalingForFootRoom = 1397182427,
        BasePivotPosition = 1065618425,
        BaseTimeToLook = 2905104124,
        BasicObjectScore = 1313622498,
        BasicPedScore = 835021064,
        BasicVehicleScore = 3463312294,
        BeJackedBlendInDuration = 2885633587,
        BehindPedModifier = 214316948,
        BehindPedToCoverCosTolerance = 1216157443,
        BehindRotateAngleLookAhead = 3025087075,
        BehindTargetAngle = 2688788428,
        BehindThreshold = 692748984,
        BeingPushedOnGroundTooLongMS = 952442515,
        BiasSide = 1744405318,
        BiasSideTime = 2827348378,
        BicycleDepletionMaxMult = 3428727331,
        BicycleDepletionMidMult = 4027241659,
        BicycleDepletionMinMult = 2709145468,
        BicycleDrivebyFilterId = 939946101,
        BicycleEnterForce = 1607735267,
        BicycleInverseMassScales = 3654250561,
        BicycleMaxDepletionLimit = 1171875727,
        BicycleMidDepletionLimit = 2465303084,
        BicycleMinDepletionLimit = 4176468490,
        BicycleVelocityToUseAnimatedJumpOff = 2218133629,
        BikeDrivebyFilterId = 3931552272,
        BikeEnterForce = 356015597,
        BikeEnterLeanAngleOvershootAmt = 1348653070,
        BikeEnterLeanAngleOvershootRate = 114247175,
        BikeExitForce = 3130040539,
        BikeHornClipId = 1786685138,
        BikeInAirDriveToStandUpTimeMax = 4108731380,
        BikeInAirDriveToStandUpTimeMin = 333974259,
        BikeInverseMassScales = 3619347977,
        BikeMaxRestoreDuration = 4019573548,
        BikeMinRestoreDuration = 1929662760,
        BikePickUpAlignBlendDuration = 3899294511,
        BikePitchSmoothingPassengerRate = 1515003340,
        BikePitchSmoothingRate = 4270612236,
        BikeVehicleMinPhaseToStartRotFixup = 4059105444,
        BikeVelocityToUseAnimatedJumpOff = 553575729,
        BirdHeightMapDeltaMax = 1961626874,
        BirdHeightMapDeltaMin = 597953858,
        BirdSpawnXYRangeMax = 2777866816,
        BirdSpawnXYRangeMin = 3368483780,
        Bitmap = 3540307690,
        BlanketForceScale = 4071693543,
        BlendDuration = 2387941002,
        BlendDurationForEarlyOut = 4197363947,
        BlendInDeltaForPed = 1293637123,
        BlendInDeltaForProp = 639648672,
        BlendInSpringConstant = 2111282409,
        BlendLevel = 42409501,
        BlendOut = 4265715862,
        BlendOutDelayBalanceFailed = 2382871963,
        BlendOutDelayStanding = 3295848876,
        BlendOutDuration = 1231407173,
        BlendOutPhase = 3550098093,
        BlendOutSpringConstant = 165735146,
        BlendOutThreshold = 124792981,
        BlendToIdleTime = 2500851482,
        BlendoutPhase = 160395732,
        BlindFireAnimStateNewInfos = 2740917805,
        BlindFireHighCoverMaxPitchLimit = 3950076744,
        BlindFireHighCoverMinPitchLimit = 1565596444,
        Block = 2210395489,
        BlockOffscreenShotReactions = 83217879,
        BlockingAreas = 20824415,
        BloomMax = 3093400296,
        BoatMaxAvoidanceAngle = 26476902,
        BoatTargetArriveDist = 3249924134,
        BodyWrithe = 1990395340,
        BoneRelativeAttachOffset = 2842669433,
        Bonus = 2733810571,
        BottomComponent = 2168296036,
        BottomSpread = 4172681798,
        Bound = 2111641000,
        BoundAnkles = 4148786995,
        Brake = 3493497994,
        BrakeControl = 2512256335,
        Braking = 3150145630,
        BrakingDifferenceForLinearVZMax = 4258663913,
        BrakingDifferenceForLinearVZMin = 3149009694,
        Bravery = 2511674669,
        BraveryTypes = 1481182292,
        BreakAttachmentMoveSpeedThreshold = 3465127340,
        BreakAttachmentOrientationThreshold = 365892591,
        BringVehicleToHaltDistance = 157002911,
        BuddyShot = 1747672916,
        BufferDistance = 2084497360,
        BumpedByCar = 19643947,
        BumpedByCarFriendly = 1912045929,
        BumpedByObject = 3428812559,
        BumpedByPed = 3386895833,
        BumpedByPedFriendly = 121419715,
        BumpedByPedIsQuadruped = 1002558306,
        BumpedByPedMinDotVel = 1234302495,
        BumpedByPedMinVel = 974350285,
        BumpedByPedRagdoll = 2004593632,
        BumpedByPlayerRagdoll = 1980284711,
        BumperOverlapForMaxSpeed = 3083236924,
        BumperOverlapForMinSpeed = 2926405391,
        BumperOverlapToBeInPosition = 1688870175,
        BuoyancySettings = 1991191506,
        BurnOutBlendInSpeed = 514772223,
        BurnOutBlendInTol = 4038428233,
        BurnOutBlendOutSpeed = 765288989,
        BurnOutClipId = 1402571365,
        BurstFireInitialSnapMult = 2148964650,
        CAMERA_METADATA_FILE = 2801332849,
        CAssassinsDispatch__Tunables = 3584713396,
        CCompEntityAnims = 1980345114,
        CCompEntityEffectsData = 3430328684,
        CCoverTuningFile = 3016688820,
        CCreditArray = 1998252412,
        CF_ALLOWED_COP_PURSUIT = 491616304,
        CF_JACKING = 2861521524,
        CFriendlyIssues = 754458458,
        CHINESE_SHUFFLING_CHECKS_FILE = 1244900227,
        CINEMATIC = 3839202812,
        COLLAR = 87075802,
        COMImpulseComponent = 3129842207,
        COMImpulseMaxRootVelocityMagnitude = 2681040368,
        COMImpulseOnlyWhileBalancing = 2187976068,
        COMImpulseScale = 3040120990,
        CONTENTS_DEBUG_ONLY = 2652598047,
        CONTENTS_MAX = 1137770612,
        CONTROLLER_LABELS_FILE = 1309368403,
        CONTROLLER_LABELS_FILE_360 = 648947982,
        CONTROLLER_LABELS_FILE_PS3 = 2127547113,
        CONTROLLER_LABELS_FILE_PS3_JPN = 2324879915,
        CPedPropInfo = 2858946626,
        CPedPropMetaData = 94549140,
        CPedSelectionSet = 253191135,
        CPedVariationInfo = 376833625,
        CPlantInfo = 1982133670,
        CPlayerSpecialAbilityManager = 2688740668,
        CPopulationGroup = 1530774378,
        CSlownessZoneManager = 3721180525,
        CTCCapsuleRadius = 3651490612,
        CTCClearanceCapsuleEndForwardOffset = 3077258891,
        CTCClearanceCapsuleEndZOffset = 2044226047,
        CTCClearanceCapsuleRadius = 837246042,
        CTCClearanceCapsuleStartForwardOffset = 4089643980,
        CTCClearanceCapsuleStartZOffset = 1328526529,
        CTCDepthDistanceCompletionOffset = 148125195,
        CTCForwardOffset = 3036685456,
        CTCHeightOffset = 1038229473,
        CTCMinDistance = 348835470,
        CTCProbeDepth = 3727526506,
        CTCSideOffset = 2512599606,
        CTCSpacingOffset = 4258697085,
        CTaskBirdLocomotion__Tunables = 1099459847,
        CTaskCuffed__Tunables = 918124422,
        CTaskInCustody__Tunables = 2117468048,
        CTuningFile = 2828759280,
        CVA_WHEEL_REAR_LEFT = 3148884390,
        Calculation = 3703855515,
        CamAttachPositionWeights = 1291841671,
        CamToCoverDirCosAngleTol = 588986036,
        CamToPedDirCosAngleTol = 1553721673,
        CameraDirToCoverMinDot = 4218123581,
        CameraLookAtBlendRate = 3198525203,
        CameraLookAtRotationLimit = 3701159057,
        CameraLookAtTurnRate = 3589690545,
        CameraRef = 1055059023,
        CameraRelativeSideOffset = 1032707911,
        CameraRelativeVerticalOffset = 1114870307,
        CameraSettings = 3095142060,
        CameraWeighting = 3990545757,
        Cameras = 1331283328,
        CanBePaused = 1966573275,
        CanCallPolice = 3833488932,
        CanStealCarsAtLights = 3908221492,
        CanStealParkedCars = 3993007617,
        CanStealPlayersVehicle = 3564233674,
        CanStealStationaryCars = 1365518895,
        CanUseForReactions = 2426586936,
        CapsuleHitForce = 883555571,
        CapsuleLengthForDetection = 322237759,
        CapsuleSettings = 2803013276,
        CapsuleVehicleHitTuning = 1834701470,
        CarSirenModifier = 3642651832,
        CatchFall = 4093402329,
        CatchFallHeightThresholdClipPose = 1581787136,
        CatchFallHeightThresholdRollUp = 2088499253,
        CatchFallHeightThresholdWindmill = 3140918872,
        CatchFallRelaxHeight = 4249251885,
        CatchUpHelperRef = 1443569911,
        CatchUpSpeed = 730064409,
        CausesRumbleWhenCollidesWithPlayer = 2821566375,
        CausesVehicleAvoidance = 1030055336,
        ChanceForGutShotKnockdown = 3055246492,
        ChanceOfFallToKneesAfterLastStand = 4015640822,
        ChanceOfFallToKneesOnCollapse = 3769959610,
        ChanceOfFilmingEventOnPhoneIfWatching = 4002374438,
        ChanceOfPedSeeingCarFromBehind = 315595788,
        ChanceOfWatchRatherThanHurryAway = 273885309,
        ChancePlayingCustomBackAwayAnimBigReact = 2458557466,
        ChancePlayingCustomBackAwayAnimSmallReact = 1713122871,
        ChancePlayingInitalTurnAnimBigReact = 551070027,
        ChancePlayingInitalTurnAnimSmallReact = 1757042582,
        ChanceToDeleteOnExitVehicle = 1276762529,
        ChancesForHesitate = 1095332633,
        ChancesForSwerve = 1825428191,
        ChancesToApplyReactionWhenShootingOutTire = 4058868243,
        ChancesToCallPolice = 2723841400,
        ChancesToDive = 3174431501,
        ChancesToFlipOff = 2395375846,
        ChancesToForceWaitInFront = 987604024,
        ChancesToHonk = 4171049765,
        ChancesToHonkHeldDown = 1871327732,
        ChancesToIntimidateArmedTarget = 2212321440,
        ChancesToIntimidateUnarmedTarget = 2214254758,
        ChancesToReactForGunAimedAt = 1942207582,
        ChancesWhenBuddyKilledWithScaryWeapon = 52194177,
        ChangeRatesForParachuting = 2700491627,
        ChangeRatesForSkydiving = 143335713,
        ChangeStationClipId = 2867244273,
        CharacterLight = 1142553590,
        ChargeTuning = 612012739,
        Chase = 2342544226,
        Cheat = 766857224,
        CheatPowerIncreaseForMatchSpeed = 3640126549,
        CheckForMovingGround = 2224677187,
        ChestForce = 2102302469,
        ChestForcePitch = 347021105,
        CinematicContexts = 1387858,
        CircleRotateAngleLookAhead = 2760165709,
        CircleTestRadii = 1409114490,
        CircleTestsMoveDistToTestNewPos = 3404462,
        CirclingAngularSpeed = 4190486872,
        CirclingMBR = 4203587509,
        ClampImpulse = 1180195582,
        ClavicleImpulseScale = 1905000551,
        ClearVehicleTimeMS = 4245738856,
        ClearZ = 2795607090,
        ClearedVehicle = 3612199348,
        ClimbAlignTolerance = 3652074424,
        ClimbingOrJumpingPedModifier = 2209113178,
        ClipId = 1300775131,
        ClipSetForCasual = 2787113182,
        ClipSetForIntro = 2755047550,
        ClipSetForRuns = 4017342285,
        ClippingAvoidance = 185739126,
        Clips = 3647518623,
        ClonePlayerBumpedByCarActivationModifier = 1036094636,
        ClonePlayerBumpedByCloneCarActivationModifier = 2745991583,
        CloseDistance = 2443685244,
        CloseDoorForceMultiplier = 2238708643,
        ClosePlayerDistanceThreshold = 2302698674,
        ClosePlayerModifier = 2278997613,
        ClosePlayerSpeedupDistanceSquaredThreshold = 2385841716,
        ClosePlayerSpeedupTimeThreshold = 1980022811,
        ClosePointCounterMax = 2874710517,
        ClosePointDistanceSquared = 2832422495,
        CloseSpawningViewMultiplier = 3846222437,
        ClosestPointToLineBonusModifier = 1432381156,
        ClosestPointToLineDist = 3770142196,
        CockGunWeaponClipId = 2737802101,
        Collision = 2519270732,
        CollisionFallBackPosition = 340312382,
        CollisionLosHeightOffset = 706571699,
        CollisionProbe = 961255660,
        CollisionRef = 3424608737,
        CollisionRootPositionFallBackToPivotBlendValue = 4279727627,
        CollisionRootPositionSpringConstant = 3507950586,
        CollisionRootPositionSpringDampingRatio = 3397058689,
        CollisionSettings = 3762874292,
        CollisionTestRadiusSpringConstant = 551575094,
        CollisionTestRadiusSpringDampingRatio = 1557769430,
        Colour = 3346932687,
        CombatAlignRate = 1557395660,
        CombatEntryBlendDuration = 2555911368,
        CombatLoitering = 3029474439,
        CombatOpenDoorClipId = 118829386,
        ComeBackInWhenAimDirectChangeInHighCover = 4276335920,
        CompletionRadius = 1468879986,
        Constant = 2414966970,
        Constraints = 1591913012,
        Contact = 3061072832,
        ContinuousContactTime = 1174887920,
        ContinuousGapHighFallTime = 1425777632,
        ControlDebugBeginAngle = 1147737070,
        ControlDebugEndAngle = 2904615002,
        ControlDebugRadius = 2886272257,
        ControlDebugXPos = 3419184861,
        ControlDebugYPos = 3872178927,
        ControlHelperRef = 2884954151,
        CopInVehicleVisualReactionRange = 2651939713,
        Cops = 1528396268,
        CoreAIMotionClipSetId = 2782502123,
        CoreMotionClipSetId = 2878139548,
        CoreWeaponClipSetId = 1024291853,
        CornerExitClips = 353989914,
        CornerExitHeadingModifier = 2292594697,
        CoverAimOffsetFromBlocked = 2495484427,
        CoverDirToCameraWeightMax = 302988723,
        CoverDirToCameraWeightMaxAimGun = 428630826,
        CoverDirToCameraWeightMaxScaleDist = 3645928265,
        CoverDirToCameraWeightMin = 2777705971,
        CoverEntryHeadingReachedTol = 647951209,
        CoverEntryMaxDirectDistance = 1608065887,
        CoverEntryMaxDistance = 1307601741,
        CoverEntryMaxDistanceAI = 3523536193,
        CoverEntryMinAngleToScale = 3426925695,
        CoverEntryMinDistance = 1391743069,
        CoverEntryMinDistanceAI = 4070109213,
        CoverEntryMinTimeNavigatingAI = 1162149057,
        CoverEntryPositionReachedTol = 1436746072,
        CoverEntryRateAI = 2901436256,
        CoverEntryRatePlayer = 443908416,
        CoverEntryShortDistanceAI = 14209833,
        CoverEntryShortDistancePlayer = 1607017826,
        CoverEntryStandDistance = 1011440787,
        CoverEntryStandStrafeDistance = 1748900014,
        CoverHeadingCloseEnough = 488807312,
        CoverHeadingCloseEnoughTurn = 52868234,
        CoverLeftFireModifier = 3014744113,
        CoverLeftFireModifierLow = 4019978349,
        CoverLeftIncreaseModifier = 314817266,
        CoverMaxDistance = 4142738100,
        CoverMinDistance = 417867439,
        CoverPoint = 2523520621,
        CoverPoints = 3053199956,
        CoverPositionCloseEnough = 2380669878,
        CoverResponseTimeout = 2346320415,
        CoverRightFireModifier = 3586592245,
        CoverRightFireModifierLow = 1508442808,
        CoverRightIncreaseModifier = 1620272884,
        CoverSettings = 3780197314,
        CoverStepClipSetId = 2450446524,
        CoverToCoverAngTol = 1570059814,
        CoverToCoverAnimStateInfos = 3577768695,
        CoverToCoverClipRate = 1687761193,
        CoverToCoverDistTol = 2125677956,
        CoverToCoverDuration = 462269180,
        CoverToCoverEdgeTestEndYOffset = 545166509,
        CoverToCoverEdgeTestStartYOffset = 2470298407,
        CoverToCoverMaxAccel = 3143775651,
        CoverToCoverMaxAngToStep = 446471957,
        CoverToCoverMaxDistToStep = 19390938,
        CoverToCoverMaxRotScalePhase = 372008448,
        CoverToCoverMaxScalePhase = 4228398614,
        CoverToCoverMinAng = 2651943117,
        CoverToCoverMinAngToScale = 3382987159,
        CoverToCoverMinDepthToScale = 1009232455,
        CoverToCoverMinDistToScale = 483457094,
        CoverToCoverMinRotScalePhase = 321218444,
        CoverToCoverMinScalePhase = 2919445883,
        CoverToCoverSmallAnimDist = 392526062,
        CoverWeightDistance = 3336702639,
        CoverWeightUsage = 3908973904,
        CoverWeightValue = 2465106291,
        CoveredInBloodPlayerModifier = 1573945112,
        CoweringForeverDeleteOffscreenTimeMS_MAX = 263563417,
        CoweringForeverDeleteOffscreenTimeMS_MIN = 1966243013,
        CrashLanding = 3151745571,
        CriminalVehicleMinStartSpeed = 4063126636,
        Criminality = 3808740257,
        CriminalityTypes = 1643851287,
        CrouchedLeftFireOffset = 3453306812,
        CrouchedOrLowCover = 3072964466,
        CrouchedRightFireOffset = 2533938546,
        CruiseDuckPrepLeftBikeClipId = 1163109918,
        CruiseDuckPrepLeftCharClipId = 733218,
        CruiseDuckPrepRightBikeClipId = 1089195126,
        CruiseDuckPrepRightCharClipId = 1933131499,
        CruisePedalCharClipId = 196702567,
        CruiseSpeed = 2895901568,
        CruiseSpeedForStrafe = 2482756980,
        CruiseSpeedMultiplierForBackOff = 3659936455,
        CruiseSpeedMultiplierForMaxBackOffDistance = 2134482011,
        CruiseSpeedMultiplierForMaxSlowdown = 2690108566,
        CruiseSpeedMultiplierForMinBackOffDistance = 3537928320,
        CruiseSpeedMultiplierForMinSlowdown = 2016261853,
        CruiseSpeedWhenClose = 587550606,
        CruiseSpeedWhenObstructedByLawEnforcementPed = 1914453083,
        CruiseSpeedWhenObstructedByLawEnforcementVehicle = 1604976859,
        Current = 2479092473,
        CurrentHeading = 413002367,
        CurveSets = 4116334946,
        CustomBoundingBoxSettings = 1022007033,
        CustomCollisionOriginRelativePosition = 4155454260,
        CustomOrbitDistanceLimitsToForce = 1828892401,
        CustomSettings = 2827051945,
        CutsceneBlendSpringConstant = 777008740,
        CutsceneBlendSpringDampingRatio = 2366444870,
        CycleTargetAngularLimit = 1394170274,
        CycleTargetAngularLimitMelee = 3789965859,
        DEFAULT_TASK_DATA_FILE = 2701401283,
        DEFORMABLE_OBJECTS_FILE = 3996479808,
        DEVINS_SNOWLIGHT = 1635759186,
        DISABLE_FILE = 3897970480,
        DISPATCH_DATA_FILE = 1977530558,
        DRIVER_RULES_STD_FILE = 4292163424,
        DSP_AERIAL = 3148113674,
        DSP_AQUATIC = 1563097128,
        DSP_GROUND_WILDLIFE = 2099691605,
        DamageMotionBlurDuration = 304164673,
        DamageMotionBlurMaxDamage = 938189370,
        DamageMotionBlurMaxStrength = 1317618698,
        DamageMotionBlurMinDamage = 3242284698,
        DampenRootTargetHeight = 1671878115,
        DampenRootTargetWeight = 794209155,
        DampeningForce = 1129875775,
        Dead = 2865917470,
        DeadFallOutClipId = 1583960251,
        DeadZoneAnyInputDirection = 1699227528,
        DeadZoneStickNorm = 3681430863,
        DebugDisplayAlwaysUseEventPosition = 387027865,
        DebugDisplayListPlayerInfo = 1307368391,
        DebugDraw = 2418474749,
        DebugLockOnTargets = 3853036348,
        DebugSwapInstantly = 2950978586,
        DebugTargetting = 4090546975,
        Decay = 398571259,
        DecayDuration = 1826449020,
        DecayRate = 1564203967,
        Deceleration = 1627413096,
        DeepWaterThreshold = 3940110369,
        DefaultAlignEndFixupPhase = 1305634921,
        DefaultAlignRate = 2555216789,
        DefaultAlignStartFixupPhase = 717764835,
        DefaultAmnestyTime = 1730819989,
        DefaultBackwardsProjectionRange = 4112548279,
        DefaultBeJackedAlivePedFromOutsideClipId = 3819225408,
        DefaultBeJackedAlivePedFromWaterClipId = 3745870995,
        DefaultBeJackedAlivePedOnVehicleClipId = 2307365987,
        DefaultBeJackedAlivePedOnVehicleIntoWaterClipId = 2347965860,
        DefaultBeJackedDeadPedFromOutsideClipId = 2626413479,
        DefaultBeJackedDeadPedFromWaterClipId = 542641977,
        DefaultBeJackedDeadPedOnVehicleClipId = 988275496,
        DefaultBeJackedDeadPedOnVehicleIntoWaterClipId = 824689766,
        DefaultChanceOfStandingWhileMoving = 3714303368,
        DefaultClimbDownClipId = 2758806077,
        DefaultClimbDownNoDoorClipId = 374589004,
        DefaultClimbUpClipId = 2993991731,
        DefaultClimbUpNoDoorClipId = 4167965920,
        DefaultCloseDoorEndIkPhase = 932416743,
        DefaultCloseDoorEndPhase = 444144670,
        DefaultCloseDoorStartIkPhase = 3092993621,
        DefaultCloseDoorStartPhase = 2181733270,
        DefaultCrashExitOnSideClipId = 828622422,
        DefaultCrouchingPose = 607364341,
        DefaultDistanceFromWorldCenter = 2251904831,
        DefaultEdgeTurnBlendDuration = 3203547922,
        DefaultFleeExitClipId = 1085529957,
        DefaultForcedEntryClipId = 4187378175,
        DefaultFov = 1391977192,
        DefaultGetInClipId = 1776336338,
        DefaultGetOutBlendDuration = 3739360652,
        DefaultGetOutClipId = 1983795837,
        DefaultGetOutNoWindBlendDuration = 2470385571,
        DefaultGetOutNoWingId = 90808597,
        DefaultGetOutOnToVehicleClipId = 2498096438,
        DefaultGetOutToWaterClipId = 4109561514,
        DefaultHiddenEvasionTimeReduction = 115496620,
        DefaultImpactBikeClipId = 2443433960,
        DefaultImpactCharClipId = 628124008,
        DefaultInverseMassScales = 1575645985,
        DefaultJackAlivePedFromOutsideClipId = 2624279103,
        DefaultJackAlivePedFromWaterClipId = 2379662115,
        DefaultJackDeadPedFromOnVehicleClipId = 1982208210,
        DefaultJackDeadPedFromOutsideClipId = 1755247816,
        DefaultJackDeadPedFromWaterClipId = 2061479056,
        DefaultJackDeadPedOnVehicleIntoWaterClipId = 3508843174,
        DefaultJackPedFromOnVehicleClipId = 807201844,
        DefaultJackPedOnVehicleIntoWaterClipId = 1866652328,
        DefaultJackRate = 4256000061,
        DefaultJumpOutClipId = 1640661523,
        DefaultKillShotImpulseMult = 1035940220,
        DefaultLookAtThreshold = 2539614217,
        DefaultMPKillShotImpulseMult = 3207843175,
        DefaultMPRapidFireKillShotImpulseMult = 3825480237,
        DefaultMaxRotationScalingValue = 3714157750,
        DefaultMaxTranslationScalingValue = 589616650,
        DefaultMeleeRange = 318279589,
        DefaultMinRotationScalingValue = 273784445,
        DefaultMinTranslationScalingValue = 4071659392,
        DefaultOpenDoorClipId = 757048139,
        DefaultOpenDoorEndIkPhase = 2631224923,
        DefaultOpenDoorEndPhase = 1506371742,
        DefaultOpenDoorRate = 350729378,
        DefaultOpenDoorStartIkPhase = 2878218804,
        DefaultOpenDoorStartPhase = 462320915,
        DefaultPedalToFreewheelBlendDuration = 811691519,
        DefaultPitch = 2266995505,
        DefaultPitchSmoothingRate = 3114188164,
        DefaultPlayerStandEntryEndMovementPhase = 2445300354,
        DefaultPlayerStandEntryStartMovementPhase = 2787336412,
        DefaultProbeOffset = 4100289588,
        DefaultRapidFireKillShotImpulseMult = 2071204131,
        DefaultRelativePitch = 551950644,
        DefaultReversePitch = 1670344535,
        DefaultSettleBlendDuration = 2855575670,
        DefaultSitToStandBlendDuration = 2455313637,
        DefaultSmallImpactBikeClipId = 2298295044,
        DefaultSmallImpactCharClipId = 2966685819,
        DefaultStandingPose = 836857486,
        DefaultStillToTurnBlendDuration = 1307353498,
        DefaultTargetAimPitchMax = 3414965475,
        DefaultTargetAimPitchMin = 3751177723,
        DefaultTargetAngularLimit = 361676600,
        DefaultTargetAngularLimitClose = 3274621266,
        DefaultTargetAngularLimitCloseDistMax = 2015184340,
        DefaultTargetAngularLimitCloseDistMin = 2598900761,
        DefaultTargetAngularLimitMelee = 3817163838,
        DefaultTargetAngularLimitMeleeLockOnNoStick = 2076997846,
        DefaultTargetAngularLimitVehicleWeapon = 2675889779,
        DefaultTargetDistanceWeightMelee = 908567944,
        DefaultTargetDistanceWeightMeleeRunning = 118717170,
        DefaultTargetHeadingWeightMelee = 3338545377,
        DefaultTargetHeadingWeightMeleeRunning = 3833299605,
        DefaultTimeBetweenIdles = 1544265672,
        DefaultTryLockedDoorClipId = 2087055883,
        DefaultWeaponLoadout = 2744215759,
        Delay = 4112497335,
        DelayBetweenPavementFloodFillSearches = 4087190680,
        DelayTimeWhenOutOfAmmoInScope = 3684533695,
        DeleteOffscreenTimeMS_MAX = 2066926080,
        DeleteOffscreenTimeMS_MIN = 2782271258,
        DeltaForMaxStickChange = 2339537570,
        DeltaScaleWhenPlayerStationary = 397262754,
        DeltaTolerance = 2032147920,
        Deploy = 325816429,
        DepthForLandProbe = 1901477334,
        DesiredDirToCoverAimingWeight = 1242729948,
        DesiredDirToCoverMinDot = 3768160914,
        DesiredDirToCoverWeight = 2932059417,
        DesiredDistanceToCover = 1551121369,
        DesiredDistanceToCoverToRequestStep = 2359940104,
        DesiredLeanAngleRate = 4138940297,
        DesiredLeanAngleRateQuad = 2940067495,
        DesiredLeanAngleTolToBringLegIn = 1030667828,
        DesiredOvershootLeanAngle = 2868091491,
        DesiredPitch = 2095341670,
        DesiredSpeedToBringLegIn = 3420225248,
        DesiredTimeToResolveAngleDifference = 2923527027,
        Despawning = 1606361377,
        DetachExitDefaultPhaseThreshold = 1532444703,
        DetectionRadius = 4278404079,
        Difficulty = 1654675133,
        DirectorList = 1163993726,
        DisableAiCoverEntryStreamCheck = 2504995190,
        DisableBikeHandleArmIk = 1131247892,
        DisableBikePickPullUpOffsetScale = 454797365,
        DisableCloseDoor = 4046635601,
        DisableCoverToCoverRotationScaling = 1227928250,
        DisableCoverToCoverTranslationScaling = 2876044804,
        DisableDoorHandleArmIk = 4238205678,
        DisableInjuredBehaviorDistLimit = 868220978,
        DisableInjuredBehaviorImpulseLimit = 1833631034,
        DisableIntroOverShootCheck = 3598945794,
        DisableIntroScaling = 1465904835,
        DisableJumpOnSteepStairs = 1258832245,
        DisableMoverFixups = 1336261201,
        DisableOutroOverShootCheck = 2745801756,
        DisableOutroScaling = 1212343445,
        DisableReachForWoundOnHeadShot = 390630339,
        DisableReachForWoundOnHeadShotMaxDelay = 702711221,
        DisableReachForWoundOnHeadShotMinDelay = 3271496489,
        DisableReachForWoundOnNeckShot = 249145917,
        DisableReachForWoundOnNeckShotMaxDelay = 266530001,
        DisableReachForWoundOnNeckShotMinDelay = 3192396779,
        DisableRotationOvershoot = 3253125136,
        DisableRotationOvershootCheck = 3699526709,
        DisableRotationScaling = 800236883,
        DisableSeatBoneArmIk = 2336701139,
        DisableStartMessageForSprintExhausted = 3533734703,
        DisableStreamedVehicleAnimRequestHelper = 3950304880,
        DisableTagSyncIntoAlign = 609083866,
        DisableTimeslicingHeadingThresholdD = 484878979,
        DisableTranslationOvershoot = 2434177980,
        DisableTranslationOvershootCheck = 2679767269,
        DisableTranslationScaling = 3134002215,
        DisableVaultForwardDot = 1893591066,
        DisableVehicleDependencies = 1599003681,
        DisableWeaponBlocking = 800840705,
        DisableWhenOffMission = 746028494,
        DisallowGroundProbeVelocity = 7853624,
        DispatchNode = 3360212191,
        DisplacementScaleApproachRateIn = 2671402641,
        DisplacementScaleApproachRateOut = 3023759131,
        Display = 2360416497,
        DisplayAimAssistCurves = 216413736,
        DisplayAimAssistIntersections = 2995853681,
        DisplayFreeAimTargetDebug = 315412703,
        DisplayLockOnAngularRanges = 951183830,
        DisplayLockOnDistRanges = 208459187,
        DisplayRemovedGroups = 1828214902,
        DisplaySoftLockDebug = 1909407402,
        DistConsideredAtAimPosition = 2297046941,
        DistFromCoverToAllowReloadCache = 3441446008,
        DistSquaredThresholdAtCrowdRoundPos = 3622532239,
        DistSquaredThresholdMovingToCrowdRoundPos = 3859213332,
        DistToCoverWeight = 2279531977,
        DistToCoverWeightNoStickBonus = 2996089454,
        DistToCoverWeightThreat = 3255589803,
        DistToEntryToAllowForcedActionMode = 1493908582,
        DistToUseShortestRotation = 3490225320,
        DistVicinityOfCrowd = 803081093,
        DistanceBetweenAiPedsCoverAndPlayersCover = 2013288531,
        DistanceForCarChaseShockingEvents = 1719190513,
        DistanceForFull = 3884700100,
        DistanceForMaxTimeBeforeNewPose = 858243059,
        DistanceForMinTimeBeforeNewPose = 3601324404,
        DistanceForStraightLineModeAlways = 2986369414,
        DistanceForStraightLineModeIfLos = 1150609584,
        DistanceLimits = 335839296,
        DistanceToCapSpeed = 3093267843,
        DistanceToEvaluateDoors = 3475018274,
        DistanceToFollowInCar = 3856148267,
        DistanceToFollowVehicleBeforeFlee = 459862259,
        DistanceToRunToVehicle = 1289358659,
        DistanceToSignalVehiclePursuitToCriminal = 783802328,
        DistanceToStart = 64309451,
        DistanceToStartCappingSpeed = 3739118103,
        DistanceToStopMassIdeal = 3823614053,
        DistanceToStopMassWeight = 979399865,
        DistanceToStopMultiplier = 2798838940,
        DistanceToTerminate = 1737497458,
        DistanceToTestDownForVehiclesToReject = 3416628233,
        DistanceToUseGunfireReactAndFleeAnimations = 2597491379,
        DistanceToWallCoverToCover = 1318415761,
        DistanceToWallCrouching = 575575803,
        DistanceToWallStanding = 2650603299,
        DistanceWeighting = 1241525786,
        DistanceWeightingNoStick = 1793159754,
        DistanceXYToUseHeightMapAvoidance = 1504259891,
        DistanceZThresholdForHighHighFall = 4004286054,
        DiveControlExtraDistanceBlendOutSpeed = 4164582757,
        DiveControlExtraDistanceForDiveFromVehicle = 145933303,
        DiveControlMaxFallDistance = 3177202947,
        DiveDepth = 639055889,
        DiveMBR = 3392297418,
        DiveProjectionDistance = 3492375078,
        DiveRampPow = 3048005225,
        DiveWaterOffsetToHitFullyInControlWeight = 2538011040,
        DoAynchronousProbesWhenFindingFreeAimAssistTarget = 2930848614,
        DoCatchFallRelax = 2414092533,
        DoFinalHeadingFixUp = 3946058806,
        DoInitialHeadingBlend = 311045516,
        DoPostCameraClipUpdateForPlayer = 2949921986,
        DofSettings = 3044898952,
        DofSettingsForMobilePhoneShallowDofMode = 1057367158,
        DofSettingsInTightSpace = 2814402846,
        DontRemoveReticuleDuringBlindFireNew = 4136330299,
        DoorAlignmentSettings = 3950418303,
        DoorRatioToConsiderDoorClosed = 3341844967,
        DoorRatioToConsiderDoorOpen = 2420294542,
        DoorRatioToConsiderDoorOpenCombat = 3006117682,
        DoorRatioToConsiderDoorOpenSteps = 2541408088,
        DotProductBehind = 1100440084,
        DotProductFacing = 2732547664,
        DotThresholdForCenterEnter = 762985941,
        DotToClampSpeedToMaximum = 2850579408,
        DotToClampSpeedToMinimum = 628879039,
        DownHillImpactBikeClipId = 450274249,
        DownHillImpactCharClipId = 4170136432,
        DownHillInAirFreeWheelBikeClipId = 4163976723,
        DownHillInAirFreeWheelCharClipId = 2221169411,
        DownHillMinPitchToStandUp = 1599024557,
        DownHillSmallImpactBikeClipId = 896939326,
        DownHillSmallImpactCharClipId = 2199245470,
        DownStairsPelvisMaxDeltaZMoving = 2173480721,
        DownStairsPelvisMaxNegativeDeltaZMoving = 1295091688,
        DownedThreatModifier = 521885682,
        DownwardSpeedLimits = 1575008605,
        DraggerArmIk = 989307764,
        DrawDebug = 2958876793,
        DrawableAltId = 3029420796,
        DrawableIds = 4176789291,
        DriftX = 1925470428,
        DriftY = 4083276309,
        DriftZ = 422585777,
        DriveToGetup = 1589180219,
        DrivingAbilityMax = 866268907,
        DrivingAbilityMin = 1569329370,
        DrivingAggressivenessMax = 534710722,
        DrivingAggressivenessMin = 1151027181,
        Drop = 2901180925,
        DropDistance = 529669607,
        DropDuration = 1445694321,
        DropForRunway = 3113590399,
        DuckAndCoverCanTriggerForPlayerTime = 760739523,
        DuckUnderOverheadCollisionSettings = 2946100032,
        DuplicateDistanceCheck = 735659884,
        DuplicateTimeCheck = 1621558076,
        DurationHeldDownEnterButtonToJackFriendly = 2689559592,
        DurationRampDownCapsulePushedByVehicle = 4163982628,
        DynamicSet1 = 2970224816,
        DynamicSet2 = 3261705071,
        DynamicSet3 = 3903387629,
        ET_AGGRESSIVE_DRIVER = 2353748938,
        ET_AMBIENT_COP = 1795127718,
        ET_COP_PURSUIT = 1484258773,
        ET_CRIME = 1610395939,
        ET_INTERESTING_DRIVER = 2215450775,
        ET_INVALID = 1195757242,
        ET_JAYWALKING = 2126457811,
        ET_SPAWNED_COP_PURSUIT = 1150557519,
        EVENTS_OVERRIDE_FILE = 350410266,
        EVehicleModelColorMetallic_1 = 969376721,
        EVehicleModelColorMetallic_2 = 731244402,
        EVehicleModelColorMetallic_3 = 3537679873,
        EVehicleModelColorMetallic_4 = 3183119293,
        EVehicleModelColorMetallic_5 = 4039766491,
        EVehicleModelColorMetallic_6 = 3777516184,
        EVehicleModelColorMetallic_7 = 229878718,
        EVehicleModelColorMetallic_8 = 4285337393,
        EVehicleModelColorMetallic_9 = 847803751,
        EVehicleModelColorMetallic_normal = 815563434,
        EXPRESSION_SETS_FILE = 3354018708,
        EXTRAMAP_CONVERSION_OCC_FILE = 1691493964,
        EaseIn = 2993575128,
        EaseOut = 4042229056,
        EasyTargettingDifficultyInfo = 1097471232,
        EdgeCapsuleRadius = 3106353871,
        EdgeCoverWeight = 3910547157,
        EdgeEndXOffset = 1400174762,
        EdgeEndYOffset = 1982386380,
        EdgeHighZOffset = 919529730,
        EdgeLowCoverMoveTime = 205550242,
        EdgeLowZOffset = 3480207128,
        EdgeMaximumOffsetDiff = 3256121602,
        EdgeMinimumOffsetDiff = 3457829957,
        EdgeStartXOffset = 3356016298,
        EdgeStartYOffset = 2250358383,
        EdgeTurnAnimStateInfos = 896061089,
        EdgeWeighting = 1511298321,
        Electrocute = 3856838428,
        EnableActivationsFromCapsuleImpacts = 3247587106,
        EnableAimDirectlyIntros = 4050756282,
        EnableBikePickUpAlign = 2377829258,
        EnableBulletBending = 1473266781,
        EnableCloseDoorHandIk = 734813238,
        EnableConflictingNormalCollisionRemoval = 3464583782,
        EnableCoverIdleVariations = 288573626,
        EnableCoverPeekingVariations = 3781531198,
        EnableCoverPinnedVariations = 2498623969,
        EnableCoverToCover = 1136710348,
        EnableFootTagSyncing = 2493304798,
        EnableForcedFireForTargetProximity = 4012970274,
        EnableIkForAI = 138117989,
        EnableInitialHeadingBlend = 914424597,
        EnableJackRateOverride = 583417184,
        EnableLeftHandIkInCover = 2828343094,
        EnableNewAICoverEntry = 661599637,
        EnableNewBikeEntry = 3299231528,
        EnableOpenDoorHandIk = 2861302055,
        EnableRagdollPooling = 325894988,
        EnableRagdollPoolingMp = 503115024,
        EnableReloadingWhilstMovingInCover = 3367723943,
        EnableRotationScaling = 3088085048,
        EnableSideSwipeActivations = 2716995625,
        EnableStreamedEntryAnims = 3726126567,
        EnableStreamedEntryVariationAnims = 2305444416,
        EnableStreamedInVehicleAnims = 774087018,
        EnableTranslationScaling = 1466859809,
        EnableUseSwatClipSet = 3380579615,
        EnableWalkStops = 2560019435,
        EnclosedSearchRegions = 937610588,
        EndHeadingTolerance = 2243016084,
        EndStuckOnVehicle = 3136215640,
        EndStuckOnVehiclePlayer = 2353506762,
        EndStuckUnderVehicle = 2222643548,
        EndStuckUnderVehiclePlayer = 3275734390,
        EnemyAccuracyScaling = 3589303034,
        EnemyCharging = 2545446674,
        EnergyLostPerSecond = 3136810971,
        EnterClipId = 517541874,
        EnterCoverAIAimingBase1H = 1405654072,
        EnterCoverAIAimingBase2H = 2519142628,
        EnterCoverAIAimingSwat1H = 4262460027,
        EnterCoverAIAimingSwat2H = 2653796808,
        EnterCoverAITransition1H = 1017470219,
        EnterCoverAITransition2H = 1163390260,
        EnterCoverAimInterruptDistanceTolerance = 3320233516,
        EnterCoverAimInterruptHeadingTolerance = 2304671979,
        EnterCoverInterruptDistanceTolerance = 1874728809,
        EnterCoverInterruptHeadingTolerance = 3084434327,
        EnterCoverInterruptMinTime = 3889498778,
        EntryPointSets = 769744308,
        EnvelopeRef = 1811750171,
        EqualizeAmount = 4026600462,
        EquipBestWeapon = 962329419,
        ErrorThreshold = 305674207,
        EvaluateThreatFromCoverPoints = 4040000084,
        EvasionThreshold = 2708798326,
        EventDecayTimeMS = 2722629246,
        EventInitInterval = 3561980965,
        EventInterval = 95033849,
        EventlessSwitchDistanceRequirement = 3437799044,
        EventlessSwitchInactivityTimeRequirement = 1865528825,
        EventlessSwitchStateTimeRequirement = 619528635,
        ExactStopTargetRadius = 2433763429,
        ExcludePedBumpAngleFromPushCalculation = 4060868299,
        ExitAttachmentMoveSpeedThreshold = 788433631,
        ExitClipId = 2518432971,
        ExitCornerDirOffset = 498927550,
        ExitCornerYOffset = 1366592047,
        ExitCornerZOffset = 3182801896,
        ExitCoverBaseClipSetId = 150770804,
        ExitCoverExtraClipSetId = 395871171,
        ExitDistance = 3093573752,
        ExitProbeDistance = 4256472352,
        ExitToAimClipSets = 3606683380,
        ExitToAimClipsName = 1926032835,
        ExitToAimVehicleInfos = 2503125343,
        ExitVehicleAttempToFireBlendOutDuration = 95286584,
        ExitVehicleBlendInDuration = 3090579301,
        ExitVehicleBlendOutDuration = 3420274436,
        ExitVehicleMaxDistance = 2200934401,
        ExitVehicleRouteMinDistance = 1946412733,
        ExitVehicleUnderWaterBlendOutDuration = 873885486,
        ExplosiveDamageMod = 2530332272,
        ExposurePush = 2577299971,
        ExtendedDistanceFromWorldCenter = 769039659,
        Extension = 207195018,
        ExtraCameraRelativeVerticalOffset = 2401664616,
        ExtraDistForGoto = 2347754539,
        ExtraDistanceToPushAway = 3893627623,
        ExtraFleeDistance = 695930878,
        ExtraForces = 1349337627,
        ExtraHeadingRate = 1444953847,
        ExtraHeightForGround = 4011421405,
        ExtraOffsetForGroundCheck = 1326750951,
        ExtraOrbitPitchOffsetForHighAngleMode = 4048007163,
        ExtraOrbitPitchOffsetForThirdPersonFarViewMode = 2477951883,
        ExtraSideOffsetForHangingOnLeftSide = 2610056728,
        ExtraSideOffsetForHangingOnRightSide = 843687785,
        ExtraToleranceForStopWatchDistance = 3333208061,
        ExtraTorqueTwistMax = 1612043114,
        ExtraWaterZGroundFixup = 207811054,
        FCT_HALF_SIGMOID = 3916722287,
        FCT_LINEAR = 2803657832,
        FCT_NONE = 383539244,
        FCT_SIGMOID = 157616235,
        FIRINGPATTERNS_FILE = 3015019398,
        FIRST_PERSON = 70078021,
        FRONTEND_DAT_FILE = 2221411686,
        FRONTEND_MENU_FILE = 1803244175,
        FXStack = 1829495763,
        FakeLungeOffset = 614448068,
        FallLandThreshold = 2788362157,
        FallOffAMovingCar = 1639523711,
        FallTestAngleBlendOutTime = 1882364948,
        FallTimeBeforeHighFallAbort = 2093200171,
        FallToKnees = 1740552960,
        FallingSpeedForHighFall = 3699124688,
        FallsOutofVehicleVelocity = 2846727445,
        FastAlignRate = 2551900503,
        FastApproachRate = 2363497120,
        FastDuckPrepLeftBikeClipId = 2693600057,
        FastDuckPrepLeftCharClipId = 1151736662,
        FastDuckPrepRightBikeClipId = 4229390137,
        FastDuckPrepRightCharClipId = 4061011008,
        FastEnterExitRate = 1506926002,
        FastExitDefaultPhaseThreshold = 2055075186,
        FastMinTurnApproachRate = 892232162,
        FastMovingPedSpeed = 1615867498,
        FastRunRateMax = 684879272,
        FastRunRateMin = 2165656152,
        FastTurnAcceleration = 305608474,
        FastTurnApproachRate = 1148310117,
        FastWalkRateMax = 806948898,
        FastWalkRateMin = 1182689916,
        FatallyInjured = 62148721,
        FeetLiftForce = 1163046056,
        FightingModifier = 2538889403,
        FinalShotImpulseClampMax = 1454653034,
        FindPropInEnvironmentDist = 1136341997,
        FindSpawnPointInDirection = 3455230182,
        FineAimBlendSpringConstant = 4207333442,
        FineAimBlendSpringDampingRatio = 1717370547,
        FineAimDownwardsVerticalMovement = 3411810706,
        FineAimHorSpeedMax = 1036145679,
        FineAimHorSpeedMin = 2633888729,
        FineAimHorSpeedPower = 2444069349,
        FineAimHorWeightSpeedMultiplier = 2407796767,
        FineAimSidewaysScale = 2012228463,
        FineAimSpeedMultiplier = 3282516112,
        FineAimSpeedMultiplierClose = 2679873658,
        FineAimSpeedMultiplierCloseDistMax = 286043552,
        FineAimSpeedMultiplierCloseDistMin = 767482079,
        FineAimVerSpeed = 2689623744,
        FineAimVerticalMovement = 1940999374,
        FireTimeAfterChaseOnFoot = 1325474651,
        FireTimeAfterStaticMovementAbort = 1579430656,
        FireTimeAfterStoppingMoveToCover = 475196801,
        FishOutOfWaterDelay = 3728756551,
        FixieSkidLeftBikeClip0Id = 3950475012,
        FixieSkidLeftBikeClip1Id = 874968111,
        FixieSkidLeftCharClip0Id = 1543557460,
        FixieSkidLeftCharClip1Id = 323139173,
        FixieSkidRightBikeClip0Id = 1348669466,
        FixieSkidRightBikeClip1Id = 2864920648,
        FixieSkidRightCharClip0Id = 2616623374,
        FixieSkidRightCharClip1Id = 3652939154,
        FixieSkidToBalanceLeftBikeClip1Id = 2138292255,
        FixieSkidToBalanceLeftCharClip1Id = 2365139646,
        FixieSkidToBalanceRightBikeClip1Id = 1620728723,
        FixieSkidToBalanceRightCharClip1Id = 963408802,
        FleeDistance = 191817975,
        FleeDuringCombat = 1811637113,
        FleeExitExtraRotationSpeed = 4193052421,
        FleeExitExtraTranslationSpeed = 4180330400,
        FleeExitVehicleBlendOutDuration = 2378492841,
        FleeIfApproachedByOtherEntity = 1542742362,
        FleeIfApproachedBySourceEntity = 2924272020,
        FleeMBR = 1024232437,
        FleeMBRMax = 1178169613,
        FleeMBRMin = 1822017225,
        FleeOffset = 335985570,
        FleeReactions = 603736164,
        FleeSafeDistance = 846083482,
        FleeSpeedInVehicle = 1520777858,
        FleeTargetTooCloseDistance = 882826582,
        FlightAngleLimitsForParachutingBraking = 2890662262,
        FlightAngleLimitsForParachutingNormal = 960147082,
        FlightAngleLimitsForSkydiving = 4264481693,
        FlightHeightAboveTarget = 2016619356,
        Flinch = 764802101,
        FlinchDecayTime = 1944104863,
        FlipForce = 3224113269,
        FocusParentToTargetBlendLevel = 2840529796,
        FollowOffset = 3967034351,
        FollowOrientationConing = 70382085,
        FollowPedLookAtBoneTag = 389542769,
        FollowRadius = 353087997,
        FollowTimeout = 2187967175,
        FollowYOffset = 1895961621,
        FollowZOffset = 647976226,
        FootInterp = 1745248481,
        FootInterpIntersecting = 1545915544,
        FootInterpIntersectingMoving = 3264564387,
        FootInterpMoving = 1979344219,
        FootInterpOnDynamic = 67151581,
        ForceAtMaxVelocity = 2377779348,
        ForceAtMinVelocity = 1864398785,
        ForceCower = 4045684189,
        ForceCrime = 1727634143,
        ForceLowCornerEastFaceNorth = 2740301581,
        ForceLowCornerEastFaceSouth = 1105971590,
        ForceLowCornerNorthFaceEast = 1675103884,
        ForceLowCornerNorthFaceWest = 2231393111,
        ForceLowCornerSouthFaceEast = 1921771349,
        ForceLowCornerSouthFaceWest = 1507251800,
        ForceLowCornerWestFaceNorth = 4153767546,
        ForceLowCornerWestFaceSouth = 3854489506,
        ForceMPAnimRatesInSP = 2345403785,
        ForceMag = 3327649992,
        ForceNewMessage = 3330375348,
        ForceNoTimeslicingHeadingDiff = 810486897,
        ForceOverVehicle = 599992998,
        ForcePinnedDown = 5986942,
        ForceRollUp = 1703031604,
        ForceRunDelayTime = 111777931,
        ForceStandEnterOnly = 1408347563,
        ForceStreamingFailure = 2569732609,
        ForceToApply = 71889384,
        ForceToTarget = 243919456,
        ForceUnderVehicle = 2074671276,
        ForceUpdatesWhenTurningStartThresholdRadians = 3756162272,
        ForceUpdatesWhenTurningStopThresholdRadians = 1213035272,
        ForceWindmill = 3831760128,
        ForcedDoorHandleArmIk = 2101205108,
        ForcedLegUpVelocity = 2821506258,
        Forces = 3184237865,
        ForcesForSkydiving = 590082074,
        ForwardAcceleration = 32744136,
        ForwardDirectionThresholdCosSquared = 745911052,
        ForwardDistToStartSideScale = 3395179822,
        FovAcceleration = 1137737707,
        FovLimits = 4288186671,
        FovScalar = 680981764,
        FrameComponents = 2102911583,
        FramesToLookAheadForProbe = 1260903928,
        FreefallThresold = 2222926220,
        Frequency = 2554379728,
        FrequencyNoise = 1511368071,
        FromCarHit = 1362978742,
        FromCoverExitDistance = 2504179355,
        FromOnFootAccelerationMod = 2358855400,
        FromStrafeAccelerationMod = 971520507,
        FromStrafe_MovingBlendOutTime = 1926561545,
        FromStrafe_WeightRate = 2545261234,
        FromValue = 3814756382,
        FromWantedLevel = 1358049181,
        FutureDistanceForMaxSteerAngle = 1786731261,
        FutureDistanceForMinSteerAngle = 2361783730,
        GangScenarioPedToPlayerModifier = 2883008619,
        GetInCombatClipId = 427276467,
        GetInFromWaterClipId = 2521753678,
        GetInRate = 1556614668,
        GetInStandOnClipId = 2593531090,
        GetOnQuickClipId = 923017874,
        GlobalLateralTorsoOffsetInLeftCover = 3909527233,
        GotoWatchRange = 2651403585,
        GravityScale = 1393168468,
        GroundFixupHeight = 4272192282,
        GroundFixupHeightBoatInWater = 667507334,
        GroundFixupHeightBoatInWaterInitial = 93138639,
        GroundFixupHeightLarge = 1434272564,
        GroundFixupHeightLargeOffset = 3416772737,
        GroundMaterialProbeDepth = 883567309,
        GroundMaterialProbeOffset = 2995052029,
        GroundMaterialSpawnCoordNormalZTolerance = 1328674939,
        GroupId = 1405734818,
        GroupMemberSlowDownDistance = 2525435888,
        GroupMemberWaitDistance = 4219594699,
        GroupMemberWaitMinTime = 2050658669,
        GroupMemberWalkCloseDistance = 3760186281,
        GuardWorldExtents = 1651229959,
        GunShotThresholdDistance = 3483089763,
        HBC_Randomize = 2066966848,
        HBC_Retain = 1409024016,
        HELI = 3778816900,
        HORSE_REINS_FILE = 1866311889,
        HUD_TXD_FILE = 1987285695,
        HandBrakeControl = 1151983218,
        HandBrakeInputEnvelopeRef = 73888528,
        HandBrakeSwingSettings = 3703185618,
        HandGunDamageMod = 1873521687,
        HandcuffedClipSetId = 1015537615,
        HangingAroundVehicleModifier = 420424724,
        HasCreateWeaponTag = 3631567393,
        HasInterruptTag = 1944180374,
        HasSixDirections = 3697908634,
        HasStickInputThreshold = 2573017241,
        HashOrdering = 3243012891,
        Hashes = 2753590613,
        HeadAndNeck = 3404836153,
        HeadLook = 3103279089,
        HeadShot = 800099441,
        HeadShotImpulseMultiplier = 3053385153,
        HeadShotMPImpulseMultiplier = 1084989136,
        HeadingAcceleration = 426969157,
        HeadingChangeRate = 2653769818,
        HeadingCorrection = 472852554,
        HeadingDelta = 2891994847,
        HeadingDiffStartBlendDegrees = 1440906110,
        HeadingOffset = 2344149746,
        HeadingPullAroundErrorScalingBlendLevel = 1199102981,
        HeadingPullAroundMaxMoveSpeed = 3319639913,
        HeadingPullAroundMinMoveSpeed = 3078528158,
        HeadingPullAroundSpeedAtMaxMoveSpeed = 1466199679,
        HeadingPullAroundSpringConstant = 1332565251,
        HeadingPullAroundSpringDampingRatio = 4054409124,
        HeadingReachedTolerance = 452418176,
        HeadingScoreForCoverLockOnRejection = 155512302,
        HeadingToleranceDegrees = 3997955765,
        HeadingWanderChange = 3829108144,
        HeadingWeighting = 328254695,
        HeadingWeightingNoStick = 1613714646,
        HealthBar = 133430210,
        HealthConfigHash = 372913173,
        HealthMultiplierBonus = 2121757492,
        HealthRatioLimit = 2392243130,
        HealthRegenEfficiency = 2721388482,
        HeavyBrakeYAcceleration = 2551415238,
        HeightChangeSettleBlendDuration = 3719483743,
        HeightMapDelta = 1983182002,
        HeightMapLookAheadDist = 552115106,
        HeightScaling = 1920226182,
        HeightToStartLanding = 3067654195,
        HeightToStartWrithe = 2221851990,
        HeliPedModelId = 2549257506,
        HeliSpeedModifier = 641071834,
        HeliTargetArriveDist = 2931101691,
        HeliVehicleModelId = 1696043144,
        Helis = 847633247,
        HighAltitudeZoomSettings = 2054392766,
        HighBlindFireAimingDirectlyLimitAngle = 298108981,
        HighCloseEdgeWallTestYOffset = 1632533833,
        HighCoverBlendInDuration = 4171399035,
        HighCoverClipRate = 677754437,
        HighCoverProbeHeight = 1565700819,
        HighFallProbeLength = 934569024,
        HighFallTimeToBlockInjuredOnGround = 1503093096,
        HighHighFallEnd = 1799229733,
        HighHighFallStart = 1342466268,
        HighImportanceModifier = 786235913,
        HighJumpMaxAngleForVelScale = 2289178459,
        HighJumpMaxVelScale = 3965084574,
        HighJumpMinAngleForVelScale = 910411457,
        HighJumpMinVelScale = 1943815238,
        HighLeftAimStepInfoSet = 80679158,
        HighLodWalkHeadingLerpRate = 2391787980,
        HighOpenDoorClipId = 3849261684,
        HighRightAimStepInfoSet = 2338326271,
        HighSpeedShakeSettings = 3319637384,
        HighSpeedZoomSettings = 2646605713,
        HighVelocity = 4250665956,
        HighVelocityBlendOut = 468457579,
        HintHelperRef = 730193180,
        History = 3024574816,
        HistoryCosineThreshold = 3400740468,
        HitRandomisation = 3061537468,
        HitRandomisationAutomatic = 4009335731,
        HoldLegOutVelocity = 682602058,
        HoldSub = 1878184186,
        HoldingSingleHandedWeapon = 3720463376,
        HoldingTwoHandedWeapon = 3291888789,
        HoldingWeaponBonus = 4170306057,
        HoldingWeaponPlayerModifier = 1493940343,
        HotPedDisableSexinessFlagChecks = 674468988,
        HotPedMaxDistance = 2831412815,
        HotPedMaxDotAngle = 1194287595,
        HotPedMaxHeightDifference = 3233483053,
        HotPedMinDistance = 334092093,
        HotPedMinDotAngle = 101327813,
        HotPedRenderDebug = 248477757,
        HotwireClipId = 2232368689,
        HotwireRate = 1960961110,
        HumanBodyScale = 3219752194,
        HumanPelvisScale = 938878998,
        HumanSpine0Scale = 670734777,
        HumanSpine1Scale = 2267090113,
        HurryAwayInitialMBR = 1287855842,
        HurryAwayMBRChangeDelay = 162073420,
        HurryAwayMBRChangeRange = 2978098349,
        HurryAwayMoveBlendRatioWhenFar = 199132405,
        HurryAwayMoveBlendRatioWhenNear = 3010798658,
        HurryAwayWatchFirst = 3611561302,
        IDE_FILE = 3422262499,
        IN_AIRCRAFT = 3210104948,
        IN_BOAT = 1045637820,
        IN_HELI = 2079134431,
        IN_SUBMARINE = 2742629541,
        IN_TURRET = 4177603501,
        IdealDistance = 2913237777,
        IdealDistanceCouldLeaveCar = 13763777,
        IdealDistanceForPursue = 514678423,
        IdealDistanceIfArmed = 3291058825,
        IdealDistanceIfUnarmed = 172591904,
        IdealDistanceInVehicleAndTargetArmed = 2541599029,
        IdealDistanceInVehicleAndTargetUnarmed = 922557972,
        IdealDistanceOnBikeAndTargetArmed = 1876514812,
        IdealDistanceOnBikeAndTargetUnarmed = 2051473778,
        IdealDistanceShotAt = 150170926,
        IdealHeadingOffsetForLimiting = 3658085406,
        IdealPitchForFiringVariation = 1908604654,
        IdealSpawnDistance = 652074796,
        IdealTurnApproachRate = 1298540281,
        IdentificationRange = 625679404,
        IdleAnimStateInfos = 3037289130,
        IdleCmini = 1252108818,
        IdleHeadingLerpRate = 183241195,
        IdleHigh1HVariationClipsets = 2565051320,
        IdleHigh2HVariationClipsets = 616197965,
        IdleLow1HVariationClipsets = 229574996,
        IdleLow2HVariationClipsets = 754984064,
        IdleTimeRandomFactor = 2115224183,
        IdleTransitionBlendTimeFromActionMode = 639925745,
        IdleTransitionBlendTimeFromStealth = 1990190949,
        IdleVariationAnimStateInfos = 1977186530,
        IdleYStartOffset = 3646563039,
        IgnoreFovForHeadIk = 2404066730,
        IgnoreIfSensingPedIsOtherEntity = 4035148525,
        IgnoreRotationBlend = 2067979515,
        ImmediateHighFallSpeedAi = 696030652,
        ImmediateHighFallSpeedPlayer = 187177991,
        ImpulseMult = 959886766,
        Impulses = 245896742,
        InAir = 1916434556,
        InAirFreeWheelBikeClipId = 3916128451,
        InAirFreeWheelCharClipId = 4285496170,
        InAirHeadingRate = 712615227,
        InAirMovementApproachRate = 2498638030,
        InAirMovementRate = 1308347600,
        InAirProbeDistance = 3752389553,
        InAirProbeForwardOffset = 4171402878,
        InAirZAccelTrigger = 1568293823,
        InBoat = 3499358923,
        InCoverMovementSpeed = 3787797455,
        InCoverMovementSpeedEnterCover = 1291062567,
        InCoverScoreModifier = 1975453329,
        InCoverTolerance = 3968028188,
        InDuration = 2456685333,
        InHeli = 345193988,
        InMotionAlignmentVelocityTolerance = 891286257,
        InMotionTighterTurnsVelocityTolerance = 3646294886,
        InPlaceAlignmentVelocityTolerance = 2324978953,
        InRangeDrivingPlayerModifier = 3099253594,
        InRangePlayerDistanceThreshold = 395317425,
        InRangePlayerInRaceDistanceThreshold = 1849354099,
        InRangePlayerModifier = 3120269183,
        InVehicle = 3094451383,
        InVehicleLookAtDampingRef = 556138114,
        InWaterExitDepth = 1332340783,
        InWaterExitProbeLength = 1768336421,
        IncidentLocation = 2790865931,
        IncreasedAerialSpawningFactor = 3248533699,
        IncreasedAquaticSpawningFactor = 1340414393,
        IncreasedGroundWildlifeSpawningFactor = 1785192888,
        InflectionPitch = 1035721466,
        Info = 4197530443,
        InitialAreaTimeoutWhenCrimeReported = 3003441217,
        InitialAreaTimeoutWhenSeen = 922425823,
        InitialBumpComponent = 406034015,
        InitialBumpForce = 2701068933,
        InitialBumpOffset = 1000319425,
        InitialDelay = 1832992496,
        InitialForce = 2966151540,
        InitialForceComponent = 871993282,
        InitialForceOffset = 279094028,
        InitialLowEdgeTestEndYOffset = 1933569235,
        InitialLowEdgeTestStartYOffset = 1759052099,
        InitialLowEdgeWallTestYOffset = 420444049,
        InitialRagdollDelay = 1901527010,
        InitialRelativeHeadingLimits = 1115426652,
        InitialRelativePitchLimits = 113692134,
        InitialTerrainAvoidanceAngleD = 3968352519,
        InitialWorldPitchLimits = 1692207327,
        InnerDistanceThreshold = 2348909882,
        InputEnvelopeRef = 1933675573,
        InputMagPowerFactor = 3265151949,
        InputMagToIncreaseDeadZoneMax = 4159970100,
        InputMagToIncreaseDeadZoneMin = 3261011203,
        InputType = 1445865118,
        InputYAxisCornerExitValue = 2129665503,
        InputYAxisQuitValue = 1147378819,
        InsideCornerStopDistance = 3341714290,
        InsideEdgeEndXOffset = 2929248824,
        InsideEdgeEndYOffset = 1055186370,
        InsideEdgeStartXOffset = 2121459739,
        InsideEdgeStartYOffset = 2408138725,
        InstantProbeDurationMin = 4060945649,
        InterpRates = 78660797,
        IntroClip0Id = 4104220306,
        IntroClip1Id = 430012531,
        IntroClipId = 3802470907,
        IntroMaxScale = 842076929,
        IntroMovementDuration = 3673514744,
        IntroRate = 1649508716,
        IntroRotScalingDefaultEndPhase = 1894035381,
        IntroRotScalingDefaultStartPhase = 1515476732,
        IntroScalingDefaultEndPhase = 4206558217,
        IntroScalingDefaultStartPhase = 3371499882,
        InvMassScale = 514198685,
        InverseMassScales = 172669903,
        IsBehindVehicleGlass = 3132205970,
        IsCasual = 3169257000,
        IsChild = 2962717212,
        IsCrouching = 1674350800,
        IsDangerousAnimal = 1867113976,
        IsGang = 1945623796,
        IsHuman = 2212592004,
        IsLocal = 3419197588,
        IsMale = 819954510,
        IsSecurity = 622092394,
        IsStationary = 4172129738,
        IsWeird = 1025165367,
        Items = 2880561169,
        JOB_AND_NAME_MED = 1218436764,
        JackingModifier = 2688373686,
        JetskiDrivebyFilterId = 2134287489,
        JumpCollision = 1017102101,
        JumpFallTestAngle = 793837940,
        JumpOutofSubNeutralBuoyancyTime = 2102914796,
        KeepWeapon = 1218243798,
        KickOnGroundTuning = 1543515715,
        KnockOffBikeEjectImpactFriction = 3996231382,
        KnockOffBikeEjectMaxImpactDepth = 301898848,
        KnockOffBikeForwardMaxComponent = 2466946069,
        KnockOffBikeForwardMinComponent = 2251372495,
        KnockOffBikeMaxSpeed = 2357933858,
        KnockOffBikeMaxUpright = 3242658957,
        KnockOffBikeMinSpeed = 2854807360,
        KnockOffBikeMinUpright = 4180033042,
        KnockOffBikePitchMaxComponent = 2962336026,
        KnockOffBikePitchMinComponent = 164203436,
        KnockOffBikeUpMaxComponent = 2641066262,
        KnockOffBikeUpMinComponent = 3963787762,
        LADDER_METADATA_FILE = 873638153,
        LEADERBOARD_DATA_FILE = 153829429,
        LEGALS = 4072415756,
        LEVEL_STREAMING_FILE = 3625514299,
        LOOKIK_BLEND_RATE_FAST = 373155899,
        LOOKIK_BLEND_RATE_FASTEST = 2515903841,
        LOOKIK_BLEND_RATE_INSTANT = 1486063330,
        LOOKIK_BLEND_RATE_NORMAL = 1833278132,
        LOOKIK_BLEND_RATE_SLOW = 986173808,
        LOOKIK_BLEND_RATE_SLOWEST = 3711568277,
        LOOKIK_ROT_LIM_NARROW = 3906611689,
        LOOKIK_ROT_LIM_NARROWEST = 1073022306,
        LOOKIK_ROT_LIM_OFF = 49782489,
        LOOKIK_ROT_LIM_WIDE = 1112780501,
        LOOKIK_ROT_LIM_WIDEST = 1594514833,
        LOOKIK_TURN_RATE_FAST = 2235154210,
        LOOKIK_TURN_RATE_NORMAL = 3984591931,
        LOOKIK_TURN_RATE_SLOW = 2708677357,
        LOOK_FORWARD_RELATIVE_TO_ATTACH = 2580680746,
        LSAcceleration = 2358484554,
        LSDeadZoneAngle = 2899233953,
        LSDeceleration = 4267995471,
        LackOfHostility = 2857118825,
        LadderAlignment = 2014258089,
        LadderPitch = 2326671617,
        LandHeadingModifier = 1347777197,
        LandProbe = 1166908668,
        LandProbeLength = 2205933583,
        LandRollHeight = 3897556344,
        LandRollHeightFromJump = 2847920310,
        LandRollHeightFromVault = 3337751765,
        LandSlopeNoseUpMax = 3983307371,
        LandSlopeNoseUpMin = 564764161,
        Landing = 1163966079,
        LargeVerticalAccelerationDelta = 4247487957,
        LastBattleEventHighEnergyEndTime = 2064072700,
        LastBattleEventHighEnergyStartTime = 271833144,
        LastSpottedDistance = 2553544690,
        LastStand = 1877343639,
        LastStandArmoured = 745594459,
        LastStandMaxArmouredTotalTime = 2286694021,
        LastStandMaxTotalTime = 417172126,
        LateralForce = 2100597904,
        LaunchLeftBikeClipId = 3073315828,
        LaunchLeftCharClipId = 1333997798,
        LaunchRightBikeClipId = 3808805794,
        LaunchRightCharClipId = 945663205,
        LayerA = 3994552921,
        LayerB = 3761008258,
        LayerBlend = 3968024215,
        Layers = 4018703742,
        LeaderExitVehicleDistance = 676285031,
        LeanAngleDefaultRate = 1850650077,
        LeanAngleDefaultRatePassenger = 1393469938,
        LeanAngleReturnRate = 1365613076,
        LeanAngleReturnedTol = 4254763028,
        LeanAngleSmoothingRate = 541806245,
        LeanForwardsAngleSmoothingRate = 4228832635,
        LeanScale = 2484601688,
        LeanSidewaysAngleMaxAccAngle = 4058717361,
        LeanSidewaysAngleMinAccAngle = 4159734133,
        LeanSidewaysAngleSmoothingAcc = 1551960100,
        LeanSidewaysAngleSmoothingRateMax = 1540399603,
        LeanSidewaysAngleSmoothingRateMin = 525349387,
        LeaningExtremeThreshold = 48278855,
        LeftBoneOffset = 416915558,
        LeftGrip = 102733762,
        LeftHandOffset = 2557494577,
        LeftPickUpTargetLerpPhaseEnd = 354147533,
        LeftPickUpTargetLerpPhaseEndBicycle = 3597820233,
        LeftPickUpTargetLerpPhaseStart = 3911832280,
        LeftPickUpTargetLerpPhaseStartBicycle = 706443375,
        LeftPullUpTargetLerpPhaseEnd = 2320755313,
        LeftPullUpTargetLerpPhaseEndBicycle = 3214386681,
        LeftPullUpTargetLerpPhaseStart = 4195927131,
        LeftPullUpTargetLerpPhaseStartBicycle = 2664369195,
        LeftRightStickInputMin = 3223119611,
        LeftRightStickInputSmoothingRate = 1082826303,
        LeftWire = 2742077142,
        LegShot = 2675545657,
        LegShotFallRootImpulseMinUpright = 4252723795,
        LegShotFallRootImpulseMult = 184133535,
        LengthScaling = 4135147407,
        LensArtefact = 661891977,
        LimbStrengthTuning = 2622719195,
        LimitAttachParentRelativePitchAndHeading = 2799648005,
        LimitMeleeRangeToDefault = 1169108573,
        LineOfSight = 2250254670,
        LineOfSightStatus = 682590761,
        LineOfSightTests = 728351840,
        LinearVZForBrakingDifferenceMax = 119610653,
        LinearVZForBrakingDifferenceMin = 950864184,
        LinearVZForPitchRatioMax = 332728501,
        LinearVZForPitchRatioMin = 135326749,
        LocationForNearestCarNodeOverrides = 3346068581,
        LockOnDistanceLimits = 4280147981,
        LockOnDistanceRejectionModifier = 2510305536,
        LockOnEnvelopeRef = 2833081775,
        LockOnOrbitDistanceSettings = 4165908011,
        LockOnRangeModifier = 3927328861,
        LockOnSwitchTimeExtensionBreakLock = 1952125540,
        LockOnSwitchTimeExtensionKillTarget = 2774244387,
        LockOnTargetDampingSettings = 1635236307,
        LockOnTargetStunnedEnvelopeRef = 2209545096,
        LockType = 4263854907,
        LongitudinalBodyLeanApproachRate = 373069342,
        LongitudinalBodyLeanApproachRateSlope = 4228525959,
        LongitudinalBodyLeanApproachRateSlow = 1466153272,
        LookAheadDistanceForBackAway = 1706779012,
        LookAheadForRunway = 1293732320,
        LookAround = 4270549134,
        LookAtBehaviour = 589368866,
        LookAtOffset = 1190303903,
        LookAtTime = 3780096928,
        LookAtUpdateTime = 1858185525,
        LookBehindOutroTimeMS = 537305387,
        LookBehindRelativeAttachPosition = 2548218645,
        LookOverSettings = 3300166924,
        LookingInRangePlayerMaxDotAngle = 1018069509,
        LoopClipId = 3333920819,
        LoopClipSetId = 3859145463,
        LoopMode = 3135858693,
        LostBalanceAndGrabbing = 944999838,
        LowBlindFireAimingDirectlyLimitAngle = 2323225479,
        LowBlockedBlend = 2527050941,
        LowCoverBlendInDuration = 2789076521,
        LowCoverClipRate = 1362808676,
        LowCoverProbeHeight = 4155982221,
        LowImportanceModifier = 592353395,
        LowLeftStep = 4111569262,
        LowLod = 3357299335,
        LowLodBaseClipSetId = 664477457,
        LowLodExtraHeadingAdjustmentRate = 3846215494,
        LowLodIdleClipSetId = 2167334901,
        LowLodWalkHeadingLerpRate = 3008826210,
        LowOffsetCapsuleLength = 568360986,
        LowOffsetCapsuleRadius = 4015224528,
        LowRightStep = 4205427545,
        LowSideZOffset = 1655026590,
        LowStepBackLeftXBlocked = 2531405930,
        LowStepBackLeftYBlocked = 2343990340,
        LowStepBackRightXBlocked = 3516373800,
        LowStepBackRightYBlocked = 3372482096,
        LowStepOutLeftXBlocked = 842428202,
        LowStepOutLeftYBlocked = 3532419784,
        LowStepOutRightXBlocked = 8574286,
        LowStepOutRightYBlocked = 298303912,
        LowVelocityReactionThreshold = 2079428645,
        LowXClearOffsetCapsuleTest = 2818774649,
        LowXOffsetCapsuleTest = 3545526197,
        LowYOffsetCapsuleTest = 717814241,
        LowZOffsetCapsuleTest = 2260315698,
        LowerArmImpulseCap = 3002630191,
        LowerArmNoTorseHitImpulseCap = 2054532609,
        LungeChangeDistance = 1585455214,
        LungeForwardOffset = 2740115372,
        LungeTargetRadius = 2981439007,
        LungeZOffset = 3783579394,
        MOTION_TASK_DATA_FILE = 775482934,
        MOTIVATIONS_FILE = 2957501757,
        MOUNT_TUNE_FILE = 2889043007,
        MPLargeAccidenThresold = 2099608654,
        Mag = 2130375977,
        MagnitudeClamp = 3388239219,
        MatchTargetWeapon = 2028274881,
        MatchTimer = 219280121,
        MaxAbsDotForAvoidDirected = 462717652,
        MaxAbsThrottleForCloseDoor = 1734471519,
        MaxAccelModifier = 150232389,
        MaxAcceleration = 2732255867,
        MaxAccelerationForLean = 419181205,
        MaxAdjustmentLookAhead = 4125886772,
        MaxAiActivationLimit = 1737477488,
        MaxAimFromGroundTime = 3996785209,
        MaxAimTimeOnStickMs = 1480451859,
        MaxAltitudeDelta = 2362779209,
        MaxAmbientVehiclesToSpawnChase = 3549282925,
        MaxAmplitude = 272708601,
        MaxAngle = 3503009483,
        MaxAngleConsidered = 2451123132,
        MaxAngleDeltaForLockOnSwitchBlendScaling = 2783842060,
        MaxAngleForScaleVelocityExtension = 360286196,
        MaxAnglePickPOI = 527596719,
        MaxAngleToBeginRotationScale = 3171601208,
        MaxAngleToSetDirectly = 3073391680,
        MaxAngularDiffBetweenDynamicAndStaticCover = 2761743161,
        MaxAngularHeadingVelocityAi = 4125755684,
        MaxAngularHeadingVelocityPlayer = 63113045,
        MaxAngularHeadingVelocityPlayerForcedStandAim = 1486772652,
        MaxAngularVelocity = 1393994109,
        MaxAngularVelocityScaleFactor = 3006329763,
        MaxArmourImpulseMult = 1393173723,
        MaxAttachParentDepthUnderWaterToRemainBuoyant = 2069938157,
        MaxAttachParentDepthUnderWaterToRemainBuoyantOut = 1698601922,
        MaxAttachParentSpeedToClonePitchFromCinematicMountedCameras = 150825038,
        MaxAttachParentSubmergedLevelToApplyFullAttachParentMatrixForRelativeOrbit = 3039556728,
        MaxBackOffDistance = 2075820886,
        MaxBaseFovScaling = 785828068,
        MaxBlendDurationForInitialLockOn = 1807116888,
        MaxBlendDurationForLockOnSwitch = 3132164856,
        MaxBrake = 1676250682,
        MaxCapsuleTests = 961760330,
        MaxCircleRadius = 3815425058,
        MaxClipsToCheckPerFrame = 1435927021,
        MaxCollisionFallBackBlendLevelToForceUnderWater = 2382802886,
        MaxCollisionRootSpeedToForcePopIn = 35427940,
        MaxCollisionRootSpeedToPausePullBack = 4012884170,
        MaxCollisionTestRadius = 2696635175,
        MaxCombineDistThresholdSquared = 3413677046,
        MaxCruiseSpeed = 2890274297,
        MaxCruiseSpeedMultiplier = 4219085548,
        MaxCruiseSpeedWhenClamped = 3775809407,
        MaxDamageTakenImpulseMult = 253998194,
        MaxDamageTakenThreshold = 4025040637,
        MaxDamageToCheckForRandomDeath = 4042046110,
        MaxDamageToIgnore = 2744941697,
        MaxDeccelModifier = 1410651137,
        MaxDeceleration = 1689883019,
        MaxDefaultAngularVelocity = 2408710412,
        MaxDefendPointWaitTimeMS = 3128562978,
        MaxDelay = 509314747,
        MaxDelayExitTime = 3125460893,
        MaxDelayForGetOff = 1867895091,
        MaxDelayTimeForExitVehicle = 2049624973,
        MaxDelayTimer = 2906908712,
        MaxDifferenceToAverageBrakes = 87152394,
        MaxDirectionVariance = 3433998695,
        MaxDistScanArc = 2704081606,
        MaxDistToConsiderPedGoingToDoorPriority = 4213098799,
        MaxDistToConsiderVehicleValid = 2104384861,
        MaxDistToCoverWhenPlayerIsClose = 2168923712,
        MaxDistToCoverXY = 2157843494,
        MaxDistToCoverZ = 2187323127,
        MaxDistToPathDefault = 819069056,
        MaxDistToVehicle = 1250203641,
        MaxDistUpdateFrequency = 3216270742,
        MaxDistanceAbovePedPositionToClampPitch = 1654280371,
        MaxDistanceAiPedFromTheirCoverToAbortPlayerEnterCover = 1955233508,
        MaxDistanceAroundClosestRoadNode = 1354574680,
        MaxDistanceErrorToIgnore = 1819399769,
        MaxDistanceForAmbientReaction = 2167383018,
        MaxDistanceForAvoid = 1319056930,
        MaxDistanceForAvoidDirected = 1721238833,
        MaxDistanceForBackAway = 2592101241,
        MaxDistanceForDispatchPosition = 43531000,
        MaxDistanceForFineAimScaling = 70391041,
        MaxDistanceForHolster = 3926218692,
        MaxDistanceForLawToReturnToCombatFromFlee = 115479140,
        MaxDistanceForOrientation = 3358534575,
        MaxDistanceForPedToBeVeryCloseToCover = 3273119465,
        MaxDistanceForRiverWaterClippingTest = 753638141,
        MaxDistanceForSearch = 2973796969,
        MaxDistanceForSlowdown = 2085906895,
        MaxDistanceForTaint = 688870759,
        MaxDistanceForWaterClippingTest = 102161666,
        MaxDistanceFromCameraForViewportChecks = 3017247137,
        MaxDistanceFromNavMesh = 1798086221,
        MaxDistanceFromOptimal = 2733041160,
        MaxDistanceFromPed = 1011332177,
        MaxDistanceFromPedToHelpPed = 3390705532,
        MaxDistanceFromRoadNode = 4277520254,
        MaxDistanceFromTargetToForceStraightLineMode = 2229910851,
        MaxDistanceNavmeshMayAdjustPath = 3452202501,
        MaxDistanceToAdjustSpeed = 2070026726,
        MaxDistanceToAlwaysLookAtTarget = 4029768824,
        MaxDistanceToBeConsideredClumped = 2154790128,
        MaxDistanceToBeConsideredOptimal = 1883452103,
        MaxDistanceToCareAboutBlockingLineOfSight = 803259673,
        MaxDistanceToCheckEntryCollisionWhenIgnoring = 3271021322,
        MaxDistanceToClampCruiseSpeed = 3954141229,
        MaxDistanceToConsiderClose = 1501439076,
        MaxDistanceToConsiderCloseToPositionToMoveTo = 2494967040,
        MaxDistanceToConsiderTooClose = 3348150388,
        MaxDistanceToContinueFromPursue = 3842476462,
        MaxDistanceToFindVehicle = 702493934,
        MaxDistanceToHoldFireForArrest = 655626928,
        MaxDistanceToInsult = 3792438004,
        MaxDistanceToMyVehicleToChase = 2374284734,
        MaxDistanceToPersist = 3073979382,
        MaxDistanceToPursueVehicle = 1506267647,
        MaxDistanceToReactToJackForGoToDoor = 3839836820,
        MaxDistanceToReturnToLastUsedVehicle = 1770714176,
        MaxDistanceToScanForNearbyVehicle = 2354829088,
        MaxDistanceToScanLookAts = 491173128,
        MaxDistanceToSearchForAquaticPoints = 1744844248,
        MaxDistanceToSearchForGroundWildlifePoints = 1961260334,
        MaxDistanceToSideOnPavement = 1016024123,
        MaxDistanceToStartFromPursue = 648063710,
        MaxDistanceToStartMatchingSpeed = 2246107998,
        MaxDistanceToTalk = 1179075662,
        MaxDistanceToUseUrgentTransitions = 2236196658,
        MaxDistanceToVehicleForCommandeer = 3887134676,
        MaxDistanceToWatchVehicle = 3050367607,
        MaxDistanceTraveledMultiplier = 713008535,
        MaxDiveHeight = 2479363241,
        MaxDoorSpeedToConsiderClosingDoor = 3503503802,
        MaxDot = 3500436404,
        MaxDotForHandBrake = 1930122576,
        MaxDotToApplyTorque = 403672092,
        MaxDotToContinueFromAnalyze = 126845285,
        MaxDotToStartFromAnalyze = 1082929500,
        MaxDotToTargetToHelpPed = 3200641731,
        MaxDriverTimeToLeaveVehicle = 3023143341,
        MaxDuration = 3115459373,
        MaxDurationForMultiplayerViewModeActivation = 1552516033,
        MaxDurationToTrackVehicles = 2514003172,
        MaxEncumberedClimbHeight = 4241887050,
        MaxEscapeDistance = 1872481699,
        MaxExtraHeightForTowedVehicles = 3584381811,
        MaxExtraHeightForVehicleTrailers = 2086333922,
        MaxExtraMoney = 471524408,
        MaxFacingThreshold = 1107258897,
        MaxFallHeight = 355034181,
        MaxFleeMoveBlendRatio = 2916287204,
        MaxFlinchDistance = 1218603971,
        MaxForceFiringDistance = 2117446694,
        MaxForceFiringStateTime = 1120297675,
        MaxForwardSpeed = 2306378250,
        MaxForwardsPitchFastSpeed = 1535257534,
        MaxForwardsPitchSlope = 1260039600,
        MaxForwardsPitchSlopeBalance = 2058043106,
        MaxForwardsPitchSlowSpeed = 705106159,
        MaxForwardsPitchWheelieBalance = 2198401741,
        MaxFov = 3615529910,
        MaxGameplayNmAgents = 1794949754,
        MaxGameplayNmAgentsMp = 3172335713,
        MaxGrabTime = 2123286016,
        MaxHandToHandleDistance = 2222197615,
        MaxHandleHeightDiff = 474312049,
        MaxHandleHeightDiffVan = 3933910603,
        MaxHeadingAdjustmentRate = 1871838464,
        MaxHeadingAlignmentCosThreshold = 3382384728,
        MaxHeadingAngle = 3669858468,
        MaxHeadingDiffBetweenCTCPoints = 225620543,
        MaxHeadingDifferenceForQuickGlanceInSameDirection = 4164431042,
        MaxHeadingSpeed = 1529419507,
        MaxHealthImpulseMult = 3839056884,
        MaxHealthLossForQuickGetup = 1165801413,
        MaxHeavyCrashDeathChance = 1466872193,
        MaxHeight = 4276410337,
        MaxHeightDifference = 3332963351,
        MaxHeightDifferenceToApproachTarget = 1288859935,
        MaxHeliDamping = 3700594697,
        MaxHoldBreathDuration = 1166926746,
        MaxHoverHeightDistToWarpIntoHeli = 2914709570,
        MaxImpulse = 1400954876,
        MaxInjuredTargetTimerVariation = 1511702574,
        MaxInputForIdleExit = 2059966079,
        MaxInstances = 2118495770,
        MaxIntensity = 1137728512,
        MaxIterations = 3378768739,
        MaxJumpHeightForSmallImpact = 1962859811,
        MaxLateralSkidSpeed = 3579471989,
        MaxLeanInDirectionTime = 2519882664,
        MaxLength = 977032494,
        MaxLift = 489565795,
        MaxLimit = 597877266,
        MaxLinearVelocity = 1416568288,
        MaxLookAroundMoveSpeedMultiplier = 2563263345,
        MaxLookAtArmWoundTime = 2663144521,
        MaxLookAtDistance = 2034399215,
        MaxLookBackAngle = 894057762,
        MaxMag = 3421300414,
        MaxMoveOrientationSpeedDuringLookAround = 1286077706,
        MaxMoveSpeedForFollowOrientation = 1014809841,
        MaxMoveSpeedInCover = 2814625688,
        MaxMoveToDefensiveAreaAngleVariation = 2154434340,
        MaxMovingProbeOffset = 4049257140,
        MaxMovingThreshold = 3214855311,
        MaxNavmeshPatrolRadiusFactor = 1708395848,
        MaxNearbyToFindPerFrame = 1638764838,
        MaxNumPedsAllowedToBeVeryCloseToCover = 1481327584,
        MaxNumPedsChasingOnFoot = 2540858782,
        MaxNumRequestsPerContext = 1337224709,
        MaxNumberCopVehiclesInChase = 1965911345,
        MaxNumberFakeApproaches = 284429428,
        MaxOffset = 826600434,
        MaxOpenRatioForOpenDoorInitialInside = 4028760366,
        MaxOpenRatioForOpenDoorInitialOutside = 4222207562,
        MaxOpenRatioForOpenDoorInside = 2427558104,
        MaxOpenRatioForOpenDoorOutside = 1484783860,
        MaxOscillationDisplacementInside = 2206944099,
        MaxOscillationDisplacementOutside = 1118824342,
        MaxParachutePitch = 1610340719,
        MaxParachuteRoll = 888388965,
        MaxPassengerTimeToLeaveVehicle = 3100475498,
        MaxPassengersForAttraction = 865654234,
        MaxPhoneFilmTime = 3084950400,
        MaxPhoneFilmTimeHurryAway = 2306714989,
        MaxPitch = 4261179401,
        MaxPitchAngle = 1021608480,
        MaxPitchAngle2H = 2966888023,
        MaxPitchDefault = 3807823759,
        MaxPitchDifferenceForFiringVariation = 644208462,
        MaxPitchInAir = 422547942,
        MaxPitchSpeed = 1910928125,
        MaxPitchingAnglePickPOI = 3709479259,
        MaxPlaneControlAbility = 1011508514,
        MaxPlaneDamping = 353529649,
        MaxPlayerActivationLimit = 83737662,
        MaxPlayerCapsulePushTimeForRagdollActivation = 2253067348,
        MaxPlayerScore = 2407947760,
        MaxPlayerToCoverDist = 4030958526,
        MaxPositionVariance = 2240856053,
        MaxPreCollisionCameraSpeedToForcePopIn = 4130418064,
        MaxPreCollisionCameraSpeedToPausePullBack = 2824365723,
        MaxRadius = 466062419,
        MaxRadiusForMaxTimeSinceLastSpotted = 208554060,
        MaxRadiusForMinTimeSinceLastSpotted = 679039028,
        MaxRageRagdolls = 2482945086,
        MaxRageRagdollsMp = 1068424255,
        MaxRangeWithoutRadioForFistFights = 2602588680,
        MaxRate = 1154906885,
        MaxRateForInVehicleAnims = 4219653521,
        MaxRateForSlowBlendDuration = 1735614949,
        MaxRateToPlayCowerReaction = 2442429563,
        MaxRateVariance = 2016189169,
        MaxReactToFireDelay = 3144065170,
        MaxReactToFireRate = 2938880609,
        MaxReactionTime = 2030474037,
        MaxRelativeHeading = 3645576770,
        MaxRoll = 1361361101,
        MaxRollFromBrake = 2707471304,
        MaxRollFromStick = 4013155074,
        MaxRotScale = 3906575696,
        MaxRotSpeed = 2343716985,
        MaxRotationalSpeed = 2507965951,
        MaxRotationalSpeedScale = 502763290,
        MaxRouteLengthForCower = 3858374889,
        MaxRouteSizeForCower = 325049815,
        MaxSearchDistance = 1252284298,
        MaxSearchRadiusForNavMesh = 861953935,
        MaxSecondsAsTopLevelTask = 324489357,
        MaxShakeInstances = 2390340428,
        MaxShellShockedDistance = 1811470108,
        MaxSidePaddingForTurn = 3250501977,
        MaxSpeedDifference = 1143414935,
        MaxSpeedDifferenceForPowerAdjustment = 1861379728,
        MaxSpeedForAvoid = 1592953719,
        MaxSpeedForAvoidDirected = 44796921,
        MaxSpeedForBrace = 508750981,
        MaxSpeedForEarlyCombatExit = 4258519451,
        MaxSpeedForHesitate = 3303023161,
        MaxSpeedForStill = 3869148508,
        MaxSpeedForStillReverse = 1916394191,
        MaxSpeedForVehicle = 2486108674,
        MaxSpeedForVehicleMovingSlowly = 408114095,
        MaxSpeedToActivate = 3555945363,
        MaxSpeedToContinueJackingVehicle = 3826933504,
        MaxSpeedToDive = 4063222790,
        MaxSpeedToStartJackingVehicle = 4182891936,
        MaxSpeedToTriggerFixieSkidTransition = 2271374387,
        MaxSpeedToTriggerTrackStandTransition = 1082334520,
        MaxSpeedToUseHandBrake = 1580566536,
        MaxStairsJumpAngle = 3734083336,
        MaxStaminaDuration = 1624872472,
        MaxStandWaitTimeMS = 3857242043,
        MaxSteerAngle = 3758934792,
        MaxSteeringAngleForAmbientIdles = 1299890657,
        MaxSteeringAngleForSitIdles = 2737592779,
        MaxStepBackDist = 3352731897,
        MaxStepOutDist = 899299281,
        MaxSteps = 3459663346,
        MaxStickChangePerSecond = 1936752322,
        MaxStickInputAngleInfluence = 3234046643,
        MaxStopPhaseToResumeMovement = 1345455105,
        MaxStoppingDuration = 863732031,
        MaxStoppingEdgeCheckProbeOffset = 1469301844,
        MaxStoppingProbeOffset = 38963063,
        MaxStruggleTime = 2216234163,
        MaxStunnedTime = 3892117779,
        MaxSuperJumpInitialVelocity = 988692459,
        MaxSweepAngleWhenAvoidingPopIn = 1583100448,
        MaxSweepAngleWhenMovingTowardsLos = 2848194588,
        MaxTakeOffHeadingChangeRate = 2210871472,
        MaxTakeOffRate = 3524235412,
        MaxTargetAngularMovementForWatch = 3193923873,
        MaxTargetOffsetX = 4229384679,
        MaxTargetOffsetY = 4066129521,
        MaxTargetOffsetZ = 3764687490,
        MaxTargetOffsetZ_TargetInAir = 3283771357,
        MaxTargetSteerAngleToContinueFromPursue = 3306631916,
        MaxTargetSteerAngleToStartFromPursue = 2501833676,
        MaxThrottle = 64513465,
        MaxThrottleForStill = 1906306837,
        MaxThrust = 3597427549,
        MaxTimeBeforeNewPose = 1274013705,
        MaxTimeBeforeReact = 3193578838,
        MaxTimeBetweenIdleVariations = 3648216318,
        MaxTimeBetweenPlayerIdleVariations = 2015526511,
        MaxTimeBetweenSearches = 110388555,
        MaxTimeBetweenShootOutTiresGlobal = 283868640,
        MaxTimeForAmbientReaction = 2937486448,
        MaxTimeForArrestBreakout = 2090607393,
        MaxTimeForAudioReaction = 143794235,
        MaxTimeForBrake = 110293208,
        MaxTimeForHandsUp = 3487053313,
        MaxTimeForInitialState = 478429586,
        MaxTimeForStream = 122331865,
        MaxTimeInBulletReactionState = 1969287622,
        MaxTimeInCombatToShootOutTires = 730951251,
        MaxTimeInStateToContinueFromPursue = 1655056873,
        MaxTimeInSwerve = 4163863357,
        MaxTimeMoveNearCrimeMs = 897487244,
        MaxTimeMoveToLawFailedPathfindingMs = 2062768994,
        MaxTimeMoveToLawMs = 1736715102,
        MaxTimeSearchMs = 3450986312,
        MaxTimeSinceGetUpForAmbientIdles = 2863765530,
        MaxTimeSinceLastSpotted = 1171478055,
        MaxTimeSinceShiftedWeightForwardToAllowWheelie = 2103453391,
        MaxTimeSinceShot = 3302572334,
        MaxTimeStayPinned = 818416092,
        MaxTimeStreamClipSetInBeforeSkippingCloseDoor = 3836837046,
        MaxTimeStreamClipSetInBeforeWarpMP = 1243230599,
        MaxTimeStreamClipSetInBeforeWarpSP = 2153531751,
        MaxTimeStreamInVehicleClipSetBeforeStartingEngine = 559307397,
        MaxTimeStreamShuffleClipSetInBeforeWarp = 3089447490,
        MaxTimeTargetVehicleMoving = 904929247,
        MaxTimeToBeObstructed = 3272441861,
        MaxTimeToCallPolice = 3706002780,
        MaxTimeToClipIntoDynamicCollision = 851288932,
        MaxTimeToConsiderPedGoingToDoorPriority = 2361725074,
        MaxTimeToFleeInVehicle = 454716601,
        MaxTimeToHesitate = 3164535731,
        MaxTimeToHoldFireAtTaskInitialization = 2545130112,
        MaxTimeToLookAheadForFutureTargetPosition = 2027520168,
        MaxTimeToPrepareWeapon = 535072586,
        MaxTimeToReact = 512026668,
        MaxTimeToRejectRespawnedTarget = 2157137274,
        MaxTimeToReserveComponentBeforeWarp = 3107868104,
        MaxTimeToSpendInEarLoopToPutDownPhone = 854541557,
        MaxTimeToSpendOccluded = 2101619543,
        MaxTimeToSpendOccludedByAttachParent = 1735950673,
        MaxTimeToSwerve = 2288728578,
        MaxTimeToTrespassWhileSwimmingBeforeDeath = 3579116253,
        MaxTimeToWait = 2597134309,
        MaxTimeToWaitForShot = 2658068209,
        MaxTimeToWatchVehicle = 3652981848,
        MaxTimeUntilReturnToIdleFromAimAfterAimedAt = 4055554934,
        MaxTimeUntilReturnToIdleFromAimDefault = 263823852,
        MaxTimeWaitForExitBeforeWarp = 1727051436,
        MaxTimeWaitingForBlockingArea = 1799405168,
        MaxTimeWaitingForCircleMs = 1160010076,
        MaxTimeWithNoReferences = 1570040321,
        MaxTimeoutToAcquireLineOfSight = 2480389571,
        MaxTrainClimbHeight = 1979246139,
        MaxTransScale = 2917519651,
        MaxTransVelocity = 766404597,
        MaxTranslationalMoveSpeed = 4264959731,
        MaxTranslationalScale = 3484537704,
        MaxTranslationalStandSpeed = 840729400,
        MaxTurnProbeOffset = 1513492849,
        MaxUprightRatio = 2171339313,
        MaxUsesForIdleVariationChange = 3247168097,
        MaxUsesForOutroReactVariationChange = 2728975961,
        MaxUsesForPeekingVariationChange = 2265825010,
        MaxUsesForPinnedVariationChange = 1988933435,
        MaxValue = 3107625217,
        MaxValueForCorrection = 4282800535,
        MaxVariationForCurrentPitch = 2853820726,
        MaxVariationForDesiredPitch = 1403610920,
        MaxVehSpeedToConsiderClosingDoor = 3267312723,
        MaxVehicleCapsulePushTimeForPlayerRagdollActivation = 3476926475,
        MaxVehicleCapsulePushTimeForRagdollActivation = 2007819517,
        MaxVehicleCollisionDamageScale = 86779191,
        MaxVehicleVelocityForAmbientIdles = 3495687858,
        MaxVel = 2245023424,
        MaxVelMag = 3255660709,
        MaxVelThreshold = 1711478621,
        MaxVelocityForSitIdles = 3221129138,
        MaxVelocityForSlow = 2650334467,
        MaxVelocityForVehicleLookAtSqr = 1245516390,
        MaxVelocityToEnterBike = 2759646652,
        MaxWaitForShotFailures = 3748385313,
        MaxWaitTime = 295850963,
        MaxWaitTimeBetweenTakeOffsMS = 626958998,
        MaxWallAngle = 2100915621,
        MaxWatchTime = 4262514281,
        MaxWatchTimeHurryAway = 3939134595,
        MaxWheelieAbility = 3607524859,
        MaxWorldLimitsPlayerX = 1353421746,
        MaxWorldLimitsPlayerY = 420979855,
        MaxWptAngle = 3402152282,
        MaxWritheTime = 127971633,
        MaxXYAccelerationForLeanBike = 2317632829,
        MaxXYDistanceForNewPosition = 1731877118,
        MaxXYDistanceToApproachTarget = 2074438621,
        MaxYIntentionToUseSlowApproach = 1157744908,
        MaxYaw = 2297479061,
        MaxYawFromRoll = 494928189,
        MaxYawFromStick = 430837016,
        MaxZAccelerationForLeanBike = 3982029176,
        MaxZComponentForCollisionNormal = 3252894044,
        MaxZDiffBetweenCoverPoints = 2570702388,
        MaxZDiffBetweenPedPos = 4136133905,
        MaxZoomFactor = 3357849814,
        MediumImportanceModifier = 3388322333,
        MediumShot = 2976595087,
        Melee = 2945330295,
        MeleeHeadingFalloffPowerRunning = 3977716086,
        MeleeHeadingOverride = 4259971013,
        MeleeHeadingOverrideRunning = 2260731941,
        MeleeLockOnCameraWeighting = 2159755352,
        MeleeLockOnCameraWeightingNoStick = 3188195832,
        MeleeLockOnPedWeightingNoStick = 2452287190,
        MeleeLockOnStickWeighting = 2608892368,
        MeleeLostLOSBreakTime = 3651791969,
        MemoryDuration = 1743809398,
        MemoryGroup = 4286534285,
        Messages = 605698999,
        MetadataList = 4098657407,
        MicroSMG = 1685333671,
        MinAccelModifier = 274966492,
        MinAccumulatedImpactForSideSwipe = 3443143875,
        MinAiSpeedForStandingUp = 510487850,
        MinAimTimeMs = 2221861795,
        MinAircraftContactSpeedToApplyFullAttachParentMatrixForRelativeOrbit = 1190961214,
        MinAircraftGroundSpeedToApplyFullAttachParentMatrixForRelativeOrbit = 1708190798,
        MinAltitudeDelta = 4256613730,
        MinAmplitude = 3172666582,
        MinAngleForScaleVelocityExtension = 2856025533,
        MinAnglePickPOI = 389125880,
        MinAngularVelocityScaleFactor = 40347237,
        MinAnimOffsetMagnitude = 2661194585,
        MinAnimRotationDeltaToScale = 3718056384,
        MinAnimTranslationDeltaToScale = 99937628,
        MinArmourImpulseMult = 3969466346,
        MinAttachParentApproachSpeedForPitchLock = 2127124229,
        MinAttachParentHeightRatioToPushAwayFromCollision = 296951838,
        MinAttachSpeedToUpdateTightSpaceLevel = 2058076685,
        MinBackOffDistance = 1492713734,
        MinBlendDurationForInitialLockOn = 3397272914,
        MinBlendDurationForLockOnSwitch = 3048647846,
        MinBlendLevelAfterPushAwayFromCollision = 527029053,
        MinBlendWeightToUseFarClipEvents = 2057785224,
        MinBlendWeightToUseHighClipEvents = 3370177558,
        MinBrake = 3259827294,
        MinBrakeForCloseUpCamera = 3323891652,
        MinCameraMoveSpeedToSweepInDirectionOfTravel = 1302934580,
        MinCentredSteeringAngleTimeForSitIdles = 3234674890,
        MinCircleRadius = 3257642822,
        MinClearDistanceBelow = 3563387020,
        MinContactDepthForContinuousPushActivation = 4064358618,
        MinCoverToPlayerCoverDist = 4196658405,
        MinCruiseSpeedMultiplier = 2635294172,
        MinCurrentRotationDeltaToScale = 478065483,
        MinDamageTakenImpulseMult = 167326155,
        MinDamageTakenThreshold = 1810182352,
        MinDamageTakenToApplyDamageAI = 2405402680,
        MinDamageTakenToApplyDamagePlayer = 2721586149,
        MinDamageToCheckForRandomDeath = 2190188961,
        MinDeccelModifier = 3966738289,
        MinDefendPointWaitTimeMS = 3250827903,
        MinDefensiveAreaRadiusForWillAdvance = 1909915037,
        MinDelay = 3403479156,
        MinDelayBetweenBuoyancyStateChanges = 1503749012,
        MinDelayExitTime = 3151657361,
        MinDelayForGetOff = 2811169447,
        MinDelayOnSubmerging = 3666052486,
        MinDelayOnSurfacing = 2560927169,
        MinDelayTimeForExitVehicle = 3267921887,
        MinDelayTimer = 564420500,
        MinDepthBelowSurface = 2503381867,
        MinDepthUnderWaterWhenNotBuoyant = 3111702866,
        MinDifferenceBetweenCowerReactionRates = 884159106,
        MinDisplacementScale = 3403073366,
        MinDistAwayFromEntryPointToConsiderFinished = 24914513,
        MinDistFromOtherPeds = 1071466356,
        MinDistFromPlayerToDeleteCoweringForever = 3668424542,
        MinDistFromPlayerToDeleteOffscreen = 162655462,
        MinDistFromPlayerToDeleteOnExitVehicle = 225841828,
        MinDistFromTargetWhenCoweringToCheckForExit = 9265257,
        MinDistPercentageToScaleScanArc = 3089390809,
        MinDistScanArc = 1000280571,
        MinDistToAlwaysClampInitialOrientation = 1420291822,
        MinDistToCoverAnyDir = 449945587,
        MinDistToCoverSpecificDir = 2215019044,
        MinDistToPlayEntryAnim = 525431756,
        MinDistToPriorityCoverToForce = 997332238,
        MinDistToScale = 3131955124,
        MinDistToVehicle = 722704686,
        MinDistUpdateFrequency = 475173943,
        MinDistanceAwayForFilming = 334429677,
        MinDistanceBetweenFilmingPeds = 2758358422,
        MinDistanceBetweenPositionsWithClearLineOfSight = 579362303,
        MinDistanceBetweenPositionsWithoutClearLineOfSightInExteriors = 72559400,
        MinDistanceBetweenPositionsWithoutClearLineOfSightInInteriors = 2086611921,
        MinDistanceForAimIntro = 813193409,
        MinDistanceForAmbientReaction = 946719330,
        MinDistanceForAvoid = 724928304,
        MinDistanceForAvoidDirected = 3043121072,
        MinDistanceForBackAway = 2509346908,
        MinDistanceForFineAimScaling = 1350912934,
        MinDistanceForLawToFleeFromCombat = 871647294,
        MinDistanceForLockOn = 9436207,
        MinDistanceForSearch = 2124766118,
        MinDistanceForSlowdown = 4284975454,
        MinDistanceFromPlayerToDeleteHurriedPed = 3508977239,
        MinDistanceFromPlayerToDeleteStuckBird = 2955815816,
        MinDistanceMovedToStartSearch = 4233283909,
        MinDistanceToAdjust = 4143621306,
        MinDistanceToAdjustSpeed = 1514235773,
        MinDistanceToBeConsideredLaggingBehind = 4205882999,
        MinDistanceToBeConsideredOptimal = 4180445694,
        MinDistanceToCheckClumped = 2096238662,
        MinDistanceToContinue = 3514547823,
        MinDistanceToCoverToStop = 3078439303,
        MinDistanceToEnterVehicleIfTargetEntersVehicle = 3875303030,
        MinDistanceToFindVehicle = 4037909654,
        MinDistanceToLookAhead = 1577260290,
        MinDistanceToLookBehind = 3533260791,
        MinDistanceToMove = 1348357381,
        MinDistanceToScanForNearbyVehicle = 868829697,
        MinDistanceToSearchForAquaticPoints = 3539942532,
        MinDistanceToSearchForGroundWildlifePoints = 303177901,
        MinDistanceToSetApproachPosition = 2521320953,
        MinDistanceToSideOnPavement = 2371258779,
        MinDistanceToStart = 3423985846,
        MinDistanceToStartMatchingSpeed = 820982755,
        MinDistanceToTargetForIdleVariations = 1823873460,
        MinDistanceToTargetForPeek = 4047811579,
        MinDiveHeight = 1331483625,
        MinDot = 1241644828,
        MinDotForInFront = 890881625,
        MinDotForPickupDirection = 1046969538,
        MinDotForSlowdown = 2841547079,
        MinDotMovingAwayFromTargetToStartCruiseInFront = 1195737890,
        MinDotMovingTowardsTargetToContinueBrakeInFront = 2713817702,
        MinDotMovingTowardsTargetToStartBrakeInFront = 935837869,
        MinDotTargetMovingTowardsOurSideToStartBackAndForth = 1212941547,
        MinDotTargetMovingTowardsUsToContinueBackAndForth = 737095977,
        MinDotTargetMovingTowardsUsToContinueBrakeInFront = 67415689,
        MinDotTargetMovingTowardsUsToContinueCruiseInFront = 2961114452,
        MinDotTargetMovingTowardsUsToStartBackAndForth = 4094305061,
        MinDotTargetMovingTowardsUsToStartBrakeInFront = 1917200737,
        MinDotTargetMovingTowardsUsToStartCruiseInFront = 3682638304,
        MinDotToBeConsideredInFront = 4211240273,
        MinDotToClampCruiseSpeed = 1823449253,
        MinDotToConsiderVehicleValid = 1576858885,
        MinDotToContinueFromAnalyze = 158897950,
        MinDotToContinueFromPursue = 2146950936,
        MinDotToInsult = 536817715,
        MinDotToPointGunAtPositionWhenUnableToTurn = 2838815119,
        MinDotToStartFromAnalyze = 2497181955,
        MinDotToStartFromPursue = 1707529261,
        MinDotToTalk = 2101568980,
        MinDriverTimeToLeaveVehicle = 1223491754,
        MinEdgeDistanceForStoppingAnim = 1251038941,
        MinExtraMoney = 1666523442,
        MinFallHeight = 3171739573,
        MinFallSpeedForHighFallAbort = 1512271781,
        MinFallingSpeedForAnimatedDyingFall = 1632351140,
        MinFallingSpeedInRagdoll = 1694228856,
        MinFineAimTime = 1340511632,
        MinFineAimTimeHoldingStick = 64509274,
        MinFleeMoveBlendRatio = 859826315,
        MinFocusToSecondaryFocusDistance = 1225855688,
        MinForDrivebys = 1749910459,
        MinForceFiringDistance = 1845309081,
        MinForceFiringStateTime = 1435641288,
        MinForwardSpeed = 2742393958,
        MinForwardsPitchFastSpeed = 3949027340,
        MinForwardsPitchSlope = 2116015636,
        MinForwardsPitchSlopeBalance = 3525415799,
        MinForwardsPitchSlowSpeed = 3517975074,
        MinForwardsPitchWheelieBalance = 3271949585,
        MinForwardsPitchWheelieBegin = 1825055764,
        MinFov = 2006858266,
        MinFovForNetworkPlay = 1881152859,
        MinGrabTime = 1433408101,
        MinHandleHeightDiffVan = 1408201742,
        MinHeadShotImpulseMultiplier = 3084941871,
        MinHeadingAlignmentCosThreshold = 3690289360,
        MinHeadingAngle = 2186047470,
        MinHealth = 1280594926,
        MinHealthForQuickGetup = 3891222055,
        MinHealthImpulseMult = 4101332336,
        MinHeavyCrashDeathChance = 663937180,
        MinHeight = 1206332797,
        MinHeightAboveTerrain = 2018929951,
        MinHeightAboveVehicleDriverSeat = 3420511035,
        MinHeightAboveWater = 851393034,
        MinHeightAboveWaterWhenBuoyant = 2469744276,
        MinHeliDamping = 2239295053,
        MinHitNormalDotWorldUpForRivers = 2252203055,
        MinHoldBreathDuration = 299633947,
        MinHoldTimeToBlockFullAttachParentMatrixForRelativeOrbit = 897419234,
        MinImpulse = 675904337,
        MinInputToInterruptIdle = 3378374324,
        MinIntensity = 1509127932,
        MinLateralSkidSpeed = 4191348047,
        MinLeanInDirectionTime = 4237013150,
        MinLength = 1352021757,
        MinLookAtArmWoundTime = 1894293331,
        MinMBRToStop = 326250284,
        MinMag = 1967662718,
        MinMagForBikeToBeOnSide = 667864712,
        MinMoveToCoverDistForCoverMeAudio = 3920545059,
        MinMovingProbeOffset = 26449222,
        MinMovingToCoverTimeToStop = 254417857,
        MinNavmeshPatrolRadiusFactor = 1521803727,
        MinNoReticuleAimTime = 2809571307,
        MinNumberFakeApproaches = 2768935848,
        MinOffsetForGetInPosition = 1340388073,
        MinOpenDoorRatioToUseArmIk = 2696374786,
        MinOrientationDeltaToCut = 1055028939,
        MinOrientationDeltaToCutForReverseAngle = 2434688331,
        MinOrientationDeltaToCutWithTrailer = 1873731470,
        MinOrientationSpeedToMaintainDirection = 785961650,
        MinParachutePitch = 1228835903,
        MinPassengerTimeToLeaveVehicle = 3439953457,
        MinPassengersForAttraction = 3561917245,
        MinPathLengthForValidExit = 1596520127,
        MinPedFwdToEntryDotToClampInitialOrientation = 158501595,
        MinPedSpeedToActivateRagdoll = 1213730703,
        MinPhaseToApplyExtraHeadingAi = 2185200792,
        MinPhaseToApplyExtraHeadingPlayer = 3617904707,
        MinPhoneFilmTime = 1169941758,
        MinPhoneFilmTimeHurryAway = 1926295578,
        MinPhysSpeedToActivateRagdoll = 4167152455,
        MinPitch = 509392339,
        MinPitchAngle = 3480847079,
        MinPitchAngle2H = 2669496770,
        MinPitchDefault = 1054799563,
        MinPitchInAir = 2469007968,
        MinPlaneControlAbility = 1670377462,
        MinPlaneDamping = 3955578614,
        MinPlayerJumpOutSpeedBike = 2863410559,
        MinPlayerJumpOutSpeedCar = 2485839112,
        MinPlayerMoveDistanceToSpawnChase = 1676424772,
        MinRate = 1240074404,
        MinRateForInVehicleAnims = 438194982,
        MinRateToPlayCowerReaction = 2568949102,
        MinRatioForClosingDoor = 1807337106,
        MinReactToFireRate = 1887154148,
        MinRelativeHeading = 3137513888,
        MinRemainingAnimDurationToScale = 2357080007,
        MinRemainingRotationForScaling = 1379047521,
        MinRoll = 1178479344,
        MinRotDelta = 1511471000,
        MinRotScale = 614907799,
        MinRotationalSpeedScale = 2167006115,
        MinSafeOrbitDistanceScalingForExtensions = 177572622,
        MinSafeRadiusReductionWithinPedMoverCapsule = 1976571596,
        MinSideNormalForSideSwipe = 48284945,
        MinSnap = 709707651,
        MinSoftLockBreakAtMaxXStickTime = 2357834650,
        MinSoftLockBreakTime = 1649684365,
        MinSoftLockBreakTimeCloseRange = 3539954611,
        MinSpawnTimeForPoliceHeliAfterDestroyed = 4153560394,
        MinSpeed = 1724998945,
        MinSpeedDifferenceForPowerAdjustment = 3207905455,
        MinSpeedForAvoid = 252789847,
        MinSpeedForAvoidDirected = 2493712752,
        MinSpeedForChase = 1337026297,
        MinSpeedForDive = 2304242044,
        MinSpeedForMaxRelativeAttachSpringConstant = 1558815907,
        MinSpeedForSwerve = 2981979817,
        MinSpeedForVehicleMovingQuickly = 1059555640,
        MinSpeedForVehicleToBeConsideredStillSqr = 4258377742,
        MinSpeedForWreck = 2743225815,
        MinSpeedInSwerve = 1487496534,
        MinSpeedLeewayToStartFromPursue = 2231898585,
        MinSpeedToAbortOpenDoor = 492953913,
        MinSpeedToAbortOpenDoorCombat = 3831454313,
        MinSpeedToAbortOpenDoorPlayer = 2387057259,
        MinSpeedToApplyReaction = 672649965,
        MinSpeedToApplyTorque = 601372446,
        MinSpeedToBeConsideredEscapingInVehicle = 2329813458,
        MinSpeedToBlendInDriveFastFacial = 380529072,
        MinSpeedToDeactivate = 3815175242,
        MinSpeedToDive = 152364693,
        MinSpeedToJumpOutOfVehicle = 3352329382,
        MinSpeedToRagdollOpenDoor = 3555981726,
        MinSpeedToRagdollOpenDoorCombat = 820682935,
        MinSpeedToRagdollOpenDoorPlayer = 1024103431,
        MinSprintResultToStand = 3302557202,
        MinSqdDistToSetPos = 2571589718,
        MinStaminaDuration = 1051647876,
        MinStandWaitTimeMS = 1521808097,
        MinSteerAngle = 168285857,
        MinStepOutDist = 427371079,
        MinStickInputToEnableCoverToCover = 1887369799,
        MinStickInputToEnableMoveAroundCorner = 2511576109,
        MinStickInputToMoveAroundCorner = 629671162,
        MinStickInputToMoveInCover = 1261300416,
        MinStickInputXAxisToTurnInCover = 2609438296,
        MinStickMagnitudeForEarlyOutMovement = 2039762038,
        MinStopPhaseToResumeMovement = 2282663253,
        MinStoppingDist = 691235540,
        MinStoppingEdgeCheckProbeOffset = 772858715,
        MinStoppingProbeOffset = 3446268000,
        MinStruggleTime = 2829230620,
        MinStunnedTime = 3100954165,
        MinSuperJumpInitialVelocity = 4057741743,
        MinTakeOffHeadingChangeRate = 72858195,
        MinTakeOffRate = 1117824032,
        MinTargetOffsetX = 69361213,
        MinTargetOffsetY = 3996070487,
        MinTargetOffsetZ = 3765475034,
        MinTargetOffsetZ_TargetInAir = 3515816840,
        MinTargetSpeedToContinueFromPursue = 1829902171,
        MinTargetSpeedToStartFromPursue = 4080325939,
        MinTargetStandingOnTrainSpeed = 3385636076,
        MinThrottle = 1568208081,
        MinTimeBeforeAllowingAutoPeek = 3608928929,
        MinTimeBeforeAllowingCornerMove = 1733226917,
        MinTimeBeforeCanChooseNewPose = 2658395586,
        MinTimeBeforeNewPose = 3603257907,
        MinTimeBeforeReact = 3183040402,
        MinTimeBeforeSwitchLookAt = 1289065068,
        MinTimeBetweenAttemptsToFindNearby = 2714855430,
        MinTimeBetweenAttemptsToFindNewPosition = 765310,
        MinTimeBetweenCloseDoorAttempts = 663934809,
        MinTimeBetweenEyeIkProcesses = 206502145,
        MinTimeBetweenFiringVariations = 817834735,
        MinTimeBetweenFlinches = 2271449308,
        MinTimeBetweenIdleVariations = 2643024561,
        MinTimeBetweenInsults = 3789052240,
        MinTimeBetweenLineOfSightTests = 967712511,
        MinTimeBetweenMeleeJackAttempts = 4106127787,
        MinTimeBetweenMeleeJackAttemptsOnNetworkClone = 1911699676,
        MinTimeBetweenOverheadBulletReactions = 3886708440,
        MinTimeBetweenPlayerIdleVariations = 1573385593,
        MinTimeBetweenQuickGlancesInSameDirection = 1927524225,
        MinTimeBetweenReactionChecksForGunAimedAt = 1752177996,
        MinTimeBetweenReactions = 3817763328,
        MinTimeBetweenSharkDispatches = 4195725397,
        MinTimeBetweenShootOutTiresGlobal = 470555105,
        MinTimeBetweenStatusUpdates = 1814559575,
        MinTimeBetweenStrafeDirectionChanges = 4157008494,
        MinTimeBoatOutOfWaterForExit = 3458993355,
        MinTimeElapsedForGroundWrithe = 3919163430,
        MinTimeForAmbientReaction = 1295611070,
        MinTimeForCornerMove = 4067447650,
        MinTimeForHandsUp = 1376968536,
        MinTimeForInitialState = 3439568038,
        MinTimeInCombatToNotStreamIn = 2838084369,
        MinTimeInCombatToShootOutTires = 1335171882,
        MinTimeInCurrentStateForStill = 2871611248,
        MinTimeInFreewheelState = 3840966049,
        MinTimeInHornState = 3070028166,
        MinTimeInPedalState = 2196376340,
        MinTimeInRagdoll = 3903892409,
        MinTimeInShuntStateBeforeRestart = 3200053693,
        MinTimeInSitToStillStateToReverse = 3389614983,
        MinTimeInStandState = 3553993325,
        MinTimeInStateForForcedFire = 1232297261,
        MinTimeInStateToAllowTransitionFromFixieSkid = 863715729,
        MinTimeInTaskToCheckForDamage = 2132426494,
        MinTimeMovingAwayToGiveToWitness = 1927499316,
        MinTimeRemainingForGroundWrithe = 2331611470,
        MinTimeSinceAnyCircleJoined = 4160428671,
        MinTimeSinceLastHostileAction = 1740762106,
        MinTimeSinceLastSpotted = 3151249820,
        MinTimeSinceSameCircleJoined = 1038805177,
        MinTimeSinceTalkingEndedToMakeCall = 3385798684,
        MinTimeSinceTalkingEndedToSayContextForCall = 4230329614,
        MinTimeSinceTargetTalkingEndedToMakeCall = 2919871050,
        MinTimeSpentInEarLoopToSayContextForCall = 2980295761,
        MinTimeSpentSwimmingToRespectMotionTask = 2968196113,
        MinTimeStayPinned = 2308421233,
        MinTimeTargetHasBeenTalkingToMakeCall = 4048361920,
        MinTimeToBePinnedDown = 3650240986,
        MinTimeToCallPolice = 821642865,
        MinTimeToChangeChaseOnFootSpeed = 615112755,
        MinTimeToConsiderDangerousDriving = 3887812374,
        MinTimeToConsiderPedGoingToDoorPriority = 423470112,
        MinTimeToFleeInVehicle = 3344957179,
        MinTimeToHesitate = 3189387953,
        MinTimeToKeepEngineAndLightsOnWhileParked = 2478597497,
        MinTimeToPrepareWeapon = 3427043837,
        MinTimeToReact = 3649567479,
        MinTimeToRepeatLastAnimation = 1359604368,
        MinTimeToScale = 2681841281,
        MinTimeToSpendInEarLoopToPutDownPhone = 2423924604,
        MinTimeToSpendInTask = 3005241839,
        MinTimeToStandUp = 2267264803,
        MinTimeToStayUprightAfterImpact = 3608841595,
        MinTimeToSwerve = 1907731990,
        MinTimeToWait = 460015891,
        MinTimeToWaitForOtherPedToExit = 746970568,
        MinTimeToWaitForShot = 1841691026,
        MinTimeUntilReturnToIdleFromAimAfterAimedAt = 1630578621,
        MinTimeUntilReturnToIdleFromAimDefault = 360559002,
        MinTimeoutToAcquireLineOfSight = 3438052999,
        MinTransScale = 1999362333,
        MinTranslationalScale = 2870050188,
        MinTurnApproachRate = 1055045198,
        MinTurnProbeOffset = 3317722172,
        MinTurnSpeedMotionOverPOI = 2806951563,
        MinUpdatesBeforeApplyingMotionBlur = 1025607184,
        MinUsesForIdleVariationChange = 3007638827,
        MinUsesForOutroReactVariationChange = 1069071024,
        MinUsesForPeekingVariationChange = 1848963111,
        MinUsesForPinnedVariationChange = 3203888722,
        MinValue = 324547252,
        MinValueForCorrection = 2782043564,
        MinVehVelMagForBicycleSideSwipe = 3048137979,
        MinVehVelMagForSideSwipe = 3804354300,
        MinVehVelocityToGoThroughWindscreen = 1165173355,
        MinVehVelocityToGoThroughWindscreenMP = 2444940549,
        MinVehicleCollisionDamageScale = 1127062988,
        MinVehicleWarning = 798220376,
        MinVel = 66577426,
        MinVelMag = 3279914945,
        MinVelStillStart = 2988949625,
        MinVelStillStop = 2175562542,
        MinVelThreshold = 3891030916,
        MinVelThroughNormalForSideSwipe = 1658632009,
        MinVelocity = 2073951791,
        MinVelocityForDriveByAssistedAim = 3025537526,
        MinVelocityForFast = 2876804674,
        MinVelocityToRagdollPed = 52645552,
        MinVelocityToScale = 3538596479,
        MinWaitTime = 3965435915,
        MinWaitTimeBetweenTakeOffsMS = 3519366748,
        MinWaitTimeToPlayPlayerIdleVariations = 1797303037,
        MinWatchTime = 424721387,
        MinWatchTimeHurryAway = 3859810396,
        MinWheelieAbility = 1924165020,
        MinWorldLimitsPlayerX = 3684109243,
        MinWorldLimitsPlayerY = 164620332,
        MinWritheTime = 4260165656,
        MinXYVelForWantsToMove = 514488562,
        MinimumDownedTime = 3571595842,
        MinimumShotReactionTimeAIMS = 1078427012,
        MinimumShotReactionTimePlayerMS = 3405078066,
        MobileChatScenarioMayAbort = 1434985449,
        MobilePhoneCameraControlHelperRef = 376729145,
        ModelForParachuteInMP = 745109363,
        ModelForParachuteInSP = 1753140963,
        ModelNamesToConsiderPlayersForScoringPurposes = 1071210221,
        Modes = 945555571,
        ModifierName = 2966939369,
        MotionBlurSettings = 490368749,
        MotionBlurStrength = 1859659636,
        MotionLookAtBlendRate = 1566172518,
        MotionLookAtRotationLimit = 3198801841,
        MotionLookAtTurnRate = 1972120707,
        MotivationMax = 2674738037,
        MotivationMin = 4238411479,
        MouseMaxHeadingSpeedMax = 2735899528,
        MouseMaxHeadingSpeedMin = 419948133,
        MouseMaxPitchSpeedMax = 1102394099,
        MouseMaxPitchSpeedMin = 2160264290,
        MoveBlendRatioForFarGoto = 1440512567,
        MoveNetworkBlendoutDuration = 780063382,
        MoveParameters = 1126598037,
        MoveRateOverride = 3469377736,
        MoveToDistanceInVehicle = 1359250131,
        MovementAcceleration = 1913804545,
        MovementAwayWeighting = 1351646535,
        MovementClipRate = 4205396201,
        MovementClipSets = 3053450155,
        MovementCostModifier = 1366066164,
        MovementMotionBlurMaxSpeed = 1743155234,
        MovementMotionBlurMaxStrength = 1328935990,
        MovementMotionBlurMinSpeed = 3274038425,
        Moving = 3575677823,
        MovingAnimStateInfos = 2676261337,
        MovingAwayVelocityMSThreshold = 1549370724,
        MovingDirectionSmoothingAngleMax = 916804787,
        MovingDirectionSmoothingAngleMin = 3163856764,
        MovingDirectionSmoothingForwardAngleRun = 4229364158,
        MovingDirectionSmoothingForwardAngleWalk = 817979133,
        MovingDirectionSmoothingForwardRateAccelerationMod = 206173392,
        MovingDirectionSmoothingForwardRateMod = 4209639571,
        MovingDirectionSmoothingRateAccelerationMax = 1021183862,
        MovingDirectionSmoothingRateAccelerationMin = 4203477475,
        MovingDirectionSmoothingRateMaxRun = 2229072832,
        MovingDirectionSmoothingRateMaxWalk = 2584063876,
        MovingDirectionSmoothingRateMin = 2151433465,
        MovingEdgeTestEndYOffset = 189580395,
        MovingEdgeTestStartYOffset = 1678354404,
        MovingExtraHeadingChangeAngleMax = 3031402448,
        MovingExtraHeadingChangeAngleMin = 243413468,
        MovingExtraHeadingChangeRate = 830448667,
        MovingExtraHeadingChangeRateAcceleration = 932904484,
        MovingExtraHeadingChangeRateAccelerationMax = 3423772986,
        MovingExtraHeadingChangeRateAccelerationMin = 2172130562,
        MovingExtraHeadingChangeRateRun = 2979286721,
        MovingExtraHeadingChangeRateWalk = 3334261987,
        MovingMultiplierBonus = 474003950,
        MovingVarsSet = 2593822105,
        MovingVehicleVelocityThreshold = 309425308,
        MovingWalkAnimRateAcceleration = 3381710529,
        MovingWalkAnimRateMax = 1051732090,
        MovingWalkAnimRateMin = 2563588038,
        MpActivationModifiers = 755518553,
        MpMaxHealthLossForQuickGetup = 1666177823,
        MpMinHealthForQuickGetup = 888956679,
        MpPlayerQuickBlendOut = 558729515,
        MultiplayerClimbClamberRateModifier = 935832867,
        MultiplayerClimbRunningRateModifier = 2530564765,
        MultiplayerClimbStandRateModifier = 367433608,
        MultiplayerCoverIntroRateModifier = 674066505,
        MultiplayerEnterExitJackVehicleRateModifier = 891602871,
        MultiplayerIdleTurnRateModifier = 2570857418,
        MultiplayerLadderRateModifier = 2900803312,
        MultiplayerReloadRateModifier = 1245165468,
        MultiplierForDangerousDriving = 4090325919,
        NAME_BIG = 1877679104,
        NAME_MED = 2980984179,
        NAME_SMALL = 298596333,
        NETWORKOPTIONS_FILE = 3850710962,
        NMBodyScale = 380014673,
        NM_TUNING_FILE = 1639152529,
        NO_REACTION = 3073843763,
        NavMeshPoint = 680699981,
        NavMeshPoints = 2288844751,
        NearClip = 1325746994,
        NearDistanceForOrientation = 4175205823,
        Nearby = 3709090817,
        NeckShot = 256476042,
        NeckStrengthTuning = 2519031107,
        NetworkBlendDuration = 1021030104,
        NetworkBlendDurationOpenDoorCombat = 132682005,
        NetworkBlendInDuration = 8008463,
        NetworkBlendOutDuration = 2175660835,
        NetworkBlendOutDurationRun = 235129999,
        NetworkBlendOutDurationRunStart = 2896892589,
        NeverUse = 2562048776,
        NewLeanSteerApproachRate = 1728172908,
        NextTransitionClipId = 3399412192,
        NextTransitionExtraScalar = 2392693984,
        NoCoverEastFaceCenter = 3014113591,
        NoCoverEastFaceNorth = 4173874730,
        NoCoverEastFaceSouth = 3315722870,
        NoCoverNorthFaceCenter = 1753198982,
        NoCoverNorthFaceEast = 3074030570,
        NoCoverNorthFaceWest = 4102086546,
        NoCoverSouthFaceCenter = 1192754605,
        NoCoverSouthFaceEast = 3712292480,
        NoCoverSouthFaceWest = 3483214048,
        NoCoverVehicleDoors = 4158814707,
        NoCoverWestFaceCenter = 1200088335,
        NoCoverWestFaceNorth = 980667646,
        NoCoverWestFaceSouth = 4149395173,
        NoParachuteMaxCollisionNormalThreshold = 1928060490,
        NoParachuteMaxPitch = 2440882257,
        NoParachuteMinCollisionNormalThreshold = 4262842160,
        NoParachuteTimeForMinCollisionNormalThreshold = 336137001,
        NoReticuleLockOnRangeModifier = 3583828968,
        NoReticuleMaxLockOnRange = 2308178823,
        NoReticuleTargetAimPitchLimit = 1235721286,
        NoReticuleTargetAngularLimit = 4232341165,
        NoReticuleTargetAngularLimitClose = 4081370038,
        NoReticuleTargetAngularLimitCloseDistMax = 3453384537,
        NoReticuleTargetAngularLimitCloseDistMin = 2946314787,
        NonFlyableArea = 3154226565,
        NonFlyableAreaArray = 665455491,
        NormalPreferredDepth = 1606727990,
        NormalTargettingDifficultyInfo = 3104062807,
        NormalThresholds = 3543710223,
        NotBeingPushedDelayMS = 4123949353,
        NotBeingPushedOnGroundDelayMS = 739931697,
        NotProfessional = 931067397,
        NumCapsuleTests = 2133560880,
        NumEarlyVehicleEntryDriversAllowed = 889613745,
        NumFramesToPersistLargeVerticalAcceleration = 2142946869,
        NumTests = 465899626,
        NumToUpdatePerFrame = 575445590,
        NumberOfBurstsMax = 3616069026,
        NumberOfBurstsMin = 236118490,
        NumberOfShotsPerBurstMax = 428905168,
        NumberOfShotsPerBurstMin = 2577107356,
        OCMClearanceCapsuleRadius = 852914750,
        OCMCrouchedForwardClearanceOffset = 3832321302,
        OCMCrouchedHeightOffset = 461310715,
        OCMSideClearanceDepth = 4269848077,
        OCMSideTestDepth = 2079300420,
        OCMStandingForwardClearanceOffset = 1249475394,
        OCMStandingHeightOffset = 708594816,
        ON_BIKE = 1812735189,
        ObjectActivationForceMultiplier = 116532981,
        ObjectMinSpeedForActivation = 602234407,
        ObstructionProbe = 1865732807,
        ObstructionProbeAngleA = 3742382496,
        ObstructionProbeAngleB = 3275063787,
        ObstructionProbeAngleC = 4169133183,
        OcclusionSweep = 1207465912,
        Occupied = 1339021909,
        OffsetLimits = 3479495276,
        OnBalanceFailed = 3974797120,
        OnBalanceFailedSprintExhausted = 3419269985,
        OnBalanceFailedStairs = 1418190490,
        OnBalanceFailure = 494965274,
        OnBeingPushed = 577683658,
        OnBeingPushedOnGround = 258986085,
        OnBeingPushedOnGroundTooLong = 1444135973,
        OnCatchFallSuccess = 4246526405,
        OnDisableDriveToGetup = 553250717,
        OnElectrocuteFinished = 3413282736,
        OnEnableDriveToGetup = 609938430,
        OnFireWeightingMult = 3746655905,
        OnFootBlendInDuration = 1084086108,
        OnFootClipRate = 4280609914,
        OnFootLookAtDampingRef = 2538678656,
        OnMovingGround = 4192987078,
        OnNotBeingPushed = 256038063,
        OnSlopeThreshold = 1801923157,
        OnStairs = 3396170193,
        OnSteepSlope = 3705331241,
        OneHandedClipSetName = 448596277,
        OnlyAllowForShot = 3256506769,
        OnlyInContact = 4063846733,
        OnlyNotInContact = 122191424,
        OnlyUseForGangPeds = 2711794664,
        OnlyUseForLawEnforcementPeds = 4078932877,
        OnlyUseForReactions = 1952942912,
        OpenDoorBlendDurationFromNormalAlign = 1615640364,
        OpenDoorBlendDurationFromOnVehicleAlign = 754839673,
        OpenDoorToJackBlendDuration = 3439162962,
        Optimal = 2980335366,
        OptimumDistToLeftCoverEdge = 796885552,
        OptimumDistToLeftCoverEdgeCrouched = 3881315855,
        OptimumDistToRightCoverEdge = 2188704570,
        OptimumDistToRightCoverEdgeCrouched = 2688479781,
        OrbitDistance = 2733631256,
        OrbitDistanceDamping = 337202266,
        OrbitDistanceLimitScaling = 1688148358,
        OrbitDistanceLimitSpringConstant = 2829148759,
        OrbitDistanceLimitSpringDampingRatio = 1084689577,
        OrbitDistanceLimitsForBasePosition = 2111969249,
        OrbitDistanceScalingForCustomFirstPersonFallBack = 3978450060,
        OrbitDistanceScalingLimits = 1871429041,
        OrbitDistanceScalingSpringConstant = 2983717675,
        OrbitDistanceScalingSpringDampingRatio = 1300443955,
        OrbitDistanceScalingToApplyWhenPushing = 2688276525,
        OrbitPitchLimits = 1974814289,
        OrbitPitchOffsetWhenFullyDucked = 3105010187,
        OrientationSpring = 3781066831,
        OutDuration = 3592760554,
        OuterDistanceThreshold = 2366160443,
        OutroClip0Id = 3585249404,
        OutroMaxScale = 2206745704,
        OutroMovementDuration = 2943938244,
        OutroRate = 2260414033,
        OutroReact1HVariationClipsets = 1976510010,
        OutroReact2HVariationClipsets = 1754157237,
        OutroRotationScalingDefaultEndPhase = 4246951180,
        OutroRotationScalingDefaultStartPhase = 2960195918,
        OutroScalingDefaultEndPhase = 1459623344,
        OutroScalingDefaultStartPhase = 3467497537,
        OverVehicle = 2691364124,
        OverlapSpeedMultiplier = 2358940861,
        Overlay = 370428790,
        OverrideDirections = 198397458,
        OverrideElasticity = 134807671,
        OverrideFleeDirection = 3320627039,
        OverrideFlipForce = 2230782934,
        OverrideFriction = 3907466188,
        OverrideInitialForce = 3258479231,
        OverrideInverseMassScales = 143477949,
        OverrideReactDirection = 3275732457,
        OverrideReactionType = 1094485493,
        OverrideRootLiftForce = 1333505912,
        OverrideStuckOnVehicleSets = 2561285304,
        OverwriteMaxPitch = 2955289081,
        PARTITION_MAX = 2899492762,
        PED_BOUNDS_FILE = 2374071028,
        PED_BRAWLING_STYLE_FILE = 1575806881,
        PED_COMPONENT_CLOTH_FILE = 1241304438,
        PED_COMPONENT_SETS_FILE = 1714450686,
        PED_DRIVES_AVERAGE_CAR = 1662727357,
        PED_DRIVES_BIG_CAR = 1066836384,
        PED_DRIVES_BOAT = 2087263659,
        PED_DRIVES_MOTORCYCLE = 698500424,
        PED_DRIVES_POOR_CAR = 3796340206,
        PED_DRIVES_RICH_CAR = 740214256,
        PED_HEALTH_FILE = 2737334773,
        PED_IK_SETTINGS_FILE = 4183131447,
        PED_NAV_CAPABILITES_FILE = 3376025535,
        PED_PERCEPTION_FILE = 1804477999,
        PED_SPECIAL_ABILITIES_FILE = 3685712067,
        PED_TASK_DATA_FILE = 3947749085,
        PED_VARS_FILE = 915034040,
        PLAYER_CARD_SETUP = 1504533439,
        POILookAtBlendRate = 1217360623,
        POILookAtRotationLimit = 3819703101,
        POILookAtTurnRate = 1321758856,
        POLICE_SCANNER_COLOUR_beige = 2477037232,
        POLICE_SCANNER_COLOUR_black = 52583446,
        POLICE_SCANNER_COLOUR_blue = 2253400966,
        POLICE_SCANNER_COLOUR_brown = 4012089111,
        POLICE_SCANNER_COLOUR_graphite = 437487559,
        POLICE_SCANNER_COLOUR_green = 730308174,
        POLICE_SCANNER_COLOUR_grey = 3129410619,
        POLICE_SCANNER_COLOUR_orange = 1762671403,
        POLICE_SCANNER_COLOUR_pink = 2615326998,
        POLICE_SCANNER_COLOUR_red = 4157715503,
        POLICE_SCANNER_COLOUR_silver = 2969646890,
        POLICE_SCANNER_COLOUR_white = 1645071976,
        POLICE_SCANNER_COLOUR_yellow = 1358390657,
        POLICE_SCANNER_PREFIX_bright = 2318284788,
        POLICE_SCANNER_PREFIX_dark = 3921902053,
        POLICE_SCANNER_PREFIX_light = 840729009,
        POPGROUP_AERIAL = 2486476801,
        POPGROUP_AMBIENT = 2602754504,
        POPGROUP_AQUATIC = 3747129892,
        POPGROUP_IN_VEHICLE = 3190143096,
        POPGROUP_IS_GANG = 198544766,
        POPGROUP_NETWORK_COMMON = 1732741445,
        POPGROUP_SCENARIO = 2037609896,
        POPGROUP_WILDLIFE = 600606236,
        POSTFX_EASE_IN = 2556745525,
        POSTFX_EASE_IN_HOLD_EASE_OUT = 1791815485,
        POSTFX_EASE_OUT = 3362010507,
        POSTFX_IN_HOLD_OUT = 332192867,
        POSTFX_LOOP_ALL = 535426628,
        POSTFX_LOOP_HOLD_ONLY = 2694408850,
        POSTFX_LOOP_NONE = 3585121058,
        PS3_SCRIPT_RPF = 3650318782,
        PadShake = 2667671232,
        PadShakeMaxDuration = 2836403845,
        PadShakeMaxHeight = 2333975606,
        PadShakeMaxIntensity = 1208994934,
        PadShakeMinDuration = 3639487949,
        PadShakeMinHeight = 2222398831,
        PadShakeMinIntensity = 2760872373,
        ParachuteBones = 3328657748,
        ParachuteCamera = 3869597064,
        ParachuteCloseUpCamera = 2309595247,
        ParachuteInitialVelocityY = 1202762864,
        ParachuteInitialVelocityZ = 904794347,
        ParachuteMass = 4131153122,
        ParachuteMassReduced = 3018517000,
        ParachutePack = 2636443310,
        ParachutePackVariations = 1735940634,
        ParachutePhysics = 3256630458,
        ParachuteProbeRadius = 4118156471,
        ParachuteUpThreshold = 739494681,
        Parachuting = 2611998079,
        ParachutingAi = 3248104514,
        ParachutingFilterId = 3728753498,
        ParamSets = 315966693,
        Params = 1933425356,
        ParentRelativeAttachOffset = 1399337810,
        ParentRelativeAttachOffsetAtOrbitHeadingLimits = 442114217,
        ParkingSpaceBlockedMaxAttempts = 4245532224,
        ParkingSpaceBlockedWaitTimePerAttempt = 1316038287,
        Passive = 1672543877,
        PathFinding = 394936210,
        PavementFloodFillSearchRadius = 3609661010,
        PedActivationForceMultiplier = 3758147000,
        PedAngleLimitsForSkydiving = 2243095299,
        PedDirToPedCoverCosAngleTol = 1073641398,
        PedFearImpact = 3170606833,
        PedGenBlockedAreaMinRadius = 3928192642,
        PedGenBlockingAreaLifeTimeMS = 1799800134,
        PedMoveAccel = 1030928652,
        PedMoveDecel = 1966094123,
        PedTestRadius = 2802682741,
        PedTestXOffset = 763167134,
        PedTestYOffset = 3960625221,
        PedTestZOffset = 480380605,
        PedTestZStartOffset = 1752043243,
        PedToCoverCapsuleRadius = 60938529,
        PedToCoverEndPullBackDistance = 1271601300,
        PedToCoverEndZOffset = 649298289,
        PedalGearApproachRate = 2418985851,
        PeekToEdgeTurnBlendDuration = 1163008630,
        PeekingAnimStateInfos = 1958652331,
        PeekingHigh1HVariationClipsets = 86703483,
        PeekingHigh2HVariationClipsets = 1692855661,
        PeekingLow1HVariationClipsets = 3656589599,
        PeekingLow2HVariationClipsets = 4084903537,
        PeekingVariationAnimStateInfos = 2572412881,
        PelvisInterp = 2837302706,
        PelvisInterpMoving = 115587354,
        PelvisInterpOnDynamic = 2709476201,
        Penalty = 581818714,
        Periodic = 1887945139,
        PersonalityName = 4206114216,
        PhaseDuringDeployToConsiderOut = 1259738869,
        PhaseToBlendOut = 4149318965,
        PhoneFov = 732629634,
        PickingUpBikeModifier = 1578175347,
        PinnedDownBlindFireChance = 1504716899,
        PinnedDownByBulletRange = 3328891889,
        PinnedDownDecreaseAmountPerSecond = 2317940667,
        PinnedDownPeekChance = 3488557674,
        PinnedDownTakeCoverAmount = 2529898856,
        PinnedDownThreshold = 2906996848,
        PinnedHigh1HVariationClipsets = 186750731,
        PinnedHigh2HVariationClipsets = 1643071074,
        PinnedIdleAnimStateInfos = 430330313,
        PinnedIntroAnimStateInfos = 2080360880,
        PinnedLow1HVariationClipsets = 1337721029,
        PinnedLow2HVariationClipsets = 3647756430,
        PinnedOutroAnimStateInfos = 3262741183,
        PitchAcceleration = 4133472264,
        PitchChangeRateAcceleration = 724740943,
        PitchClampMax = 4112643692,
        PitchClampMin = 1388744206,
        PitchForBraking = 2154895854,
        PitchForMaxIntensity = 2952102575,
        PitchForMinIntensity = 4133137923,
        PitchForNormal = 2757465295,
        PitchInDirectionComponent = 3608118347,
        PitchInDirectionForce = 2459418685,
        PitchOffsetAtMaxHeight = 2605085544,
        PitchOffsetAtMinHeight = 3346546090,
        PitchPullAroundErrorScalingBlendLevel = 3418263557,
        PitchPullAroundMaxMoveSpeed = 430354724,
        PitchPullAroundMinMoveSpeed = 2976192130,
        PitchPullAroundSpeedAtMaxMoveSpeed = 634917686,
        PitchPullAroundSpringConstant = 835784625,
        PitchPullAroundSpringDampingRatio = 1088580250,
        PitchRatioForLinearVZMax = 3041351606,
        PitchRatioForLinearVZMin = 2724758116,
        PitchSideAngle = 107265024,
        PitchTorqueMax = 3768610799,
        PitchTorqueMin = 2554943154,
        PivotOverBoundingBoxSettings = 588927535,
        PivotPosition = 3256568637,
        PlaneDrivingSubtaskArrivalDist = 1499169614,
        PlaneTargetArriveDist = 370645093,
        PlaneTargetArriveDistTaxiOnGround = 1118749782,
        PlayerBumpedByCar = 3418860704,
        PlayerBumpedByCloneCarActivationModifier = 3611321062,
        PlayerCapsuleMinSpeedForContinuousPushActivation = 3679622218,
        PlayerClearedVehicleDelay = 112556840,
        PlayerClearedVehicleSmartFallDelay = 2235898070,
        PlayerCopCarModifier = 1479577695,
        PlayerCopModifier = 4108478935,
        PlayerDeath = 2720032072,
        PlayerDeathMP = 1586436866,
        PlayerDeathSP = 3600525461,
        PlayerHasslingModifier = 3008009434,
        PlayerIdleHigh0HVariationClipsets = 3420717239,
        PlayerIdleHigh1HVariationClipsets = 2643498096,
        PlayerIdleHigh2HVariationClipsets = 1210186805,
        PlayerIdleIntroAnimRate = 2967257859,
        PlayerIdleLow0HVariationClipsets = 1469086565,
        PlayerIdleLow1HVariationClipsets = 421291191,
        PlayerIdleLow2HVariationClipsets = 2423980252,
        PlayerLookAtDebugDraw = 2179898613,
        PlayerMoveAccel = 3051090926,
        PlayerMoveDecel = 1886735419,
        PlayerMoverFixupMaxExtraHeadingChange = 1887702115,
        PlayerMp = 410406055,
        PlayerPedModifier = 2396547402,
        PlayerQuickBlendOut = 2430282312,
        PlayerSexyPedModifier = 390614501,
        PlayerSprintEntryRate = 1168875174,
        PlayerStatInfos = 977451662,
        PlayerSwankyCarMax = 3873670579,
        PlayerSwankyCarMin = 369519904,
        PlayerSwankyCarModifier = 1078762608,
        PlayerSwimTimeThreshold = 422419421,
        PlayerTimeBetweenLookAtsMax = 408684949,
        PlayerTimeBetweenLookAtsMin = 2542169368,
        PlayerTimeMyVehicleLookAtsMax = 3266178324,
        PlayerTimeMyVehicleLookAtsMin = 831935567,
        Player_IdleTurnRate = 1662197919,
        Player_MBRAcceleration = 3782895898,
        Player_MBRDeceleration = 1302286994,
        PointOnMap = 2637460797,
        PopulationFleeMod = 3370827836,
        Pos = 4135922358,
        PositionDiffStartBlend = 126173811,
        PowerForMaxAdjustment = 3574337729,
        PowerForMinAdjustment = 4239471096,
        PreEmptiveEdgeActivationMaxDistance = 3827728081,
        PreEmptiveEdgeActivationMaxHeadingDiff = 1934953324,
        PreEmptiveEdgeActivationMaxVel = 3639122208,
        PreEmptiveEdgeActivationMinDesiredMBR2 = 3990938220,
        PreEmptiveEdgeActivationMinDotVel = 2370073816,
        PreToPostCollisionLookAtOrientationBlendValue = 3068587259,
        PrecisionAimSettings = 2539872798,
        PredictiveBraceBlendInDuration = 1609589815,
        PredictiveBraceBlendOutDuration = 2469517273,
        PredictiveBraceMaxUpDotSlope = 1011217048,
        PredictiveBraceProbeLength = 2158524964,
        PredictiveBraceStartDelay = 3163116709,
        PredictiveProbeZOffset = 1351443366,
        PredictiveRagdollIntersectionDot = 1107591412,
        PredictiveRagdollProbeLength = 1048227809,
        PredictiveRagdollProbeRadius = 503191318,
        PredictiveRagdollRequiredVelocityMag = 2170844885,
        PredictiveRagdollStartDelay = 3462282137,
        PreferNearWaterSurfaceArrivalRadius = 2212250161,
        PreventDirectTransitionToReverseFromSit = 1025905604,
        PreventRotationOvershoot = 634174859,
        PreventShufflingExtraRange = 1174072295,
        PreventTranslationOvershoot = 570011198,
        PreviousTransitionClipId = 681665994,
        PreviousTransitionExtraScalar = 2390268263,
        PrioHarmless = 3537128593,
        PrioIngangOrFriend = 2239503730,
        PrioMeleeCombatThreat = 3520267510,
        PrioMeleeDead = 2219818555,
        PrioMeleeDownedCombatThreat = 3711072717,
        PrioMeleeInjured = 2459910426,
        PrioMeleePotentialThreat = 1405902341,
        PrioMissionThreat = 1044442786,
        PrioMissionThreatCuffed = 647449150,
        PrioNeutral = 2861651580,
        PrioNeutralInjured = 354050193,
        PrioPlayer2Player = 1964865895,
        PrioPlayer2PlayerAttackers = 762484474,
        PrioPlayer2PlayerCuffed = 1986201193,
        PrioPlayer2PlayerEveryone = 3895688789,
        PrioPlayer2PlayerStrangers = 2061852453,
        PrioPotentialThreat = 1168690220,
        PrioScriptedHighPriority = 1053617936,
        PriorityCoverWeight = 3734777024,
        PriorityCoverWeighting = 1292700163,
        ProbSpawnHeli = 2463315253,
        ProbabilityDrawWeaponWhenLosing = 1774223506,
        ProbabilityWeighting = 51557962,
        Probe = 217069262,
        ProbeHeightAbovePelvis = 1229015521,
        ProbeResults = 3041273548,
        Probes = 1934123857,
        ProcessPhysicsApproachRate = 2123652996,
        Professional = 2673189131,
        ProgressiveTerrainAvoidanceAngleD = 4040142753,
        PullAlongside = 2022288628,
        PullAroundSettings = 1394164846,
        PullAroundSettingsForLookBehind = 914396031,
        PullBackSpringConstant = 1125215459,
        PullBackTowardsCollision = 333745998,
        PullPinClipId = 547753211,
        Pursue = 2777285984,
        PursuitModeExtraHeadingRate = 2496636494,
        PursuitModeGallopRateFactor = 3846643666,
        PushAngleDotTolerance = 1293114690,
        PushBeyondEntitiesIfClipping = 2276761303,
        PushInSpringConstant = 2562227249,
        PushedThresholdOnGround = 476585181,
        PutOnHelmetClipId = 2026680640,
        QUADBIKE = 1011863180,
        QuickBlendOut = 784154981,
        RADIO_FILE = 2322405299,
        RADIO_GENRE_CLASSIC_HIPHOP = 255693040,
        RADIO_GENRE_COUNTRY = 1750835908,
        RADIO_GENRE_DANCE = 43700981,
        RADIO_GENRE_LEFT_WING_TALK = 3586021020,
        RADIO_GENRE_MODERN_HIPHOP = 285221172,
        RADIO_GENRE_POP = 4176867203,
        RADIO_GENRE_UNSPECIFIED = 4132096390,
        RAGDOLL_BUTTOCKS = 540107349,
        RAGDOLL_CLAVICLE_LEFT = 2288805232,
        RAGDOLL_CLAVICLE_RIGHT = 488421620,
        RAGDOLL_FOOT_LEFT = 2446307443,
        RAGDOLL_FOOT_RIGHT = 4158664243,
        RAGDOLL_HAND_LEFT = 3905421121,
        RAGDOLL_HAND_RIGHT = 1124094743,
        RAGDOLL_HEAD = 111082097,
        RAGDOLL_LOWER_ARM_LEFT = 125251313,
        RAGDOLL_NECK = 339046583,
        RAGDOLL_SHIN_LEFT = 2408459571,
        RAGDOLL_SHIN_RIGHT = 3373894112,
        RAGDOLL_SPINE0 = 2548005619,
        RAGDOLL_SPINE1 = 1729141078,
        RAGDOLL_SPINE2 = 1967764936,
        RAGDOLL_SPINE3 = 3266498717,
        RAGDOLL_THIGH_LEFT = 1739907813,
        RAGDOLL_THIGH_RIGHT = 3821605495,
        RAGDOLL_UPPER_ARM_LEFT = 2053403138,
        RAGDOLL_UPPER_ARM_RIGHT = 1968199161,
        RadiusForContact = 1978969151,
        RadiusForFindNearby = 2410167662,
        RadiusForViewportCheck = 3808847755,
        RadiusScalingForClippingTest = 2642729834,
        RadiusScalingForOcclusionTest = 2763528752,
        RagdollAbortPoseDistanceThreshold = 1562486689,
        RagdollAbortPoseMaxVelocity = 445822306,
        RagdollBlendEnvelopeRef = 2513422573,
        RagdollComponentAirResistanceForce = 1187767114,
        RagdollComponentAirResistanceMinStiffness = 3808435735,
        RagdollIntoWaterVelocity = 477015084,
        RagdollPlayerDistanceThreshold = 3324445918,
        RagdollUnderWheelTuning = 2982454130,
        RagdollingModifier = 3445942281,
        RageRagdollImpulseTuning = 3405457664,
        Ram = 3087082769,
        RandomEventData = 4113341331,
        RandomEventName = 790968462,
        RandomEventTimeIntervalMax = 2841351028,
        RandomEventTimeIntervalMin = 2347950667,
        RandomEventType = 2154193106,
        RandomEventTypeName = 2873713085,
        RandomiseLeadingHand = 2410986509,
        RandomiseSettledTime = 2400689426,
        Randomness = 3060363673,
        RangeOffset = 3211719875,
        RangePercentage = 2083139838,
        RangeToUseDynamicCoverPointMax = 2744819135,
        RangeToUseDynamicCoverPointMin = 2676905487,
        RapidFireBoostShotImpulseMult = 926832193,
        RapidFireBoostShotMaxRandom = 2456570730,
        RapidFireBoostShotMinRandom = 3069940419,
        RapidHitCount = 1056935054,
        RappellingAlignment = 4264482777,
        ReactAndFleeBlendOutPhase = 851779527,
        ReactToOtherEntity = 409978509,
        ReactionMode = 3828609944,
        ReactionTime = 1025142686,
        RearExitSideOffset = 1266778169,
        RecentlyLookedAtEntityModifier = 2971794167,
        RecentlyLookedAtPlayerModifier = 975579249,
        RecklessCarModifier = 813645662,
        RecklessCarSpeedMax = 199234802,
        RecklessCarSpeedMin = 1168459099,
        RecoilShakeAmplitudeScaling = 2294924343,
        RecreateWeaponTime = 3706230533,
        ReduceDownedTimeByPerformanceTime = 1128285975,
        ReduceWithPedAngularVelocity = 3126754678,
        ReduceWithPedVelocity = 1660316244,
        ReenterFallLandThreshold = 4199432698,
        Refuel = 3888134503,
        RegainComet = 605981827,
        RegisteredStacks = 3283104082,
        RegularExitDefaultPhaseThreshold = 5170829,
        RejectLockIfBestTargetIsInCover = 3603478229,
        RejectLockonHeadingTheshold = 655402948,
        RelativeAttachPosition = 2323851759,
        RelativeAttachPositionSmoothRate = 2878053132,
        RelativeAttachSpringConstantEnvelopeRef = 4086545075,
        RelativeAttachSpringConstantLimits = 1204776061,
        RelativeAttachSpringConstantLimitsForPassengers = 340115724,
        RelativeAttachSpringDampingRatio = 2918672176,
        RelativeHeadingLimitsForMobilePhoneCamera = 503778969,
        RelativeLookAtPosition = 54415504,
        RelativeOffset = 4287557601,
        RelativeOrbitHeadingLimits = 1654683326,
        Relaxation = 1783791261,
        ReleaseDelay = 4289809678,
        ReleaseDuration = 4066793496,
        ReleaseSub = 2933611601,
        RemoveReticuleDuringBlindFire = 3024014754,
        RenderAimArcDebug = 3262184677,
        RenderArcsAtCoverPosition = 4249860971,
        RenderDebug = 3284686610,
        RenderDebugDraw = 2797308174,
        RenderDebugToTTY = 3670985951,
        RenderId = 2789976084,
        Rendering = 67050499,
        Reservations = 3702072617,
        ReserveLocalPlayerNmAgent = 2584307454,
        ReserveLocalPlayerNmAgentMp = 75381461,
        Reserved = 4030133267,
        Resource = 4037058594,
        Restrictions = 3321094558,
        ResultMult = 2301637192,
        ResumeDistSq = 810755963,
        ReticuleSlowDownCapsuleLength = 1217679840,
        ReticuleSlowDownCapsuleRadius = 494811143,
        ReticuleSlowDownRadius = 1424095429,
        ReturnToNormalDistanceSq = 829574868,
        ReturnZoneThreshold = 4004042226,
        ReverseLeftFootAlignAnims = 1175770299,
        RifleDamageMod = 3362977435,
        RightBoneOffset = 697293397,
        RightGrip = 2936843542,
        RightHandOffset = 4292584457,
        RightPickUpTargetLerpPhaseEnd = 58162742,
        RightPickUpTargetLerpPhaseEndBicycle = 4109701939,
        RightPickUpTargetLerpPhaseStart = 1933869525,
        RightPickUpTargetLerpPhaseStartBicycle = 3395959775,
        RightPullUpTargetLerpPhaseEnd = 2264946778,
        RightPullUpTargetLerpPhaseEndBicycle = 3699582686,
        RightPullUpTargetLerpPhaseStart = 1089127336,
        RightPullUpTargetLerpPhaseStartBicycle = 149985112,
        RightWire = 2577801154,
        RocketSettings = 4146741065,
        RollAcceleration = 802099030,
        RollAngleScale = 2238978991,
        RollForBraking = 3154540810,
        RollForMaxYaw = 1251049479,
        RollForMinYaw = 1128820245,
        RollForNormal = 3016943843,
        RollSettings = 4214646062,
        RollSpringConstant = 261121990,
        RollSpringDampRatio = 1003830880,
        RollUpHeightThreshold = 2106002013,
        RollingFall = 2787586299,
        RootLiftForce = 2143662100,
        RotationChangeRate = 3669742245,
        RotationLookAhead = 3143134944,
        RotationTowardsLos = 1899363737,
        RouteArrivalDistance = 157944410,
        RouteLengthThresholdForApproachOffset = 4290867387,
        RouteLengthThresholdForFinalApproach = 394374347,
        RouteLookAheadDistance = 1396210696,
        RouteRadiusFactor = 4261831117,
        RubberBulletKnockdown = 3062524360,
        RunAndGunAimCamera = 724878846,
        RunAndGunInterpolateInDuration = 674462637,
        RunAndGunOutroTime = 3879469601,
        RunAngAccel = 469859232,
        RunForever = 4079974935,
        Running = 3805238957,
        RunningAgainstBulletImpulseMult = 930478842,
        RunningAgainstBulletImpulseMultMax = 2892741044,
        RunningPedModifier = 1209452937,
        RunningWithBulletImpulseMult = 188546747,
        RunwayProbes = 731090194,
        SAC_Randomize = 1962395292,
        SAC_Retain = 2341131515,
        SAT_BULLET_TIME = 2744852139,
        SAT_CAR_SLOWDOWN = 2137706596,
        SAT_INSULT = 2169367037,
        SAT_RAGE = 3583791984,
        SAT_SNAPSHOT = 977651983,
        SCENARIO_POINTS_FILE = 276092270,
        SCENARIO_POP_STREAMING_SMALL = 1152280719,
        SF_AltBackDriverSide = 2355736970,
        SF_AltBackPassengerSide = 2152776352,
        SF_AltFrontDriverSide = 3757862915,
        SF_AltFrontPassengerSide = 1261964441,
        SF_BackDriverSide = 3935682468,
        SF_BackPassengerSide = 2563045769,
        SF_FrontDriverSide = 982742767,
        SF_FrontPassengerSide = 469567916,
        SLOD_KEEP_LOWEST = 462532381,
        SLOD_LARGE_QUADPED = 3496177438,
        SLOD_NULL = 551739454,
        SLOD_SMALL_QUADPED = 1128152005,
        SMALL_REACTION = 2909022553,
        SPACE_BIG = 652367616,
        SPACE_END = 1961485429,
        SPACE_MED = 2308938833,
        SPACE_SMALL = 3292874000,
        SPECIAL_AIRPORT = 3761654755,
        SPECIAL_NONE = 514090469,
        SPLargeAccidenThresold = 803970846,
        SPRITE_1 = 394130841,
        SP_Variation = 3866220764,
        STREAMING_FILE = 265895563,
        STREAMING_FILE_PLATFORM_OTHER = 1322995281,
        STREAMING_FILE_PLATFORM_PS3 = 4254420265,
        STREAMING_FILE_PLATFORM_XENON = 569488699,
        SUBMARINE = 2537188912,
        SafeDistance = 2538781855,
        SafeTimeBeforeLeavingCover = 4116865999,
        SafetyProportionInDefensiveAreaMax = 189140842,
        SafetyProportionInDefensiveAreaMin = 1022323136,
        ScaleAccelWithDelta = 801104139,
        ScaleHeadShotImpulseWithSpineOrientation = 1833987390,
        ScaleSnapWithSpineOrientation = 125672080,
        ScaleStayUprightWithVel = 3892109820,
        ScaleWithMass = 2640302727,
        ScaleWithUpright = 1033385210,
        ScaleWithVelocity = 2708100865,
        ScalingFactor = 4050830448,
        ScanDistance = 1702320721,
        ScanRadius = 2723670760,
        ScenarioDelayAfterFailureMax = 4009937054,
        ScenarioDelayAfterFailureMin = 4004750790,
        ScenarioDelayAfterFailureWhenStationary = 1166603434,
        ScenarioDelayAfterNotAbleToSearch = 2129795449,
        ScenarioDelayAfterSuccessMax = 2887992243,
        ScenarioDelayAfterSuccessMin = 1467495810,
        ScenarioDelayInitialMax = 1049520739,
        ScenarioDelayInitialMin = 2307005569,
        ScenarioScanOffsetDistance = 1173793332,
        ScenarioScanRadius = 2718645532,
        ScenarioToScenarioPedModifier = 645696278,
        ScoreCalculationsPerFrame = 1815040418,
        Scoring = 3333387022,
        ScreenRatioForMaxFootRoom = 3982287448,
        ScreenRatioForMaxFootRoomInTightSpace = 695725580,
        ScreenRatioForMinFootRoom = 2014345705,
        ScreenRatioForMinFootRoomInTightSpace = 2449849624,
        Scripted = 1420062864,
        ScubaGear = 7473239,
        ScubaGearVariations = 1092654765,
        ScubaGearWithLightsOff = 505931244,
        ScubaGearWithLightsOn = 1478092361,
        ScubaMaskProps = 2321693669,
        SearchRotateAngleLookAhead = 1512295050,
        SearchThreatMaxDot = 1574888900,
        SearchToCoverCosTolerance = 2892923069,
        SeatBlendAngSpeed = 580774094,
        SeatBlendLinSpeed = 3426806263,
        SeatDisplacementSmoothingRateDriver = 3305089148,
        SeatDisplacementSmoothingRatePassenger = 166726527,
        SeatPosition = 788888146,
        SecondaryFocusParentToTargetBlendLevel = 2535634527,
        SecondsBeforeWarpToLeader = 3663548072,
        SecondsSinceInWaterThatCountsAsWet = 3211610412,
        SensesRange = 1188235128,
        SeparationDrag = 3440934413,
        SeparationPickup = 383086153,
        SeparationPutdown = 4100111705,
        SetFallingReactionFallOverVehicle = 246824093,
        SetFallingReactionFallOverWall = 3571002906,
        SetFallingReactionHealthy = 1126347982,
        SetFallingReactionInjured = 3814409847,
        SettingsRef = 926775845,
        SettleAnimStateInfos = 260425135,
        SettledTimeMS = 2088054141,
        SettledTimeMinMS = 2229954249,
        ShakeAmplitude = 415335014,
        ShakeAmplitudeScalingForShootingAbilityLimits = 1149560055,
        ShakeFirstPersonShootingAbilityLimits = 937843974,
        ShakeRef = 1511687083,
        SharkAddRangeInViewMin = 750370993,
        SharkFleeDist = 3147934542,
        SharkModelName = 2326003695,
        ShockingFilmSpeechHash = 1372129940,
        ShockingSpeechChance = 1805287691,
        ShockingSpeechHash = 1884622848,
        ShootRateModifier = 920840724,
        Shot = 2213248546,
        ShotAgainstWall = 2464589752,
        ShotgunChanceToMoveHeadImpulseToSpine2 = 2406131077,
        ShotgunChanceToMoveNeckImpulseToSpine2 = 895546582,
        ShotgunChanceToMoveSpine3ImpulseToSpine2 = 3217262184,
        ShotgunLiftNearThreshold = 4071309368,
        ShotgunMaxLiftImpulse = 3764669870,
        ShotgunMaxSpeedForLiftImpulse = 3579666943,
        Shots = 4029364641,
        ShouldAimSweepOverrideOrbitPitchLimits = 184490319,
        ShouldAlign = 2033261313,
        ShouldAlignOnVehicleExit = 3431976824,
        ShouldAllowInterpolationSourceCameraToPersistReticule = 4238055063,
        ShouldAllowOtherCollisionToConstrainCameraIntoEntities = 615517883,
        ShouldApply = 651835053,
        ShouldApplyAimSensitivityPref = 2185008081,
        ShouldApplyAttachOffsetRelativeToCamera = 3807713258,
        ShouldApplyAttachParentRoll = 4012821505,
        ShouldApplyAttachPedPelvisOffset = 2861227361,
        ShouldApplyBuoyancy = 959048093,
        ShouldApplyDamping = 2339455115,
        ShouldApplyInAttachParentLocalSpace = 3748493944,
        ShouldApplyRoll = 436250856,
        ShouldApplyScaling = 1357431466,
        ShouldApplySniperControlPref = 2355159673,
        ShouldApplyWeaponFov = 2917952843,
        ShouldAttachToFollowPedHead = 2659354456,
        ShouldAttachToFollowPedSeat = 339929903,
        ShouldAttachToParentCentreOfGravity = 372575308,
        ShouldAttachToVehicleBone = 3725196996,
        ShouldAttachToVehicleExitEntryPoint = 2429106995,
        ShouldBlendOutWhenAttachParentIsInAir = 3478105571,
        ShouldBlendOutWhenAttachParentIsOnGround = 1212391588,
        ShouldBlendWithAttachParentMatrixForRelativeOrbitBlend = 3993671513,
        ShouldByPassNearClip = 4107190241,
        ShouldCalculateXYDistance = 9156722,
        ShouldConsiderAttachParentForwardSpeedForPullAround = 3857630189,
        ShouldConsiderAttachParentLocalXYVelocityForPullAround = 4045243730,
        ShouldConsiderData = 3663951405,
        ShouldConstrainCollisionRootPositionAgainstClippingTypes = 823526659,
        ShouldCopyVehicleCameraMotionBlur = 1232220671,
        ShouldDetect = 1134622566,
        ShouldDisplayReticule = 1348911901,
        ShouldDisplayReticuleDuringInterpolation = 870186590,
        ShouldDuck = 1848522270,
        ShouldFleeDistance = 2097584563,
        ShouldFleeFilmingDistance = 2071699275,
        ShouldFleeVehicleDistance = 1339551933,
        ShouldFocusOnLockOnTarget = 4137686847,
        ShouldForceCutToOrbitDistanceLimitsForThirdPersonFarViewMode = 1953360151,
        ShouldIgnoreAttachParentMovementForOrientation = 1256703824,
        ShouldIgnoreAttachParentPitchForLookBehind = 2793581079,
        ShouldIgnoreBuoyancyStateAndAvoidSurface = 134488060,
        ShouldIgnoreCollisionWithAttachParent = 1949881438,
        ShouldIgnoreCollisionWithFollowVehicle = 3863307203,
        ShouldIgnoreFollowVehicleForCollisionOrigin = 3696538081,
        ShouldIgnoreFollowVehicleForCollisionRoot = 2213127338,
        ShouldIgnoreOcclusionWithBrokenFragments = 1921983042,
        ShouldIgnoreOcclusionWithBrokenFragmentsOfIgnoredEntities = 3325779817,
        ShouldIgnoreOcclusionWithRagdolls = 1973279102,
        ShouldIgnoreOcclusionWithSelectCollision = 2656848273,
        ShouldIgnoreVelocityOfAttachParentAttachEntity = 1933402526,
        ShouldIgnoreVerticalPivotOffsetForFootRoom = 881872463,
        ShouldLockHeading = 2098973612,
        ShouldLockOnToTargetEntityPosition = 1419212045,
        ShouldLockVerticalOffset = 1581058504,
        ShouldMakeAttachedEntityInvisible = 1478931781,
        ShouldMakeFollowPedHeadInvisible = 1762086384,
        ShouldMakePedInAttachSeatInvisible = 1538342627,
        ShouldMoveTowardsLos = 1510673380,
        ShouldOrbitRelativeToAttachParentOrientation = 2846809829,
        ShouldPersistOrbitOrientationRelativeToAttachParent = 3002500493,
        ShouldPersistPopInBehaviour = 2762175909,
        ShouldPullAroundToAttachParentFront = 2208576746,
        ShouldPullAroundToBasicAttachParentMatrix = 3468493382,
        ShouldPullAroundUsingSimpleSpringDamping = 3614496996,
        ShouldPullBackByCapsuleRadius = 1356103878,
        ShouldPushBeyondAttachParentIfClipping = 724966028,
        ShouldReportAsCameraTypeTest = 1876340735,
        ShouldRestictToFrontSeat = 523999628,
        ShouldRewardMoneyOnDeath = 89900819,
        ShouldScriptedAimTaskOverrideOrbitPitchLimits = 3180847895,
        ShouldSetBuoyantWhenAttachParentNotFullySubmerged = 448788827,
        ShouldSweepToAvoidPopIn = 1756495672,
        ShouldTerminateForDistanceToTarget = 179124010,
        ShouldTerminateForOcclusion = 474380051,
        ShouldTerminateForPitchAndHeading = 4172426852,
        ShouldTerminateForWorldPitch = 1301968002,
        ShouldTerminateIfOccludedByAttachParent = 1072193524,
        ShouldTestForClipping = 2106075408,
        ShouldTestForMapPenetrationFromAttachPosition = 1051168964,
        ShouldToggleAccurateModeInput = 288255802,
        ShouldToggleViewModeBetweenThirdAndFirstPerson = 3604554750,
        ShouldTorsoIkLimitsOverrideOrbitPitchLimits = 3271563285,
        ShouldUseAccurateModeInput = 2283622261,
        ShouldUseBaseAttachPosition = 2274949645,
        ShouldUseCustomCollisionOrigin = 2702878862,
        ShouldUseCustomFramingInTightSpace = 4033450681,
        ShouldUseDiscreteZoomControl = 1466092206,
        ShouldUseDynamicCentreOfGravity = 799910142,
        ShouldUseGameTime = 820757070,
        ShouldUseLockOnAiming = 1301399000,
        ShouldUseLockOnAimingForDriver = 721433849,
        ShouldUseLockOnAimingForPassenger = 1821508366,
        ShouldUseLookBehindCustomPosition = 956615974,
        ShouldUseLookBehindInput = 4114297506,
        ShouldUseViewModeInput = 509270218,
        ShouldUseZoomInput = 1706209718,
        ShouldValidateLockOnTargetPosition = 114759485,
        ShuntAccelerateMag = 1917995403,
        ShuntAccelerateMagBike = 3020055197,
        ShuntDamageMultiplierAI = 158324629,
        ShuntDamageMultiplierPlayer = 851764695,
        SideOffset = 2119254607,
        SideScale = 1948575789,
        SideSwipeForce = 3413603413,
        SideZoneThreshold = 1333345561,
        SimulationTimeInMs = 3281708108,
        SitToStillBikeClipId = 1718435094,
        SitToStillCharClipId = 2341866800,
        SitToStillClipId = 3951489866,
        SkipGotoHeadingDeltaDegrees = 2090002900,
        SkipGotoXYDist = 699708569,
        SkipGotoZDist = 790344800,
        SkipHolsterWeapon = 45502974,
        SkyDiveProbeDistance = 343578348,
        SkyDivingCamera = 365994391,
        SlideWalkAnimRate = 4171416824,
        SlopeSlide = 862016535,
        SlowApproachRate = 2330583994,
        SlowDown = 1251865784,
        SlowDownDist = 2685821768,
        SlowDownDistance = 4110448569,
        SlowDownDistanceMax = 1781466093,
        SlowDownDistanceMin = 947493336,
        SlowDownSpeed = 2686150441,
        SlowFastSpeedThreshold = 4250418611,
        SlowMinTurnApproachRate = 3696984410,
        SlowPedalToFreewheelBlendDuration = 1900606204,
        SlowRunRateMax = 843042981,
        SlowRunRateMin = 3959772122,
        SlowTurnAcceleration = 3928052593,
        SlowTurnApproachRate = 3661307080,
        SlowdownDistance = 3943951078,
        SmallCapsuleCoverPenalty = 184089910,
        SmallCapsuleCoverRadius = 1348626108,
        SmgDamageMod = 167232035,
        SmoothRate = 1863632928,
        SniperImpulses = 3585973980,
        SniperLegShot = 3003938851,
        SoftLockBreakDistanceMax = 2224486137,
        SoftLockBreakDistanceMin = 1661550302,
        SoftLockBreakValue = 4067802571,
        SoftLockFineAimBreakXYValue = 1403902499,
        SoftLockFineAimBreakZValue = 3553881274,
        SoftLockFineAimXYAbsoluteValue = 352361634,
        SoftLockFineAimXYAbsoluteValueClose = 1117580274,
        SoftLockTime = 2124028122,
        SoftLockTimeToAcquireTarget = 3433060120,
        Sonar = 409760750,
        SpActivationModifiers = 1742296994,
        Spawning = 4197810024,
        SpawningChasesEnabled = 1201683089,
        SpeedDifferenceForMaxDistanceToStartMatchingSpeed = 1979699436,
        SpeedDifferenceForMinDistanceToStartMatchingSpeed = 2025348338,
        SpeedForMinimumDot = 1301007976,
        SpeedForNarrowestAnglePickPOI = 1078877377,
        SpeedLimitsForVerticalMoveSpeedScaling = 1914871967,
        SpeedToAlwaysDive = 2913264363,
        SphereTestRadiusForDeadWaterSettle = 2511398250,
        SpinOut = 1954107545,
        SpineStrengthTuning = 2573019437,
        SpreadLimit = 662073465,
        SpringConstant = 4163819120,
        SpringDampingRatio = 731206835,
        SpringForce = 2286316924,
        SpringMountRef = 4021873979,
        SprintControlData = 3828880770,
        SprintExhausted = 29931670,
        SprintReplenishFinishedPercentage = 3615351832,
        SprintReplenishRateMultiplier = 3211960089,
        SprintReplenishRateMultiplierBike = 600117053,
        Sprinting = 2194212345,
        SprintingDeath = 3676971081,
        SprintingLegShot = 1190774472,
        StairsFootInterp = 3289881556,
        StairsFootInterpCoverAim = 2144071841,
        StairsFootInterpIntersecting = 3671506242,
        StairsPelvisInterp = 2577533666,
        StairsPelvisInterpCoverAim = 1271955779,
        StairsPelvisInterpMoving = 2302577809,
        StairsPelvisMaxNegativeDeltaZCoverAim = 3894253961,
        StairsSpringMultiplierMax = 816343475,
        StairsSpringMultiplierMin = 369470094,
        StaminaEfficiency = 1862920964,
        StandAlignMaxDist = 996663150,
        StandClip0Id = 2845656216,
        StandClip1Id = 1744028122,
        StandClip2Id = 1441580086,
        StandardAI = 1367672446,
        StandardBlendOutThresholds = 2851995582,
        StandingLandHeadingModifier = 176941965,
        StartAggressive = 987294494,
        StartAnimatedTurnsD = 3129761256,
        StartCatchFall = 1213801104,
        StartClipWaitTime = 123069407,
        StartClipWaitTimePlayer = 1412213192,
        StartDefault = 385444229,
        StartDelayDuration = 966603625,
        StartEngineClipId = 723740105,
        StartEngineForce = 3175914177,
        StartExtendedProbeTime = 2633188230,
        StartForceDownHeight = 2371670611,
        StartLocomotionBlendoutThreshold = 1243932439,
        StartLocomotionDefaultBlendDuration = 1266064609,
        StartLocomotionDefaultBlendOutDuration = 1010088937,
        StartLocomotionEarlyOutBlendOutDuration = 3914009351,
        StartLocomotionHeadingDeltaBlendoutThreshold = 562952832,
        StartLocomotionWalkRunBoundary = 1107407285,
        StartPosition = 4070310820,
        StartRollDownStairs = 2633206880,
        StartToIdleDirectlyPhaseThreshold = 265096732,
        StartTurnThresholdDegrees = 1138520829,
        StartWeak = 2862149771,
        StartWindmill = 776602752,
        StartingEnergy = 3024832208,
        StaticLosTest1Offset = 2749521042,
        StaticLosTest2Offset = 4086815177,
        StayUpright = 509938192,
        StayUprightAtMaxVel = 930009703,
        StayUprightAtMinVel = 3524092362,
        StdVehicleMinPhaseToStartRotFixup = 2300124116,
        StealthNoisePeriodMS = 2280670656,
        StealthSpeedThresholdHigh = 2089726799,
        StealthSpeedThresholdLow = 324788932,
        StealthVehicleTypeFactorBicycles = 897691679,
        StealthZoomSettings = 3610920953,
        SteepSlopeStartAnimatedTurnsD = 2582103758,
        SteepSlopeStopAnimatedTurnsD = 1722856329,
        SteepSlopeThresholdD = 3054410305,
        SteerAngleControl = 3605734753,
        SteeringChangeToStartProcessMoveSignals = 2406738390,
        SteeringChangeToStopProcessMoveSignals = 3912339645,
        SteeringDeadZone = 2532196566,
        SteeringDeadZoneCentreTimeMS = 1503418851,
        SteeringDeadZoneTimeMS = 1683629424,
        StepInfos = 1592390985,
        StepOutCapsuleRadiusScale = 2554062878,
        StepOutLeftX = 1144003052,
        StepOutRightX = 3683453861,
        StepOutX = 259942193,
        StepOutY = 4255892364,
        StepTransitionMaxAngle = 1584333756,
        StepTransitionMinAngle = 2533820819,
        SteppingAnimStateInfos = 3007867016,
        SteppingApproachRate = 2556798213,
        SteppingApproachRateFast = 1705449547,
        SteppingApproachRateSlow = 4027315230,
        SteppingEdgeTestEndYOffset = 2621555533,
        SteppingEdgeTestStartYOffset = 1342115678,
        SteppingHeadingApproachRate = 4090917343,
        SteppingMovementSpeed = 2296590808,
        StickDownDuration = 4175251844,
        StickDownMinRange = 488214823,
        StickValueForMax = 2536907014,
        StickValueForMin = 1576728196,
        StickX = 1871798248,
        StickY = 1965746967,
        StickyId = 2164901921,
        StillAccTol = 1079251923,
        StillDelayTime = 3047698562,
        StillPitchAngleTol = 2495843356,
        StillToSitApproachRate = 3504747140,
        StillToSitClipId = 1322656239,
        StillToSitLeanRate = 651496609,
        StopAnimatedTurnsD = 1268028398,
        StopDistSq = 1791608761,
        StopPhaseThreshold = 1520516679,
        StopResponseWhenExpired = 2309582193,
        StopTurnThresholdDegrees = 1142247737,
        StopWatchDistance = 2181133548,
        StoppingAnimStateInfos = 2080209369,
        StoppingDistanceGallopMBR = 3764305197,
        StoppingDistanceRunMBR = 2508724347,
        StoppingDistanceWalkMBR = 792142948,
        StoppingGotoPointRemainingDist = 577153356,
        StrafeAcceleration = 1363831855,
        StrafeDirectionLerpRateMaxAI = 1204182041,
        StrafeDirectionLerpRateMaxPlayer = 2769179410,
        StrafeDirectionLerpRateMinAI = 2509399696,
        StrafeDirectionLerpRateMinPlayer = 1932572913,
        StraightLineDistance = 474269749,
        StreamConnectedSeatAnims = 3147840041,
        StreamEntryAndInVehicleAnimsTogether = 1924248769,
        StreamInVehicleAndEntryAnimsTogether = 4236803127,
        StreamedOneHandedCoverMovementClipSetId = 3568457068,
        StreamedUnarmedCoverMovementClipSetId = 3141671110,
        StreamingName = 692898807,
        StrongBlastMagnitude = 1446526858,
        StuckOnVehicle = 648899635,
        StuckOnVehicleBlendOutThresholds = 2482984819,
        StuckOnVehicleMaxTime = 1360661757,
        StuckOnVehiclePlayer = 2880735205,
        StuckUnderVehicle = 1316017959,
        StuckUnderVehicleMaxUpright = 1218193578,
        StuckUnderVehiclePlayer = 600771112,
        StuckWaitTime = 774340160,
        StuckWaitTimeMp = 4110175468,
        StunnedDistanceSpringConstant = 399773061,
        StunnedDistanceSpringDampingRatio = 340673450,
        StunnedHeadingSpringConstant = 1625429307,
        StunnedHeadingSpringDampingRatio = 2414166560,
        StunnedPitchSpringConstant = 1044796272,
        StunnedPitchSpringDampingRatio = 122790262,
        StuntJump = 2578429326,
        StuntJumpPitchInDirectionComponent = 2080285568,
        StuntJumpPitchInDirectionForce = 2619863448,
        SubmergedBlendOutThreshold = 3512832436,
        SuperHighFallStart = 2200596271,
        SurfaceHeightFallingLerpRate = 3431403282,
        SurfaceHeightFollowingTriggerRange = 3742890223,
        SurfaceHeightRisingLerpRate = 1039725890,
        SurfacePitchLerpRate = 61986925,
        SurfaceProbeHead = 1909345264,
        SurfaceProbeTail = 1086011957,
        SurfaceProjectionDistance = 2147768117,
        SurfaceSkimmerDepth = 1405419534,
        SurfaceZOffset = 2629938407,
        Surprised = 730897041,
        Swat = 507550818,
        SweepClip0Id = 3630917852,
        SweepClip1Id = 3117869494,
        SweepClip2Id = 4068466847,
        SwerveTime = 3588251070,
        SwingSpeedAtMaxSkidSpeed = 2084746057,
        SwitchToNextPointDistJogging = 4287996365,
        SwitchToNextPointDistWalking = 1010415847,
        SwitchToStraightLineDist = 2409655710,
        TC_Randomize = 279516121,
        TC_Retain = 3014288776,
        THIRD_PERSON_FAR = 2770781844,
        THIRD_PERSON_MEDIUM = 3489645472,
        THIRD_PERSON_NEAR = 2573120959,
        THROWNWEAPONINFO_FILE = 1339784773,
        TIME_DEPENDENT = 3029576156,
        TRAIN = 3644569018,
        TUNABLE_OBJECTS_FILE = 3511689339,
        TailgateDistanceMax = 10772112,
        TailgateIdealDistanceMax = 3640450256,
        TailgateIdealDistanceMin = 3101610967,
        TailgateSpeedMultiplierMax = 94249946,
        TailgateSpeedMultiplierMin = 2435522850,
        TailgateVelocityMin = 3105879189,
        TakeCustodyDistance = 116998034,
        TakedownProbability = 3234488441,
        TapAdd = 3672071413,
        TargetArriveDist = 3935882297,
        TargetDirectionMinDot = 3431388800,
        TargetDistance = 2300691636,
        TargetDistanceFallOffMax = 2509546906,
        TargetDistanceFallOffMin = 780951691,
        TargetDistanceFromVehicleEntry = 2654770325,
        TargetDistanceMaxWeightingAimTime = 2894102221,
        TargetDistanceWeightingMax = 1298342428,
        TargetDistanceWeightingMin = 4286470540,
        TargetHeadingWeighting = 379592677,
        TargetInfluenceSphereRadius = 4246707502,
        TargetJackRadius = 1336699435,
        TargetMaxSpeedToStrafe = 2121954925,
        TargetMinDistanceToAwayFacingNavLink = 1032956977,
        TargetMinDistanceToRoute = 1578284711,
        TargetMinSpeedToIgnore = 3344078648,
        TargetOffsetFilter = 4288775642,
        TargetRadiusForCloseNavMeshTask = 1670586696,
        TargetRadiusForMoveToPosition = 4292170157,
        TargetRadiusForOrientatedAlignRun = 2898549300,
        TargetRadiusForOrientatedAlignWalk = 3904376533,
        TargetReached = 2955443375,
        TargetRearDoorOpenRatio = 1172728662,
        TaskMessage = 191752587,
        TeeterControl = 2265693971,
        TeeterEdge = 1040810614,
        TestLowLodIdle = 718713683,
        TexId = 1424942312,
        TextLabel = 2047169098,
        TextureKey = 1994003276,
        ThirdPersonVehicleAimCameraRef = 961264130,
        ThreatDirWeight = 3141504902,
        ThreatEngageDirWeight = 3121364054,
        ThreatResponseArmed = 1842245065,
        ThreatResponseMelee = 2782470584,
        ThreatResponseUnarmed = 1368196689,
        Threshhold = 1066024874,
        ThresholdRun = 317231619,
        ThresholdWatch = 3695837863,
        ThresholdWatchAfterFace = 1236817557,
        ThresholdWatchStop = 3056724293,
        ThrottleControl = 1718221861,
        ThrottleMultiplier = 2515377448,
        ThroughWindScreenBlendInDuration = 1384973258,
        ThroughWindscreenDamageAi = 1443265623,
        ThroughWindscreenDamagePlayer = 91246296,
        ThrowLongClipId = 2511572601,
        ThrowProjectileClipSetId = 76855168,
        ThrowProjectileClips = 1011459206,
        ThrowShortClipId = 573759163,
        ThrowSmokeGrenadeTuning = 3088747583,
        TightSpaceSpringConstant = 488216999,
        TightSpaceSpringDampingRatio = 1406371922,
        TighterTurn = 2775606479,
        Tiles = 2501703395,
        TimeAfterAttractionMs = 3415237781,
        TimeAfterChainTestFailedMs = 884187023,
        TimeAfterFailedConditionsMs = 281170344,
        TimeAfterGunshotForPlayerToPlayIdles = 3057149274,
        TimeAfterGunshotToPlayIdles = 1718176557,
        TimeAfterNoBoundsMs = 2108114328,
        TimeAheadForBrake = 1369613048,
        TimeAheadForBrakeOnWideRoads = 3279921996,
        TimeAheadForGetInPosition = 1751757949,
        TimeBefore = 353469799,
        TimeBeforeDriverAnimCheck = 2064516214,
        TimeBeforeFiringMax = 6520997,
        TimeBeforeFiringMin = 1761265942,
        TimeBeforeInitialForcedFire = 1561898282,
        TimeBeforeOvertakeToMatchSpeedWhenCruising = 3069250390,
        TimeBeforeOvertakeToMatchSpeedWhenPulledOver = 847675324,
        TimeBetweenAddingDangerousVehicleEvents = 3877124457,
        TimeBetweenArmedMeleeAttemptsInMs = 3218253966,
        TimeBetweenBlockingAreaChecksMS = 3384585290,
        TimeBetweenBrokenPointChecks = 1732510557,
        TimeBetweenBurstsAbsoluteMin = 913069912,
        TimeBetweenBurstsMax = 1662854346,
        TimeBetweenBurstsMaxRandomPercent = 3041121812,
        TimeBetweenBurstsMin = 1007771611,
        TimeBetweenCarChaseShockingEvents = 2475600241,
        TimeBetweenChecksToLeaveCowering = 3836158716,
        TimeBetweenCoverPointSearches = 2294664490,
        TimeBetweenDifficultyUpdates = 2905197964,
        TimeBetweenDoorChecks = 910622893,
        TimeBetweenExitVehicleDueToRouteChecks = 4172879726,
        TimeBetweenForcedFireStates = 1133862058,
        TimeBetweenGroundProbes = 2107629661,
        TimeBetweenHandsUpChecks = 1422617106,
        TimeBetweenIncreasingAvoidanceAngle = 530164593,
        TimeBetweenInfluenceSphereChecks = 847783567,
        TimeBetweenInvalidateInvalidDispatchVehicles = 606050838,
        TimeBetweenLineOfSightChecks = 2789360544,
        TimeBetweenLookAts = 3284365585,
        TimeBetweenMarkDispatchVehiclesForDespawn = 2966580682,
        TimeBetweenPeeksWithoutLOS = 1685929346,
        TimeBetweenPlayerArrestAttempts = 1777999076,
        TimeBetweenPlayerEvents = 3786622949,
        TimeBetweenPointUpdates = 933911179,
        TimeBetweenReactionIdlesMax = 1213974814,
        TimeBetweenReactionIdlesMin = 1003164741,
        TimeBetweenRouteAdjustments = 368954988,
        TimeBetweenScenarioScans = 95380765,
        TimeBetweenSearchesForNextScenarioInChain = 2148143287,
        TimeBetweenSeekChecksAtTacticalPoint = 2565736146,
        TimeBetweenShotsAbsoluteMin = 4134391333,
        TimeBetweenShotsMax = 2449042043,
        TimeBetweenShotsMin = 965484170,
        TimeBetweenShoutTargetPosition = 3942172091,
        TimeBetweenSpawnAttempts = 3078950392,
        TimeBetweenSpawnAttemptsModifier = 296253880,
        TimeBetweenSwitchToClearTasks = 2109232134,
        TimeBetweenTestSpheresIntersectingRoute = 4076542446,
        TimeBetweenWaterHeightMapChecks = 1094365177,
        TimeBetweenWaterProbes = 3534467233,
        TimeEvadingForMaxValue = 3674050950,
        TimeForEyeIk = 420989827,
        TimeForRunAndGunOutroDelays = 1555086572,
        TimeForTakedownTargetAcquiry = 2979929207,
        TimeInSeconds = 704872957,
        TimeInWheelieToEnforceMinPitch = 2654954309,
        TimeMinBeforeLastPoint = 3697919373,
        TimeMinBeforeLastPointType = 3167164487,
        TimeOfDayRandomnessHours = 643049118,
        TimeOnGroundToDrive = 4081532692,
        TimeScale = 3983645896,
        TimeSinceLastSpottedToLeaveEngineOn = 3885866805,
        TimeSinceNotWantingToTrackStandToAllowStillTransition = 3469844948,
        TimeStillToTransitionToTrackStand = 3178576793,
        TimeToAllowCachedStickInputForMelee = 694461643,
        TimeToApplyPushFromVehicleForce = 2802719757,
        TimeToAvoidTargetAfterDamaged = 4228837765,
        TimeToCircle = 432972202,
        TimeToConsiderEnterInputValid = 195183113,
        TimeToCower = 2520530295,
        TimeToDelayChaseOnFoot = 259290858,
        TimeToFlapMax = 177240921,
        TimeToFlapMin = 2321281590,
        TimeToGiveUp = 2406795129,
        TimeToHoldFireAfterJack = 2874514021,
        TimeToLeaveMinBetweenAnybody = 2913322701,
        TimeToLeaveRandomAmount = 3638708710,
        TimeToLeaveRandomFraction = 3090913677,
        TimeToLive = 4175948694,
        TimeToLookAhead = 3717085729,
        TimeToLookAheadForCollision = 1222335592,
        TimeToLookBehind = 2632846246,
        TimeToSignalVehiclePursuitToCriminalMax = 3952273225,
        TimeToSignalVehiclePursuitToCriminalMin = 972295474,
        TimeToStare = 3623978511,
        TimeToStartCatchFall = 3622461286,
        TimeToStartCatchFallPlayer = 2616410929,
        TimeToThrowWeaponMS = 4154063324,
        TimeToThrowWeaponPlayerMS = 2820766976,
        TimeToUseUrgentTransitionsWhenThreatened = 2561996113,
        TimeToWait = 1118835093,
        TimeToWaitAtPosition = 3070881148,
        TimeUntilDeletionWhenHurrying = 4026550489,
        TimeUntilDeletionWhenStuckOffscreen = 731604244,
        TimeUntilRelease = 331709996,
        TimeWhenStuckToIgnoreBird = 2942205087,
        TimedMessages = 2683667002,
        Timers = 577434903,
        TimesliceMinDistToTarget = 2393149687,
        TimesliceTimeAfterAvoidanceMs = 47710483,
        ToPose = 1765007258,
        TopComponent = 883722394,
        TopSpread = 1191223326,
        TorqueMultiplier = 2183062202,
        TotalStickInput = 4050970672,
        TowardsDoorPushAngleDotTolerance = 3263047395,
        TrackStandLeftBikeClipId = 413582134,
        TrackStandLeftCharClipId = 1792476542,
        TrackStandRightBikeClipId = 688331024,
        TrackStandRightCharClipId = 697395711,
        TrackStandToStillLeftBikeClipId = 2145122814,
        TrackStandToStillLeftCharClipId = 1736721816,
        TrackStandToStillRightBikeClipId = 2112680596,
        TrackStandToStillRightCharClipId = 2306546493,
        TransitionReactionTime = 4282065899,
        Transitions = 2275723194,
        TranslationChangeRate = 86992154,
        TrespassGuardModelName = 560650271,
        TriggerAmbientReactionChances = 449694767,
        TripleHeadNearClip = 1634093344,
        TuckFreeWheelToTrackStandRightBikeClipId = 182997087,
        TuckFreeWheelToTrackStandRightCharClipId = 4218531778,
        TurbulenceSettings = 668098498,
        Turn180ActivationAngle = 956068907,
        Turn180ConsistentAngleTolerance = 997046562,
        TurnAcceleration = 660335017,
        TurnClipRate = 849148447,
        TurnEndAnimStateInfos = 2833513553,
        TurnEnterAnimStateInfos = 313911161,
        TurnFromRoll = 320841962,
        TurnFromStick = 914788843,
        TurnLeftFastClipId = 139557085,
        TurnLeftSlowClipId = 1974526496,
        TurnResetThresholdD = 3939547333,
        TurnRightFastClipId = 3609018768,
        TurnRightSlowClipId = 3624061968,
        TurnSpeedMBRThreshold = 545188344,
        TurnTime = 992439102,
        TurnToIdleTransitionDelay = 246989054,
        TurnTransitionDelay = 3543637314,
        TurnWalkStartAnimStateInfos = 2132068389,
        TurningEnergyLowerThreshold = 2301662345,
        TurningEnergyUpperThreshold = 3891776628,
        TurningRate = 2265632345,
        TurningTolerance = 3607448121,
        TwoHandedClipSetName = 646946550,
        UnarmedBonus = 1120630761,
        UnarmedInCoverTargetingDistance = 1369945566,
        UncertaintySettings = 71599683,
        UncuffDistance = 85726558,
        UnderCarMaxVelocity = 3776343247,
        UnderVehicle = 3262694177,
        UnderVehicleContinuousContactTime = 3606585778,
        UnderVehicleInitialDelay = 2055428725,
        UnderVehicleVelocityThreshold = 1061400063,
        Underwater = 3260924144,
        UnderwaterRelax = 1203310844,
        UpDownStickInputMin = 2758926922,
        UpDownStickInputSmoothingRate = 1495829016,
        UpHillMinPitchToStandUp = 221837246,
        UpStairsPelvisMaxDeltaZMoving = 2784569431,
        UpStairsPelvisMaxNegativeDeltaZMoving = 1210483821,
        UpdateOnVehicle = 2664008333,
        UpdateOnVehiclePlayer = 2214161412,
        UpdatesBeforeShiftingBounds = 2237139323,
        UpperArmImpulseCap = 3575120372,
        UpperArmNoTorsoHitImpulseCap = 3342224597,
        UpperBodyAimBlendInDuration = 1388147608,
        UpperBodyAimBlendOutDuration = 870279090,
        UpwardMoveSpeedScalingInAir = 2018965896,
        UpwardMoveSpeedScalingOnGround = 1487131765,
        Urgent = 638477469,
        UseAttachDuringAlign = 1827422982,
        UseAutoPeekAimFromCoverControls = 1366091002,
        UseBalanceForEdgeActivation = 1435456656,
        UseButtonToMoveAroundCorner = 92660424,
        UseByDefault = 3330866903,
        UseCameraOrientationForBackwardsDirection = 4080484940,
        UseCameraOrientationWeighting = 3262493116,
        UseCameraOrientationWhenStill = 2656290976,
        UseCapsuleTests = 3032938120,
        UseCombatEntryForAiJack = 2341452292,
        UseConstantIntroScaling = 1930123256,
        UseConstantOutroScaling = 28269420,
        UseDriveByAssistedAim = 2834495058,
        UseEnclosedSearchRegions = 759464384,
        UseExtraHeading = 1171907848,
        UseFineAimSpring = 1815260878,
        UseInitialLeanForcing = 1694816095,
        UseLastSeenPosition = 2888264108,
        UseLegIkOnBikes = 3852741535,
        UseLockOnTargetSwitching = 2942037123,
        UseMeleeHeadingOverride = 2400008353,
        UseMoverPositionWhilePeeking = 3860983555,
        UseMovingDirectionDiff = 26697373,
        UseNewSlowDownCode = 1214053169,
        UseNewStepAndWalkStarts = 4236998281,
        UseNewTurnWalkStarts = 2618193402,
        UseNewTurns = 2597341356,
        UseNonNormalisedScoringForPlayer = 1619169047,
        UseOrientationFromParachuteBone = 3610904814,
        UsePreEmptiveEdgeActivation = 2870540718,
        UsePreEmptiveEdgeActivationMp = 89764064,
        UseRagdollTargetIfNoAssistTarget = 2837888679,
        UseRelaxBehaviour = 2811070889,
        UseRemainingMinTimeForGroundWrithe = 3956869012,
        UseReticuleSlowDown = 3139641677,
        UseReticuleSlowDownForRunAndGun = 2667436072,
        UseReticuleSlowDownStrafeClamp = 1791816512,
        UseReturnOvershoot = 347971119,
        UseShortDistAngleRotation = 2589136465,
        UseSlowInOut = 2172495855,
        UseSprintButtonForCoverToCover = 3117448440,
        UseStickHistoryForCoverSearch = 3891560208,
        UseThreatWeighting = 1056793189,
        UseVerticalAxis = 2547715741,
        UserData1 = 647685198,
        UserData2 = 4202662936,
        VEHICLE_CAMERA_OFFSETS_FILE = 321643698,
        VFXCullRangeScaleNotVisible = 3493766854,
        VMCP_BOTTOM = 2770495034,
        VMCP_FRONT = 3001706694,
        VMCP_FRONT_LEFT = 1148399176,
        VMCP_FRONT_RIGHT = 2057559994,
        VMCP_LEFT = 1629770278,
        VMCP_REAR = 1556139353,
        VMCP_REAR_LEFT = 1830737308,
        VMCP_REAR_RIGHT = 457854237,
        VMCP_RIGHT = 2879151926,
        VMCP_TOP = 3193071790,
        VMT_DOOR_R = 514696742,
        VMT_HYDRAULICS = 3919652883,
        VMT_TURBO = 2334449168,
        VMT_TYRE_SMOKE = 3968559424,
        VMT_XENON_LIGHTS = 2656522436,
        ValidityProbes = 1879187973,
        ValueForMax = 1433159873,
        ValueForMaxDistanceFromOptimal = 502596100,
        ValueForMaxDistanceFromPed = 2889265507,
        ValueForMin = 2828335077,
        ValueForMinDistanceFromOptimal = 744506381,
        ValueForMinDistanceFromPed = 1140912184,
        ValueForTooCloseToTarget = 3390301810,
        ValueForUnableToFind = 1083242382,
        Vault = 224741676,
        VaultDepth = 428832696,
        VaultExtraZGroundTest = 3090504223,
        VaultFallTestAngle = 1723088470,
        VaultHorizClearance = 3626807160,
        VaultVertClearance = 1828436652,
        VehicleActivationForceMultiplierBicycle = 1598687789,
        VehicleActivationForceMultiplierBike = 2070345117,
        VehicleActivationForceMultiplierBoat = 1538253009,
        VehicleActivationForceMultiplierDefault = 1953114585,
        VehicleActivationForceMultiplierHeli = 2815969152,
        VehicleActivationForceMultiplierPlane = 2575088986,
        VehicleActivationForceMultiplierQuadBike = 1027107196,
        VehicleActivationForceMultiplierTrain = 1298279329,
        VehicleAttachPart = 1760348159,
        VehicleCentreZOffset = 3606813162,
        VehicleCollisionElasticityMult = 4203888010,
        VehicleCollisionFrictionMult = 1270097093,
        VehicleCollisionNormalPitchOverVehicle = 1698949999,
        VehicleCollisionNormalPitchUnderVehicle = 760529768,
        VehicleCustomSettingsList = 3282527658,
        VehicleEdgeProbeXOffset = 1461993132,
        VehicleEdgeProbeZOffset = 370845448,
        VehicleEntryExitPitchLevelSmoothRate = 135621085,
        VehicleFallingSpeedWeight = 3356594861,
        VehicleForwardInitialScale = 99981148,
        VehicleForwardScale = 399270735,
        VehicleJumpLookAtBlendRate = 3988230675,
        VehicleJumpLookAtTurnRate = 3786041740,
        VehicleMinSpeedForAiActivation = 999125689,
        VehicleMinSpeedForContinuousPushActivation = 1115174900,
        VehicleMinSpeedForPlayerActivation = 1493712076,
        VehicleMinSpeedForStationaryAiActivation = 2568028856,
        VehicleMinSpeedForStationaryPlayerActivation = 3804386946,
        VehicleMinSpeedForWarningActivation = 3383227946,
        VehicleOnTopOfVehicleCollisionSettings = 227846107,
        VehicleOverrides = 2892094444,
        VehicleSlowDown = 144280219,
        VehicleSpeedToAbortCloseDoor = 2994929358,
        VehicleTypes = 101865872,
        VehicleVelToImpactNormalMinDot = 670176362,
        VelMagStairsSpringMax = 1652778083,
        VelMagStairsSpringMin = 1875736055,
        VelStartCircling = 3146864305,
        VelStopCircling = 3555988495,
        VelocityDeltaThrownOut = 3562480846,
        VelocityDeltaThrownOutPlayerMP = 935626028,
        VelocityDeltaThrownOutPlayerSP = 1359095251,
        VelocityInheritance = 3529865731,
        VelocityMax = 3727574793,
        VelocityMin = 3439766974,
        VelocityThreshold = 3597443216,
        VelocityZThresholdForHighHighFall = 1373544668,
        VelocityZThresholdForSuperHighFall = 2767003073,
        VerifyCoverInterval = 3544497884,
        VerticalAcceleration = 335505697,
        VerticalFlightModeSettings = 2663165374,
        VerticalMoveSpeedScaling = 3594576614,
        VerticalMoveSpeedScalingAtMaxSpeed = 1880225385,
        VeryCloseIgnoreDesAndCamToleranceDist = 3378257781,
        VeryCloseIgnoreDesAndCamToleranceDistAimGun = 1824902254,
        VeryCloseToCoverDist = 3671850988,
        VeryCloseToCoverWeight = 3278990871,
        Vibration = 3143512563,
        ViewModeBlendEnvelopeRef = 1610750427,
        ViewModes = 2142445901,
        VisualReactionRange = 2272290579,
        WEATHER_DEPENDENT = 211193083,
        WaitForFootPlant = 3115377094,
        WaitTimeAfterFailedVehExit = 637992620,
        WaitTimeForJackingSlowedVehicle = 3405855740,
        WaitingOffsets = 2967055211,
        WalkAngAccel = 214999846,
        WalkStartAnimStateInfos = 3590260370,
        Walking = 3122448379,
        WalkingRoundPedModifier = 4057155416,
        WallHighTestZOffset = 2168664060,
        WallProbeDistance = 180206572,
        WallProbeRadius = 3138282762,
        WallTestEndXOffset = 1396197980,
        WallTestStartXOffset = 1813675586,
        WallTestYOffset = 1784425794,
        WanderInfluenceSphereRadius = 3384130276,
        WantedClean = 651905954,
        WantedLevel = 1092646882,
        WatchSayFightCheers = 1461520922,
        WatchSayShocked = 3973997152,
        WaterBobShakeRef = 572898954,
        WaterCannon = 3460531080,
        WaterEntryShakeSettings = 3250603115,
        WaterHeightSmoothRate = 3243646861,
        WaterProbeDepth = 519277350,
        WaterProbeOffset = 2825120069,
        Waveform = 579825085,
        WeaponAccuracyModifierForAimedAt = 2268167532,
        WeaponAccuracyModifierForEvasiveMovement = 409082717,
        WeaponAccuracyModifierForOffScreen = 3234043128,
        WeaponAnimsFPSIdle = 961290246,
        WeaponAnimsFPSLT = 3087874789,
        WeaponAnimsFPSRNG = 2940814298,
        WeaponAnimsFPSScope = 1227904788,
        WeaponBlockingLengthOffset = 68994958,
        WeaponBlockingOffsetInLeftCover = 1375297558,
        WeaponBlockingOffsetInRightCover = 2238616520,
        WeaponLongBlockingOffsetInLeftCover = 1090704787,
        WeaponSets = 1399921457,
        WeaponZoomFactorSpringConstant = 447200092,
        WeaponZoomFactorSpringDampingRatio = 3347315427,
        Wearing = 4006165571,
        Weight = 2283156278,
        WeightToBlockFromPursue = 46040720,
        WeightToPullAlongsideFromPursue = 3622347383,
        WeightToRamFromPursue = 355255193,
        WeightToSpinOutFromPursue = 1145877267,
        Weights = 3025359898,
        WheelieAccelerateControlThreshold = 908927858,
        WheelieApproachRate = 1223047739,
        WheelieDesiredLeanAngleTol = 830782336,
        WheelieMaxSpeedThreshold = 2115168466,
        WheelieShiftThreshold = 524252818,
        WheelieSitToStandBlendDuration = 1137589274,
        WheelieStickPullBackMinIntention = 2587752772,
        WheelieUpDownControlThreshold = 301666014,
        WideShot = 742934843,
        WideTargetAngularLimit = 1280045894,
        WitnessPersonality = 1504162135,
        Witnesses = 473322006,
        WorldPitchLimits = 759759236,
        X360_SCRIPT_RPF = 2882324974,
        Yaw = 2514469802,
        ZAccForHighImpact = 3275703461,
        ZAccForLowImpact = 2682740739,
        ZAccForMedImpact = 819470063,
        ZAccelerationToStartLeaning = 1346841624,
        ZThresholdForApproachOffset = 1712423423,
        ZeroRateOnDirectionChange = 3627404834,
        ZeroValue = 1611654117,
        Zoom = 2983410641,
        ZoomDuration = 2271271663,
        ZoomFactor = 447392537,
        ZoomMotionBlurMaxFovDelta = 3100931510,
        ZoomMotionBlurMaxStrengthForFov = 1238524664,
        ZoomMotionBlurMinFovDelta = 1054008152,
        aSlownessZone = 1652130128,
        activeAnimSet = 4032486415,
        angleToTargetDegreesToNotUseMinRadius = 2986015914,
        animPoseAttachDefault = 1043632907,
        animPoseAttachToVehicle = 3798182907,
        animPoseDefault = 1916209420,
        animPoseHandsCuffed = 2725274669,
        attributeList = 1107288906,
        attributes = 1956494238,
        avoidHeadingChangeSpeed = 1518108829,
        avoidHeadingJump = 3036720225,
        avoidLockDuration = 3551843612,
        avoidPitchChangeSpeed = 1623304217,
        avoidPitchJump = 1597259961,
        bAllowSmashDuringJump = 2841425601,
        bAllowUnderwaterExplosion = 2310120635,
        bApplyVehicleEMP = 178952880,
        bApplyVehicleSlick = 1236241772,
        bApplyVehicleSlowdown = 1509365439,
        bApplyVehicleTyrePop = 1334397542,
        bBlockJumpCollisionAgainstRagdollBlocked = 69785967,
        bBox = 1231029245,
        bCanSetPlayerOnFire = 3710755331,
        bChargeTargetEnabled = 3037590705,
        bControlledByPlayerSprintInput = 3904393624,
        bDebugRender = 1991353814,
        bDisable2HandedGetups = 1782949708,
        bDrawIdleHeadLookTarget = 2274869694,
        bEnableDebugDraw = 3665067262,
        bEnableGaitAdditive = 3236417550,
        bEnableJumpCollisions = 787384491,
        bEnableJumpCollisionsMp = 1816652759,
        bEnabled = 1409504843,
        bFaceAndBodyAreMerged = 2435794203,
        bForcePetrolTankDamage = 3983992955,
        bForceVehicleExplosion = 3312297335,
        bFoundFaceAnimation = 259776703,
        bHorizontalRighting = 2237132872,
        bIgnoreRatioCheckForFire = 2400251666,
        bOverrideFaceAnimation = 1741651815,
        bStatic = 2375647859,
        bThrowSmokeGrenadeEnabled = 2007829514,
        bTrafficLightPositioning = 956704533,
        bUseClipPoseHelper = 2006791804,
        bUseStayUpright = 2778976875,
        bValue = 208974921,
        bVerticalRighting = 1056777533,
        blurType = 2749488155,
        boatBowPtFxForwardMountedName = 2402780585,
        boatBowPtFxForwardMountedOffset = 1426207057,
        boatExitPtFxEnabled = 913361740,
        boatExitPtFxName = 276219657,
        boatExitPtFxRange = 3427519025,
        boatExitPtFxScale = 2913951911,
        boatExitPtFxSpeedEvoMax = 669705932,
        boatExitPtFxSpeedEvoMin = 501212370,
        bobble_hand = 785162942,
        bodyshell = 1970334199,
        boneSize = 60123590,
        break_extra_1 = 2190258525,
        break_extra_10 = 2734584581,
        break_extra_2 = 1950749904,
        break_extra_3 = 1709504522,
        break_extra_4 = 1480285367,
        break_extra_5 = 1213709552,
        break_extra_6 = 848662892,
        break_extra_7 = 3990325233,
        break_extra_8 = 367056899,
        break_extra_9 = 3413787451,
        cAnimCompressionFile = 2016919075,
        cAnimExportCtrlSpecFile = 2982365822,
        cExtraRoom = 2952522139,
        cFaceDir = 399683105,
        cFaceExportCtrlSpecFile = 3382327909,
        cHandle = 1251016415,
        cName = 1286194959,
        cRemoveBoneNameList = 1501402472,
        cSceneName = 3148363891,
        camCinematicPoliceCarMountedShotMetadata = 1537399056,
        camInterpolatorMetadata = 2380636687,
        camVehicleRocketSettings = 2211164655,
        cameraCutList = 2618346740,
        cascadeIndex = 311972855,
        chargeMultiplier = 510925374,
        colA = 4130410962,
        colB = 193412222,
        colG = 2816570672,
        colR = 960927728,
        colTint = 690075466,
        colorShift = 4254456164,
        concatDataList = 1452216515,
        continuousCharge = 463466415,
        curves = 1403691063,
        cutfAttributes = 2237184102,
        damageAtMid = 3010331635,
        damageMultiplier = 18336056,
        decalId = 2371851021,
        decalLength = 1229088392,
        decalLife = 96058849,
        decalWidth = 2398011309,
        defenseMultiplier = 2057680844,
        density = 3843932311,
        depletionMultiplier = 3653186651,
        depthMult = 1469744358,
        destroySuppressor = 1745227706,
        dirtBlue = 365907991,
        dirtGreen = 986658337,
        dirtRed = 3463006534,
        disableDrivebySeat = 161724223,
        disableDrivebySeatSecondary = 484538291,
        eImpactConeRagdollComponent = 100413071,
        eModKitType = 3865430600,
        entries = 934859523,
        exhaust_10 = 2600343066,
        exhaust_11 = 3598945568,
        exhaust_12 = 3896619164,
        exhaust_13 = 2989016171,
        exhaust_14 = 3320572913,
        exhaust_15 = 529211190,
        exhaust_16 = 823345734,
        exhaust_5 = 1666652977,
        exhaust_6 = 1972682668,
        exhaust_7 = 3204862618,
        exhaust_8 = 3503093287,
        exhaust_9 = 442599751,
        extra_10 = 2125833567,
        extra_11 = 2431830489,
        extra_12 = 2720558148,
        extra_13 = 903844796,
        extra_14 = 1202337617,
        extra_6 = 3145755371,
        extra_7 = 2360446286,
        extra_8 = 2661527858,
        extra_9 = 1913477126,
        fAIGreetingDistanceMax = 2521394702,
        fAIGreetingDistanceMin = 2740963979,
        fAIGreetingPedModifier = 383049694,
        fAbsoluteMinDistanceToTarget = 3835533225,
        fAccuracyReductionFloor = 552287921,
        fAccuracyReductionPerEnemy = 887750836,
        fAimToIdleAngleLimitLeft = 867760403,
        fAimToIdleAngleLimitRight = 3299346053,
        fAimToIdleBreakOutAngle = 2204270248,
        fAmbientAnimsMaxDistToTargetSq = 2501949685,
        fAmbientAnimsMinDistToTargetSq = 2971689701,
        fAnimalImpulseMultMax = 3454936156,
        fAnimalImpulseMultMin = 3492529421,
        fAnimalMassMult = 3679879803,
        fArgumentProbability = 2595564437,
        fBaseAlpha = 3124083955,
        fBlockedLosAimTime = 547548618,
        fBlockedLosWeighting = 1239531869,
        fBulletReactionPosAdjustmentZ = 2724641994,
        fCancelTargetInCoverMovedDist = 2002565392,
        fCancelTargetOutOfCoverMovedDist = 2120328830,
        fCargoFuel = 304399001,
        fChanceOfArgumentChallenge = 784723777,
        fChanceOfArgumentChallengeBeingAccepted = 2295557741,
        fChanceOfConversationRant = 1878691053,
        fChanceOfDynamicRun = 7313110,
        fChargeGoalBehindCoverCentralOffset = 1417010304,
        fChargeGoalCompletionRadius = 3325627586,
        fChargeGoalLateralOffset = 1507206306,
        fChargeGoalMaxAdjustRadius = 1141048876,
        fChargeGoalRearOffset = 2183058530,
        fConeAngle = 1743670592,
        fConversationSoundReductionAmount = 3201590411,
        fConversationSoundReductionDistance = 1212129799,
        fCoronaIntensity = 1078847881,
        fCoronaSize = 1810161173,
        fCoronaZBias = 1698708840,
        fCounterImpulseRatio = 3072803950,
        fCounterImpulseScale = 2189152686,
        fCoverPointScoreMultiplier = 1893361518,
        fDecideToRunChance = 1248305822,
        fDefaultDescendRate = 1487680899,
        fDefaultRopeLength = 1491518630,
        fDirectionTestProbeLength = 2195773039,
        fDirtLevel = 3834082948,
        fDisplayZ = 806477731,
        fDistSearch = 2679850916,
        fDistToHidingTarget_Inner = 1373272095,
        fDistToHidingTarget_Outer = 1408109790,
        fDistToPickNewPoint = 3620765866,
        fDistanceBetweenInfluenceSpheres = 2500728149,
        fDoInjuredOnGroundChance = 3434153865,
        fDotMinThrowerToTarget = 1053509475,
        fDurationStage1 = 3898851432,
        fDurationStage2 = 498117381,
        fEndStrength = 649526198,
        fExistingTargetScoreWeight = 1679672363,
        fExitDescendRate = 2768160631,
        fExtraRopeLength = 2199025334,
        fFadeInCutsceneDuration = 969234229,
        fFadeInGameDuration = 3025199107,
        fFadeOutCutsceneDuration = 953346839,
        fFadeOutGameDuration = 473400434,
        fFallOff = 391886097,
        fFallingSpeedForHighFall = 906382083,
        fFallingSpeedThreshold = 715813748,
        fFarDrawDistance = 3688268720,
        fFastCarPushImpulseMult = 2370876339,
        fFinisherShotgunBonusArmedSpeedModifier = 1950052429,
        fFireContinuouslyDistMax = 884701582,
        fFireContinuouslyDistMin = 3652101978,
        fFireWeaponStrengthForceMultiplier = 336969407,
        fFleeProjectRange = 1574250361,
        fFleeRange = 3546053113,
        fFlinchTargetZOffset = 1502498286,
        fFlinchTargetZOffsetOnGround = 3223569917,
        fForceLeanInDirectionAmountMax = 615835079,
        fForceLeanInDirectionAmountMin = 481812193,
        fForceRampMaxSpeed = 2515092116,
        fForceRampMinSpeed = 3439085926,
        fForceStrafeDistance = 679941746,
        fGlassBreakRadius = 3567409373,
        fGlassDamage = 2130522201,
        fGoToDefAreaTimeOut = 2145163833,
        fHeadLookHeadingRandomizationRange = 1337934970,
        fHeadLookPitchRandomizationRange = 1747662930,
        fHeadLookZOffset = 3439106982,
        fHeadLookZOffsetOnGround = 3990998153,
        fHeadingRandomizationRange = 1290250752,
        fHeight = 4242690206,
        fHorizontalRightingStrength = 3772786175,
        fHorizontalRightingTime = 3419496233,
        fImpactConeAngleBack = 3437539423,
        fImpactConeAngleFront = 2987127575,
        fImpulseMultLimbs = 2222583561,
        fImpulseMultSpine = 2449600555,
        fImpulseRecoveryPerSecond = 3098879897,
        fImpulseReductionPerShot = 702174865,
        fImpulseReductionScaleMax = 1706111854,
        fIndent = 3956347885,
        fInfluenceSphereCheckRouteRadius = 2889725249,
        fInfluenceSphereInnerWeight = 3016470091,
        fInfluenceSphereOuterWeight = 983725397,
        fInfluenceSphereRequestRadius = 3585286231,
        fInitialDelay = 79279568,
        fInitialHitImpulseMult = 664247322,
        fInitialSearchRadius = 2790363538,
        fInjuredGetupImpulseMag2 = 461478411,
        fInputMax = 541735427,
        fIntensity = 3937240636,
        fJumpDescendRate = 564993371,
        fJumpToSmashWindowPhaseChange = 3670878450,
        fLifeTime = 2257773206,
        fLongJumpDescendRate = 1357105096,
        fLostTargetTime = 593698055,
        fMaxAboveHeadForOverheadReactions = 2841960409,
        fMaxAllyDistance = 1305363589,
        fMaxAngleBetweenTargets = 1848729150,
        fMaxAngleOffset = 3595841120,
        fMaxArmAmplitude = 3679690700,
        fMaxArmPeriod = 2396268986,
        fMaxArmStiffness = 3395352877,
        fMaxAttemptMoveToCoverDelay = 1947279181,
        fMaxAttemptMoveToCoverDelayGlobal = 3581780763,
        fMaxBuoyancy = 2562294840,
        fMaxDistForOverheadReactions = 1522624465,
        fMaxDistanceFromCorner = 1719840119,
        fMaxDistanceToTarget = 624502137,
        fMaxDstanceToMoveAwayFromAlly = 3914650526,
        fMaxDynamicStrafeDistance = 1721763990,
        fMaxHeliSpeedForRappel = 210693397,
        fMaxImpulseModifier = 628688906,
        fMaxJumpPhaseAllowDescend = 3096283176,
        fMaxJumpPhaseAllowSmashWindow = 1851998260,
        fMaxLeavingCornerDistance = 2930793396,
        fMaxRandomAdditionalOffset = 3574291632,
        fMaxRouteDistanceModifier = 685847089,
        fMaxSecondsDelayBetweenChatLines = 1048379145,
        fMaxSecondsDelayBetweenPhoneLines = 3637331931,
        fMaxStroke = 2122555922,
        fMaxTargetDistToUpdateFlinch = 3171415609,
        fMaxTargetDistToUpdateFlinchOnGround = 2588071080,
        fMaxTimeBeforeReactToExplosion = 1679184192,
        fMaxTimeBetweenBulletReactions = 433744442,
        fMaxTimeBetweenFrustratedPeds = 2786807653,
        fMaxTimeBetweenLookAt = 3890597462,
        fMaxTimeStrafing = 630125920,
        fMaxTimeToWait = 328649625,
        fMaxWaitForCoverExitTime = 1074424476,
        fMaxWaitSeconds = 1143137996,
        fMidStrength = 494142166,
        fMinAlliesForMaxAngleOffset = 1154727971,
        fMinArmAmplitude = 1774619724,
        fMinArmPeriod = 2926397774,
        fMinArmStiffness = 966292507,
        fMinAttemptMoveToCoverDelay = 449264633,
        fMinAttemptMoveToCoverDelayGlobal = 1975275563,
        fMinBuoyancy = 3789430640,
        fMinDistBetweenTargetAndOtherEnemies = 3248381180,
        fMinDistToNonTargetEnemy = 3283971281,
        fMinDistanceBetweenPeds = 398266299,
        fMinDistanceForAltCover = 1192276059,
        fMinDistanceFromPrimaryTarget = 2423717597,
        fMinDistanceSavingToUseVehicle = 3352862788,
        fMinDistanceSquaredToPlayerForAudio = 4242148097,
        fMinDistanceToBeConsideredSameEvent = 4233735310,
        fMinDistanceToBreakWindow = 1608634776,
        fMinDistanceToClearCorner = 2829098503,
        fMinDistanceToTarget = 2783817407,
        fMinDistanceToUseVehicle = 3455250403,
        fMinFinisherShotgunTotalImpulseBraced = 1412443494,
        fMinFinisherShotgunTotalImpulseNormal = 1471062121,
        fMinForwardVectorToFlinch = 729908938,
        fMinForwardVectorToFlinchOnGround = 3628130093,
        fMinHeadingDeltaToFixTurn = 1358716283,
        fMinHeadingDeltaToIdleTurn = 890221191,
        fMinHeightToRappel = 2869375884,
        fMinHoldThrowPitch = 1407383707,
        fMinImpulseModifier = 4043035065,
        fMinJumpPhaseAllowDescend = 2330528087,
        fMinJumpPhaseAllowSmashWindow = 425134671,
        fMinListenerRangeToDrawSonarBlips = 2604348013,
        fMinLoiteringTimeSeconds = 2196178671,
        fMinOtherPedDistanceDiff = 2587275512,
        fMinRiverFlowForRapids = 978248567,
        fMinRiverGroundClearanceForRapids = 2761683393,
        fMinSecondsDelayBetweenChatLines = 3930402274,
        fMinSecondsDelayBetweenPhoneLines = 2156082331,
        fMinSmashWindowPhase = 2105176291,
        fMinSpeedForPush = 1105441606,
        fMinStickValueAllowDescend = 4109388444,
        fMinStroke = 1198151288,
        fMinTimeAfterAimPoseForStateChange = 3273513642,
        fMinTimeBeforeReactToExplosion = 4258831091,
        fMinTimeBetweenBulletReactions = 1300484749,
        fMinTimeBetweenFrustratedPeds = 919558869,
        fMinTimeBetweenLookAt = 2167660448,
        fMinTimeBetweenRunDirectlyChecks = 3866357326,
        fMinTimeInCombatSeconds = 197521501,
        fMinTimeInGetUpToAllowCover = 266220607,
        fMinTimeInState = 1959218646,
        fMinTimeRunning = 1041070680,
        fMinTimeStandingAtCover = 4116440083,
        fMinTimeToWait = 1415555709,
        fMoveBlendRatioLerpTime = 599255143,
        fMuscleAngleStrengthRampDownRate = 3498784443,
        fMuscleSpeedStrengthRampDownRate = 3163227947,
        fNearDrawDistance = 1690336060,
        fNewPositionThreshold = 445998819,
        fOffset = 1293919506,
        fParachutingZoom = 105068200,
        fPitch = 632986329,
        fPlayerBeingTargetedExtraDistance = 3975640219,
        fPlayerDirectThreatDistance = 4134350078,
        fPlayerHighThreatWeighting = 2927479807,
        fPlayerMoveDistToResetChargeGoals = 1014164585,
        fPlayerMoveDistToResetLoiterPosition = 2426887593,
        fPlayerObstructionCheckRadius = 2115554015,
        fPlayerObstructionRadius = 2354781986,
        fPlayerThreatDistance = 1772648844,
        fPow = 2680890523,
        fPreferInjuredGetupPlayerHealthThreshold = 1193017389,
        fProbeLength = 586057169,
        fPronePedKickImpulse = 2891493908,
        fRadioSoundReductionAmount = 1747790072,
        fRadioSoundReductionDistance = 1838053251,
        fRadius = 315509558,
        fRagdollComponentBuoyancy = 2460325000,
        fRagdollScore = 4246262885,
        fRainSnowSoundReductionAmount = 801070127,
        fResultMax = 2372087104,
        fRetreatTime = 2224359067,
        fRoll = 2689106272,
        fRopeUnwindRate = 2890096206,
        fRotation = 2963173633,
        fSearchRangeMax = 3314827784,
        fSearchScaler = 2543804780,
        fSecondsInAirBeforePassengerComment = 156254164,
        fSecondsInRainTransitionPeriod = 3510850224,
        fSectionByTimeSliceDuration = 3421999474,
        fShadowBlur = 1632842349,
        fShotBlindFireProbability = 2977969682,
        fShotHeadAngleToFireGun = 3872529888,
        fShotWeaponAngleToFireGun = 3753244842,
        fShoutBlockingLosInterval = 1257619633,
        fShoutTargetPositionInterval = 2226395755,
        fSmallInfluenceSphereRadius = 304969557,
        fSoundRange_BarelyAudible = 347298932,
        fSoundRange_CarHighSpeed = 29182579,
        fSoundRange_CarHorn = 2428401420,
        fSoundRange_CarLowSpeed = 871660954,
        fSoundRange_ClearlyAudible = 2698396339,
        fSoundRange_Explosion = 1114733078,
        fSoundRange_FootstepBase = 3197086918,
        fSoundRange_FootstepFoliage = 1197726055,
        fSoundRange_GlassBreak = 1070205007,
        fSoundRange_Gunshot = 4073295642,
        fSoundRange_HeavyFootstep = 1578589400,
        fSoundRange_LandFromFall = 3329995088,
        fSoundRange_Megaphone = 121379805,
        fSoundRange_MostlyAudible = 1166640595,
        fSoundRange_ObjectCollision = 819051225,
        fSoundRange_Shouting = 2190165672,
        fSoundRange_SilencedGunshot = 3759114450,
        fSoundRange_Talking = 496127271,
        fSoundRange_WaterSplashLarge = 807986206,
        fSoundRange_WaterSplashSmall = 1532863616,
        fSoundRange_WeaponSpinUp = 3813597325,
        fSoundRange_Whisper = 1593818711,
        fSpecialAbilityRageKickImpulseModifier = 913654553,
        fStaminaDepletionBlinkPercentage = 420083265,
        fStartAimingDistance = 2899412417,
        fStartDescendingDistToTargetSq = 2804961359,
        fStartStrength = 2901808706,
        fStayUprightForceIdle = 604632997,
        fStayUprightForceMoving = 603776431,
        fStayUprightForceNonVelocityBased = 230707381,
        fStopAimingDistance = 1894206862,
        fSubtitleDuration = 1836544003,
        fTargetScenarioRadius = 1578763478,
        fTargetThreatOverride = 925392687,
        fTargetTooCloseDistance = 970868308,
        fTargetableDistance = 1046040592,
        fTargetingInactiveDisableTime = 3550430565,
        fTempInitialStiffnessWhenShot = 3121676006,
        fTime = 1591208228,
        fTimeBetweenAllyProximityChecks = 1201850831,
        fTimeBetweenAltCoverSearches = 1187764077,
        fTimeBetweenCombatDirectorUpdates = 687676716,
        fTimeBetweenCoverSearchesMax = 379663563,
        fTimeBetweenCoverSearchesMin = 4141996221,
        fTimeBetweenDragsMin = 697272720,
        fTimeBetweenFailedGestureMax = 1249935741,
        fTimeBetweenFailedGestureMin = 562041905,
        fTimeBetweenGestureAnimsMax = 853543838,
        fTimeBetweenGestureAnimsMin = 1148925964,
        fTimeBetweenGesturesMaxGlobal = 1473938462,
        fTimeBetweenGesturesMinGlobal = 3136547752,
        fTimeBetweenJackingAttempts = 2673669317,
        fTimeBetweenPassiveAnimsMax = 2278473263,
        fTimeBetweenPassiveAnimsMin = 3683572550,
        fTimeBetweenQuickGlancesMax = 3389707560,
        fTimeBetweenQuickGlancesMin = 2756383457,
        fTimeBetweenRouteSearches = 1932437978,
        fTimeBetweenSecondaryTargetUsesMax = 3340527808,
        fTimeBetweenSecondaryTargetUsesMin = 610577934,
        fTimeBetweenUpdates = 4202105817,
        fTimeSinceLastAimedAtForGesture = 2237966956,
        fTimeToIgnoreBlockedLosWeighting = 3653083064,
        fTimeToPickNewPoint = 330577879,
        fTimeToStandAtPerimeter = 2009665019,
        fTimeToUseSecondaryTargetMax = 3128077167,
        fTimeToUseSecondaryTargetMin = 3243108638,
        fTotalDuration = 1185457940,
        fTransitionInDuration = 2279341021,
        fTransitionOutDuration = 1271134520,
        fValue = 198751340,
        fVehicleOffset = 285457106,
        fVehicleTilt = 382138818,
        fVerticalRightingStrength = 3868696870,
        fVerticalRightingTime = 1372422790,
        fVolumeIntensity = 3963210786,
        fWidth = 658992148,
        fWorldH = 2995953429,
        fWorldW = 3885599006,
        fWorldX = 4115899538,
        fWorldY = 70992481,
        faceAnimationNodeName = 555167272,
        faceAttributesFilename = 3123042911,
        fadeCurveType = 2259012140,
        fadeInColor = 1910831709,
        fadeInTime = 3161810789,
        fadeOutColor = 2234426246,
        fadeOutTime = 2157942304,
        fblade_1fast = 1032498025,
        fblade_1mod = 1157497495,
        fblade_2fast = 930609265,
        fblade_2mod = 2573434709,
        fblade_3fast = 411536741,
        fblade_3mod = 879315983,
        forceFall = 569763335,
        forks_l = 991413023,
        forks_u = 837923007,
        frames = 580974885,
        futureHeightmapSampleTime = 892450737,
        futureSampleTime = 2996388896,
        fwClipSetWithGetup = 4285341798,
        fwDirectedClipItemWithProps = 3883314999,
        gpuPtFxEnabled = 4158673537,
        halfSigmoidConstant = 3368438810,
        handlebars = 2921986035,
        hdrMult = 271126249,
        iBulletEventResponseLengthMs = 2255380962,
        iComponent = 505193016,
        iCutsceneFlags = 2110267871,
        iDrawable = 2231657823,
        iEventArgsIndex = 4289498236,
        iEventId = 3149172832,
        iHeadLookRandomizationTimeMin = 1333092266,
        iHeadingRandomizationTimeMax = 72944862,
        iHeadingRandomizationTimeMin = 15793390,
        iHeadlookRandomizationTimeMax = 3088121500,
        iHealthDepletionBlinkPercentage = 4066516916,
        iLanguageID = 1537748314,
        iLightProperty = 2477126074,
        iLightType = 1233248098,
        iLivery = 756943177,
        iLivery2 = 2453634574,
        iMainBodyColour = 4067992989,
        iMaxLookAtTime = 2834021629,
        iMaxNumInjuredOnGroundAgents = 2495781827,
        iMaxPedsAtTrafficLights = 3623500230,
        iMaxPedsInCombatTask = 269064650,
        iMaxRandomExplosionTime = 3153397162,
        iMaxTime = 2235294119,
        iMaxTimeBeforeSearchingForNewHidingPlace = 3217586928,
        iMinLookAtTime = 1571509424,
        iMinNumEnemiesForScaling = 2189340328,
        iMinTime = 4168588760,
        iMinTimeBeforeSearchingForNewHidingPlace = 3618288355,
        iObjectId = 1657245540,
        iObjectIdList = 1236477325,
        iOverlayType = 211975133,
        iPlayerDirectThreatTimeMs = 653564341,
        iRandomDurationMax = 2620945991,
        iRandomDurationMin = 18835671,
        iRangeEnd = 398786672,
        iRangeStart = 1047819622,
        iRunningTimeForVelocityBasedStayupright = 971008663,
        iShotMaxBlindFireTimeH = 4263173023,
        iShotMaxBlindFireTimeL = 3609300401,
        iShotMaxTimeBeforeGunThreaten = 3639036861,
        iShotMaxTimeBetweenFireGun = 655022274,
        iShotMinTimeBeforeGunThreaten = 3985239087,
        iShotMinTimeBetweenFireGun = 3419541350,
        iSpecularColour = 1609620374,
        iTargetNotSeenIgnoreTimeMs = 3270779927,
        iTexture = 467155910,
        iTimeToStandAtSearchPoint = 1751162602,
        iTransitionIn = 2643240271,
        iTransitionOut = 2810110094,
        iVectorDefault = 178027873,
        indicator_lr = 3979005071,
        indicator_rr = 112742354,
        initialUnlockedCap = 1709960891,
        interiorHash = 595627342,
        interpTime = 3980674446,
        isUnderwater = 2320897552,
        largeCharge = 1846583548,
        lawResponseTime = 218173601,
        lawResponseType = 1915622273,
        layers = 197915343,
        leanKd = 664693842,
        leanKi = 814841404,
        leanKp = 2222663190,
        lightingType = 2671568709,
        limbId = 970730558,
        lookAtVelProbIfNoBumpTarget = 1708224645,
        maxCruiseSpeed = 3454970252,
        maxDesiredAnglePitchDegrees = 1673702936,
        maxDesiredAngleRollDegrees = 1731534963,
        maxDesiredAngleYawDegrees = 3035684229,
        maxDistanceAfterAimingToApplyAlternateScalingMax = 2968415887,
        maxHangoutChatDistSq = 1876536698,
        maxMinDistanceForRollComputation = 2791696823,
        maxPitch = 2569057742,
        maxPitchRoll = 139171723,
        maxRoll = 682642275,
        maxSecondsNearPlayerUntilHangoutQuit = 2302651663,
        maxThrottle = 2384591971,
        maxYaw = 4244700983,
        mediumCharge = 3545223222,
        midRadius = 3099411482,
        minMinDistanceForRollComputation = 502368761,
        minSecondsNearPlayerUntilHangoutQuit = 232011649,
        misc_1 = 2690009945,
        misc_2 = 1385115596,
        mod_a = 3654959273,
        mod_aa = 3843353624,
        mod_ab = 3135215534,
        mod_ac = 3364434689,
        mod_ad = 2723112578,
        mod_ae = 2970026993,
        mod_af = 2245832093,
        mod_ag = 2492156666,
        mod_ah = 1765012564,
        mod_ai = 2014155263,
        mod_aj = 1286290243,
        mod_ak = 1535367412,
        mod_b = 808381781,
        mod_c = 4268165574,
        mod_col_10 = 3033709986,
        mod_col_11 = 2249285664,
        mod_col_12 = 1498318491,
        mod_col_13 = 1787603223,
        mod_col_14 = 1573326728,
        mod_col_15 = 1862676998,
        mod_col_16 = 1044598917,
        mod_col_6 = 1547719720,
        mod_col_7 = 580018373,
        mod_col_8 = 4191162177,
        mod_col_9 = 3257212908,
        mod_d = 3579951032,
        mod_e = 2733953759,
        mod_f = 4123490435,
        mod_g = 3342441320,
        mod_h = 1726175929,
        mod_i = 1947366679,
        mod_j = 2065498928,
        mod_k = 2572238744,
        mod_l = 730555402,
        mod_m = 4194074861,
        mod_n = 1343696161,
        mod_o = 506677594,
        mod_p = 4167728581,
        mod_q = 3326122354,
        mod_r = 217851628,
        mod_s = 3666821647,
        mod_t = 2168885119,
        mod_u = 2399611648,
        mod_v = 3519328378,
        mod_w = 2958716326,
        mod_x = 3292501248,
        mod_y = 2651277456,
        mod_z = 3888995355,
        models = 4042130640,
        neon_b = 728001778,
        neon_f = 3850133799,
        neon_l = 4084563217,
        neon_r = 556062831,
        nonFlyableAreas = 3958481819,
        numFutureSamples = 54155191,
        numHeightmapFutureSamples = 1335540990,
        outFxName = 3344142251,
        overrideFaceAnimationFilename = 2464163899,
        pCutsceneEventArgsList = 101111438,
        pCutsceneEventList = 873743947,
        pCutsceneLoadEventList = 1537015366,
        pCutsceneObjects = 1337787258,
        pExtraBoneIds = 814194086,
        parameterIntensity = 3579895798,
        patchFile = 246845325,
        pedGroups = 3299118270,
        pitchKd = 1584865556,
        pitchKi = 665138033,
        pitchKp = 2427028852,
        playerNearToHangoutDistanceInMetersSquared = 724033442,
        ptFxDepthEvoMax = 3186421174,
        ptFxDepthEvoMin = 1171785422,
        rage__cutfAnimatedLightObject = 425672361,
        rage__cutfAnimatedParticleEffectObject = 3750235532,
        rage__cutfAnimationManagerObject = 162924556,
        rage__cutfAssetManagerObject = 68930034,
        rage__cutfAudioObject = 204478241,
        rage__cutfBlockingBoundsObject = 1024212505,
        rage__cutfBoolValueEventArgs = 2483426166,
        rage__cutfCameraCutCharacterLightParams = 2335868993,
        rage__cutfCameraCutEventArgs = 1032739425,
        rage__cutfCameraCutTimeOfDayDofModifier = 1378659296,
        rage__cutfCameraObject = 2665839426,
        rage__cutfCascadeShadowEventArgs = 852034231,
        rage__cutfCutsceneFile2 = 3527760993,
        rage__cutfCutsceneFile2__SConcatData = 1737539928,
        rage__cutfDecalEventArgs = 3570809234,
        rage__cutfDecalObject = 576081308,
        rage__cutfEvent = 2587541103,
        rage__cutfEventArgs = 534106966,
        rage__cutfFinalNameEventArgs = 80958073,
        rage__cutfFixupModelObject = 989168939,
        rage__cutfFloatValueEventArgs = 1609567909,
        rage__cutfHiddenModelObject = 979016746,
        rage__cutfLightObject = 1781777258,
        rage__cutfLoadSceneEventArgs = 3528166281,
        rage__cutfNameEventArgs = 1160694198,
        rage__cutfObjectIdEvent = 3787091478,
        rage__cutfObjectIdEventArgs = 3132728576,
        rage__cutfObjectIdListEventArgs = 1377451264,
        rage__cutfObjectIdNameEventArgs = 4198689239,
        rage__cutfObjectVariationEventArgs = 2095750852,
        rage__cutfOverlayObject = 2083739024,
        rage__cutfParticleEffectObject = 1696721139,
        rage__cutfPedModelObject = 462317467,
        rage__cutfPlayParticleEffectEventArgs = 222809975,
        rage__cutfPropModelObject = 2296489151,
        rage__cutfRayfireObject = 578480161,
        rage__cutfScreenFadeEventArgs = 303942334,
        rage__cutfScreenFadeObject = 2841702621,
        rage__cutfSubtitleEventArgs = 3215026609,
        rage__cutfSubtitleObject = 307438872,
        rage__cutfTriggerLightEffectEventArgs = 3654996547,
        rage__cutfVehicleExtraEventArgs = 4113944278,
        rage__cutfVehicleModelObject = 2042362651,
        rage__cutfVehicleVariationEventArgs = 918254035,
        rage__cutfWeaponModelObject = 3028272477,
        rage__parAttributeList = 1334016442,
        rblade_1fast = 451472348,
        rblade_1mod = 4141162370,
        rblade_2fast = 3599310922,
        rblade_2mod = 1768767594,
        rblade_3fast = 3929521030,
        rblade_3mod = 1496111458,
        rollKd = 2739053876,
        rollKi = 1158342846,
        rollKp = 3696891742,
        sampleSize = 1245538595,
        scoop_1mod = 2292220415,
        scoop_2mod = 2166816405,
        scoop_3mod = 2486991428,
        sectionSplitList = 4212477189,
        sigmoidConstant = 3286738338,
        sizeEvo = 1814735825,
        slowDistance = 2171885531,
        smallCharge = 2475436365,
        sortIndex = 2685533834,
        specialAbilities = 1644716366,
        speedMult = 1478381657,
        spike_1mod = 2796607005,
        spike_2mod = 3978311755,
        spike_3mod = 4063416457,
        strRequestRecording = 1353902600,
        streakDirection = 2002769312,
        streamedMusc = 4241737797,
        swingarm = 3929033220,
        tacticalXml = 2014698042,
        taillight_l = 3008822349,
        taillight_r = 914195096,
        throttleKd = 528950431,
        throttleKi = 974150069,
        throttleKp = 2573768812,
        timeAfterAimingToApplyAlternateScalingMax = 4000301303,
        timeAfterAimingToApplyAlternateScalingMin = 1097326038,
        timeAfterAimingToApplyDistanceBlend = 2278684726,
        timeToCatchfallMS = 382034967,
        timeWarpScale = 448101701,
        turret_a1 = 3992710274,
        turret_a2 = 1077448950,
        turret_a3 = 1382757723,
        turret_a4 = 614062521,
        turret_b1 = 3783807571,
        turret_b2 = 2839830988,
        turret_b3 = 3138651499,
        turret_b4 = 2400824695,
        typeFile = 2221257278,
        uAITimeBetweenGreeting = 4188496022,
        uAimToIdleLookAtTime = 1015010494,
        uCheckForChargeTargetPeriodMS = 1748071312,
        uCheckForSmokeThrowPeriodMS = 1637328324,
        uConsiderRecentChargeAsActiveTimeoutMS = 698042866,
        uConsiderRecentThrowAsActiveTimeoutMS = 865965443,
        uDistanceCheckPeriodMS = 2454614730,
        uMaxNumActiveChargers = 1678873512,
        uMaxNumActiveThrowers = 2870486361,
        uMaxTimeInMSToPlayRingTone = 3917563062,
        uMinTimeBetweenChargesAtSameTargetMS = 2705750728,
        uMinTimeBetweenThrowsAtSameTargetMS = 4240191943,
        uMinTimeForSamePedToChargeAgainMS = 921957248,
        uMinTimeForSamePedToThrowAgainMS = 2208519322,
        uNumPedsToTransitionToRainPerPeriod = 3616711897,
        uRepeatedAttemptsBeforeTeleportToLeader = 3188916891,
        uTicksUntilHangoutConversationCheck = 1226852111,
        uTimeBetweenLookBacks = 891569975,
        uTimeInMSUntilNewWeirdPedComment = 1037671842,
        uTimeToLookBack = 3027972140,
        uTimeToWaitAfterNewSayFailureInSeconds = 1968341934,
        vColour = 3313809689,
        vCorners = 2013990738,
        vDirection = 3788713491,
        vExtraRoomPos = 1493683017,
        vHaltFrequency = 220202594,
        vOffset = 281069076,
        vPosition = 1835178760,
        vRotation = 330442780,
        vRotationQuaternion = 1522820057,
        vScale = 1805863696,
        vScroll = 2514516235,
        vStartPosition = 2268451071,
        vTriggerOffset = 1263529604,
        vehGroups = 3356170168,
        vfxGroup = 222345803,
        weaponSlotSecondary = 2656206330,
        whiskerForwardSpeedScale = 3367104276,
        whiskerForwardTestDistance = 4280868953,
        whiskerLateralTestDistance = 369724672,
        whiskerTestAngle = 1412479638,
        whiskerVerticalTestDistance = 2043681017,
        widthRatio = 2261099445,
        wildlifeHabitats = 2772741337,
        windDebrisPtFxEnabled = 3909318761,
        windDebrisPtFxName = 1353578052,
        window_lm = 2675373130,
        window_lr = 2639884295,
        window_rm = 3523659197,
        window_rr = 2355575415,
        yawKd = 3266080932,
        yawKi = 1366920760,
        yawKp = 922081581,


        Velocity2 = 2944635386,


















        //from rubidium / dav90 PSO XML / zonebind
        mpName = 2031203854,
        zoneName = 257000,
        vfxRegion = 3384955624,
        vehDirtMin = 1831590592,
        vehDirtMax = 625824556,
        vehDirtGrowScale = 2919812941,
        pedDirtMin = 1861946207,
        pedDirtMax = 3150688023,



        //dilapidated list - from dav90 hash collider
        ActivateVehicleSiren = 3401359988,
        AerialVehiclePoint = 1653545417,
        MoveFollowMaster = 3724117664,
        AggressiveVehicleDriving = 2626064871,
        UseSearchlight = 1524211135,
        IgnoreWeatherRestrictions = 176469077,









        //from 0x1F9F1 - from companion app - thanks!!
        AbsoluteIntensityEnabled = 2168731396,
        AllowAnimatedDeadFall = 2283074537,
        AnimStreamingBase = 1324611103,
        AnimatedDeadFallSet = 1451470102,
        AttachedParentName = 734609027,
        CDataFileMgr__ChangeSetData = 666520515,
        CDataFileMgr__DataFileArray = 3044571784,
        CDataFileMgr__ResourceReference = 4089109759,
        CScenarioPointFlags__Flags = 700327466,
        DeadBlendOutSet = 4254591792,
        DirectionalLightMultiplier = 4246749927,
        DisableDirectionalLighting = 22229384,
        DisableHighQualityDof = 4064056507,
        FreezeReflectionMap = 2666061934,
        GenericWeaponType = 4160620743,
        GetupSet = 1940051574,
        LensArtefactMultiplier = 1253384283,
        LightFadeDistanceMult = 3267149471,
        LightShadowFadeDistanceMult = 3063864558,
        LightSpecularFadeDistMult = 71148997,
        LightVolumetricFadeDistanceMult = 2331545500,
        LodMultHD = 2245753507,
        LodMultLod = 129942887,
        LodMultOrphanedHD = 3792964618,
        LodMultSLod1 = 1682304034,
        LodMultSLod2 = 1316012152,
        LodMultSLod3 = 1218720991,
        LodMultSLod4 = 872811427,
        LookIkBlendRate = 1931302076,
        LookIkRotationLimit = 4044698613,
        LookIkTurnRate = 454750378,
        ReflectionLodRangeEnd = 2269408044,
        ReflectionLodRangeStart = 3995079835,
        ReflectionSLodRangeEnd = 1455403991,
        ReflectionSLodRangeStart = 2792355072,
        SSAOLightInten = 1099319606,
        TextureDictID = 2104882549,
        TimeOfDayDofModifers = 3502363965,
        WaterReflectionFarClip = 1832730358,
        allowedFolders = 3665250723,
        athFxListHash = 1844888803,
        bCanApplyRealDamage = 3754821582,
        bUseTimeCycleValues = 1299282176,
        bValidForPlayBack = 1999956592,
        cRenderTargetName = 4294123624,
        cameraCutHashName = 1262004121,
        clipVariationSets = 1333660780,
        discardFrameList = 1234565986,
        eAnimBoneTag = 2363471356,
        eAnimPlayerFlag = 224899699,
        eCurveType = 3921015781,
        eStreamingPolicy = 1631789397,
        eStreamingPriority = 733577798,
        fExponentialFallOff = 1342101,
        fExteriorFootZoom = 3725084347,
        fExteriorFootZoomRunning = 4112712376,
        fExteriorFootZoomWanted = 646913210,
        fExteriorFootZoomWantedRunning = 397988749,
        fFowWaterHeight = 1452712925,
        fInnerConeAngle = 2725338958,
        fInteriorFootZoom = 3533921583,
        fMapLodScale = 3931395097,
        fRangeZoomedScalarPlane = 928938887,
        fRangeZoomedScalarStandard = 707151806,
        fVehicleMovingWantedZoom = 709315443,
        fVehicleMovingZoom = 4088397509,
        fVehicleSpeedZoomScalar = 1734631491,
        fVehicleStaticWantedZoom = 3692711717,
        fVehicleStaticZoom = 2402173156,
        fVolumeSizeScale = 75610905,
        fwClipVariationSet = 1005381910,
        fwProfanityFilter = 932638721,
        iAltRangeEnd = 4079543520,
        iAttachBoneHash = 3936668519,
        iAttachParentId = 867510818,
        iBlendOutCutsceneDuration = 1783584102,
        iBlendOutCutsceneOffset = 660302675,
        iSecondBodyColour = 1237172464,
        iWheelTrimColour = 2225359196,
        interpolateToDisabled = 2862808673,
        modelHashName = 2549745289,
        pChildEvents = 3754530640,
        profaneTerms = 4259179796,
        rage__cutfAttributeList = 1016128875,
        rage__eLodType = 1264241711,
        rage__ePriorityLevel = 648413703,
        rage__fwArchetypeDef__eAssetType = 1991964615,
        rage__fwContainerLodDef = 372253349,
        reservedFSCharacters = 3574026465,
        reservedTerms = 3705267857,
        strRecordedRequest = 3356301454,
        strResourceReference = 2548004600,
        uHourFlags = 2759730476,
        uLightFlags = 2428927641,
        vInitialBoneOffset = 583681460,
        vInitialBoneRotation = 1039931786,

        //from 0x1F9F1
        PROCOBJ_USE_GRID = 2886679239,
        VFXGROUP_BRICK = 3154734852,
        VFXGROUP_BUSHES = 1128169606,
        VFXGROUP_CARPET_FABRIC = 3026080462,
        VFXGROUP_CARPET_FABRIC_DUSTY = 267379975,
        VFXGROUP_CAR_GLASS = 2254996260,
        VFXGROUP_CAR_METAL = 1472286989,
        VFXGROUP_CERAMIC = 2224745689,
        VFXGROUP_CLAY = 340754025,
        VFXGROUP_CONCRETE = 3909664268,
        VFXGROUP_DIRT_DRY = 3010631297,
        VFXGROUP_DRIED_MEAT = 2465001478,
        VFXGROUP_FEATHERS = 1671778076,
        VFXGROUP_FRESH_MEAT = 3221146268,
        VFXGROUP_GLASS = 676227960,
        VFXGROUP_GLASS_BULLETPROOF = 1453403596,
        VFXGROUP_GRASS = 415809717,
        VFXGROUP_GRASS_SHORT = 349709635,
        VFXGROUP_GRAVEL = 1433594767,
        VFXGROUP_GRAVEL_DEEP = 455532549,
        VFXGROUP_HAY = 1126885779,
        VFXGROUP_ICE = 646994767,
        VFXGROUP_LEAVES = 1143575659,
        VFXGROUP_LIQUID_BLOOD = 4066674550,
        VFXGROUP_LIQUID_OIL = 2971250354,
        VFXGROUP_LIQUID_PETROL = 3406258685,
        VFXGROUP_LIQUID_WATER = 2626785081,
        VFXGROUP_MARBLE = 1577332483,
        VFXGROUP_METAL = 3837427351,
        VFXGROUP_MUD_DEEP = 3891414216,
        VFXGROUP_MUD_SOFT = 2357888979,
        VFXGROUP_MUD_UNDERWATER = 3403853718,
        VFXGROUP_PAPER = 4159761865,
        VFXGROUP_PAVING = 2355147898,
        VFXGROUP_PED_CAPSULE = 55400259,
        VFXGROUP_PED_FOOT = 1875610286,
        VFXGROUP_PED_HEAD = 2268340744,
        VFXGROUP_PED_LIMB = 2787107962,
        VFXGROUP_PED_TORSO = 2473728071,
        VFXGROUP_PLASTER_BRITTLE = 3891593880,
        VFXGROUP_PLASTIC = 3864441807,
        VFXGROUP_PLASTIC_HOLLOW = 1987630632,
        VFXGROUP_PUDDLE = 1875581587,
        VFXGROUP_RUBBER = 3735882313,
        VFXGROUP_SANDSTONE = 1961167048,
        VFXGROUP_SANDSTONE_BRITTLE = 2694183171,
        VFXGROUP_SAND_COMPACT = 350030577,
        VFXGROUP_SAND_WET = 3640634991,
        VFXGROUP_SAND_WET_DEEP = 3942228219,
        VFXGROUP_SNOW_COMPACT = 4165326180,
        VFXGROUP_SNOW_LOOSE = 3285173209,
        VFXGROUP_STONE = 3533829783,
        VFXGROUP_TARMAC = 1181702304,
        VFXGROUP_TREE_BARK = 2219631463,
        VFXGROUP_VOID = 2399258053,
        VFXGROUP_WOOD = 59976830,
        VFXGROUP_WOOD_DUSTY = 1551687812,
        VFXGROUP_WOOD_SPLINTER = 4047674909,












        //from junctions.xml -dexy
        CJunctionTemplateArray = 313816480,
        CJunctionTemplate = 2985578477,
        Entries = 3580294544,
        iFlags = 1490815345,
        iNumJunctionNodes = 3730457984,
        iNumEntrances = 3629382379,
        iNumPhases = 4284697782,
        iNumTrafficLightLocations = 2024774002,
        fSearchDistance = 3543631740,
        fPhaseOffset = 33051442, //from dav90
        vJunctionMin = 4254986313,
        vJunctionMax = 2705763988,
        vJunctionNodePositions = 1140501121,
        Entrances = 2079778626,
        PhaseTimings = 970330902,
        TrafficLightLocations = 3688283693,
        vNodePosition = 137333670,
        iPhase = 1580401081,
        fStoppingDistance = 4131936721,
        fOrientation = 2674216667,
        fAngleFromCenter = 253800508,
        bCanTurnRightOnRedLight = 4189109284,
        bLeftLaneIsAheadOnly = 15530841,
        bRightLaneIsRightOnly = 1190125928,
        iLeftFilterLanePhase = 478748718,
        fStartTime = 1971943265,
        fDuration = 3674620953,
        iPosX = 681100199,
        iPosY = 1574841905,
        iPosZ = 176392061,


        //from openIV
        dependencies = 1013942340,
        hdTextureDist = 2908576588,
        clipDictionary = 424089489,
        physicsDictionary = 3553040380,
        priorityLevel = 647098393,
        ambientOcclusionMultiplier = 415356295,
        artificialAmbientOcclusion = 599844163,
        tintValue = 1015358759,
        contentFlags = 1785155637,
        streamingExtentsMin = 3710026271,
        streamingExtentsMax = 2720965429,
        entitiesExtentsMin = 477478129,
        entitiesExtentsMax = 1829192759,
        containerLods = 2935983381,
        boxOccluders = 3983590932,
        occludeModels = 2132383965,
        physicsDictionaries = 949589348,
        instancedData = 2569067561,
        carGenerators = 3254823756,
        LODLightsSOA = 1774371066,
        DistantLODLightsSOA = 2954466641,
        Ao = 2996378564,
        BatchAABB = 1859041902,
        InstanceList = 470289337,
        LodFadeStartDist = 2216273066,
        LodInstFadeRange = 1405992723,
        OrientToTerrain = 3341475578,
        ImapLink = 2142127586,
        PropInstanceList = 3551474528,
        GrassInstanceList = 255292381,
        numStreetLights = 3708891211,
        category = 2052871693,
        exportedBy = 1983184981,
        StartImapFile = 2462971690,
        EndImapFile = 2059586669,
        PtFxAssetName = 2497993358,
        punchInPhase = 3142377407,
        punchOutPhase = 2164219370,

        AvailabilityInMpSp = 2932681318,
        iTimeStartOverride = 591476992,
        iTimeEndOverride = 2688038523,
        TimeTillPedLeaves = 4073598194,
        instances = 274177522,
        flashiness = 3829693202,
        lightType = 482065968,
        groupId = 2501631252,
        cullingPlane = 1689591312,
        padding1 = 3180641850,
        padding2 = 2346113727,
        padding3 = 3521603295,
        volIntensity = 689780512,
        volSizeScale = 2029533327,
        volOuterColour = 2283994062,
        lightHash = 643049222,
        volOuterIntensity = 3008198647,
        coronaSize = 1705000075,
        volOuterExponent = 2758849250,
        lightFadeDistance = 1307926275,
        shadowFadeDistance = 1944267876,
        specularFadeDistance = 4150887048,
        volumetricFadeDistance = 2066998816,
        shadowNearClip = 954647178,
        coronaIntensity = 2292363771,
        coronaZBias = 2520359283,
        coneInnerAngle = 1163671864,
        coneOuterAngle = 4175029060,
        extents = 759134656,
        projectedTextureKey = 1076718994,
        timeAndStateFlags = 3112418278,
        coneOuterAngleOrCapExt = 3161894080,

        minExtents = 1731020657,
        maxExtents = 2554806840,

        orientX = 735213009,
        orientY = 979440342,
        perpendicularLength = 124715667,
        bodyColorRemap1 = 1429703670,
        bodyColorRemap2 = 1254848286,
        bodyColorRemap3 = 1880965569,
        bodyColorRemap4 = 1719152247,
        popGroup = 911358791,

        enableLimitAngle = 1979299226,
        startsLocked = 3204572347,
        canBreak = 2756786344,
        doorTargetRatio = 770433283,
        audioHash = 224069936,

        effectHash = 2982223448,
        materialType = 932754174,
        canGetOffAtTop = 564839673,
        canGetOffAtBottom = 923729576,

        manifestFlags = 1683136603,

        AT_DRB = 1956121915,
        AT_FRG = 2872363693,
        AT_DWD = 474212588,
        INTERIOR_DATA = 559321238,

        METAL_SOLID_LADDER = 1101797524,

        PRI_REQUIRED = 1943361227,
        PRI_OPTIONAL_HIGH = 3993616791,
        PRI_OPTIONAL_MEDIUM = 515598709,
        PRI_OPTIONAL_LOW = 329627604,


        ASSET_TYPE_UNINITIALIZED = 189734893,
        ASSET_TYPE_FRAGMENT = 571047911,
        ASSET_TYPE_DRAWABLE = 130075505,
        ASSET_TYPE_DRAWABLEDICTIONARY = 1580165652,
        ASSET_TYPE_ASSETLESS = 4161085041,

        aLevelsData = 1643066032,
        cFriendlyName = 2077026003,
        cTitle = 834048882,
        cFilename = 3760135447,
        cBugstarName = 3970741067,



        //openIV carcols.ymt
        VehiclePlates = 593302648,
        Textures = 1767854039,
        TextureSetName = 539384795,
        DiffuseMapName = 1085051633,
        FontExtents = 1008020858,
        MaxLettersOnPlate = 1247956775,
        FontColor = 1707432934,
        FontOutlineColor = 2386115193,
        IsFontOutlineEnabled = 3610161521,
        FontOutlineMinMaxDepth = 1248154675,
        DefaultTexureIndex = 3080794991,
        NumericOffset = 4285827253,
        AlphabeticOffset = 1050521113,
        SpaceOffset = 1314537973,
        RandomCharOffset = 2935763181,
        NumRandomChar = 3588975658,
        Colors = 721554909,
        metallicID = 2578478329,
        audioColor = 1773594779,
        audioPrefix = 2369251831,
        audioColorHash = 2318773127,
        audioPrefixHash = 319619186,
        colorName = 3636206675,
        MetallicSettings = 1425754958,
        specInt = 583457853,
        specFalloff = 4263701895,
        specFresnel = 3304136448,
        WindowColors = 923621137,
        Sirens = 2599949557,
        timeMultiplier = 1771951321,
        lightFalloffMax = 154568665,
        lightFalloffExponent = 1650161522,
        lightInnerConeAngle = 1576817313,
        lightOuterConeAngle = 3797248043,
        lightOffset = 1620490850,
        sequencerBpm = 1335282710,
        sequencer = 3240773244,
        leftHeadLight = 649479127,
        rightHeadLight = 1381853174,
        leftTailLight = 1551657213,
        rightTailLight = 3049986329,
        leftHeadLightMultiples = 3399909735,
        rightHeadLightMultiples = 3461946667,
        leftTailLightMultiples = 4275157148,
        rightTailLightMultiples = 2310746177,
        useRealLights = 804083006,
        delta = 1117510170,
        syncToBpm = 43887647,
        corona = 3191162493,
        faceCamera = 992261783,
        lightGroup = 2689509391,
        scaleFactor = 3961827348,
        light = 1118124053,
        spotLight = 1568651848,
        castShadows = 3640997727,
        livery2Names = 3280812844,
        GlobalVariationData = 4171652890,
        xenonLightColor = 4198188279,
        xenonCoronaColor = 4113209874,
        xenonLightIntensityModifier = 849227792,
        xenonCoronaIntensityModifier = 3145775573,
        XenonLightColors = 2580788834,
        lightColor = 78766281,
        coronaColor = 3615736814,
        lightIntensityModifier = 1981979787,
        coronaIntensityModifier = 3155797354,












        //popgroups.ymt - From FiveM
        //For the pedgroups/item/name field
        richman_glen_bevhills = 1916548608,
        marlowe_drive_bevhills = 3724985487,
        baytree_canyon_bevhills = 1095587898,
        galileo_park_bevhills = 3773030709,
        galileo_park_hipsters = 1226562551,
        galileo_park_tourists = 2437681877,
        ocean_general = 699946682,
        pacific_bluffs_beach = 1771635400,
        pacific_bluffs_streetgeneral = 2128557429,
        del_perro_streetgeneral = 4003270267,
        del_perro_bums = 3222414768,
        vespucci_pier_beach = 2175040393,
        vespucci_streetgeneral = 853940634,
        vespucci_bums = 908912315,
        vespucci_canals_streetgeneral = 4149286830,
        vespucci_canals_bevhills = 2120071986,
        puerto_business = 2592745348,
        puerto_streetgeneral = 3620209527,
        puerto_bevhills = 2096726272,
        puerto_hipsters = 4241471320,
        lsa_airport = 3523754501,
        lsa_streetgeneral = 3526862920,
        elysian_island_streetgeneral = 851640179,
        elysian_island_genped = 398248766,
        terminal_construction = 3440476579,
        terminal_specificjob = 3674390882,
        beachparty = 2592453449,
        banning_construction = 46699983,
        banning_specificjob = 2575047138,
        banning_streetgeneral = 3474460204,
        banning_tramps = 2130175499,
        el_burro_general = 2730520509,
        cypress_general = 1446780254,
        cypress_tramps = 3214037884,
        la_mesa_general = 2636968603,
        la_mesa_tramps = 748862053,
        murrieta_general = 697895317,
        murrieta_tramps = 3052120512,
        murrieta_gang = 2843705451,
        hippy = 944887848,
        cult = 2010391401,
        racecourse_bevhills = 1764904172,
        racecourse_streetgeneral = 1498417612,
        east_vinewood_local = 1545421012,
        east_vinewood_hipster = 271987258,
        east_vinewood_streetgeneral = 3366133940,
        paleto_bay_general = 3474455539,
        mirror_park_business = 777133455,
        mirror_park_hipsters = 2253228929,
        mirror_park_streetgeneral = 61725078,
        west_vinewood_hipsters = 1283940400,
        west_vinewood_streetgeneral = 310058182,
        west_vinewood_vinewood = 3235047195,
        eclipse_hipsters = 3720433148,
        eclipse_streetgeneral = 2052334107,
        eclipse_vinewood = 2593057275,
        eclipse_sexuals = 2351577296,
        club_nighttime = 2022489214,
        downtown_tramps = 987833330,
        downtown_bevhills = 809773694,
        downtown_hipsters = 180130592,
        downtown_streetgeneral = 3523779044,
        fish_ = 1207004798,
        birds_city = 589253797,
        birds_ground_city = 1230242748,
        birds_countryside = 390908839,
        birds_ocean = 3168035254,
        birds_ground_ocean = 3110385855,
        burton_tramps = 256463428,
        burton_business = 3165443402,
        burton_bevhills = 3155703512,
        burton_hipsters = 2194132880,
        burton_vinewood = 1651740194,
        burton_streetgeneral = 3056012715,
        hawick_bevhills = 1318738468,
        hawick_hipsters = 3708634492,
        hawick_streetgeneral = 1267713346,
        hawick_tramps = 2932194291,
        hawick_vinewood = 360078400,
        alta_business = 485106051,
        alta_tramps = 3962261894,
        alta_bevhills = 3657786126,
        alta_streetgeneral = 2583180649,
        rockford_shop_bevhills = 4171238205,
        rockford_shop_streetgeneral = 2899076840,
        rockford_residential_bluecollar = 2323943313,
        rockford_residential_bevhills = 577684089,
        rockford_hills_day = 2546072613,
        rockford_hills_night = 3291264832,
        richman_bevhills = 2279583243,
        richman_streetgeneral = 3757962161,
        morningwood_tramps = 501399946,
        morningwood_bevhills = 763676531,
        morningwood_hipsters = 2303048052,
        morningwood_streetgeneral = 115436112,
        backlot_film = 897751036,
        backlot_streetgeneral = 1689692965,
        little_seoul_koreatown = 3058390933,
        little_seoul_gang = 3164653322,
        little_seoul_streetgeneral = 2782104137,
        pillbox_business = 325325429,
        pillbox_bevhills = 2147006744,
        pillbox_tramps = 578868739,
        textile_bluecollar = 3279161038,
        textile_tramps = 187018675,
        textile_streetgeneral = 2072811124,
        mission_tramps = 1765836040,
        mission_streetgeneral = 477790886,
        strawberry_sc = 3513229903,
        strawberry_tramps = 3763929697,
        strawberry_gang = 1084379725,
        chamberlain_sc = 3488106941,
        chamberlain_tramps = 3657678612,
        chamberlain_gang = 411250856,
        davis_hookers = 263474307,
        davis_sc = 2938794522,
        davis_gang = 2259354683,
        davis_tramps = 80817981,
        rancho_sc = 116771963,
        rancho_gang = 3730883993,
        rancho_tramps = 282950945,
        incar_general = 1725824697,
        stadium_streetgeneral = 3270139100,
        los_puerta_armenian = 2855646127,
        los_puerta_streetgeneral = 1461524714,
        vespucci_magdemo = 1443256237,
        rockford = 601104499,
        beach_fat = 1495265263,
        fat_general = 3194660753,
        s_central = 1270994027,
        fashion = 2922437723,
        bohemian = 2527915385,
        hipsters = 1206548044,
        eastla = 3903831171,
        business = 942215692,
        restaurant_night = 2230335161,
        tramp = 295674176,
        tourists = 4052103791,
        prisoners = 3489630150,
        freeway_countryside = 141741896,
        freeway_haulage = 2921281021,
        gang_chinese = 344476045,
        gang_south_la = 1434944763,
        net_common = 1475419019,
        net_uncommon = 3944733161,
        rampage_south_ls = 855514417,
        rampage_little_seoul = 1518670552,
        rampage_rockford_hills = 154314028,
        veh_poor = 454752152,
        veh_poor_mp = 226581960,
        veh_mid = 3112896464,
        veh_mid_mp = 326963640,
        veh_rich = 4160258559,
        veh_rich_mp = 3705405835,
        veh_haulage = 2260594341,
        veh_haulage_mp = 443246348,
        veh_utility = 2942896063,
        veh_utility_mp = 3737227278,
        veh_freeway = 4222100980,
        veh_freeway_mp = 2591138726,
        veh_large_city = 3079238267,
        veh_large_city_mp = 4156290791,
        veh_countryside_offroad = 3880382407,
        veh_countryside_offroad_mp = 2218713197,
        veh_countryside_onroad = 1817408484,
        veh_countryside_onroad_mp = 1218898747,
        veh_yankton = 2030452436,
        veh_yankton_mp = 3116561190,
        veh_bikes = 347476719,
        veh_bikes_mp = 3953384100,
        native_zon_only = 3826828622,
        veh_salt = 1026046820,
        veh_salt_mp = 2143875649,
        veh_army = 2983944587,
        veh_army_mp = 1478794142,
        veh_boats = 1968910249,
        veh_boats_mp = 769254936,
        veh_boats_freeway = 800811870,
        veh_boats_freeway_mp = 2697936629,
        veh_bicycles = 1387773269,
        veh_bicycles_mp = 3588295793,
        veh_beach_bike = 875099148,
        veh_beach_bike_mp = 2956724466,
        veh_lost = 927861950,
        veh_lost_mp = 2710493793,
        veh_copcar = 113873283,
        veh_copcar_mp = 3625575212,
        veh_taxi = 2516826768,
        veh_taxi_mp = 3476042821,
        veh_airport = 3318832790,
        veh_airport_mp = 3494166071,
        veh_test_simple = 2438558856,
        veh_test_complex = 297209538,
        veh_transport = 2042289260,
        veh_transport_mp = 1022555546,
        veh_countrycoach = 4024372987,
        veh_countrycoach_mp = 2395407794,
        veh_prologue = 3821814614,
        veh_prologue_mp = 595582180,
        // wildlifeHabitats/Item
        sand_loose = 2549909946,
        sand_compact = 2397730525,
        sand_wet = 1064898850,
        grass_long = 4160773303,
        grass_short = 1200682253,





        //Carl Johnson: I discovered  in zonebind
        specialZoneAttribute = 218662697,

    }


}
